# -*- coding: cp936 -*-
import sys,os
import customer
import model

###############################################################
# Generate Build Batch File
###############################################################

program_name = "QR Product Configuration Tool"
version = "V1.0"
build_type = ["Release", "Debug"]

def usage():
    print '===================================='
    print program_name
    print version
    print '===================================='

# ָõı
# : ļ
def GenBuildCmd(modelname, buildtype, custname, target="APP", ver=None, needpause=None):
    config = []
    config.append("@echo off")
    config.append("::==============================")
    config.append("::Auto Generated By configure.py")
    config.append("::DO NOT EDIT THIS FILE")
    config.append("::==============================")
    config.append("@set QR_PRODUCT_MODEL=%s" % (modelname))
    config.append("@set QR_BUILD_TYPE=%s" % (buildtype))
    config.append("@set QR_BUILD_TARGET=%s" % (target))
    config.append("@set QR_CUSTOMER_NAME=%s" % (custname))
    if ver != None:
        config.append("@call build.cmd %s" % ver)
    else:
        config.append("@call build.cmd")
    
    config.append("@set OUTPUT_APPNAME=%QR_PRODUCT_MODEL%_%QR_CUSTOMER_NAME%_%QR_BUILD_TYPE%_%APP_VERSION%_%APP_BUILD_DATE%.img")
    config.append("@set OUTPUT_SIGNED_APPNAME=%QR_PRODUCT_MODEL%_%QR_CUSTOMER_NAME%_%QR_BUILD_TYPE%_%APP_VERSION%_%APP_BUILD_DATE%_signed.img")
    
    config.append("@IF NOT EXIST out\showAPP.img goto fail")
    config.append("@copy out\showAPP.img out\%OUTPUT_APPNAME%")	
    config.append("@del /F out\showAPP.img")
    config.append("@IF NOT EXIST out\showAPP_signed.img goto fail")    
    config.append("@copy out\showAPP_signed.img out\%OUTPUT_SIGNED_APPNAME%")	
    config.append("@echo @SET SUBAPP_NAME=%OUTPUT_SIGNED_APPNAME% > target_image_name.cmd")
    config.append("@del /F out\showAPP_signed.img")
    
    config.append("@del /F upd.tmp")
    config.append("@echo flag:1; > upd.tmp")
    config.append("@echo update second app:secapp.img; >> upd.tmp")
    config.append("@echo last result:-1; >> upd.tmp")
           
    config.append(":success")
    config.append('@ECHO ================================')
    config.append('@ECHO.')
    config.append('@ECHO  mmmmm    mm    mmmm   mmmm ')
    config.append('@ECHO  #   "#   ##   #"   " #"   "')
    config.append('@ECHO  #mmm#"  #  #  "#mmm  "#mmm')
    config.append('@ECHO  #       #mm#      "#     "#')
    config.append('@ECHO  #      #    # "mmm#" "mmm#"')
    config.append('@ECHO.')
    config.append('@ECHO ================================')
    config.append("@goto end")
    config.append(":fail")
    config.append('@ECHO ================================')
    config.append('@ECHO.')
    config.append('@ECHO  mmmmmm   mm   mmmmm  m '  )  
    config.append('@ECHO  #        ##     #    # '   ) 
    config.append('@ECHO  #mmmmm  #  #    #    # '  )  
    config.append('@ECHO  #       #mm#    #    # '  )  
    config.append('@ECHO  #      #    # mm#mm  #mmmmm')
    config.append('@ECHO.')
    config.append('@ECHO ================================')
    config.append(":end")

    if needpause != None:
        config.append("@pause")
        
    build_batch_name = "001_build_%s_%s_%s_%s.cmd" % (modelname, custname, buildtype, target)
    
    fd = open(build_batch_name, mode='w+')
    for line in config:
        fd.write("%s\n" % line)
    fd.close()
    return build_batch_name

def genAllCustomerBatch():
    target = "APP"
    build_all_batch = []
    build_all_batch.append("@echo off")
    build_all_batch.append("::==============================")
    build_all_batch.append("::Auto Generated By configure.py")
    build_all_batch.append("::DO NOT EDIT THIS FILE")
    build_all_batch.append("::==============================")    
    for custname in customer.names:
        for modelname in customer.model[custname]:
            for buildtype in build_type:
                batch_name = GenBuildCmd(modelname, buildtype, custname, target, "V0.09.2003")
                print "Gen: %s" % batch_name
                build_all_batch.append("@echo ----------------------------------------")
                build_all_batch.append("@echo %s %s" % (modelname, target))
                build_all_batch.append("@echo ----------------------------------------")
                build_all_batch.append("@call 000_clean.cmd")
                build_all_batch.append("@call %s" % batch_name)
                build_all_batch.append("@IF NOT EXIST out\\showAPP.img goto fail")
                #build_all_batch.append("@copy out\\src\\bwsdk.a libs\\V1_8_8\\%s_bwsdk_%s.a" % (modelname, buildtype))
    build_all_batch.append(':success')
    build_all_batch.append('@ECHO ================================')
    build_all_batch.append('@ECHO.')
    build_all_batch.append('@ECHO  mmmmm    mm    mmmm   mmmm ')
    build_all_batch.append('@ECHO  #   "#   ##   #"   " #"   "')
    build_all_batch.append('@ECHO  #mmm#"  #  #  "#mmm  "#mmm')
    build_all_batch.append('@ECHO  #       #mm#      "#     "#')
    build_all_batch.append('@ECHO  #      #    # "mmm#" "mmm#"')
    build_all_batch.append('@ECHO.')
    build_all_batch.append('@ECHO ================================')
    build_all_batch.append('goto end')
    
    build_all_batch.append(':fail')
    build_all_batch.append('@ECHO ================================')
    build_all_batch.append('@ECHO.')
    build_all_batch.append('@ECHO  mmmmmm   mm   mmmmm  m '  )  
    build_all_batch.append('@ECHO  #        ##     #    # '   ) 
    build_all_batch.append('@ECHO  #mmmmm  #  #    #    # '  )  
    build_all_batch.append('@ECHO  #       #mm#    #    # '  )  
    build_all_batch.append('@ECHO  #      #    # mm#mm  #mmmmm')
    build_all_batch.append('@ECHO.')
    build_all_batch.append('@ECHO ================================')
    build_all_batch.append('@ECHO.')
    build_all_batch.append('@ECHO.')
    build_all_batch.append('@ECHO.')
    build_all_batch.append('goto end')
    build_all_batch.append(':end')
    #build_all_batch.append('@pause')

    build_batch_name = "099_build_AllAPP.cmd"
    fd = open(build_batch_name, mode='w+')
    for line in build_all_batch:
        fd.write("%s\n" % line)
    fd.close()
    return build_batch_name   

def ManualConfig():
    usage();
    for i in range(0, len(model.names), 1):
        print "%d - %s" % (i, model.names[i])
    
    model_idx = int(raw_input("Choose Model: "))
    print "You select: %s" % (model.names[model_idx])
    
    # if no customer name not need to print to choose
    for i in range(0, len(customer.names), 1):
        print "%d - %s" % (i, customer.names[i])
    
    customer_idx = int(raw_input("Choose Customer:"))
    print "You select: %s" % (customer.names[customer_idx])
    
    for i in range(0, len(build_type), 1):
        print "%d - %s" % (i, build_type[i])
    
    build_type_idx = int(raw_input("Choose Build Type:"))
    print "You select: %s" % (build_type[build_type_idx])
    
    build_target = ["APP"]
    build_target_idx = 0
    print "You select: %s" % (build_target[build_target_idx])
    
    GenBuildCmd(model.names[model_idx], build_type[build_type_idx], customer.names[customer_idx], build_target[build_target_idx], None, True)

if __name__ == "__main__":
    if len(sys.argv) == 1:
        ManualConfig()
    elif sys.argv[1] in ["APP", "app"]:
        genAllCustomerBatch()
