/*
 * Copyright (C) 2018 Shanghai Basewin Technology Co.,Ltd
 */
 
#ifndef __HTTP_UTILS_H__
#define __HTTP_UTILS_H__

/**
 * Upload file mode define.
 */
enum
{
    UPLOAD_FILE_MODE_CURRENT, 
    UPLOAD_FILE_MODE_ALL,
    UPLOAD_FILE_MODE_MAX
};

/**
 * post and response size.
 */ 
#define HTTP_POST_MAX_LEN       (1024)
#define HTTP_RESP_MAX_LEN       (1024)

/**
 * Default http receive data timeout.
 */
#define DEFAULT_HTTP_RECV_TIMEOUT 30 * 1000

/**
 * Define max try for downloading.
 */
#define MAX_TRY_CNT (3)

int http_download_file(const char* file_name, const char* url, 
    int port, int spt_resume, char* chksum_buf, void (*progress_cb)(int percent), 
    const char* extra_header_param);

int http_upload_file(const char* url, int port, int mode, const char* filename, 
    void (*progress_cb)(int percent));

void http_clear_download_info(const char* filename);

#endif //__HTTP_UTILS_H__
