#ifndef _APP_CALL_BACK__H
#define _APP_CALL_BACK__H


#define APP_CALL_BACK_FLAG

#include "EmvRevocationIPKList.h"
#include "EmvExceptionFileList.h"
#include "EMVTransHandle.h"
#include "EMVCapkList.h"
#include "EmvAidList.h"
#include "Kernel_Param.h"

#ifndef APP_CALL_BACK_FLAG

#define EMV_TRUE  1
#define EMV_FALSE 0

typedef unsigned int EMV_UINT32;

typedef unsigned char EMV_BYTE;// ޷

typedef unsigned char EMV_UINT8;

typedef char EMV_CHAR;// з

typedef const EMV_CHAR * LPC_EMV_CHAR;

typedef EMV_BYTE * LP_EMV_BYTE;

typedef unsigned short EMV_UINT16;

typedef EMV_UINT16 * LP_EMV_UINT16;

typedef const EMV_BYTE * LPC_EMV_BYTE;

typedef unsigned char EMV_BOOL; // ޷

typedef EMV_CHAR * LP_EMV_CHAR;

typedef EMV_BOOL * LP_EMV_BOOL;

typedef EMV_UINT32 EMV_TAG;

// 
#define	EMV_ONLINE_APPROVED         0x00 // ׼
#define	EMV_ONLINE_REJECT			0x01 // ܾ
#define	EMV_ONLINE_VOICE_PREFER		0x02 // 
#define	EMV_ONLINE_ERROR			0x03 // 
#define	EMV_ONLINE_TIME_OUT			0x04 // ʱ
#define	EMV_ONLINE_CONNECT_FAILED	0x05 // ʧ
#define EMV_ONLINE_NULL				0xFF // 



struct EMV_TERMINAL_INFO {
    // 315
    EMV_CHAR m_TerminalID[8 + 1];
    EMV_CHAR m_IFDSerialNumber[8 + 1];
    EMV_CHAR m_TerminalCountryCode[2 * 2 + 1];
    EMV_CHAR m_Merchant_ID[15 + 1];
    EMV_CHAR m_Merchant_Category_Code[2 * 2 + 1];
    EMV_CHAR m_Merchant_Location[255 + 1];
    EMV_CHAR m_Trans_Currency_Code[2 * 2 + 1];
    EMV_UINT8 m_Trans_Currency_Exp;
    EMV_CHAR m_Trans_Ref_Currency_Code[2 * 2 + 1];
    EMV_UINT8 m_Trans_Ref_Currency_Exp;
    EMV_CHAR m_TerminalEntryMode[1 * 2 + 1];
};

typedef const struct EMV_TERMINAL_INFO * LPC_EMV_TERMINAL_INFO;


struct EMV_TIME {
    EMV_UINT16 m_Year;
    EMV_UINT8 m_Month;
    EMV_UINT8 m_Day;
    EMV_UINT8 m_Hour;
    EMV_UINT8 m_Minute;
    EMV_UINT8 m_Second;
};

typedef struct EMV_TIME * LP_EMV_TIME;


typedef EMV_BYTE EMV_CDA_METHOD;// cda ʽ
#define	EMV_CDA_MODE1 0x00 //CDA on ARQC _ Req, CDA on 2nd GenAC TC after approved Online authorization
#define	EMV_CDA_MODE2 0x01 //CDA on ARQC _ No Req CDA on 2 2nd Gen Ac TC after appproved online authorization
#define	EMV_CDA_MODE3 0x02 //No Req. CDA on ARQC + No Req CDA on 2nd GenAc after approved Online authorization
#define	EMV_CDA_MODE4 0x03 //No Req CDA on ARQC + req CDA on 2nd GenAcC after approved Online Authorization
typedef EMV_BYTE EMV_DEFAULT_ACTION_CODE_METHOD; // ĬΪ뷽ʽ
#define EMV_DEFAULT_ACTION_CODE_BEFOR_GAC1 0x00
#define EMV_DEFAULT_ACTION_CODE_AFTER_GAC1 0x01


struct EMV_KERNEL_CONFIG {
    // 48
    EMV_BOOL m_PSE;
    EMV_BOOL m_CardHolderConfirm;
    EMV_BOOL m_PreferredDisplayOrder; //NO implemented,նõAID˳ʾ
    EMV_BOOL m_LanguateSelect;
    EMV_BOOL m_RevocationOfIssuerPublicKey;
    EMV_BOOL m_Default_DDOL;
    EMV_BOOL m_Bypass_PIN_Entry;
    EMV_BOOL m_Subsequent_Bypass_PIN_Entry;
    EMV_BOOL m_Getdata_For_PIN_Try_Counter;
    EMV_BOOL m_Floor_Limit_Checking;
    EMV_BOOL m_Random_Transaction_Selection; //unvaliable for the offline only terminal
    EMV_BOOL m_Velocity_Checking;
    EMV_BOOL m_TransactionLog;
    EMV_BOOL m_Exception_File;
    EMV_BOOL m_TerminalActionCode;
    EMV_DEFAULT_ACTION_CODE_METHOD m_DefaultActionCodeMethod;
    EMV_BOOL m_TAC_IAC_Default_SkipedWhenUnableToGoOnline;
    EMV_BOOL m_CDA_FailureDetectedPriorTerminalActionAnalysis;

    EMV_CDA_METHOD m_CDA_Method;

    EMV_BOOL m_ForcedOnline;
    EMV_BOOL m_ForcedAcceptance;
    EMV_BOOL m_Advices;
    EMV_BOOL m_Issuer_Referral;
    EMV_BOOL m_BatchDataCapture;
    EMV_BOOL m_OnlineDataCapture;
    EMV_BOOL m_Default_TDOL;
    EMV_BOOL m_Terminal_SupportAccountTypeSelection; //No Implemented

    EMV_CHAR m_TerminalType[1 * 2 + 1];
    EMV_CHAR m_TerminalCapabilities[3 * 2 + 1];
    EMV_CHAR m_AddtionalTerminalCapabilities[5* 2 + 1];
};

typedef const struct EMV_KERNEL_CONFIG * LPC_EMV_KERNEL_CONFIG;


struct RISK_PARAM {
    //#1
    EMV_BOOL m_ActiveCTLCheck;// ǽӽ޶
    EMV_UINT32 m_ContactlessTransLimit;//

    //#2
    EMV_BOOL m_ActiveCVMCheck;// ǽcvm޶
    EMV_UINT32 m_ContactlessCVMLimit;

    //#3
    EMV_BOOL m_ActiveCFLCheck;// ǽ޶
    EMV_BOOL m_ContactlessFloorLimitExist;
    EMV_BOOL m_FloorlimitCheck;
    EMV_UINT32 m_ContactlessFloorLimit;
    EMV_UINT32 m_FloorLimit;

    //#4
    EMV_BOOL m_ActiveStatusCheck;// ״̬

    //#5
    EMV_BOOL m_ActiveZeroAmtCheck;// 
    EMV_BOOL m_ZeroAmtPath;
};

typedef struct RISK_PARAM QVSDC_RISK_PARAM;

struct RISK_RESULT {
    EMV_BOOL m_isMatched;// Ƿȫƥ
    EMV_BOOL m_AppNotAllowFlag;// ӦǷ
    EMV_BOOL m_RequireOnlineFlag;// 
    EMV_BOOL m_RequireCVMFlag;// cvm
};

typedef struct RISK_RESULT QVSDC_RISK_RESULT;


struct RISK_PARAM_FOR_TRANS {
    EMV_BYTE m_TransType;
    QVSDC_RISK_PARAM m_RiskParam;
    QVSDC_RISK_RESULT m_RiskResult;
};


typedef struct RISK_PARAM_FOR_TRANS QVSDC_RISK_PARAM_FOR_TRANS;



struct QPBOC_PARAMETER {
    EMV_BOOL m_Support_PBOC; // 
    EMV_BOOL m_Support_QPBOC; // QPBOC
    EMV_BOOL m_Support_Contact; // Ӵ
    EMV_BOOL m_Support_Online; // ն˾
    EMV_BOOL m_Support_Online_PIN; // PIN
    EMV_BOOL m_Support_Signature; // ǩ
    EMV_BOOL m_Support_Online_ODA; // oda
    EMV_BOOL m_Support_Status_Check; // նǷ֧״̬飬ȱʡΪر
    EMV_BOOL m_Support_CDCVM; //
    EMV_BOOL m_Support_ExceptionFile; // 
    QVSDC_RISK_PARAM_FOR_TRANS m_RiskParam_Default;
};


typedef struct QPBOC_PARAMETER * LP_QPBOC_PARAM;


// * AID 
struct EMV_AID_ITEM {
    //  596
    EMV_UINT16 m_uiAID;
    EMV_BYTE m_AID[16];
    EMV_BYTE m_AppVersion[2];
    EMV_BOOL m_PartMach;
    EMV_BYTE m_TerminalAcquireID[6];
    EMV_BYTE m_Default_DDOL[255]; //use when DDA
    EMV_UINT32 m_Default_DDOL_Len;
    EMV_BYTE m_Default_TDOL[255]; //use when CDA
    EMV_UINT32 m_Default_TDOL_Len;

    EMV_UINT32 m_TerminalFloorLimit;
    EMV_UINT32 m_TresholdValue;
    EMV_UINT32 m_TargetPercentage;
    EMV_UINT32 m_MaxTargetPercentage;

    EMV_BYTE m_TAC_Denial[5];
    EMV_BYTE m_TAC_Online[5];
    EMV_BYTE m_TAC_Default[5];

    EMV_UINT32 m_EC_Trans_Limite; //EC

    EMV_UINT32 m_ContactlessTransLimit; //qPBOC
    EMV_UINT32 m_ContactlessFloorLimit; //qPBOC
    EMV_UINT32 m_ContactlessCVMAmount; //qPBOC
};

typedef const struct EMV_AID_ITEM * LPC_EMV_AID_ITEM;


struct EMV_CAPK_ITEM {
    // 290
    EMV_BYTE m_RID[5];
    EMV_BYTE m_CapkIndex;
    EMV_UINT16 m_uiModules;
    EMV_BYTE m_Modules[256];
    EMV_UINT16 m_uiExponents;
    EMV_BYTE m_Exponents[3];
    EMV_BYTE m_Checksum[20];
};

typedef struct EMV_CAPK_ITEM * LP_EMV_CAPK_ITEM;

typedef const struct EMV_CAPK_ITEM * LPC_EMV_CAPK_ITEM;


// ܹԿ
typedef struct SM_CAPK__ITEM {
    // 70
    EMV_BYTE m_RID[5];
    EMV_BYTE m_CapkIndex;
    EMV_BYTE m_Modules[64];
}SM_CAPK;

typedef struct SM_CAPK__ITEM * LP_EMV_SM_CAPK_ITEM;


struct EMV_REVO_IPK_ITEM {
    // 9
    EMV_BYTE m_RID[5];
    EMV_BYTE m_CapkIndex;
    EMV_BYTE m_SerialNo[3];
};

typedef const struct EMV_REVO_IPK_ITEM * LPC_EMV_REVO_IPK_ITEM;


struct EMV_EXCEPT_ITEM {
    // 22
    EMV_UINT16 m_uiPAN;
    EMV_BYTE m_PAN[19];
    EMV_BYTE m_Seq;
};

typedef const struct EMV_EXCEPT_ITEM * LPC_EMV_EXCEPT_ITEM;


#define EMV_OK					0
#define EMV_APPROVED_OFFLINE    1  // ѻ
#define EMV_APPROVED_ONLINE     2	// 
#define EMV_DECLINED_OFFLINE    3	// ѻܾ
#define EMV_DECLINED_ONLINE     4	// ܾ
#define EMV_NO_ACCEPTED         6	// 
#define EMV_TERMINATED			7	//  ն˴
#define EMV_CARD_BLOCKED        8	// Ƭ
#define EMV_APP_BLOCKED         9	// Ӧ
#define EMV_NO_APP              10	// Ӧ

#define EMV_CAPK_EXPIRED        11 // Կ
#define EMV_CAPK_CHECKSUM_ERROR 12 // ԿУ
#define EMV_AID_DUPLICATE       13 // Ӧظ

#define EMV_CERTIFICATE_RECOVER_FAILED 14 // ָ֤
#define EMV_DATA_AUTH_FAILED     15 // ֤ʧ

#define EMV_UN_RECOGNIZED_TAG	16 // Чtag
#define EMV_DATA_NOT_EXISTS     17 // ݲ
#define EMV_DATA_LENGTH_ERROR   18 // ݳȴ
#define EMV_INVALID_TLV         19 // Чtlv
#define EMV_INVALID_RESPONSE    20 // ЧӦ
#define EMV_DATA_DUPLICATE      21 // ظ

#define EMV_MEMORY_NOT_ENOUGH	22 // ڴ治
#define EMV_MEMORY_OVERFLOW		23 // ڴ
#define EMV_PARAMETER_ERROR     24 // 
#define EMV_ICC_ERROR           25 //icc

#define EMV_NO_MORE_DATA        26 // ޸
#define EMV_CAPK_NO_FOUND       27 // Կûҵ

#define EMV_APP_NOT_ALLOW		28 // Ӧò
#define EMV_OTHER_ERROR         255 // 


// ɾļʶ
#define REMOVE_APPLIST 0
#define REMOVE_CAPK 1
#define REMOVE_SMCAPK 2
#define REMOVE_IPK 3
#define REMOVE_EXCEPT_FILE 4
#define REMOVE_TER_INFO 5
#define REMOVE_CONFIG 6
#define REMOVE_QVSDC_P 7
#define REMOVE_QPBOC_P 8

#define REMOVE_ALL 0xFF

// VISA 
#define		TRANSACTION_TYPE_SALE					0x00 // 
#define		TRANSACTION_TYPE_REFUND					0x20 // ˻
#define		TRANSACTION_TYPE_CASH					0x01 // ֽ
#define		TRANSACTION_TYPE_CASHBACK				0x09 // 
#define		TRANSACTION_TYPE_CASH_DISBURSEMENT		0x17 // 

// qpboc 
#define		TRANSACTION_TYPE_CASH1					0x30
#define		TRANSACTION_TYPE_CASHBACK1				0x31
#define		TRANSACTION_TYPE_GOODS					0x32
#define		TRANSACTION_TYPE_SERVICE			    0x33
#define		TRANSACTION_TYPE_INQUIRY				0x34
#define		TRANSACTION_TYPE_TRANSFER				0x35
#define		TRANSACTION_TYPE_PAYMENT				0x36
#define		TRANSACTION_TYPE_ADMIN					0x37
#define		TRANSACTION_TYPE_DEPOSIT		        0x38






#endif


typedef void(*Fn_Kernel_Log_Print)(const char *pszMessage, unsigned int len);

typedef void(*Fn_Kernel_GetCurrentTime)(LP_EMV_TIME pCurrentTime);

typedef void(*Fn_Kernel_GetRandomData)(unsigned char *pRandBuff, unsigned short uiSize);

typedef unsigned char(*Fn_Kernel_ExchangeApdu)(const unsigned char *pApdu, unsigned short uiApdu,
                                      unsigned char *pResp, unsigned short *puiResp);

typedef unsigned char(*Fn_Kernel_DetectBreak)(void);

typedef unsigned char(*Fn_Kernel_SelectApplication)(const char **ppAppNames, const char **ppAppAids,
                                           unsigned short uiAppCount, unsigned short *puiSelected);

typedef unsigned char(*Fn_Kernel_CardHolderConfirm)(const char *pAID, const char *pAppName, const char *pPreferAppName);

typedef unsigned char(*Fn_Kernel_TryOtherApplication)(void);

typedef unsigned char(*Fn_Kernel_EnterAmount)(unsigned int *pAmount, unsigned int *pAmountOther);

typedef unsigned char(*Fn_Kernel_GetPlainTextPin)(unsigned char bAllowBypass, char *pszPIN, unsigned short uiPinBuffSize,
                                         unsigned char pbBypass);

typedef unsigned char(*Fn_Kernel_GetOnlinePin)(unsigned char bAllowBypass, const char *pszPAN, char *pszPinBlock,
                                      unsigned short uiPinBlockBuffSize, unsigned char* pbBypass);

typedef unsigned char(*Fn_Kernel_Display_Pin_Verify_Status)(unsigned char uiRetryTimes);

typedef void(*Fn_Kernel_Display_Trans_Report)(unsigned int uiErrorCode, unsigned char bSignatureNeeded);

typedef void(*Fn_Kernel_AskRemoveCard)(void);

typedef void(*Fn_Kernel_AuthorisationRequest)(
        const char *pszOnlineEncipherPIN, unsigned char *pOnlineResult,
        char *pszIssueAuthData, unsigned short uiIssueAuthDataBuffSize,
        char *pszARC, unsigned short uiARCBuffSize, char *pszAuthCode,
        unsigned short uiAuthCode, char *pszIssueScript,
        unsigned short *uiScriptBuffSize);


typedef void(*Fn_Kernel_FinacialTransactionRequest)(const char *pszOnlineEncipherPIN,
                                                    unsigned char *pOnlineResult, char *pszIssueAuthData,
                                                    unsigned short uiIssueAuthDataBuffSize, char *pszARC,
                                                    unsigned short uiARCBuffSize, char *pszIssuerAuthCode,
                                                    unsigned short uiIssuerAuthCode, char *pszIssueScript,
                                                    unsigned short uiScriptBuffSize);

typedef unsigned char(*Fn_Kernel_SecondTapCard)();


struct KERNEL_CALLBACK_FUNCS {
    Fn_Kernel_Log_Print m_Log_Print;//ӡ־
    Fn_Kernel_GetCurrentTime m_GetCurrentTime;//ȡնʱ
    Fn_Kernel_GetRandomData m_GenerateRandomData;//ȡ

    Fn_Kernel_DetectBreak m_DetectBreak;//࿨ . жϵǰǷִзǽӿ
    Fn_Kernel_ExchangeApdu m_ExchangeApdu;// APDU ͨѶ
    Fn_Kernel_SelectApplication m_SelectApplication; //ѡӦ
    Fn_Kernel_CardHolderConfirm m_CardHolderConfirm;//ȷ
    Fn_Kernel_TryOtherApplication m_TryOtherApplication;//Ӧ

    Fn_Kernel_EnterAmount m_EnterAmount; //
    Fn_Kernel_GetPlainTextPin m_GetPlainTextPin; //ı ,ѻPINʹ
    Fn_Kernel_GetOnlinePin m_GetOnlinePin; // PIN
    Fn_Kernel_Display_Pin_Verify_Status m_Display_Pin_Verify_Status;//ȡѻ״̬
    Fn_Kernel_Display_Trans_Report m_Display_Trans_Report;//׽
    Fn_Kernel_AskRemoveCard m_AskRemoveCard;// ƿ

    Fn_Kernel_AuthorisationRequest m_AuthorisationRequest;//
    Fn_Kernel_FinacialTransactionRequest m_FinacialTransactionRequest;//ѻݴ
    Fn_Kernel_SecondTapCard m_SecondTapCard;//Ŀ. ű.
};
typedef const struct KERNEL_CALLBACK_FUNCS *LPC_KERNEL_CALLBACK_FUNCS;
typedef struct KERNEL_CALLBACK_FUNCS *LP_KERNEL_CALLBACK_FUNCS;



/****************************************appõķ,ò**************************************************/


// ն˲ 0ʾɹ
int EMV_SetTerminalInfo_App(LPC_EMV_TERMINAL_INFO pTerminalInfo);

// òؽײ
int EMV_SetKernelConfig_App(LPC_EMV_KERNEL_CONFIG pKernelConfig);

// qpbocؽײ
int QPBOC_Parameter_App(LP_QPBOC_PARAM qpbocParameter);

// aid
int EMV_AidList_Add_App(LPC_EMV_AID_ITEM pItem);

// ӹԿ
int EMV_CapkList_Add_App(LPC_EMV_CAPK_ITEM pItem);

// ӹԿ ҪУchecksum
int EMV_CapkList_Add_NoCheck_App(LPC_EMV_CAPK_ITEM pItem);

// ӹܹԿ
int EMV_SMCapkList_Add_App(LP_EMV_SM_CAPK_ITEM pItem);

// ɾԿ
int EMV_CapkList_DeleteEx_App(LPC_EMV_BYTE pRID, EMV_BYTE bIndex);

// ɾܹԿ
int EMV_SMCapkList_DeleteEx_App(LPC_EMV_BYTE pRID, EMV_BYTE bIndex);

// ӻչԿ
int EMV_RevoIPKList_Add_App(LPC_EMV_REVO_IPK_ITEM pItem);

// Ӻ
int EMV_ExceptList_Add_App(LPC_EMV_EXCEPT_ITEM pItem);

// aidб
int EMV_AidList_Clear_App(void);

// չԿб
int EMV_CapkList_Clear_App(void);

// չܹԿ
int EMV_SMCapkList_Clear_App(void);

// ջչԿ
int EMV_RevoIPKList_Clear_App(void);

// պ
int EMV_ExceptList_Clear_App(void);


/****************************************appõķ,***************************************************/


/**
* ʼ
*/
unsigned int Contactless_init_EntryKernel(LPC_KERNEL_CALLBACK_FUNCS pCallbackFuncs);

/**
* 
*/
unsigned int Contactless_Start_Kernel(unsigned int uiTarnsCounter,
                                      unsigned char TransType, unsigned int Amount, unsigned int AmountOther);

/**
* ׽
*/
unsigned int Contactless_Clean_Kernel(void);

/**
* ׹  δŹ
*/
unsigned int Contactless_Customized_Kernel(void *buffer);

/**
* ȡں˰汾 
*/
unsigned int Contactless_Version_Kernel(char *pBuffer, int uiBufferSize);


//׹̻ȡ ƬTAG 
unsigned int Contactless_GetTransData(unsigned int Tag, unsigned char *pValue,
                                      unsigned short *puiValue);

unsigned int Contactless_GetTransDataAsHex(unsigned int Tag, char *pszValue,
                                           unsigned short uiBuffSize);


// PPSE + Select 
unsigned int Contactless_SelectWithoutGPO(unsigned char bPPSE);

//ִи÷Ҫ ȵ Contactless_SelectWithoutGPO ڵ.
unsigned int Contactless_ReadCardLog(unsigned char count, unsigned char *szTempRecord, unsigned char *uiTempRecord);

// getData APDU ָȡ.
unsigned int Contactless_GetDataFromICC(unsigned int Tag, unsigned char *pValue,
                                        unsigned short *puiValue);

//ִи÷Ҫ ȵ Contactless_SelectWithoutGPO ڵ.
unsigned int Contactless_GetPAN(char *pszBuff,int uiSize);

/***********************************************************************************************************/


#endif


