#ifndef EMV_CAPK_LIST_H_
#define EMV_CAPK_LIST_H_

#include "EMVTransHandle.h"

#define MAX_CAPK_LIST   50
#define MAX_SMCAPK_LIST 10

struct EMV_CAPK_ITEM {
	// 290
	EMV_BYTE m_RID[SIZE_RID];
	EMV_BYTE m_CapkIndex;
	EMV_UINT16 m_uiModules;
	EMV_BYTE m_Modules[MAX_RSA_KEY_SIZE];
	EMV_UINT16 m_uiExponents;
	EMV_BYTE m_Exponents[MAX_RSA_EXPONENTS_SIZE];
	EMV_BYTE m_Checksum[20];
};

typedef struct EMV_CAPK_ITEM * LP_EMV_CAPK_ITEM;
typedef const struct EMV_CAPK_ITEM * LPC_EMV_CAPK_ITEM;


// ܹԿ
typedef struct SM_CAPK__ITEM {
	// 70
	EMV_BYTE m_RID[SIZE_RID];
	EMV_BYTE m_CapkIndex;
	EMV_BYTE m_Modules[64];
}SM_CAPK;

typedef struct SM_CAPK__ITEM * LP_EMV_SM_CAPK_ITEM;


// ȡԿ
EMV_UINT32 EMV_CapkList_GetCount(LP_EMV_TRANS_HANDLE pTransHandle);
// ȡԿ
EMV_UINT32 EMV_CapkList_GetItem(LP_EMV_TRANS_HANDLE pTransHandle,
		EMV_UINT32 uiIndex, LP_EMV_CAPK_ITEM pItem);
// ȡԿ		
EMV_UINT32 EMV_CapkList_GetItemEx(LP_EMV_TRANS_HANDLE pTransHandle,
		LPC_EMV_BYTE pRID, EMV_BYTE Index, LP_EMV_CAPK_ITEM pItem);
// ӹԿ		
EMV_UINT32 EMV_CapkList_Add(LP_EMV_TRANS_HANDLE pTransHandle,
		LPC_EMV_CAPK_ITEM pItem);

EMV_UINT32 EMV_SMCapkList_Add(LP_EMV_TRANS_HANDLE pTransHandle,
		LP_EMV_SM_CAPK_ITEM pItem);

EMV_UINT32 EMV_CapkList_Add_NO_Check(LP_EMV_TRANS_HANDLE pTransHandle,
		LPC_EMV_CAPK_ITEM pItem);

// ɾԿ		
EMV_UINT32 EMV_CapkList_Delete(LP_EMV_TRANS_HANDLE pTransHandle,
		EMV_UINT32 uiIndex);
// Կб
EMV_UINT32 EMV_CapkList_Clear(LP_EMV_TRANS_HANDLE pTransHandle);
// ȡԿ
EMV_UINT32 EMV_CapkList_DeleteEx(LP_EMV_TRANS_HANDLE pTransHandle,
		LPC_EMV_BYTE pRID, EMV_BYTE bIndex);
// 
EMV_BOOL EMV_Capk_CheckChecksum(LPC_EMV_CAPK_ITEM pCapk);

// ѰҹܹԿ	

LP_EMV_SM_CAPK_ITEM EMV_SMCapkList_Find(LPC_EMV_BYTE pRID, EMV_BYTE Index);


// ȡܹԿ		
EMV_UINT32 EMV_SMCapkList_GetItemEx(LP_EMV_TRANS_HANDLE pTransHandle,
			LPC_EMV_BYTE pRID, EMV_BYTE Index, LP_EMV_SM_CAPK_ITEM pItem);

EMV_UINT32 EMV_SMCapkList_Delete(LP_EMV_TRANS_HANDLE pTransHandle,
	EMV_UINT32 uiIndex);

EMV_UINT32 EMV_SMCapkList_DeleteEx(LP_EMV_TRANS_HANDLE pTransHandle,
	LPC_EMV_BYTE pRID, EMV_BYTE bIndex);

EMV_UINT32 EMV_SMCapkList_Clear(LP_EMV_TRANS_HANDLE pTransHandle);
#endif

