#ifndef EMV_DATA_SIZE_H_
#define EMV_DATA_SIZE_H_

#define MAX_SCRIPT_LENGTH 128
#define MAX_DATA_SIZE 255
#define MAX_PAN 19
#define MAX_APPS 100
#define MAX_RSA_KEY_SIZE 256
#define MAX_RSA_EXPONENTS_SIZE 3
#define MAX_AID 16
#define MAX_APP_LABEL 16
#define MAX_DRL 16

#define SIZE_CVM_RESULT 3
#define SIZE_CVM_AMOUNT_X 4
#define SIZE_CVM_AMOUNT_Y 4
#define SIZE_RESPONSE_CODE 2
#define SIZE_APP_CRYPTOGRAM 8
#define SIZE_AC 2
#define SIZE_ISSUER_AUTH_DATA 50
#define SIZE_APP_VERSION 2
#define SIZE_APP_PRIORITY 1
#define SIZE_TVR 5
#define SIZE_TSI 2
#define SIZE_AMOUNT 6
#define SIZE_AMOUNT_BINARY 4
#define SIZE_PAN_SEQUENCE_NUM 1
#define SIZE_RID 5
#define SIZE_CAPK_INDEX 1
#define SIZE_PIN_BLOCK 8
#define SIZE_TERMINAL_ID 8
#define SIZE_TERMINAA_ACQUIRE_ID 6
#define SIZE_MERCHANT_ID 15
#define SIZE_MERCHANT_CATEGORY_CODE 2
#define SIZE_MERCHANT_LOCATION 255
#define SIZE_TRANS_CURRENCY_CODE 2
#define SIZE_IFD_SERIAL_NUMBER 8
#define SIZE_COUNTRY_CODE 2
#define SIZE_TERMINAL_TYPE 1
#define SIZE_TERMINAL_CAPABILITIES 3
#define SIZE_ADDTIONAL_TERMINAL_CAPABILITIES 5
#define SIZE_TERMINAL_ENTRY_MODE 1
#define SIZE_ACTION_CODE SIZE_TVR
#define SIZE_APP_PROGRAM_ID 16
#define SIZE_TTQ 4
#define SIZE_CTQ 2
#define SIZE_CARD 16
#define SIZE_LOG_ENTRY 2

#endif
