#ifndef _EMV_SHA1_H 
#define _EMV_SHA1_H 
#include "EmvDataType.h"

#if !defined(EMV_SHA1)
#define EMV_SHA1
typedef struct {
	unsigned long Total[2];
	unsigned long State[5];
	unsigned char Buffer[64];
} SHA1_CONTEXT;
typedef SHA1_CONTEXT * LP_SHA1_CONTEXT;
#endif

#ifdef __cplusplus
extern "C" {
#endif

EMV_VOID EMV_SHA1_Init(LP_SHA1_CONTEXT ctx);
EMV_VOID EMV_SHA1_Update(LP_SHA1_CONTEXT ctx, LPC_EMV_BYTE pData,
		EMV_UINT32 ulLength);
EMV_VOID EMV_SHA1_Fina(LP_SHA1_CONTEXT ctx, EMV_BYTE digest[20]);

#ifdef __cplusplus
}
#endif

#endif 
