#ifndef KERNEL_PARAM_H_
#define KERNEL_PARAM_H_
#include "EmvKernel.h"
#include "EmvDataType.h"
#include "EmvDataSize.h"
#include "qvsdc.h"

#include "EmvRevocationIPKList.h"
#include "EmvExceptionFileList.h"
#include "EmvTransHandle.h"
#include "EmvCapkList.h"
#include "EmvAidList.h"


struct CAPK {// Կ
	EMV_CHAR m_pRID[20];
	EMV_CHAR m_pCapkIndex[5];
	EMV_CHAR m_pModules[MAX_RSA_KEY_SIZE * 2];
	EMV_CHAR m_pExponents[6 * 2];
	EMV_CHAR m_pChecksum[20 * 2];
};

struct REVOCATION_IPK {// չԿ
	EMV_CHAR m_pRID[17];
	EMV_CHAR m_pCapkIndex[4];
	EMV_CHAR m_pSerialNo[5];
};

struct EXCEPTION_FILE {
	EMV_CHAR m_pPan[20];
	EMV_CHAR m_pSerialNo[5];
};

struct START_KERNEL {// 
	unsigned int pAmount;
	unsigned int pAmountOther;
	unsigned int pTarnsCounter;
	unsigned char pRandom[16];
};



extern struct EMV_TERMINAL_INFO __TERMINAL_INFO;
extern struct EMV_KERNEL_CONFIG __KERNEL_CONFIG;
extern EMV_UINT32 __TRANSACTION_COUNTER;
extern struct QVSDC_PARAMETER __QVSDC_PARAMETER;
extern struct QPBOC_PARAMETER __QPBOC_PARAMETER;
extern EMV_BOOL __EC_STATUS;
extern EMV_BOOL __IS_LOG;
extern EMV_BYTE __TRANS_TYPE;
extern LPC_EMV_CHAR __TERMINAL_ACQUIRE_ID;
extern struct START_KERNEL __KERNEL_START;


//others
#define		TRANSACTION_TYPE_SALE					0x00 // 
#define		TRANSACTION_TYPE_REFUND					0x20 // ˻
#define		TRANSACTION_TYPE_CASH					0x01 // ֽ
#define		TRANSACTION_TYPE_CASHBACK				0x09 // 
#define		TRANSACTION_TYPE_CASH_DISBURSEMENT		0x17//

// qpboc 
#define		TRANSACTION_TYPE_CASH1					0x30
#define		TRANSACTION_TYPE_CASHBACK1				0x31
#define		TRANSACTION_TYPE_GOODS					0x32
#define		TRANSACTION_TYPE_SERVICE			    0x33
#define		TRANSACTION_TYPE_INQUIRY				0x34
#define		TRANSACTION_TYPE_TRANSFER				0x35
#define		TRANSACTION_TYPE_PAYMENT				0x36
#define		TRANSACTION_TYPE_ADMIN					0x37
#define		TRANSACTION_TYPE_DEPOSIT		        0x38


//---------------------------  ׿ʼ
#define TAG_TRANS_TYPE                0x9C
#define TAG_TRANS_AMT                 0x9F02
#define TAG_TRANS_CASH                0x9F03
#define TAG_TRANS_DATE                0x9A
#define TAG_TRANS_TIME                0x9F21
#define TAG_TRANS_LOG                 0x9F70
#define TAG_TRANS_RANDOM              0x9F71
#define TAG_TRANS_TARNS_COUNTER       0x9F72

//---------------------------

//--------------------------- ն˲
#define TAG_TERMINAL_ID_JAVA              0x9F01
#define TAG_TERMINAL_COUNTRY_CODE_JAVA       0x9F02
#define TAG_TERMINAL_ENTRY_MODE         0x9F03
#define TAG_MERCHANT_MERCHANT_ID      	0x9F04
#define TAG_MERCHANT_CATEGORY_CODE_JAVA      0x9F05
#define TAG_MERCHANT_LOCATION           0x9F06
#define TAG_TRANS_CURRENCY_CODE         0x9F07
#define TAG_TRANS_CURRENCY_EXP          0x9F08
#define TAG_TRANS_REF_CURRENCY_CODE     0x9F09
#define TAG_TRANS_REF_CURRENCY_EXP      0x9F10
//---------------------------

//--------------------------- ں˲
#define TAG_CONFIG                      				0x9F01
#define TAG_CONFIG_CODE_METHOD       					0x9F02
#define TAG_CONFIG_CDA_METHOD         					0x9F03
#define TAG_CONFIG_TERMINAL_TYPE      					0x9F04
#define TAG_CONFIG_TERMINAL_CAPABILITIES      			0x9F05
#define TAG_CONFIG_ADDTIONAL_TERMINAL_CAPABILITIES      0x9F06
//---------------------------

//--------------------------- QVSDC
#define TAG_QVSDC                 0x9F01
#define TAG_QVSDC_RISK_DEFAULT    0x9F02
#define TAG_QVSDC_RISK_CASH       0x9F03
#define TAG_QVSDC_RISK_CASHBACK   0x9F04
#define TAG_QVSDC_RISK_PURCHASE   0x9F05

//--------------------------- QPBOC
#define TAG_QPBOC                 0x9F01
#define TAG_QPBOC_RISK_DEFAULT    0x9F02

//--------------------------- QVSDC_RISK
#define TAG_QVSDC_RISK                       0x9F01
#define TAG_QVSDC_RISK_CONTACTLESSTRANSLIMIT 0x9F02
#define TAG_QVSDC_RISK_CONTACTLESSCVMLIMIT   0x9F03
#define TAG_QVSDC_RISK_CONTACTLESSFLOORLIMIT 0x9F04
#define TAG_QVSDC_RISK_FLOORLIMIT            0x9F05
//---------------------------

//---------------------------

//--------------------------- AID
#define TAG_AID_AID                       0x9F01
#define TAG_AID_APP_VER                   0x9F02
#define TAG_AID_PART_MACH                 0x9F03
#define TAG_AID_DEFAULT_DDOL              0x9F04
#define TAG_AID_DEFAULT_TDOL              0x9F16
#define TAG_AID_TAC_DENIAL                0x9F05
#define TAG_AID_TAC_ONLINE                0x9F06
#define TAG_AID_TAC_DEFAULT               0x9F07
#define TAG_AID_TERMINALFLOORLIMIT        0x9F08
#define TAG_AID_TRESHOLDVALUE             0x9F09
#define TAG_AID_TARGETPERCENTAGE          0x9F10
#define TAG_AID_MAXTARGETPERCENTAGE       0x9F11
#define TAG_AID_EC_TRANS_LIMIT            0x9F12
#define TAG_AID_CONTACTLESSMAXTRANSAMOUNT 0x9F13
#define TAG_AID_CONTACTLESSFLOORLIMIT     0x9F14
#define TAG_AID_CONTACTLESSCVMAMOUNT      0x9F15

//---------------------------

//--------------------------- Capk
#define TAG_CAPK_RID                      0x9F01
#define TAG_CAPK_CAPK_INDEX               0x9F02
#define TAG_CAPK_MODULES                  0x9F03
#define TAG_CAPK_EXPONENTS                0x9F04
#define TAG_CAPK_CHECKSUM                 0x9F05
//---------------------------

//--------------------------- RevocationIPK
#define TAG_REVOCATIONIPK_RID             0x9F01
#define TAG_REVOCATIONIPK_CAPK_INDEX      0x9F02
#define TAG_REVOCATIONIPK_SERIAL_NO       0x9F03
//---------------------------

//--------------------------- ExceptionFile
#define TAG_EXCEPTIONFILE_PAN             0x9F01
#define TAG_EXCEPTIONFILE_SERIAL_NO       0x9F02
//---------------------------

//--------------------------- ǰ׿Ƭ
#define TAG_INSERTED_ICCARD     0x80
#define TAG_SWIPED_MAGCARD      0x81
#define TAG_INSERTED_PICC       0x82


//---------------------------

#ifdef __cplusplus
extern "C" {
#endif

/**
* ں Ԥ Ƿʹ AID жĲ
*/
unsigned int Contactless_Set_KernelApplyAid(int parameter);

void Kernel_Set_Trans_Param(EMV_INT32 uiTarnsCounter,
	EMV_UINT8 TransType, EMV_UINT32 Amount, EMV_UINT32 AmountOther);

// ն˲
int EMV_SetTerminalInfo_App(LPC_EMV_TERMINAL_INFO pTerminalInfo);

// òؽײ
int EMV_SetKernelConfig_App(LPC_EMV_KERNEL_CONFIG pKernelConfig);

// qpbocؽײ
int QPBOC_Parameter_App(LP_QPBOC_PARAM qpbocParameter);

// aid
int EMV_AidList_Add_App(LPC_EMV_AID_ITEM pItem);

// ӹԿ
int EMV_CapkList_Add_App(LPC_EMV_CAPK_ITEM pItem);

// ӹԿ ҪУchecksum
int EMV_CapkList_Add_NoCheck_App(LPC_EMV_CAPK_ITEM pItem);

// ӹܹԿ
int EMV_SMCapkList_Add_App(LP_EMV_SM_CAPK_ITEM pItem);

// ɾԿ
int EMV_CapkList_DeleteEx_App(LPC_EMV_BYTE pRID, EMV_BYTE bIndex);

// ɾܹԿ
int EMV_SMCapkList_DeleteEx_App(LPC_EMV_BYTE pRID, EMV_BYTE bIndex);

// ӻչԿ
int EMV_RevoIPKList_Add_App(LPC_EMV_REVO_IPK_ITEM pItem);

// Ӻ
int EMV_ExceptList_Add_App(LPC_EMV_EXCEPT_ITEM pItem);

// aidб
int EMV_AidList_Clear_App(void);

// չԿб
int EMV_CapkList_Clear_App(void);

// չܹԿ
int EMV_SMCapkList_Clear_App(void);

// ջչԿ
int EMV_RevoIPKList_Clear_App(void);

// ɾչԿ
int EMV_RevoIPKList_DeleteEx_App(LPC_EMV_REVO_IPK_ITEM pItem);

// ɾ
int EMV_ExceptList_DeleteEx_App(LPC_EMV_BYTE pPAN, EMV_UINT16 uiPAN, EMV_BYTE bSeq);

// б
int EMV_ExceptList_Clear_App(void);



#endif
