#ifndef Z_POS_PROTOCOL_H
#define Z_POS_PROTOCOL_H

#define Z_POS_STX 0x2
#define Z_POS_ETX 0x3
#define Z_POS_SUCCESS 0x0
#define Z_POS_FAIL 0x1

#define Z_POS_RESULT_SIZE 6
#define Z_POS_MERCHANT_SIZE 40
#define Z_POS_RANDOM_SIZE 12
#define Z_POS_KCV_SIZE 20
#define Z_POS_KEY_SIZE 2048

typedef struct
{
	int kcvSize;
	char kcv[Z_POS_KCV_SIZE];
	int merchantSize;
	char merchant[Z_POS_MERCHANT_SIZE];
	int keySize;
	char key[Z_POS_KEY_SIZE];
}Z_POS_CTX;

int zPosMarshalSnAndRandom(const char*serialNumber, int serialNumberSize, const char*random, char**result, int*resultSize);

int zPosUnmarshalKey(const char*value, int valueSize, Z_POS_CTX*ctx);

const char* zPosResponse(int ok);

#endif
