#include "MercurySystem.h"
#include "bwsdk.h"

#include "Pos_global.h"
#include "Emv_Aid.h"
#include "Kernel_Param.h"

struct EMV_AID_ITEM _AID_LIST[MAX_AID_LIST];

struct EMV_REVO_IPK_ITEM _IPK_LIST[MAX_IPK_LIST];

struct EMV_EXCEPT_ITEM _EXT_LIST[MAX_EXCEPTION_LIST];

int _AID_LIST_COUNT;

int _IPK_LIST_COUNT;

int _EXT_LIST_COUNT;


int EMV_AIDList_Clear(void)
{
    EMV_UINT32 uiRetval = EMV_OK;
    _AID_LIST_COUNT = 0;
    memset(_AID_LIST, 0x00, sizeof(_AID_LIST));
    return uiRetval;
}
int EMV_IPKList_Clear(void)
{
    EMV_UINT32 uiRetval = EMV_OK;
    _IPK_LIST_COUNT = 0;
    memset(_IPK_LIST, 0x00, sizeof(_IPK_LIST));
    return uiRetval;
}
int EMV_EXTList_Clear(void)
{
    EMV_UINT32 uiRetval = EMV_OK;
    _EXT_LIST_COUNT = 0;
    memset(_EXT_LIST, 0x00, sizeof(_EXT_LIST));
    return uiRetval;
}



int EMV_AIDList_Add(LPC_EMV_AID_ITEM pItem)
{
    int uiRetval = EMV_OK;

    LPC_EMV_AID_ITEM pAid = NULL;

    if (_AID_LIST_COUNT == MAX_AID_LIST)
    {
        uiRetval = EMV_MEMORY_NOT_ENOUGH;
    }
    else
    {
        pAid = &_AID_LIST[_AID_LIST_COUNT++];
    }

    if (NULL != pAid)
    {
        memcpy(pAid, pItem, sizeof(struct EMV_AID_ITEM));
    }


    return uiRetval;
}

int EMV_IPKList_Add(LPC_EMV_REVO_IPK_ITEM pItem)
{
    int uiRetval = EMV_OK;

    LPC_EMV_REVO_IPK_ITEM pIpk = NULL;

    if (_IPK_LIST_COUNT == MAX_IPK_LIST)
    {
        uiRetval = EMV_MEMORY_NOT_ENOUGH;
    }
    else
    {
        pIpk = &_IPK_LIST[_IPK_LIST_COUNT++];
    }

    if (NULL != pIpk)
    {
        memcpy(pIpk, pItem, sizeof(struct EMV_REVO_IPK_ITEM));
    }


    return uiRetval;
}

int EMV_EXTList_Add(LPC_EMV_EXCEPT_ITEM pItem)
{
    int uiRetval = EMV_OK;

    LPC_EMV_EXCEPT_ITEM pExt = NULL;

    if (_EXT_LIST_COUNT == MAX_EXCEPTION_LIST)
    {
        uiRetval = EMV_MEMORY_NOT_ENOUGH;
    }
    else
    {
        pExt = &_EXT_LIST[_EXT_LIST_COUNT++];
    }

    if (NULL != pExt)
    {
        memcpy(pExt, pItem, sizeof(struct EMV_EXCEPT_ITEM));
    }
    return uiRetval;
}



// ֵں,

int EMV_Aid_Load(void)
{
    char bRetval = EMV_TRUE;
    int i;

    if (_AID_LIST_COUNT != 0)
    {

        EMV_AidList_Clear_App();

        for (i = 0; i < sizeof(_AID_LIST) / sizeof(struct EMV_AID_ITEM); i++)
        {
            if (EMV_OK != EMV_AidList_Add_App(&_AID_LIST[i]))
            {
                bRetval = EMV_FALSE;
                break;
            }
        }

        EMV_AIDList_Clear();
    }

    return bRetval;
}

int EMV_Revocation_Load(void)
{
    char bRetval = EMV_TRUE;
    int i;

    if (_IPK_LIST_COUNT != 0)
    {

        EMV_RevoIPKList_Clear_App();

        for (i = 0; i < sizeof(_IPK_LIST) / sizeof(struct EMV_REVO_IPK_ITEM); i++)
        {
            if (EMV_OK != EMV_RevoIPKList_Add_App(&_IPK_LIST[i]))
            {
                bRetval = EMV_FALSE;
                break;
            }
        }

        EMV_IPKList_Clear();
    }

    return bRetval;
}

int EMV_Exception_Load(void)
{
    char bRetval = EMV_TRUE;
    int i;

    if (_EXT_LIST_COUNT != 0)
    {

        EMV_ExceptList_Clear_App();

        for (i = 0; i < sizeof(_EXT_LIST) / sizeof(struct EMV_EXCEPT_ITEM); i++)
        {
            if (EMV_OK != EMV_ExceptList_Add_App(&_EXT_LIST[i]))
            {
                bRetval = EMV_FALSE;
                break;
            }
        }

        EMV_EXTList_Clear();
    }

    return bRetval;
}


