#include "MercurySystem.h"
#include "bwsdk.h"

#include "Pos_global.h"
#include "Pos_Api.h"
#include "Pos_Base64.h"
#include "Pos_Param.h"

#include "EmvKernel.h"
#include "macropar.h"
#include "mmi_util.h"
#include "utilAPI.h"

#include "Scan_Tag.h"
#include "Emv_Tag.h"
#include "AppCallBack.h"

#include "Pos_Scan.h"
#include "cup_trace_package.h"
#include "global_fv.h"

#define DEBUG_OPEN  0

#define PARAM_FILE_NAME  "PARAM.dat"


// װ55
#define MAKE_TRANS_DATA_F55(Tag)	do { \
    uiTempData = sizeof(szRealTmpBuf); \
    memset(szRealTmpBuf, 0, sizeof(szRealTmpBuf)); \
if (EMV_OK == Contactless_GetTransDataAsHex(Tag, (char *)szRealTmpBuf, uiTempData)) \
    {	\
    icDataLen = TlvAppendAscii(Tag, (unsigned char*)szRealTmpBuf, 0, (unsigned char*)icDataBuf, icDataLen, strlen((char*)szRealTmpBuf)); \
    } \
} while (0)

#define MAKE_SEND_DATA(Tag,Value) \
{\
    sprintf(szSendBuff + uiSendBuff, "%s=%s&", \
    Tag, Value); \
    uiSendBuff += strlen(szSendBuff + uiSendBuff); \
    memset((char *)Value, 0, strlen((char *)Value)); \
}

#define MAKE_SEND_END_DATA(Tag,Value) \
{\
    sprintf(szSendBuff + uiSendBuff, "%s=%s", \
    Tag, Value); \
    uiSendBuff += strlen(szSendBuff + uiSendBuff); \
    memset((char *)Value, 0, strlen((char *)Value)); \
}

#define MAKE_NO_SEND_DATA(Tag,Value) \
{\
    sprintf(szSendBuff + uiSendBuff, "%s=%s&", \
    Tag, Value); \
    uiSendBuff += strlen(szSendBuff + uiSendBuff); \
}

#define MAKE_NO_SEND_END_DATA(Tag,Value) \
{\
    sprintf(szSendBuff + uiSendBuff, "%s=%s", \
    Tag, Value); \
    uiSendBuff += strlen(szSendBuff + uiSendBuff); \
}


int NFC_TAG_CardTransData(char * szOutBuff)
{
    char icHexDataBuf[512] =
    { 0 };
    unsigned int icHexDataLen = 512;
    char icDataBuf[512] =
    { 0 }; // ʱ洢ic
    unsigned int icDataLen = 0; // icݵĳ

    char szRealTmpBuf[64] =
    { 0 };
    unsigned short uiTempData; // ȡtagݵĳ

    MAKE_TRANS_DATA_F55(TAG_APP_CRYPTOGRAM); // 9f26
    MAKE_TRANS_DATA_F55(TAG_CID); // 9f27
    MAKE_TRANS_DATA_F55(TAG_ISSUER_APPLICATION_DATA); // 9f10
    MAKE_TRANS_DATA_F55(TAG_UNPREDICTABLE_NUMBER); // 9f37
    MAKE_TRANS_DATA_F55(TAG_ATC); // 9f36
    MAKE_TRANS_DATA_F55(TAG_TVR); // 95
    MAKE_TRANS_DATA_F55(TAG_TRANSACTION_DATE); // 9a
    MAKE_TRANS_DATA_F55(TAG_TRANSACTION_TYPE); // 9c
    MAKE_TRANS_DATA_F55(TAG_AMOUNT_AUTHORISED_N); // 9f02
    MAKE_TRANS_DATA_F55(TAG_TRANSACTION_CURRENCY_CODE); // 5f2a
    MAKE_TRANS_DATA_F55(TAG_AIP); // 82
    MAKE_TRANS_DATA_F55(TAG_TERMINAL_COUNTRY_CODE); // 9f1a
    MAKE_TRANS_DATA_F55(TAG_AMOUNT_OTHER_N); // 9f03
    MAKE_TRANS_DATA_F55(TAG_TERMINAL_CAPABILITIES); // 9f33
    MAKE_TRANS_DATA_F55(TAG_TERMINAL_TYPE); // 9f35

    memcpy(icDataBuf + icDataLen, "9F1E083230313233343536", strlen("9F1E083230313233343536"));
    icDataLen += strlen("9F1E083230313233343536");
    //  MAKE_TRANS_DATA_F55(TAG_IFD_SERIAL_NUMBER); // 9f1e
    MAKE_TRANS_DATA_F55(TAG_DF_NAME);// 84
    MAKE_TRANS_DATA_F55(TAG_APP_VERSION_NUMBER_TERMINAL); // 9f09
    MAKE_TRANS_DATA_F55(TAG_TRANSACTION_SEQUENCE_COUNTER); // 9f41
    //MAKE_TRANS_DATA_F55(TAG_PBOC_PRODUCT_INFO); // 9f63

    memcpy(icDataBuf + icDataLen, "9f63103030303130303030ff00000000000000",
            strlen("9f63103030303130303030ff00000000000000"));
    icDataLen += strlen("9f63103030303130303030ff00000000000000");

    icDataBuf[icDataLen] = '\0';

#if DEBUG_OPEN
    LOG("CardTransData [ %s ]  \n", icDataBuf);
#endif
    HexStringToBytes(icDataBuf, icDataLen, icHexDataBuf, &icHexDataLen);

    base64_encode((unsigned char *) szOutBuff, (unsigned char *) icHexDataBuf, icHexDataLen);
#if DEBUG_OPEN
    LOG("CardTransData BASE64 [ %s ] \n", szOutBuff);
#endif
    return EMV_TRUE;
}

int NFC_TAG_Track2Data(char * szOuntBuff)
{
    char szTrack2[56] = { 0 };
    unsigned short uiTrack2 = 56;
    char szTrackDelF2[56] = { 0 };
    char szBuff[256] = { 0 };
    char szSmBuff[256] = { 0 };
    int uiSmBuff = 0;

    if (EMV_OK == Contactless_GetTransDataAsHex(TAG_TRACK2_EQUIVALENT_DATA, (char *) szTrack2, uiTrack2))
    {
        //sprintf(szOuntBuff, "%s|%s|%s|%d|%s", TERMINAL_INFO.MERCHANT_ID, mScanTrans.Trans_Order, mScanTrans.Trans_Time, mScanTrans.Trans_Amt, szTrack2);
        uiTrack2 = strlen(szTrack2);
        if (szTrack2[uiTrack2 - 1] == 'f' || szTrack2[uiTrack2 - 1] == 'F') // f
        {
            memcpy(szTrackDelF2, szTrack2, uiTrack2 - 1);
            //  memcpy(szTrackDelF2, szTrack2, uiTrack2);
        }
        else
        {
            memcpy(szTrackDelF2, szTrack2, uiTrack2);
        }
		if(inputFlag){
	    	memcpy(DataSave3.elecBala.track2Info, szTrackDelF2, strlen(szTrackDelF2));
	    }
#if DEBUG_OPEN
        LOG("uamt  [%s] ", NormalTrans.uamt);
#endif

        sprintf(szBuff, "%s|%s|%s|%s|%s", TERMINAL_INFO.MERCHANT_ID, NormalTrans.Trans_Order, NormalTrans.Trans_Time,
                NormalTrans.uamt, szTrackDelF2);
#if DEBUG_OPEN
        LOG("NFC_TAG_Track2Data  [%s] ", szBuff);

        LOG("ݼ ԿX : %s  ԿY : %s", Txn_EncrypeCertPublicX, Txn_EncrypeCertPublicY);
#endif

        //
        uiSmBuff = sm2_encrypt(Txn_EncrypeCertPublicX, Txn_EncrypeCertPublicY, szBuff, strlen(szBuff),
                               (unsigned char *) szSmBuff);

        if (uiSmBuff < 0)
        {
            return EMV_FALSE;
        }
        memset(szBuff, 0, strlen(szBuff));
        memcpy(szBuff, "\x04", 0x01);
        memcpy(szBuff + 1, szSmBuff, uiSmBuff);
        base64_encode((unsigned char *) szOuntBuff, (unsigned char *) szBuff, uiSmBuff + 1);
#if DEBUG_OPEN
        LOG("NFC_TAG_Track2Data  [%s] ", szOuntBuff);
#endif

        return EMV_TRUE;
    }
    return EMV_FALSE;
}

int NFC_TAG_ICCardData(char * szOutBuff)
{
    char szSendBuff[1024] = { 0 };
    unsigned int uiSendBuff = 0;
    char szUrlSendBuff[1024] = { 0 };
    char szCardTransData[256] = { 0 };
    char szTrack2[512] = { 0 };
    char szPanSeq[10] = { 0 };
    unsigned int uiPanSeq = 10;

    NFC_TAG_CardTransData(szCardTransData);

    MAKE_SEND_DATA(PARMA_ICCARDDATA, szCardTransData);

    if (EMV_OK == Contactless_GetTransDataAsHex(TAG_PAN_SEQ, szPanSeq, uiPanSeq))
    {
        char cardExpDate[10] =
        { 0 };
        cardExpDate[0] = '0';
        memcpy(cardExpDate + 1, szPanSeq, uiPanSeq);
        MAKE_NO_SEND_DATA(PARMA_ICCARDSEQNUMBER, cardExpDate);
    }
    else
    {
        MAKE_NO_SEND_DATA(PARMA_ICCARDSEQNUMBER, "000");
    }
    MAKE_NO_SEND_DATA(PARMA_POSENTRYMODECODE, "07");

    MAKE_NO_SEND_DATA(PARMA_CARRIERAPPTP, "3"); //0ȱʡ 1:upcard 2:pboc 3:instcard
    MAKE_NO_SEND_DATA(PARMA_CARRIERTP, "5"); //5:mPOS 6: Apple Pay 11: pos
    MAKE_NO_SEND_DATA(PARMA_TRANSSENDMODE, "1");
    MAKE_NO_SEND_DATA(PARMA_TERMENTRYCAP, "6");

    NFC_TAG_Track2Data(szTrack2);
    MAKE_NO_SEND_END_DATA(PARMA_TRACK2DATA, szTrack2);
    sprintf(szUrlSendBuff, "{%s}", szSendBuff);
    URLEncode(szUrlSendBuff, szOutBuff);

    return EMV_TRUE;
}


void Kernel_Log_Printf(const char * pszMessage, int len)
{
    LOG(pszMessage);
}

void Kernel_GetRandomData(unsigned char* pRandBuff, int uiSize)
{
    //memcpy(pRandBuff, "\xa1\xa2\xa3\xa4", 4);
    OS_Generate_Rand(pRandBuff, uiSize);
}

void Kernel_GetCurrentTime(LP_EMV_TIME pCurrentTime)
{
    struct OS_TIME st;
    OS_GetCurrentTime(&st);
    pCurrentTime->m_Year = st.m_Year;
    pCurrentTime->m_Month = st.m_Month;
    pCurrentTime->m_Day = st.m_Day;
    pCurrentTime->m_Hour = st.m_Hour;
    pCurrentTime->m_Minute = st.m_Minute;
    pCurrentTime->m_Second = st.m_Second;
}

unsigned char Kernel_DetectBreak(void)
{
    return 0x00;
}

char Kernel_ExchangeApdu(const unsigned char *pApdu, unsigned short uiApdu, unsigned char *pResp,
                         unsigned short *puiResp)
{
    char bRetval = EMV_TRUE;
    int len = 0;
    unsigned char SW[2] = { 0 };

    if (*puiResp < 2)
        bRetval = EMV_FALSE;
    else
    {
        *puiResp -= 2;
        if (POS_OK == CL_ExchangeApdu(pApdu, uiApdu, pResp, puiResp, SW))
        {
            len = *puiResp;
            memcpy(pResp + len, SW, 2);
            len += 2;
            *puiResp = len;
        }
        else
        {
            bRetval = EMV_FALSE;
        }
    }
    return bRetval;
}

char Kernel_SelectApplication(char ** ppAppNames, char ** ppAppAids, int uiAppCount, int * puiSelected)
{
    char bRetval = EMV_TRUE;
    return bRetval;
}

char Kernel_CardHolderConfirm(const char * pAID, const char * pAppName, const char * pPreferAppName)
{
    char bRetval = EMV_TRUE;
    return bRetval;
}

char Kernel_TryOtherApplication(void)
{
    char bRetval = EMV_TRUE;
    return bRetval;
}

unsigned char Kernel_GetOnlinePin(unsigned char bAllowBypass,
                                  const char * pszPAN, char * pszPinBlock,
                                  unsigned short uiPinBlockBuffSize, unsigned char * pbBypass)
{
    unsigned char  bRetval = EMV_TRUE;
    *pbBypass = EMV_FALSE;
    return bRetval;
}

void Kernel_AskRemoveCard(void)
{
    //Ƭµ .
    CL_Close();
    OS_Beep("ɹ");
}

// ͨ57ȡźͿƬЧ
void getCardNoFor57(char *data57, unsigned char *cardNo, unsigned char *expData)
{
    char *card = NULL;
    int count = 0;
    card = strtok(data57, "D");
    while (card != NULL)
    {
        count++;
#if OPEN_DEBUG_EMV_CALLBACK
        LOGD("card:%s",card);
#endif
        if (count == 1)
            memcpy(cardNo, card, strlen(card));
        else if (count == 2)
            memcpy(expData, card, 4);
        card = strtok(NULL, "D");
    }
}

int EMV_NFC_TAG_Track2Data(void)
{
    char szTrack2[56] = { 0 };
    unsigned short uiTrack2 = 56;
    char szBuff[30] = { 0 };
    char szSmBuff[30] = { 0 };

    if (EMV_OK == Contactless_GetTransDataAsHex(TAG_TRACK2_EQUIVALENT_DATA, (char *) szTrack2, uiTrack2))
    {
        uiTrack2 = strlen(szTrack2);
        if (szTrack2[uiTrack2 - 1] == 'f' || szTrack2[uiTrack2 - 1] == 'F') // f
        {
            szTrack2[uiTrack2] = 0x00;
        }

        //ȡ
        memset(szBuff, 0, sizeof(szBuff));
        memset(szSmBuff, 0, sizeof(szSmBuff));
        getCardNoFor57((char *)szTrack2, szBuff, szSmBuff);
        memcpy(NormalTrans.Trans_CardNo, szBuff, strlen((char *)szBuff));
        if(inputFlag){
	    	memcpy(DataSave3.elecBala.cardValid, szSmBuff, strlen(szSmBuff));
	    }
        return EMV_TRUE;
    }
    return EMV_FALSE;
}

void Kernel_AuthorisationRequest(const char * pszOnlineEncipherPIN, unsigned char * pOnlineResult,
                                 char * pszIssueAuthData, unsigned short uiIssueAuthDataBuffSize, char * pszAC, unsigned short uiACBuffSize,
                                 char * pszAuthCode, unsigned short uiAuthCode, char * pszIssueScript, unsigned short* uiScriptBuffSize)
{
    int ret;

    if (EMV_NFC_TAG_Track2Data() != EMV_TRUE)
    {
        *pOnlineResult = EMV_ONLINE_ERROR;    //
        emvState = ERROR;
        return;
    }
	if(!memberCardFlag){
	    if (DataSave2.runData.ucTransType == TRANS_TYPE_REVOKE
	        || DataSave2.runData.ucTransType == TRANS_TYPE_RETURN)
	    {
	        emvState = NORMAL;
	        *pOnlineResult = EMV_ONLINE_APPROVED;    // ׼
	        return;
	    }

	    ret = TRANS_NFC_SaleOnline();
	    if (ret == SUCCESS)
	    {
	    	if(inputFlag){
				memcpy(DataSave3.elecBala.returnCode, "00", strlen("00"));
			}
	        emvState = NORMAL;
	        *pOnlineResult = EMV_ONLINE_APPROVED;   // ׼
	        return;
	    }
		if(inputFlag && !strlen(DataSave3.elecBala.returnCode)){
			memcpy(DataSave3.elecBala.returnCode, "01", strlen("01"));
		}
	    *pOnlineResult = EMV_ONLINE_ERROR;
	    emvState = ERROR;
	}else{
		if(strlen(NormalTrans.Trans_CardNo) > 0){
			 emvState = NORMAL;
	        *pOnlineResult = EMV_ONLINE_APPROVED;   // ׼
	        return;
		}
		*pOnlineResult = EMV_ONLINE_ERROR;
	    emvState = ERROR;
	}
    return;
}

void Kernel_Display_Trans_Report(int uiErrorCode, char bSignatureNeeded)
{
    LOG("uiErrorCode() %d ", uiErrorCode);
    if (!strlen((char *)NormalTrans.ucErrorCode))
        BUFCLR(NormalTrans.ucErrorCode);

    switch (uiErrorCode)
    {
        case EMV_APPROVED_ONLINE:
            emvState = NORMAL;
            TRANSACTION_COUNTER++;
            break;
        case EMV_APPROVED_OFFLINE:
            break;
        case EMV_DECLINED_OFFLINE:
            emvState = ERROR;
            if (!strlen((char *)NormalTrans.ucErrorCode))
                memcpy(NormalTrans.ucErrorCode, "ʧ", strlen("ʧ"));
            break;
        case EMV_NO_ACCEPTED:
            emvState = ERROR;
            memcpy(NormalTrans.ucErrorCode, "δ", strlen("δ"));
            break;
        case EMV_TERMINATED:
            emvState = ERROR;
            memcpy(NormalTrans.ucErrorCode, "", strlen(""));
            break;
        case QPBOC_AMOUNT_BIG_THAN_CL_LIMIT:
            emvState = ERROR;
            memcpy(NormalTrans.ucErrorCode, "޶", strlen("޶"));
            break;
        case QPBOC_OTHER_INTERFACE:
            emvState = ERROR;
            memcpy(NormalTrans.ucErrorCode, "ֹ", strlen("ֹ"));
            break;
        case QPBOC_IN_EXCEPTION_FILE:
            emvState = ERROR;
            memcpy(NormalTrans.ucErrorCode, "", strlen(""));
            break;
        case QPBOC_CARD_EXPIRED:
            emvState = ERROR;
            memcpy(NormalTrans.ucErrorCode, "Ƭѹ", strlen("Ƭѹ"));
            break;
        case QPBOC_CANT_GO_ONLINE_DECLINE:
            emvState = ERROR;
            memcpy(NormalTrans.ucErrorCode, "޷,׾ܾ", strlen("޷,׾ܾ"));
            break;
        default:
            emvState = ERROR;
            if (!strlen((char *)NormalTrans.ucErrorCode))
                memcpy(NormalTrans.ucErrorCode, "ʧ", strlen("ʧ"));
            break;
    }
}

