#include "MercurySystem.h"
#include "bwsdk.h"

#include "Pos_global.h"
#include "Emv_Capk.h"
#include "Kernel_Param.h"

//#include <string.h>

int CAPK_LIST_COUNT = 0;
struct EMV_CAPK_ITEM _CAPK_LIST[MAX_LOAD_CAPK_LIST];

struct SM_CAPK__ITEM _SM_CAPK_LIST[MAX_LOAD_SMCAPK_LIST];
int SM_CAPK_LIST_COUNT = 0;

int EMV_Load_CapkList_Clear()
{
    int uiRetval = EMV_OK;
    CAPK_LIST_COUNT = 0;
    memset(_CAPK_LIST, 0x00, sizeof(_CAPK_LIST));
    return uiRetval;
}

int EMV_Load_SMCapkList_Clear()
{
    int uiRetval = EMV_OK;
    SM_CAPK_LIST_COUNT = 0;
    memset(_SM_CAPK_LIST, 0x00, sizeof(_SM_CAPK_LIST));
    return uiRetval;
}

int EMV_Load_CapkList_Add(LPC_EMV_CAPK_ITEM pItem)
{
    int uiRetval = EMV_OK;

    LP_EMV_CAPK_ITEM pCapk = NULL;

    if (CAPK_LIST_COUNT == MAX_LOAD_CAPK_LIST)
    {
        uiRetval = EMV_MEMORY_NOT_ENOUGH;
    }
    else
    {
        pCapk = &_CAPK_LIST[CAPK_LIST_COUNT++];
    }


    if (NULL != pCapk)
    {
        memcpy(pCapk, pItem, sizeof(struct EMV_CAPK_ITEM));
    }


    return uiRetval;
}

int EMV_Load_SMCapkList_Add(LP_EMV_SM_CAPK_ITEM pItem)
{

    int uiRetval = EMV_OK;
    int i;
    LP_EMV_SM_CAPK_ITEM smCapk = NULL;

    for (i = 0; i < SM_CAPK_LIST_COUNT; i++)
    {
        if ((0 == memcmp(_SM_CAPK_LIST[i].m_RID, pItem->m_RID, 5))
            && (_SM_CAPK_LIST[i].m_CapkIndex == pItem->m_CapkIndex))
        {
            smCapk = &_SM_CAPK_LIST[i];
            break;
        }
    }

    if (smCapk == NULL)  // ûҵӦĹԿ
    {
        if (SM_CAPK_LIST_COUNT == MAX_LOAD_SMCAPK_LIST)
        {
            uiRetval = EMV_MEMORY_NOT_ENOUGH;
        }
        else
        {
            smCapk = &_SM_CAPK_LIST[SM_CAPK_LIST_COUNT++];
        }
    }

    if (NULL != smCapk)
    {
        memcpy(smCapk, pItem, sizeof(SM_CAPK));
    }


    return uiRetval;
}

int EMV_Load_CAPKS(void)
{
    int bRetval = EMV_TRUE;
    int i;

    if (CAPK_LIST_COUNT != 0)
    {

        EMV_CapkList_Clear_App();

        for (i = 0; i < sizeof(_CAPK_LIST) / sizeof(struct EMV_CAPK_ITEM); i++)
        {
            if (EMV_OK != EMV_CapkList_Add_NoCheck_App(&_CAPK_LIST[i]))
            {
                bRetval = EMV_FALSE;
                break;
            }
        }


    }

    if (SM_CAPK_LIST_COUNT != 0)
    {

        EMV_SMCapkList_Clear_App();

        for (i = 0; i < sizeof(_SM_CAPK_LIST) / sizeof(struct SM_CAPK__ITEM); i++)
        {
            if (EMV_OK != EMV_SMCapkList_Add_App(&_SM_CAPK_LIST[i]))
            {
                bRetval = EMV_FALSE;
                break;
            }
        }
    }

    return bRetval;
}
