#include "MercurySystem.h"
#include "bwsdk.h"

#include "Pos_global.h"
#include "Emv_Trans.h"
#include "Emv_Aid.h"
#include "Emv_Capk.h"
#include "Pos_Api.h"
#include "Emv_CallBack.h"
#include "Kernel_Param.h"
#include "AppCallBack.h"

#include "mmi_util.h"

struct KERNEL_CALLBACK_FUNCS _CALLBACK_KERNEL;


unsigned int EMV_Trans_InitEntryKernel(void)
{

    memset((LP_EMV_BYTE)&_CALLBACK_KERNEL, 0, sizeof(_CALLBACK_KERNEL));

    _CALLBACK_KERNEL.m_Log_Print = (Fn_Kernel_Log_Print)Kernel_Log_Printf;
    //_CALLBACK_KERNEL.m_Log_Print  = NULL;
    _CALLBACK_KERNEL.m_GetCurrentTime = (Fn_Kernel_GetCurrentTime)Kernel_GetCurrentTime;
    _CALLBACK_KERNEL.m_GenerateRandomData = (Fn_Kernel_GetRandomData)Kernel_GetRandomData;
    _CALLBACK_KERNEL.m_ExchangeApdu = (Fn_Kernel_ExchangeApdu)Kernel_ExchangeApdu;
    _CALLBACK_KERNEL.m_SelectApplication = (Fn_Kernel_SelectApplication)Kernel_SelectApplication;
    _CALLBACK_KERNEL.m_DetectBreak = (Fn_Kernel_DetectBreak)Kernel_DetectBreak;
    _CALLBACK_KERNEL.m_CardHolderConfirm = (Fn_Kernel_CardHolderConfirm)Kernel_CardHolderConfirm;
    _CALLBACK_KERNEL.m_TryOtherApplication = (Fn_Kernel_TryOtherApplication)Kernel_TryOtherApplication;
    _CALLBACK_KERNEL.m_EnterAmount = NULL;
    _CALLBACK_KERNEL.m_GetPlainTextPin = NULL;
    _CALLBACK_KERNEL.m_GetOnlinePin = (Fn_Kernel_GetOnlinePin)Kernel_GetOnlinePin;
    _CALLBACK_KERNEL.m_Display_Pin_Verify_Status = NULL;
    _CALLBACK_KERNEL.m_Display_Trans_Report = (Fn_Kernel_Display_Trans_Report)Kernel_Display_Trans_Report;
    _CALLBACK_KERNEL.m_AskRemoveCard = (Fn_Kernel_AskRemoveCard)Kernel_AskRemoveCard;
    _CALLBACK_KERNEL.m_AuthorisationRequest = (Fn_Kernel_AuthorisationRequest)Kernel_AuthorisationRequest;
    _CALLBACK_KERNEL.m_FinacialTransactionRequest = NULL;

    return Contactless_init_EntryKernel(&_CALLBACK_KERNEL);
}

char EMV_Trans_InitParam(void)
{
    char bSuccess = EMV_TRUE;


    strcpy(EMV_TERMINAL_INFO.m_IFDSerialNumber, "90000001");

    if ((EMV_OK == QPBOC_Parameter_App(&QPBOC_PARAMETER)) &&
        (EMV_OK == EMV_SetKernelConfig_App(&KERNEL_CONFIG)) &&
        (EMV_OK == EMV_SetTerminalInfo_App(&EMV_TERMINAL_INFO)))
    {

    }
    else
    {
        bSuccess = EMV_FALSE;
        mmi_clearLine(255);
        mmi_display(ALIG_CENTER, ALIG_CENTER, "KERNELʼʧ");
        Keyboard_WaitKey(2, KEY_CANCEL, KEY_ENTER);
    }

    if (EMV_FALSE == EMV_Aid_Load())
    {
        bSuccess = EMV_FALSE;
        mmi_clearLine(255);
        mmi_display(ALIG_CENTER, ALIG_CENTER, "AIDװʧ");
        Keyboard_WaitKey(2, KEY_CANCEL, KEY_ENTER);
    }

    if (EMV_FALSE == EMV_Load_CAPKS())
    {
        bSuccess = EMV_FALSE;
        mmi_clearLine(255);
        mmi_display(ALIG_CENTER, ALIG_CENTER, "CAPKװʧ");
        Keyboard_WaitKey(2, KEY_CANCEL, KEY_ENTER);
    }

    if (EMV_FALSE == EMV_Revocation_Load())
    {
        bSuccess = EMV_FALSE;
        mmi_clearLine(255);
        mmi_display(ALIG_CENTER, ALIG_CENTER, "CAPKװʧ");
        Keyboard_WaitKey(2, KEY_CANCEL, KEY_ENTER);
    }

    if (EMV_FALSE == EMV_Exception_Load())
    {
        bSuccess = EMV_FALSE;
        mmi_clearLine(255);
        mmi_display(ALIG_CENTER, ALIG_CENTER, "װʧ");
        Keyboard_WaitKey(2, KEY_CANCEL, KEY_ENTER);
    }
    return bSuccess;
}


int EMV_Trans_Init(void)
{
    EMV_Trans_InitEntryKernel();

    if (EMV_FALSE == EMV_Trans_InitParam())
    {
        return EMV_FALSE;
    }
    return EMV_TRUE;
}

