/*============================================
* ļ洢
*
*============================================*/

#include "bwsdk_api.h"
#include "MercuryErrorValue.h"
#define POS_DATA
#include "Pos_Data.h"
#undef POS_DATA
#include "Pos_Data_Config.h"

#include "mmi_util.h"
#include "utilAPI.h"
#include "macropar.h"
#include "logger.h"

#ifdef TAG
#undef TAG
#endif
#define TAG "posData"



unsigned int BWFS_FilenameToPath(char *dest, const char* filename);
/*---------------------- ļ ----------------------
һűļԡļݴС
*/
typedef struct
{
    unsigned short  fileID;     //ݱID
    unsigned short  fileVar;    //ݱ汾
    unsigned int    fileSize;   //ݱС
} DATA_FILE_CONFIG;

int DATA_updateCfgFile(DATA_FILE_INFO *pFileInfo)
{
    int iRet = -1;
    int m_fd = -1;
    int m_size, m_offset;
    int m_index, m_maxIndex;
    DATA_FILE_CONFIG m_dbConfig;

    if ((m_maxIndex = FsSize(DATA_CFG_FILE)) < 0)
    {
        m_maxIndex = 0;
        if ((m_fd = FsOpen(DATA_CFG_FILE, O_CREATE)) < 0)
        {
            goto DO_END;
        }
    }
    else
    {
        if ((m_fd = FsOpen(DATA_CFG_FILE, O_RDWR)) < 0)
        {
            goto DO_END;
        }
    }

    m_size = sizeof(DATA_FILE_CONFIG);
    m_maxIndex /= m_size;
    m_offset = 0;
    for (m_index = 0; m_index < m_maxIndex; m_index++)
    {
        memset(&m_dbConfig, 0x00, sizeof(m_dbConfig));
        if (FsSeek(m_fd, m_offset, SEEK_SET) < 0)
        {
            goto DO_END;
        }

        if (FsRead(m_fd, &m_dbConfig, m_size) != m_size)
        {
            goto DO_END;
        }

        if (m_dbConfig.fileID == pFileInfo->fileID)
        {
            break;
        }
        m_offset += m_size;
    }

    memset(&m_dbConfig, 0, sizeof(m_dbConfig));
    m_dbConfig.fileID = pFileInfo->fileID;
    m_dbConfig.fileVar = pFileInfo->fileVar;
    m_dbConfig.fileSize = pFileInfo->fileSize;
    if (FsSeek(m_fd, m_offset, SEEK_SET) < 0)
    {
        goto DO_END;
    }

    if (FsWrite(m_fd, &m_dbConfig, m_size) == m_size)
    {
        iRet = 0;
    }

DO_END:
    if (m_fd >= 0)
    {
        FsClose(m_fd);
    }
    return iRet;
}

//ݱǷҪ(0-Ҫ,1-汾䶯ṹ䶯Ҫ£
int DATA_checkFileUpdate(DATA_FILE_INFO *pFileInfo, DATA_FILE_CONFIG *dbConfig)
{
    int iRet = -1;
    int m_fd = -1;
    int m_size, m_offset;
    int m_index, m_maxIndex;

    m_size = sizeof(DATA_FILE_CONFIG);
    memset(dbConfig, 0x00, m_size);

    if ((m_maxIndex = FsSize(DATA_CFG_FILE)) < 0)
    {
        goto DO_END;
    }

    if ((m_fd = FsOpen(DATA_CFG_FILE, O_RO)) < 0)
    {
        goto DO_END;
    }

    m_maxIndex /= m_size;
    m_offset = 0;
    for (m_index = 0; m_index < m_maxIndex; m_index++)
    {
        iRet = -1;
        memset(dbConfig, 0x00, m_size);
        if (FsSeek(m_fd, m_offset, SEEK_SET) < 0)
        {
            goto DO_END;
        }

        m_offset += m_size;
        if (FsRead(m_fd, (unsigned char *)dbConfig, m_size) == m_size)
        {
            iRet = 1;
            if (dbConfig->fileID == pFileInfo->fileID)
            {
                if (dbConfig->fileVar == pFileInfo->fileVar && dbConfig->fileSize == pFileInfo->fileSize)
                {
                    iRet = 0;
                }
                break;
            }
            continue;
        }
        break;
    }

    //ûҵdb_cfg
    if (m_index == m_maxIndex)
    {
        iRet = -1;
        memset(dbConfig, 0x00, m_size);
        dbConfig->fileID = pFileInfo->fileID;
        dbConfig->fileVar = pFileInfo->fileVar;
        dbConfig->fileSize = pFileInfo->fileSize;
        if (FsSeek(m_fd, m_offset, SEEK_SET) >= 0)
        {
            if (FsWrite(m_fd, dbConfig, m_size) == m_size)
            {
                iRet = 2;
            }
        }
    }

DO_END:
    if (m_fd >= 0)
    {
        FsClose(m_fd);
    }
    return iRet;
}

static int DATA_checkValidDirectory(const char *pathName)
{
    int iRet = 0;
    char unicodeName[256] = {0};

    memset(unicodeName, 0x00, sizeof(unicodeName));
    BWFS_FilenameToPath(unicodeName, pathName);

    iRet = CreateDirectory((LPCTSTR)unicodeName, (LPSECURITY_ATTRIBUTES)(MCFILE_OPERATE_MODE_READ|MCFILE_OPERATE_MODE_WRITE));
    if(iRet != 0)
    {
        switch(GetLastError())
        {
            case ERROR_FILE_HAS_EXIST:
                iRet = 0;
                break;
            default:
                iRet = -1;
                break;
        }
    }
    return iRet;
}

int xdata_getFileRecordCount(unsigned int fileIndex)
{
    switch(fileIndex)
    {
        case FileTrans:
            break;
        default:
            return -1;
    }
    return transDBGetMaxCount(fileInfo[fileIndex].fileName);
}

//¼
int DATA_insertRecordFile(unsigned int fileIndex)
{
    int iRet = FileErr_WriteFailed;
    int m_fd = -1;
    int ioffset = 0;

    switch(fileInfo[fileIndex].attr)
    {
        case DFA_RecordDB:
            if ((m_fd = transDBOpen(fileInfo[fileIndex].fileName)) < 0){
                break;
			}
			ioffset = DataSave.PosPar.ioffSet;
			LOGD("[%s:%d]ioffset:[%d]\n", __FUNCTION__, __LINE__, ioffset);
            if (!transDBUpdate(m_fd, ioffset, fileInfo[fileIndex].fileData, fileInfo[fileIndex].fileSize))
            {
                iRet = FileErr_Success;
            }
			DataSave.PosPar.ioffSet++;
		    if( DataSave.PosPar.ioffSet >= MAXTRANCENUM)
			{
				DataSave.PosPar.ioffSet = 0;
			}
			DATA_writeFile(FileCnstnt);
            transDBClose(m_fd);
            break;
        default:
            break;
    }
    return iRet;
}

//ļ
int DATA_createFile(unsigned int fileIndex)
{
    int iRet = FileErr_CreateFailed;
    int m_fd = -1;
    int m_i;

    memset(fileInfo[fileIndex].fileData, 0x00, fileInfo[fileIndex].fileSize);
    switch(fileInfo[fileIndex].attr)
    {
        case DFA_RecordDB:
            if (!transDBCreate(fileInfo[fileIndex].fileName, fileInfo[fileIndex].fileSize))
            {
                iRet = FileErr_Success;
            }
            break;
        default:
            //
            if ((m_fd = FsOpen(fileInfo[fileIndex].fileName, O_CREATE)) < 0)
            {
                return iRet;
            }

            //ȡĬֵ
            if (fileInfo[fileIndex].loadDefData)
            {
                fileInfo[fileIndex].loadDefData(fileIndex);
            }

            //дļ, ʧд3Σ3ʧܱ
            for (m_i = 0; m_i < 3; m_i++)
            {
                if (FsWrite(m_fd, fileInfo[fileIndex].fileData, fileInfo[fileIndex].fileSize) == fileInfo[fileIndex].fileSize)
                {
                    iRet = FileErr_Success;
                    break;
                }
                Sleep(50);
            }
            break;
    }

    if (m_fd >= 0)
    {
        FsClose(m_fd);
    }

    if (iRet == FileErr_Success)
    {
        DATA_updateCfgFile(&fileInfo[fileIndex]);
    }

    return iRet;
}

//ļ
int DATA_openFile(unsigned int fileIndex)
{
    switch(fileInfo[fileIndex].attr)
    {
        case DFA_RecordDB:
            return transDBOpen(fileInfo[fileIndex].fileName);
        default:
            return FsOpen(fileInfo[fileIndex].fileName, O_RDWR);
    }
}

//ļ
int DATA_eraseFile(unsigned int fileIndex)
{
    int iRet = FileErr_EraseFailed;

    FsRemove(fileInfo[fileIndex].fileName);
    if (DATA_createFile(fileIndex) == FileErr_Success)
        return iRet;
    return iRet;
}

//ļ
int DATA_readFile(unsigned int fileIndex)
{
    int iRet = FileErr_ReadFailed;
    int m_fd = -1;

    switch(fileInfo[fileIndex].attr)
    {
        case DFA_RecordDB:
            return iRet;
        default:
            if ((m_fd = FsOpen(fileInfo[fileIndex].fileName, O_RO)) < 0)
            {
                break;
            }

            if (FsSeek(m_fd, 0, SEEK_SET) < 0)
            {
                break;
            }

            if (FsRead(m_fd, fileInfo[fileIndex].fileData, fileInfo[fileIndex].fileSize) >= 0)
            {
                iRet = FileErr_Success;
            }
            break;
    }

    if (m_fd >= 0)
    {
        FsClose(m_fd);
    }
    return iRet;
}

//дļ
int DATA_writeFile(unsigned int fileIndex)
{
    int iRet = FileErr_WriteFailed;
    int m_fd = -1;

    switch(fileInfo[fileIndex].attr)
    {
        case DFA_RecordDB:
            return iRet;
        default:
            if ((m_fd = FsOpen(fileInfo[fileIndex].fileName, O_RDWR)) < 0)
            {
                break;
            }

            if (FsSeek(m_fd, 0, SEEK_SET) < 0)
            {
                break;
            }

            if (FsWrite(m_fd, fileInfo[fileIndex].fileData, fileInfo[fileIndex].fileSize) >= 0)
            {
                iRet = FileErr_Success;
            }
            break;
    }

    if (m_fd >= 0)
    {
        FsClose(m_fd);
    }
    return iRet;
}

//ļṹ
static int DATA_updateFileStruct(unsigned int fileIndex)
{
    int iRet = FileErr_UpdateFailed;

    FsRemove(fileInfo[fileIndex].fileName);
    if (DATA_createFile(fileIndex) == FileErr_Success)
        return iRet;
    return iRet;
}

//ļЧ
static int DATA_checkValidFile(unsigned int fileIndex)
{
    int iRet;
    int m_fileSize;
    DATA_FILE_CONFIG m_dbConfig;

    m_fileSize = FsSize(fileInfo[fileIndex].fileName);

    //û򴴽
    if (m_fileSize < 0)
    {
        return DATA_createFile(fileIndex);
    }

    //ݱǷи
    switch(DATA_checkFileUpdate(&fileInfo[fileIndex], &m_dbConfig))
    {
        case 0: //,ȡ
            mmi_clearLine(255);
            mmi_display(ALIG_CENTER, ALIG_CENTER, ",Ժ...");
            iRet = DATA_readFile(fileIndex);
            break;
        case 1: //Ҫݱ
            mmi_clearLine(255);
            mmi_display(ALIG_CENTER, ALIG_CENTER, "ݿ,Ժ...");
            iRet = DATA_updateFileStruct(fileIndex);
            break;
        default:
            iRet = -1;
            break;
    }
    mmi_clearLine(255);
    mmi_display(ALIG_CENTER, ALIG_CENTER, "Ժ...");
    return iRet;
}

int DATA_checkAllValidFiles(void)
{
    int iRet = -1;
    int m_i;

    //Ŀ¼(ûĿ¼Զ)
    DATA_checkValidDirectory(DATA_PATH);

    for (m_i = 0; m_i < FileMaxIndex; m_i++)
    {
        iRet = DATA_checkValidFile(m_i);
        Sleep(100);
    }
    Sleep(1000);
    return iRet;
}
