#include "MercurySystem.h"
#include "bwsdk.h"
#include "Pos_global.h"

#include "Pos_Api.h"
#include "Pos_Scan.h"
#include "Pos_Storage.h"
#include "Pos_Param.h"

#include "Scan_Tag.h"

#include "Pos_Base64.h"
#include "Pos_Util.h"

#include "Pos_x509crt.h"
#include "macropar.h"
#include "Pos_Data.h"
#include "cJSON.h"
#include "dzcUtils.h"
#include "msg.h"
#include "commu.h"
#include "global_fv.h"
#include "logger.h"
#include "device.h"



static char s_recdata[1024*3];
static char s_sendData[1024*2];
static char temp[1024*3];
extern int igbhttpstate; // ״̬


#define DEBUG_POS_SCAN      0
#define DEBUG_OPEN      0
#define TAG      "POS_SCAN.C"


#define MAKE_SEND_DATA(Tag,Value) \
{\
    sprintf(szSendBuff + uiSendBuff, "%s=%s&", \
    Tag, Value); \
    uiSendBuff += strlen(szSendBuff + uiSendBuff); \
    memset((char *)Value, 0, sizeof((char *)Value)); \
}

#define MAKE_SEND_END_DATA(Tag,Value) \
{\
    sprintf(szSendBuff + uiSendBuff, "%s=%s", \
    Tag, Value); \
    uiSendBuff += strlen(szSendBuff + uiSendBuff); \
    memset((char *)Value, 0, sizeof((char *)Value)); \
}

#define MAKE_NO_SEND_DATA(Tag,Value) \
{\
    sprintf(szSendBuff + uiSendBuff, "%s=%s&", \
    Tag, Value); \
    uiSendBuff += strlen(szSendBuff + uiSendBuff); \
}

#define MAKE_NO_SEND_END_DATA(Tag,Value) \
{\
    sprintf(szSendBuff + uiSendBuff, "%s=%s", \
    Tag, Value); \
    uiSendBuff += strlen(szSendBuff + uiSendBuff); \
}


void POS_Get_PayTimeoutTime(char * Time, char * outTime, int PayTimeout)
{
    unsigned int i, Cyear = 0;
    unsigned long  CountDay = 0;
    unsigned short iYear, iMon, iDay, iHour, iMin, iSec;
    unsigned char norMoth[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

    char szTime[15] = { 0 };

    memcpy(szTime, Time, strlen(Time));

    iSec = atoi(&szTime[12]);
    szTime[12] = 0x00;
    iMin = atoi(&szTime[10]);
    szTime[10] = 0x00;
    iHour = atoi(&szTime[8]);
    szTime[8] = 0x00;
    iDay = atoi(&szTime[6]);
    szTime[6] = 0x00;
    iMon = atoi(&szTime[4]);
    szTime[4] = 0x00;
    iYear = atoi(&szTime[0]);
    szTime[0] = 0x00;

    for (i = 1970; i<iYear; i++)
    {
        if (((i % 4 == 0) && (i % 100 != 0)) || (i % 400 == 0)) Cyear++;
    }
    CountDay = Cyear * 366 + (iYear - 1970 - Cyear) * 365;
    for (i = 1; i<iMon; i++)
    {
        if ((i == 2) && (((iYear % 4 == 0) && (iYear % 100 != 0)) || (iYear % 400 == 0)))
            CountDay += 29;
        else
            CountDay += norMoth[i - 1];
    }
    CountDay += (iDay - 1);
    CountDay = CountDay * 86400 + (unsigned long)(iHour - 8) * 3600 + ((unsigned long)iMin) * 60 + iSec;
    CountDay = CountDay + (unsigned long)(PayTimeout)* 3600;

    Now_To_Time(CountDay, outTime);
}

int POS_Get_KeyValue(char * szRecord, char * Tag, char * szOutData)
{
    char bRetval = EMV_FALSE;
    char pszRecord[2048] = { 0 };
    unsigned int uiBuffSize = 0;
    char * pszTag;
    char * pszValue;
    char * pTemp;
    char * pTV;
    unsigned int uiTV = 0;

    uiBuffSize = 512;

    memcpy(pszRecord, szRecord, strlen(szRecord));

    pTemp = pszRecord;
    //printf("ȡ [ %s ] \n", pTemp);
    uiBuffSize = strlen(pTemp);
    while (uiBuffSize > 0)
    {
        pTV = pTemp;

        if (strstr(pTV, "&") != NULL)
        {
            *strstr(pTV, "&") = 0x00;
            uiTV = strlen(pTV);
        }
        else
        {
            uiTV = strlen(pTV) - 1;
        }
        pszTag = pTV;
        if (strstr(pTV, "=") == NULL)
        {
            bRetval = EMV_FALSE;
            return bRetval;
        }
        *strstr(pszTag, "=") = 0x00;
        pszValue = pszTag + strlen(pszTag) + 1;

        pTemp += uiTV + 1;

        if (strcmp(pszTag, Tag) == 0)
        {
            memcpy(szOutData, pszValue, strlen(pszValue));
            return EMV_TRUE;
        }
    }
    bRetval = EMV_FALSE;
    return bRetval;
}

int SCAN_SM_Verify_Test(char *Txn_CertId,char * smPublicX, char * smPublicY, char * data, unsigned int dataLen, char * szDataSign, int uiDataSign)
{
    unsigned int iRetval = EMV_FALSE;
    int i;
    unsigned char outData[245] = { 0 };
    unsigned char outDgst[125] = { 0 };
    unsigned char hexbuff[246] = { 0 };
    unsigned int hexlen = 245;
    unsigned int outlen = 245;
    unsigned int outDgstlen = 245;

    //memcpy(Txn_CertId, TERMINAL_INFO.CERT_ID, strlen(TERMINAL_INFO.CERT_ID));
    LOGE("%s %d \n",__func__,__LINE__);

    LOGE(" %s \n", data);
    LOGE("ǩ uiDataSign %d \n", uiDataSign);
    logger_serial_dump_buff("ǩ:", szDataSign, uiDataSign);
    LOGE("smPublicX %s \n", smPublicX);
    LOGE("smPublicY %s \n", smPublicY);

    iRetval = sm3((unsigned char *)data, dataLen, outData);
    LOGE("%s %d iRetval=%d\n",__func__,__LINE__,iRetval);
    if (iRetval <= 0)
    {
        return EMV_FALSE;
    }

    memset(hexbuff, 0, hexlen);
    hexlen = 245;
    BytesToHexString((char *)outData, iRetval, (char *)hexbuff, &hexlen);
    for (i = 0; i <hexlen; i++)
    {
        hexbuff[i] = tolower(hexbuff[i]);
    }

#if DEBUG_POS_SCAN
    LOG("Txn_CertId:[ %s ]", Txn_CertId);
#endif

    logger_serial_dump_buff("hexbuff:", hexbuff, hexlen);

    outDgstlen = sm2_digest(smPublicX, smPublicY, (char *)Txn_CertId, strlen((char *)Txn_CertId), hexbuff, hexlen, outDgst);
    LOGE("%s %d outDgstlen %d\n",__func__,__LINE__,outDgstlen);


    if (outDgstlen <= 0)
    {
        return EMV_FALSE;
    }
    logger_serial_dump_buff("outDgst:", outDgst, outDgstlen);


    memset(outData, 0x00, 245);

    logger_serial_dump_buff("szDataSign:", szDataSign, uiDataSign);

    iRetval = sm2_verify(outDgst, outDgstlen, (unsigned char *)szDataSign, uiDataSign, smPublicX, smPublicY);

#if DEBUG_POS_SCAN
    LOG("SCAN_SM_Verify_Test :[ %i ]", iRetval);
#endif
    //memset(Txn_CertId, 0, strlen((char *)Txn_CertId));
    if (iRetval != 1)
    {
        return EMV_FALSE;
    }
    return EMV_TRUE;
}

int SCAN_SM_Sign(char * data, unsigned int dataLen, char * dataSign){
    unsigned int iRetval = ERROR;
	int i;
	unsigned char outData[245] = { 0 };
	unsigned char outDgst[125] = { 0 };
	unsigned char hexbuff[2048] = { 0 };

	unsigned int hexlen = 2048;
	unsigned int outlen = 245;
	unsigned int outDgstlen = 245;


	hexlen = URLDecode(data, dataLen - 1, (char *)hexbuff, hexlen);
	iRetval = sm3((unsigned char *)hexbuff, hexlen, outData);
	if (iRetval <= 0){
        return ERROR;
	}
	memset(hexbuff, 0, hexlen);
	hexlen = 245;
	BytesToHexString(( char *)outData, iRetval, (char *)hexbuff, &hexlen);
#if DEBUG_POS_SCAN
	LOG("SM3 ǩ:[ %s ]", hexbuff);
#endif
	for (i = 0; i <hexlen; i++)
		hexbuff[i] = tolower(hexbuff[i]);
#if DEBUG_POS_SCAN
	LOG("Txn_CertId:[ %s ]", Txn_CertId);
#endif
	outDgstlen = sm2_digest(Txn_CertPublicX, Txn_CertPublicY, (char *)Txn_CertId, strlen((char *)Txn_CertId), hexbuff, hexlen, outDgst);
	if (outDgstlen <= 0){
        return ERROR;
	}
	hexlen = 245;
	memset(hexbuff, 0x00, sizeof(hexlen));
	BytesToHexString((char *)outDgst, outDgstlen, (char *)hexbuff, &hexlen);

#if DEBUG_POS_SCAN
	LOG("SM2 Digest ǩ:[ %s ]", hexbuff);
#endif
	memset(outData, 0x00, iRetval);
	iRetval = sm2_sign(Txn_CertKey, outDgst, outDgstlen, (unsigned char *)outData, &outlen);
	if (iRetval <= 0){
        return ERROR;
	}

    memset(hexbuff, 0x00, strlen((char *)hexbuff));
	base64_encode((unsigned char *)hexbuff, (unsigned char *)outData + 32, iRetval - 32);
#if DEBUG_POS_SCAN
	LOG("BASE 64 ǩ:[ %s ]", hexbuff);
#endif
	memcpy(dataSign, hexbuff, strlen((char *)hexbuff));
    return SUCCESS;
}


int SCAN_SM_Verify(char * smPublicX, char * smPublicY, char * data, unsigned int dataLen, char * szDataSign, int uiDataSign)
{
    unsigned int iRetval = EMV_FALSE;
    int i;
    unsigned char outData[245] = { 0 };
    unsigned char outDgst[125] = { 0 };
    unsigned char hexbuff[246] = { 0 };
    unsigned int hexlen = 245;
    unsigned int outlen = 245;
    unsigned int outDgstlen = 245;

#if DEBUG_OPEN
    LOGE("%s %d \n",__func__,__LINE__);

    LOGE(" %s \n", data);
    LOGE("ǩ uiDataSign %d \n", uiDataSign);
    logger_serial_dump_buff("ǩ:", szDataSign, uiDataSign);
    LOGE("smPublicX %s \n", smPublicX);
    LOGE("smPublicY %s \n", smPublicY);
#endif

    iRetval = sm3((unsigned char *)data, dataLen, outData);
    LOGE("%s %d iRetval=%d\n",__func__,__LINE__,iRetval);
    if (iRetval <= 0)
    {
        return EMV_FALSE;
    }

    memset(hexbuff, 0, hexlen);
    hexlen = 245;
    BytesToHexString((char *)outData, iRetval, (char *)hexbuff, &hexlen);
    for (i = 0; i <hexlen; i++)
    {
        hexbuff[i] = tolower(hexbuff[i]);
    }

#if DEBUG_OPEN
    LOG("Txn_CertId:[ %s ]", Txn_CertId);
    logger_serial_dump_buff("hexbuff:", hexbuff, hexlen);
#endif
    outDgstlen = sm2_digest(smPublicX, smPublicY, (char *)Txn_CertId, strlen((char *)Txn_CertId), hexbuff, hexlen, outDgst);
    LOGE("%s %d outDgstlen %d\n",__func__,__LINE__,outDgstlen);


    if (outDgstlen <= 0)
    {
        return EMV_FALSE;
    }

    memset(outData, 0x00, sizeof(outData));
    
#if DEBUG_OPEN    
    logger_serial_dump_buff("outDgst:", outDgst, outDgstlen);
    logger_serial_dump_buff("szDataSign:", szDataSign, uiDataSign);
#endif

    iRetval = sm2_verify(outDgst, outDgstlen, (unsigned char *)szDataSign, uiDataSign, smPublicX, smPublicY);

#if DEBUG_OPEN
    LOG("SM2 Verify :[ %i ]", iRetval);
#endif
    memset(Txn_CertId, 0, sizeof((char *)Txn_CertId));
    if (iRetval != 1)
    {
        return EMV_FALSE;
    }
    return EMV_TRUE;
}

//  ѻɶά  .
int SCAN_ApplyQrCode(char * orderId, char * txnTime, char* szSendSignData)
{
    int ret = 0;
    unsigned int uiSendBuff = 0;
    unsigned int uiDataSign = 0;
    int offset = 0;
    char szOutData[512] = { 0 };
    cJSON *root = NULL;
    char desKey[40];
    char buf[100];
    char signAsc[64];
    char *pointer = NULL;
    net_dev_hwinfo_t net_hwinfo = {0};
    uchar tempSn[64];
    char tempBuf[16];
    char resultBuf[64];
    char errBuf[16];
    cJSON *item = NULL;
    T_SOFTTIMER tm;

    if(0 == NetSocketCheck(igbhttpstate))
    {
        nfcFlag = 0;
        CommuInit("qra.95516.com",443,iotx_dzc_ca_get(),strlen(iotx_dzc_ca_get()));
    }
	unionFlag = 1;
    BUFCLR(tempSn);
    GetDSN(tempSn, sizeof(tempSn));
    memset(s_sendData, 0x00, sizeof(s_sendData));
    root = cJSON_CreateObject();
    ret = 0;
    BUFCLR(desKey);
    PedGetRandom(8, (uchar *) desKey);
    while (ret < 8)
    {
        desKey[ret] = '0' + ((uchar) desKey[ret]) % 10;
        ret++;
    }
    BUFCLR(buf);
    utilsBcd2Asc((uchar *) desKey, ret, (uchar *) buf);

    cJSON_AddStringToObject(root, "attach", DataSave.PosPar.elec_title);
    cJSON_AddStringToObject(root, "body", "goods");
    cJSON_AddStringToObject(root, "charset", "UTF-8");
    cJSON_AddStringToObject(root, "device_info", tempSn);

    if (NetDeviceGetHwInfo(&net_hwinfo) == 0)
    {
        if(net_hwinfo.ipaddr != NULL)
        {
            cJSON_AddStringToObject(root, "mch_create_ip", net_hwinfo.ipaddr);
        }
        else
        {
            cJSON_AddStringToObject(root, "mch_create_ip", "");
        }
    }
    else
    {
        cJSON_AddStringToObject(root, "mch_create_ip", "");
    }
    cJSON_AddStringToObject(root, "mch_id", DataSave.PosPar.aucMerchantCode);
    cJSON_AddStringToObject(root, "nonce_str", buf);
    cJSON_AddStringToObject(root, "notify_url", "null");
    cJSON_AddStringToObject(root, "out_trade_no", (char *)NormalTrans.Trans_Order);
    cJSON_AddStringToObject(root, "service", "unified.trade.native");
    cJSON_AddStringToObject(root, "sign_type", "MD5");
    cJSON_AddNumberToObject(root, "total_fee", utilsAsc2Int(NormalTrans.uamt));
    cJSON_AddStringToObject(root, "version", "2.0");


    BUFCLR(signAsc);
    ret = JsontoAsc(root, signAsc);
#if DEBUG_OPEN
    LOG("get asc success, line:[%d], buffer:[%s], length:[%d]\n", __LINE__, signAsc, ret);
#endif

    cJSON_AddStringToObject(root, "sign", signAsc);

    pointer = cJSON_PrintUnformatted(root);
    ret = Json2Xml(pointer, s_sendData);
    free(pointer);
    cJSON_Delete(root);
    root = NULL;

#if DEBUG_OPEN
    LOG("[%s:%d]Ĵ:[ %s ]", __FUNCTION__, __LINE__, s_sendData);
#endif
    memset(s_recdata, 0x00, sizeof(s_recdata));
    ret = sendHttpsUrlData_7(s_sendData, strlen(s_sendData), 443, "/pay/gateway", s_recdata, &offset, false);

#if DEBUG_OPEN
    LOG("ret:%d offset:[%d]----\n", ret, offset);
#endif

    if (ret == SUCCESS)
    {
        if (offset > 0)
        {
            pointer = strstr(s_recdata, ">");

            if (s_recdata[0] != '<' || !pointer)
            {
                memcpy(NormalTrans.ucErrorCode, "ʧ,", strlen("ʧ,"));
                return ErrType_UserDefine;
            }
#if DEBUG_OPEN
            LOG("Des decrypt success, out length:%d\n", offset);
            //logger_serial_dump_buff("Recv json:", temp, ret);
#endif

            root = Xml2Json(s_recdata);
            if(!root)
            {
                memcpy(NormalTrans.ucErrorCode, "ʧ,", strlen("ʧ,"));

                return ErrType_UserDefine;
            }
#if DEBUG_OPEN
            LOG("[%s:%d]Json parse success\n", __FUNCTION__, __LINE__);
#endif
            //ҵ
            BUFCLR(tempBuf);
            item = cJSON_GetObjectItem(root, "status");
            if (item)
            {
                maniData(item->valuestring, tempBuf);
#if DEBUG_OPEN
                LOG("[%s]status:%s\n", __func__, tempBuf);
#endif
            }

            if (!memcmp(tempBuf, "0", strlen("0")))  //׳ɹ
            {
                BUFCLR(tempBuf);
                item = cJSON_GetObjectItem(root, "result_code");
                if (item)
                {
                    maniData(item->valuestring, tempBuf);
#if DEBUG_OPEN
                    LOG("[%s]status:%s\n", __func__, tempBuf);
#endif
                }

                if(!memcmp(tempBuf, "0", strlen("0")))
                {
                    item = cJSON_GetObjectItem(root, "code_url");
                    if (item)
                    {
                        maniData(item->valuestring, szSendSignData);
                    }
             
                    memset(Txn_CertId, 0, sizeof((char *) Txn_CertId));
                    item = NULL;
                    cJSON_Delete(root);
                    root = NULL;
                    return SUCCESS;
                }
                memcpy(NormalTrans.ucErrorCode, "ʧ", strlen("ʧ"));
                //itemÿ,ͷjsonʱĿռ
                item = NULL;
                cJSON_Delete(root);
                root = NULL;
                return ERROR;
            }
            else
            {

                item = cJSON_GetObjectItem(root, "return_msg");
                if (item)
                {
                    BUFCLR(errorMsg);
                    maniData(item->valuestring, errorMsg);
                }

                item = cJSON_GetObjectItem(root, "err_code_des");
                if (item)
                {
                    BUFCLR(errorMsg);
                    maniData(item->valuestring, errorMsg);
                }

                item = NULL;
                cJSON_Delete(root);
                root = NULL;
                return ERROR;
            }

        }
        else
        {
            LOG("Des decrypt fail:%d\n", ret);
            ret = -1;
        }

    }
    else
    {
        if (ret == CONNECTFAIL)
        {
            memcpy(NormalTrans.ucErrorCode, "ʧ", strlen("ʧ"));
            ret = ErrType_UserDefine;
        }
        else if (ret == SENDFAIL)
        {
            memcpy(NormalTrans.ucErrorCode, "ʧ", strlen("ʧ"));
            ret = ErrType_UserDefine;
        }
        else if (ret == RECVFAIL)
        {
            memcpy(NormalTrans.ucErrorCode, "ʧ", strlen("ʧ"));
            ret = ErrType_UserDefine;
        }
    }
    if(root)
    {
        item = NULL;
        cJSON_Delete(root);
        root = NULL;
    }
    return ERROR;
}

int SCAN_DataVerify(unsigned char * pszRequestData, unsigned int uiRequestData)
{
    char bRetval = EMV_TRUE;
    char szSendBuff[2048] = { 0 };
    unsigned int uiSendBuff = 0;

    char pszRecord[2048] = { 0 };
    unsigned int uiBuffSize = 0;

    char szSortBuff[25][30] = { 0 };
    char SortBuff[30] = { 0 };
    char szSignaBuff[512] = { 0 };

    char smPublicX[66] = { 0 };
    char smPublicY[66] = { 0 };
    char pSerial[30] = { 0 };

    char * pszTag;
    char * pTemp;
    char * pTV;
    unsigned int uiTV = 0;
    unsigned int iTVcount = 0;
    int baseLen=0;

    mbedtls_x509_crt crt509_ca;
    int i, j;

    pos_x509_crt_init(&crt509_ca);

    memcpy(pszRecord, pszRequestData, uiRequestData);

    pTemp = pszRecord;
    //printf("ȡ [ %s ] \n", pTemp);
    uiBuffSize = strlen(pTemp);
#if DEBUG_OPEN
    LOGE("uiBuffSize:%d\n",uiBuffSize);
#endif

    while (uiBuffSize > 0)
    {
        pTV = pTemp;

        if (strstr(pTV, "&") != NULL)
        {
            *strstr(pTV, "&") = 0x00;
            uiTV = strlen(pTV);
        }
        else
        {
            uiTV = strlen(pTV) - 1;
        }
        pszTag = pTV;
        if (strstr(pTV, "=") == NULL)
        {
            bRetval = EMV_FALSE;
            return bRetval;
        }
        *strstr(pszTag, "=") = 0x00;
        pszTag + strlen(pszTag) + 1;

        pTemp += uiTV + 1;
        if (strcmp(pszTag, PARAM_SIGNATURE) == 0)
        {
        }
        else
        {
            memcpy(szSortBuff[iTVcount], pszTag, strlen(pszTag));
            iTVcount++;
        }
        uiBuffSize = strlen(pTemp);
    }

    for (i = 0; i < iTVcount; ++i)
    {
        for (j = i + 1; j < iTVcount + 1; ++j)
        {
            if (strcmp(szSortBuff[i], szSortBuff[j]) > 0)
            {
                strcpy(SortBuff, szSortBuff[i]);
                strcpy(szSortBuff[i], szSortBuff[j]);
                strcpy(szSortBuff[j], SortBuff);
            }
        }
    }

    for (i = 0; i < iTVcount; ++i)
    {

        memset(pszRecord, 0, 1700);
        POS_Get_KeyValue((char *) pszRequestData, szSortBuff[i + 1], pszRecord);
#if DEBUG_OPEN   
        LOGE("szSortBuff %s \n", szSortBuff[i]);
#endif

        MAKE_SEND_DATA(szSortBuff[i + 1], pszRecord);

    }
    szSendBuff[strlen(szSendBuff) - 1] = '\0';

    memset(pszRecord, 0, sizeof(pszRecord));
    POS_Get_KeyValue((char *) pszRequestData, PARAM_SIGNATURE, pszRecord);
    baseLen=base64_decode(pszRecord, szSignaBuff);

#if DEBUG_OPEN    
    logger_serial_dump_buff("szSignaBuff", szSignaBuff, baseLen);
    LOGE("szSignaBuff len=%d strlen(szSignaBuff)=%d \n",baseLen,strlen(szSignaBuff));
#endif

    //Կ
    memset(pszRecord, 0, sizeof(pszRecord));
    if (POS_Get_KeyValue((char *) pszRequestData, PARAM_SIGNPUBKEYCERT, pszRecord) == EMV_TRUE)
    {
        memset(DB_Change.signPubKeyCert.data, 0, sizeof(DB_Change.signPubKeyCert.data));
        memcpy(DB_Change.signPubKeyCert.data, pszRecord, strlen(pszRecord));
        DB_Change.signPubKeyCert.bDown = 1;
        DATA_writeFile(FileChange);
    }

    if (!DB_Change.signPubKeyCert.bDown || !strlen((char *)DB_Change.signPubKeyCert.data))
    {
        return RESP_CODE_INVALID_CERTIFICATE;
    }
    else if (0 != pos_x509_crt_parse(&crt509_ca, DB_Change.signPubKeyCert.data, strlen((char *)DB_Change.signPubKeyCert.data) + 1))
    {
        return RESP_CODE_INVALID_CERTIFICATE;
    }

    memset(pszRecord, 0, sizeof(pszRecord));
    memcpy(pszRecord, crt509_ca.pk.p, crt509_ca.pk.len);
    vOneTwo((unsigned char *) pszRecord, 32, (unsigned char *) smPublicX);
    smPublicX[65] = '\0';
    vOneTwo((unsigned char *) pszRecord + 32, 32, (unsigned char *) smPublicY);
    smPublicY[65] = '\0';

    memset(DataSavekey.uPublicX, 0, sizeof(DataSavekey.uPublicX));
    memset(DataSavekey.uPublicY, 0, sizeof(DataSavekey.uPublicY));
    strcpy(DataSavekey.uPublicX, smPublicX);
    strcpy(DataSavekey.uPublicY, smPublicY);
    FVFileWriteFile(MODULE_NAME,(char*)&DataSavekey, sizeof(DataSavekey));

    if (crt509_ca.serial.len != 0)
    {
        memset(Txn_CertId, 0, sizeof(Txn_CertId));
        memset(pszRecord, 0, sizeof(pszRecord));
        memset(SortBuff, 0, sizeof(SortBuff));
        memcpy(pszRecord, crt509_ca.serial.p, crt509_ca.serial.len);
        vOneTwo((unsigned char *) pszRecord, crt509_ca.serial.len, (unsigned char *) SortBuff);

        HexToDec(SortBuff, pSerial);
        memcpy(Txn_CertId, pSerial, strlen(pSerial));
    }
    pos_x509_crt_free(&crt509_ca);
    
#if DEBUG_OPEN
    logger_serial_dump_buff("=====>>>szSendBuff", szSendBuff, strlen(szSendBuff));
#endif

    return SCAN_SM_Verify(smPublicX, smPublicY, szSendBuff, strlen(szSendBuff), szSignaBuff, strlen(szSignaBuff));
}

int	 NFC_TAG_CardNumData(char *cardNum, char * szOuntBuff){

	unsigned char szSmBuff[256] = {0};// 
	unsigned char szBuffBase64[256] = {0};// 
	int uiSmBuff = 0;

	memset(szSmBuff,0,sizeof(szSmBuff));
	memset(szBuffBase64,0,sizeof(szBuffBase64));
	
	szSmBuff[0]=0x04;
	
	#if DEBUG_OPEN	
	LOG("NFC_TAG_cardNum  [%s] [%i]", cardNum, strlen(cardNum));
	LOG("ݼ ԿX : %s  ԿY : %s", DataSavekey.uPublicX, DataSavekey.uPublicY);
	#endif
	
	//
	uiSmBuff = sm2_encrypt(DataSavekey.uPublicX, DataSavekey.uPublicY, cardNum, strlen(cardNum),szSmBuff+1);

	LOG("uiSmBuff %i",uiSmBuff);
	if (uiSmBuff < 0){
		return EMV_FALSE;
	}

	base64_encode(szBuffBase64,szSmBuff, uiSmBuff + 1);
	URLEncode((char*)szBuffBase64, szOuntBuff);

	#if DEBUG_OPEN	
	LOG("NFC_TAG_CardNum URL [%s] ", szOuntBuff);
	#endif
	
	return EMV_TRUE;
}


