#include "mmi_util.h"
#include "utilAPI.h"

#include "Pos_Ui.h"
#include "Pos_global.h"
#include "macropar.h"

#ifdef TAG
#undef TAG
#endif
#define TAG __func__

int UI_CheckAuth(void)
{
    int iRet = INPUT_FAIL;
    char pwd[9];

    mmi_clearLine(255);
    mmi_display(ALIG_TOP, ALIG_CENTER, "豸");
    while(1)
    {
        memset(pwd, 0, sizeof(pwd));
        iRet = utilInput_String(ALIG_CENTER, ALIG_CENTER, 1, 8, 'P', pwd, NULL, 60);
        if (iRet == INPUT_OK)
        {
            if (strcmp(pwd, getadminPwd()) != 0 && strcmp(pwd, getcashierPwd()) != 0)
            {
                mmi_clearLine(ALIG_CENTER);
                mmi_display(ALIG_CENTER, ALIG_CENTER, ",");
                Sleep(500);
                continue;
            }
        }
        else if (iRet == INPUT_BYPASS)
        {
            continue;
        }
        break;
    }
    switch(iRet)
    {
        case INPUT_OK:
            return STATE_FINISH;
        default:
            return STATE_BACK;
    }
}

/**
* @brief    ֤Ա
* @author   XuZhou.Chen
*/
int UI_CheckAdminPwd(void)
{
    int iRet = INPUT_FAIL;
    char pwd[9];

    mmi_clearLine(255);
    mmi_display(ALIG_TOP, ALIG_CENTER, "Ա");
    while(1)
    {
        memset(pwd, 0, sizeof(pwd));
        iRet = utilInput_String(ALIG_CENTER, ALIG_CENTER, 1, 8, 'P', pwd, NULL, 60);
        if (iRet == INPUT_OK)
        {
            if (strcmp(pwd, getadminPwd()) != 0)
            {
                mmi_clearLine(ALIG_CENTER);
                mmi_display(ALIG_CENTER, ALIG_CENTER, ",");
                Sleep(500);
                continue;
            }
        }
        else if (iRet == INPUT_BYPASS)
        {
            continue;
        }
        break;
    }

    switch(iRet)
    {
        case INPUT_OK:
            return STATE_KEEPON;
        case INPUT_USER_ABORT:
        case INPUT_TIMEOUT:
        default:
            return STATE_BACK;
    }
}

int UI_CheckCashierPwd(void)
{
    int iRet = INPUT_FAIL;
    char pwd[9];

    mmi_clearLine(255);
    mmi_display(ALIG_TOP, ALIG_CENTER, "Ա");
    while(1)
    {
        memset(pwd, 0, sizeof(pwd));
        iRet = utilInput_String(ALIG_CENTER, ALIG_CENTER, 1, 8, 'P', pwd, NULL, 60);
        if (iRet == INPUT_OK)
        {
            if (strcmp(pwd, getcashierPwd()) != 0)
            {
                mmi_clearLine(ALIG_CENTER);
                mmi_display(ALIG_CENTER, ALIG_CENTER, ",");
                Sleep(500);
                continue;
            }
        }
        else if (iRet == INPUT_BYPASS)
        {
            continue;
        }
        break;
    }

    switch(iRet)
    {
        case INPUT_OK:
            return STATE_KEEPON;
        case INPUT_USER_ABORT:
        case INPUT_TIMEOUT:
            return STATE_BACK;
    }
}

int UI_EditPassword(unsigned char *pwd)
{
    int iRet = INPUT_FAIL;
    char m_pwd[9], m_agnPwd[9];

    memset(m_pwd, 0, sizeof(m_pwd));
    mmi_clearLine(255);
    mmi_display(1, ALIG_CENTER, "");
    iRet = utilInput_String(5, ALIG_CENTER, 1, 8, 'P', m_pwd, NULL, 60);
    if (iRet != INPUT_OK)
        goto DO_END;

    mmi_clearLine(5);
    mmi_display(5, ALIG_CENTER, "һ");
    Sleep(500);

    while(1)
    {
        memset(m_agnPwd, 0, sizeof(m_agnPwd));
        iRet = utilInput_String(5, ALIG_CENTER, 1, 8, 'P', m_agnPwd, NULL, 60);
        if (iRet != INPUT_OK)
            goto DO_END;

        if (strcmp(m_pwd, m_agnPwd) != 0)
        {
            mmi_clearLine(5);
            mmi_display(5, ALIG_CENTER, "벻һ£");
            Sleep(500);
            continue;
        }
        else if (iRet == INPUT_BYPASS)
        {
            continue;
        }
        break;
    }

DO_END:
    switch(iRet)
    {
        case INPUT_OK:
            memcpy(pwd, m_agnPwd, strlen((char *)m_agnPwd));
            return STATE_KEEPON;
        case INPUT_USER_ABORT:
        case INPUT_TIMEOUT:
            return STATE_BACK;
    }
}

int UI_InputOrderNo(unsigned char bFlag, char *pTitle, char *pCaption, unsigned char *pDrvType, char *pOrderNo, int maxLen, int timeout)
{
    int iRet = INPUT_FAIL;
    int iRow;
    char mOrderNo[30];
    unsigned char m_offset;
    tsSysTime time;

    memset(&time, 0, sizeof(time));
    GetSysLocalTime(&time);

    m_offset = 1;
#if defined(QR100)
    if (strlen(pCaption) > 20)
        m_offset = 0;
#endif

    iRow = 2;
    mmi_clearLine(255);
    mmi_display(ALIG_TOP, ALIG_CENTER, pTitle);
    mmi_display(iRow++, m_offset, pCaption);
    if(bFlag == 1)
    {
        mmi_display(iRow++, m_offset, "(ɨӿ)");
    }
    else if (bFlag == 2)
    {
        mmi_display(iRow++, m_offset, "(ɨ)");
    }
    mmi_display(5, m_offset, "밴[]");
    memset(mOrderNo, 0, sizeof(mOrderNo));
    if (bFlag)
        iRet = utilInput_StringAndScan(iRow, 1, bFlag == 2 ? 0 : 1, 1, 10, 'N', pDrvType, mOrderNo, timeout);
    else
        iRet = utilInput_String(iRow, 1, 1, 10, 'N', mOrderNo, NULL, timeout);

    if (iRet == INPUT_OK)
    {
        if (strlen((char *)mOrderNo) > 10)
        {
            memcpy(pOrderNo, mOrderNo, strlen((char *)mOrderNo));
        }
        else
        {
            snprintf((char *)pOrderNo, maxLen, "%s%04d%s", "QR200", time.year, mOrderNo);
        }
    }

    if (iRet == INPUT_OK)
    {
        return STATE_KEEPON;
    }
    else if (iRet == INPUT_USER_ABORT)
    {
        memset((char *)NormalTrans.ucErrorCode, 0, sizeof((char *)NormalTrans.ucErrorCode));
        strcpy((char *)NormalTrans.ucErrorCode, "ûȡ");
        return STATE_ERROR;
    }
    else if (iRet == INPUT_TIMEOUT)
    {
    	memset((char *)NormalTrans.ucErrorCode, 0, sizeof((char *)NormalTrans.ucErrorCode));
        strcpy((char *)NormalTrans.ucErrorCode, "ɨ볬ʱ");
        return STATE_ERROR;
    }
    return STATE_BACK;
}

int UI_DispOrderInfoEx(char *pTitle)
{
    char ordertemp[64] = { 0 };
    char amttemp[64] = { 0 };
    char codetemp[64] = { 0 };
    char tmp[20] = { 0 };
    char m_year[5] = { 0 };
    char m_mon[3] = { 0 };
    char m_day[3] = { 0 };
    char m_hour[3] = { 0 };
    char m_min[3] = { 0 };
    char m_sec[3] = { 0 };
    int amt = 0;
    int iRow;

    amt = utilsAsc2Int((char *) NormalTrans.uamt);

    snprintf(tmp, sizeof(tmp), "%d.%02d", amt / 100, amt % 100);
    snprintf(ordertemp, sizeof(ordertemp), ": %s", NormalTrans.Trans_QueryId);
    snprintf(amttemp, sizeof(amttemp), ": %s", tmp);

    if (NormalTrans.Trans_Code == RESP_CODE_SUCCESS)
    {
        snprintf(codetemp, sizeof(codetemp), "״̬:%s", "֧");
    }
    /*else if (NormalTrans.Trans_Code == RESP_CODE_SALE_REVOKE)
    {
        snprintf(codetemp, sizeof(codetemp), "״̬:%s", "ѳ");
    }
    else if (NormalTrans.Trans_Code == RESP_CODE_SALE_RETURN)
    {
        snprintf(codetemp, sizeof(codetemp), "״̬:%s", "˿");
    }*/
    else if (NormalTrans.Trans_Code == RESP_CODE_DEFAULT)
    {
        snprintf(codetemp, sizeof(codetemp), "״̬:%s", "δ֧");
    }
    else
    {
        snprintf(codetemp, sizeof(codetemp), "״̬:%s", "δ֪");
    }

     //ʱ
    if(NormalTrans.scan_yard){
    	memcpy(m_year, NormalTrans.Trans_Time, 4);
	    memcpy(m_mon, NormalTrans.Trans_Time + 4, 2);
	    memcpy(m_day, NormalTrans.Trans_Time + 6, 2);
	    memcpy(m_hour, NormalTrans.Trans_Time + 8, 2);
	    memcpy(m_min, NormalTrans.Trans_Time + 10, 2);
	    memcpy(m_sec, NormalTrans.Trans_Time + 12, 2);
    }else{
	    memcpy(m_year, NormalTrans.Trans_Time, 4);
	    memcpy(m_mon, NormalTrans.Trans_Time + 5, 2);
	    memcpy(m_day, NormalTrans.Trans_Time + 8, 2);
	    memcpy(m_hour, NormalTrans.Trans_Time + 11, 2);
	    memcpy(m_min, NormalTrans.Trans_Time + 14, 2);
	    memcpy(m_sec, NormalTrans.Trans_Time + 17, 2);
	}

    mmi_clearLine(255);
    mmi_display(ALIG_TOP, ALIG_CENTER, pTitle);
    iRow = mmi_display(2, 0, ordertemp);
    iRow = mmi_display(iRow, 0, amttemp);
    iRow = mmi_display(iRow, 0, codetemp);
    iRow = mmi_display(iRow, 0, "ʱ: %s-%s-%s %s:%s:%s", m_year, m_mon, m_day, m_hour, m_min, m_sec);
}

int UI_DispOrderInfo(char *pTitle, int timeout)
{
    int iKey;

    UI_DispOrderInfoEx(pTitle);
    mmi_display(ALIG_BOTTOM, ALIG_RIGHT, "[ȷ]");
    while(1)
    {
        iKey = utilInput_GetKey(timeout);
        if (iKey == KEY_CANCEL)
            return STATE_BACK;
        else if (iKey == KEY_ENTER)
            return STATE_KEEPON;
    }
}


int transQueryKeypress(int _key, tsNormalTrans *pNormalTrans);
int UI_DispOrderInfo_QOnline(char *pTitle, int timeout)
{
    int m_key;
    tsNormalTrans tempRecord;

    memset(&tempRecord, 0, sizeof(tsNormalTrans));
    memcpy(&tempRecord, &NormalTrans, sizeof(tsNormalTrans));
    UI_DispOrderInfoEx(pTitle);
    //׳ɹ
    switch(NormalTrans.Trans_Code)
    {
        /*case RESP_CODE_SUCCESS:
        	if(DataSave.PosPar.scan_yard){
            	mmi_display(ALIG_BOTTOM, 0, "[1] [2]˻");
           	}else{
           		mmi_display(ALIG_BOTTOM, 0, "[2]˻");
           	}
            break;
        case RESP_CODE_SALE_RETURN:
            mmi_display(ALIG_BOTTOM, 0, "[2]˻");
            break;*/
        case RESP_CODE_DEFAULT:
        case RESP_CODE_FAILURE:
            mmi_display(ALIG_BOTTOM, 0, "[3]ѯ");
            break;
        default:
            break;
    }

    while(1)
    {
        m_key = utilInput_GetKey(timeout);
        switch(m_key)
        {
            case KEY_CANCEL:
            case INPUT_TIMEOUT:
                return STATE_BACK;
            /*case KEY_ASCII1:
            	if(!DataSave.PosPar.scan_yard){
            		break;
            	}
                if (NormalTrans.Trans_PayMent == PAY_CASH_RECEIPTS)
                    break;

                if (NormalTrans.Trans_Code != RESP_CODE_SUCCESS)
                    break;

                transQueryKeypress(m_key, &tempRecord);
                return STATE_FINISH;
            case KEY_ASCII2:
                if (NormalTrans.Trans_PayMent == PAY_CASH_RECEIPTS)
                    break;

                if (NormalTrans.Trans_Code != RESP_CODE_SUCCESS
                    && NormalTrans.Trans_Code != RESP_CODE_SALE_RETURN)
                    break;

                transQueryKeypress(m_key, &tempRecord);
                return STATE_FINISH;*/
            case KEY_ASCII3:
                if (NormalTrans.Trans_PayMent == PAY_CASH_RECEIPTS)
                    break;

                if (NormalTrans.Trans_Code != RESP_CODE_DEFAULT
                    && NormalTrans.Trans_Code != RESP_CODE_FAILURE)
                    break;

                transQueryKeypress(m_key, &tempRecord);
                return SUCCESS;
            default:
                break;
        }
    }
}

int UI_InputAmount(char *pTitle, char *pCaption, unsigned long *pulAmount, int timeout)
{
    int iRet;
    unsigned long ulMaxAmount = utilsAsc2Int(NormalTrans.uamt);

//    if (ulMaxAmount < 1)
    ulMaxAmount = 999999998;

    mmi_clearLine(255);
    mmi_display(ALIG_TOP, ALIG_CENTER, pTitle);
    mmi_display(2, 1, pCaption);
    mmi_display(5, 1, "밴[]");
    iRet = utilInput_Amount(3, 1, ulMaxAmount, pulAmount, timeout);
    switch(iRet)
    {
        case INPUT_OK:
            return STATE_KEEPON;
        case INPUT_USER_ABORT:
#if 0
            memset(errorMsg, 0, sizeof(errorMsg));
            strcat(errorMsg, "ȡ");
            return STATE_ERROR;
#else
            return STATE_BACK;
#endif
        default:
            memset(errorMsg, 0, sizeof(errorMsg));
            strcat(errorMsg, "ȴʱ˳");
            return STATE_ERROR;
    }
}

int UI_InputActiveCode(char *pTitle, char *pTips, char *pActiveCode, int timeout)
{
    int iRet;

    mmi_clearLine(255);
    mmi_display(ALIG_TOP, ALIG_CENTER, pTitle);
    mmi_display(2, 1, pTips);
    mmi_display(5, 1, "밴[]");
    iRet = utilInput_String(3, ALIG_CENTER, 1, 20, 'N', pActiveCode, NULL, timeout);
    switch(iRet)
    {
        case INPUT_OK:
            return STATE_KEEPON;
        case INPUT_USER_ABORT:
            memset(errorMsg, 0, sizeof(errorMsg));
            strcat(errorMsg, "ȡ");
            return STATE_ERROR;
        default:
            memset(errorMsg, 0, sizeof(errorMsg));
            strcat(errorMsg, "ȴʱ˳");
            return STATE_ERROR;
    }
}

