#include "MercurySystem.h"
#include "bwsdk.h"
#include "Pos_Api.h"


static int norMoth[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
static int leapMoth[] = { 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

static int Leap_Year(int year)
{
    return  ((year % 400 == 0) || ((year % 4 == 0) && (year != 0))) ? 1 : 0;
}

struct OS_TIME Now_To_Later(struct OS_TIME now, int gap)
{
    struct OS_TIME d1;
    int sum = 0, sum_bak=0;
    int temp;

    d1 = now;
    sum = gap;

    if ((sum>0) && (sum < 3649270))
    {
        while (sum>365)
        {
            if (d1.m_Month >= 3)
            {
                d1.m_Year++;
                sum = sum - 365 - Leap_Year(d1.m_Year);
            }
            else
            {
                sum = sum - 365 - Leap_Year(d1.m_Year);
                d1.m_Year++;
            }
        }
        while (sum > 0)
        {
            if (d1.m_Month != 2)
            {
                temp = norMoth[d1.m_Month - 1] - d1.m_Day + 1;
            }
            else
            {
                temp = norMoth[d1.m_Month - 1] + Leap_Year(d1.m_Day) - d1.m_Day + 1;
            }
            sum_bak = sum;
            sum = sum - temp;
            if (sum >= 0)
            {
                d1.m_Month++;
                d1.m_Day = 1;
                if (d1.m_Month > 12)
                {
                    d1.m_Month = 1;
                    d1.m_Year++;
                }
                sum_bak = sum;
            }
        }
        d1.m_Day += sum_bak;
    }
    return d1;
}

struct OS_TIME Now_To_Fronter(struct OS_TIME now, int gap)
{
    struct OS_TIME d1;
    int sum, sum_bak;
    int temp;

    d1 = now;
    sum = gap;

    if ((sum < 0) && (sum > -3649270))
    {
        while (sum < -365)
        {
            if (d1.m_Minute >= 3)
            {
                sum = sum + 365 + Leap_Year(d1.m_Year);
                d1.m_Year--;
            }
            else
            {
                d1.m_Year--;
                sum = sum + 365 + Leap_Year(d1.m_Year);
            }
        }

        sum_bak = sum;

        while (sum < 0)
        {
            temp = -d1.m_Day;
            sum = sum - temp;
            if (sum <= 0)
            {
                d1.m_Month--;
                if (d1.m_Month < 1)
                {
                    d1.m_Month = 12;
                    d1.m_Year--;
                }
                if (d1.m_Month == 2)
                    d1.m_Day = norMoth[d1.m_Month - 1] + Leap_Year(d1.m_Year);
                else
                    d1.m_Day = norMoth[d1.m_Month - 1];

                sum_bak = -sum;
            }
        }
        if (sum_bak < 0)
        {
            d1.m_Day = d1.m_Day + sum_bak;
        }
        else
        {

            if (d1.m_Month == 2)
                d1.m_Day = norMoth[d1.m_Month - 1] + Leap_Year(d1.m_Year) - sum_bak;
            else
                d1.m_Day = norMoth[d1.m_Month - 1] - sum_bak;
        }
    }
    return d1;
}

void Now_To_MothAndDay(char bLeapYear, int nDays, int *nMoth, int *nDay)
{
    int i = 0;
    int nTmp = 0;
    int *pMoth = bLeapYear ? leapMoth : norMoth;

    for (i = 0; i<12; i++)
    {
        nTmp = nDays - pMoth[i];
        if (nTmp <= 0)
        {
            *nMoth = i + 1;
            if (nTmp == 0)
            {
                *nDay = pMoth[i];
            }
            else
            {
                *nDay = nDays;
            }
            break;
        }
        nDays = nTmp;
    }
}


static unsigned int Now_years(unsigned int day, unsigned int *year)
{
    if (day < 365)
    {
        return day;
    }

    if (*year % 4 == 0 && *year % 100 != 0 || *year % 400 == 0)
    {
        if (day > 365)
        {
            day -= 366;
        }
        (*year)++;
    }
    else
    {
        day -= 365;
        (*year)++;
    }
    day = Now_years(day, year);

    return day;
}

static void Now_month(unsigned int *mon, unsigned int *day, unsigned int year)
{
    switch (*mon)
    {
        case 1:
        case 3:
        case 5:
        case 7:
        case 8:
        case 10:
        case 12:
            if ((*day) > 31)
            {
                (*mon)++;
                *day = *day - 31;
            }
            else
            {
                return;
            }
            break;
        case 4:
        case 6:
        case 9:
        case 11:
            if ((*day) > 30)
            {
                (*mon)++;
                *day = *day - 30;
            }
            else
            {
                return;
            }
            break;
        case 2:
            if (year % 4 == 0 && year % 100 != 0 || year % 400 == 0)
            {
                if ((*day) > 29)
                {
                    (*mon)++;
                    *day = *day - 29;
                }
                else
                {
                    return;
                }
            }
            else
            {
                if ((*day) > 28)
                {
                    (*mon)++;
                    *day = *day - 28;
                }
                else
                {
                    return;
                }
            }
            break;
        default:
            break;
    }

    Now_month(mon, day, year);
}


void Now_To_Time(unsigned long seconds, char * outTime)
{
    unsigned int total_hour;
    unsigned int mon = 1, hour, day, min, sec;
    unsigned int year = 1970;

    if (seconds == 0 || outTime == NULL)
    {
        return;
    }

    sec = (unsigned int)(seconds % 60);
    min = ((unsigned int)(seconds % 3600)) / 60;
    total_hour = (unsigned int)(seconds / 3600);
    day = total_hour / 24;
    hour = total_hour - day * 24 + 8;//Լ+8ʱ
    day++;//ʱ1
    day = Now_years(day, &year);
    Now_month(&mon, &day, year);
    if (hour > 24)
    {
        day++;
        hour = hour % 24;
    }
    else if (hour == 24)
    {
        day++;
        hour = 0;
    }

    sprintf(outTime, "%04d%02d%02d%02d%02d%02d", year, mon, day, hour, min, sec);
}

#define NON_NUM '0'

char Char2Num(char ch)
{
    if (ch >= '0' && ch <= '9')return (char)(ch - '0');
    if (ch >= 'a' && ch <= 'f')return (char)(ch - 'a' + 10);
    if (ch >= 'A' && ch <= 'F')return (char)(ch - 'A' + 10);
    return NON_NUM;
}

int hex2num(char c)
{
    if (c >= '0' && c <= '9') return c - '0';
    if (c >= 'a' && c <= 'z') return c - 'a' + 10;//+10ԭ:16ƵaֵΪ10
    if (c >= 'A' && c <= 'Z') return c - 'A' + 10;
    return NON_NUM;
}
// base64ݣתString
/*replace('+', '-');
replace('/', '_');
replaceAll("=", "");

int Base64EncodeURLSafe(const unsigned char *in_str, int in_len, unsigned char *out_str){
    char tmpOut[1024]={0};
    int outLen=0;
    Base64Encode(in_str,in_len,(unsigned char*)tmpOut);
    if(0==StringReplayce(tmpOut,strlen(tmpOut),(char*)out_str,&outLen))
        return outLen;
    else
        return 0;

}
*/


/**
* @brief URLDecode ַURL,
*
* @param str ԭַ
* @param strSize ԭַС\0
* @param result ַ
* @param resultSize ַĻС(\0)
*
* @return: >0 result ʵЧַ
*            0 ʧ
*/
int URLDecode(const char* str, const int strSize, char* result, const int resultSize)
{
    char ch, ch1, ch2;
    int i;
    int j = 0;//record result index

    if ((str == NULL) || (result == NULL) || (strSize <= 0) || (resultSize <= 0))
    {
        return 0;
    }

    for (i = 0; (i<strSize) && (j<resultSize); ++i)
    {
        ch = str[i];
        switch (ch)
        {
            case '+':
                result[j++] = ' ';
                break;
            case '%':
                if (i + 2<strSize)
                {
                    ch1 = hex2num(str[i + 1]);//4λ
                    ch2 = hex2num(str[i + 2]);//4λ
                    if ((ch1 != NON_NUM) && (ch2 != NON_NUM))
                        result[j++] = (char)((ch1 << 4) | ch2);
                    i += 2;
                    break;
                }
                else
                {
                    break;
                }
            default:
                result[j++] = ch;
                break;
        }
    }

    result[j] = 0;
    return j;
}

char dec2hex(short int c)
{
    if (0 <= c && c <= 9)
    {
        return c + '0';
    }
    else if (10 <= c && c <= 15)
    {
        return c + 'A' - 10;
    }
    else
    {
        return 0;
    }
}

void URLEncode(char* url, char * urlencode)
{
    int i = 0;
    int len = strlen(url);
    int res_len = 0;
    char res[1024];
    for (i = 0; i < len; ++i)
    {
        char c = url[i];
        if (('0' <= c && c <= '9') ||
            ('a' <= c && c <= 'z') ||
            ('A' <= c && c <= 'Z') ||
            c == '/' || c == '.')
        {
            res[res_len++] = c;
        }
        else
        {
            int j = (short int)c;
            int i1, i0;

            if (j < 0)
                j += 256;

            i1 = j / 16;
            i0 = j - i1 * 16;
            res[res_len++] = '%';
            res[res_len++] = dec2hex(i1);
            res[res_len++] = dec2hex(i0);
        }
    }
    res[res_len] = '\0';
    strcpy(urlencode, res);
}

static char *strupr(char *src)
{
    while (*src != '\0')
    {
        if (*src >= 'a' && *src <= 'z')
            //ASCIIдֵַȶӦСдֵַС32.
            //*p -= 0x20; // 0x20ʮƾ32
            *src -= 32;
        src++;
    }
    return src;
}

static char * strrev(char* s)
{
    /* hָsͷ */
    char* h = s;
    char* t = s;
    char ch;

    /* tָsβ */
    while (*t++) {};
    t--;    /* t++ */
    t--;    /* '\0' */

    /* htδغʱַָ */
    while (h < t)
    {
        ch = *h;
        *h++ = *t;    /* hβƶ */
        *t-- = ch;    /* tͷƶ */
    }

    return(s);
}

int HexToDec(char *source, char * out)
{
    char *pn_Result, *pn_old;
    unsigned char num, rn, c, n_l, cx, vx, ii = 0, i, j;
    n_l = strlen(source);
    for (c = 0; c<n_l; c++)
    {
        if (!isxdigit(*(source + c)))
            return EMV_FALSE;
    }
    cx = (char)(n_l*1.2) + 3;
    vx = cx - 1;
    pn_old = (char *)malloc(sizeof(char)*(n_l + 1));
    if (pn_old == NULL)
        return EMV_FALSE;

    pn_Result = (char *)malloc(sizeof(char)*cx);
    if (pn_Result == NULL)
    {
        return EMV_FALSE;
    }

    strcpy(pn_old, source);
    strupr(source);
    vx = 0;
    c = 0;
    for (i = 0; c = (unsigned char)source[i];)
    {
        if (vx == 0)
            vx++;
        else if (c == '0')
        {
            i++;
            continue;
        }
        num = c - (c <= '9' ? '0' : 0x37);
        for (j = i;; j++)
        {
            c = num / 10;
            source[j] = c + (c <= 9 ? '0' : 0x37);
            rn = num % 10;
            if ((c = source[j + 1]) == NULL)
                break;
            num = 16 * rn + c - (c <= '9' ? '0' : 0x37);
        }
        pn_Result[ii++] = rn + '0';
    }
    pn_Result[ii] = NULL;
    pn_Result = strrev(pn_Result);
    strcpy(out, pn_Result);
    free(pn_old);
    free(pn_Result);
    return EMV_TRUE;
}


/*
*Կʶַʾ "9f3303E0E9C8"
//idx=TlvAppendAscii(0x9f21, buf1, 0,buff,idx,3);
Tag:Ҫװtag
srcData:ԭ
srcOffset:ԭʼλ
dstData:Ŀ
dstOffset:Ŀʼλ
srcLen:ԭݳ
tlvĸʽװݵbuff,ֵΪbuffĵǰ
*/
int TlvAppendAscii(unsigned int Tag, unsigned char *srcData, int srcOffset, unsigned char *dstData, int dstOffset, int srcLen)
{
    int idx = 0;
    int tagLen = 0;
    unsigned char tmpTag[3] = { 0 }, tmpL[3] = { 0 };
    int lLen = 0, wangLen = 0;
    wangLen = srcLen / 2;
    idx = dstOffset;
    // t
    if (Tag > 0xffff)
    {
        tmpTag[tagLen + 2] = Tag & 0xff;
        Tag >>= 8;
        tmpTag[tagLen + 1] = Tag & 0xff;
        Tag >>= 8;
        tmpTag[tagLen] = Tag & 0xff;
        tagLen += 3;
    }
    else if (Tag > 0xff)
    {
        tmpTag[tagLen + 1] = Tag & 0xff;
        Tag >>= 8;
        tmpTag[tagLen] = Tag & 0xff;
        tagLen += 2;
    }
    else
        tmpTag[tagLen++] = Tag & 0xff;

    vOneTwo(tmpTag, tagLen, dstData + idx);
    idx += tagLen * 2;
    // l
    if (wangLen <= 0x7f)
    {	
        tmpL[lLen++] = wangLen & 0xff;
    }
    else if (wangLen <= 0xff)
    {
    	
        tmpL[lLen++] = 0x81;
        tmpL[lLen++] = wangLen & 0xff;
    }
    else
    {	
        tmpL[lLen++] = 0x82;
        tmpL[lLen++] = wangLen / 256;
        tmpL[lLen++] = wangLen % 256;
    }
    
    vOneTwo(tmpL, lLen, dstData + idx);
    
    idx += lLen * 2;
    //  v
    memcpy(dstData + idx, srcData + srcOffset, srcLen);
    return idx + srcLen;
}

int TlvAppendAsciiDzc(unsigned int Tag, unsigned char *srcData, int srcOffset, unsigned char *dstData, int dstOffset, int srcLen)
{
    int idx = 0;
    int tagLen = 0;
    unsigned char tmpTag[3] = { 0 }, tmpL[3] = { 0 };
    int lLen = 0, wangLen = 0;
    wangLen = srcLen / 2;
    idx = dstOffset;
    // t
    if (Tag > 0xffff)
    {
        tmpTag[tagLen + 2] = Tag & 0xff;
        Tag >>= 8;
        tmpTag[tagLen + 1] = Tag & 0xff;
        Tag >>= 8;
        tmpTag[tagLen] = Tag & 0xff;
        tagLen += 3;
    }
    else if (Tag > 0xff)
    {
        tmpTag[tagLen + 1] = Tag & 0xff;
        Tag >>= 8;
        tmpTag[tagLen] = Tag & 0xff;
        tagLen += 2;
    }
    else
        tmpTag[tagLen++] = Tag & 0xff;

    vOneTwo(tmpTag, tagLen, dstData + idx);
    idx += tagLen * 2;
    // l
    if (wangLen <= 0x7f)
    {	
    	tmpL[lLen++] = 0x00;
        tmpL[lLen++] = wangLen & 0xff;
    }
    else if (wangLen <= 0xff)
    {
    	
        tmpL[lLen++] = 0x81;
        tmpL[lLen++] = wangLen & 0xff;
    }
    else
    {	
        tmpL[lLen++] = 0x82;
        tmpL[lLen++] = wangLen / 256;
        tmpL[lLen++] = wangLen % 256;
    }
    
    vOneTwo(tmpL, lLen, dstData + idx);
    
    idx += lLen * 2;
    //  v
    memcpy(dstData + idx, srcData + srcOffset, srcLen);
    return idx + srcLen;
}

int sha1(unsigned char *indata, int indata_len, unsigned char *outdata)
{


    int stepsize = 256;
    int calc_cnt = 0;
    PedHashCtx ctx;
    int ret = 0;
    ret = PedHashInit(&ctx, PED_HASH_ALGO_SHA1);
    if (ret == FALSE)
    {
        // LOGE("PedHashInit Fail!\n");
        return ret;
    }

    for (calc_cnt = 0; calc_cnt < indata_len;)
    {
        int len = indata_len - calc_cnt;
        if (len > stepsize)
        {
            len = stepsize;
        }

        ret = PedHashUpdate(&ctx, len, &indata[calc_cnt]);
        if (ret == FALSE)
        {
            return ret;
        }

        calc_cnt += len;
    }

    ret = PedHashFinal(&ctx, outdata, NULL);
    return ret;
}




void asc_to_bcd(char *AscStr, char *BcdStr, int AscStrLen)
{
    int     i;
    unsigned char str[2];
    unsigned char   t_buff;
    memset(str, 0, sizeof(str));

    for (i = 0; i<AscStrLen; i += 2)
    {
        t_buff = AscStr[i];
        if ((t_buff >= 'a') && (t_buff <= 'f'))
            str[0] = t_buff - 'a' + 0x0A;
        else if ((t_buff >= 'A') & (t_buff <= 'F'))
            str[0] = t_buff - 'A' + 0x0A;
        else if (t_buff >= '0')
            str[0] = t_buff - '0';
        else
            str[0] = 0;

        if ((i + 2) > AscStrLen) t_buff = '0';
        else    t_buff = AscStr[i + 1];
        if ((t_buff >= 'a') && (t_buff <= 'f'))
            str[1] = t_buff - 'a' + 0x0A;
        else if ((t_buff >= 'A') && (t_buff <= 'F'))
            str[1] = t_buff - 'A' + 0x0A;
        else if (t_buff >= '0')
            str[1] = t_buff - '0';
        else
            str[1] = 0;

        BcdStr[i / 2] = (str[0] << 4) | (str[1] & 0x0F);
    }
}


// 170428--->313730343238
void bcd_to_asc(char *bcd, char *asc, int asc_len)
{
    int i;
    int len;
    int j = 0;
    len = (asc_len + 1) / 2;
    j = asc_len % 2;

    for (i = 0; i < len; i++)
    {
        if (i != 0 || j != 1)
        {
            if (j)
                asc[i * 2 - j] = (bcd[i - 1]) & 0X0F;
            else
                asc[i * 2 - j] = (bcd[i] >> 4) & 0X0F;

            if (asc[i * 2 - j] > 9)
                asc[i * 2 - j] += ('A' - (char) 10);
            else
                asc[i * 2 - j] += '0';
        }

        if (j)
            asc[i * 2 + 1 - j] = (bcd[i] >> 4) & 0X0F;
        else
            asc[i * 2 + 1 - j] = (bcd[i]) & 0X0F;
        if (asc[i * 2 + 1 - j] > 9)
            asc[i * 2 + 1 - j] += ('A' - (char) 10);
        else
            asc[i * 2 + 1 - j] += '0';
    }
    asc[asc_len] = 0;
}


void utilsSpitAmt(const char *amt, char *result)
{


    int i;
    char amt2[13]= {0};
    int j=0;
    int dotFlag = 0;
    int icount  = 0;

    for (i = 0; i <= strlen(amt); i++)
    {

        if (amt[i] == '.')
        {
        	dotFlag = 1;
            continue;
        }
        
        if(amt[i]=='\0'){
            break;
        }
        amt2[j++]=amt[i];
        if(dotFlag){
        	icount++;
        }

    }
    if(dotFlag){
    	if(0 == icount){
    		amt2[j++] = '0';
    		amt2[j++] = '0';
    	}else if(1 == icount){
    		amt2[j++] = '0';
    	}
    }
    amt2[j]='\0';
	



    memcpy(result,amt2,strlen(amt2));


}


