#include "global.h"
#include "Pos_global.h"
#include "Pos_Err.h"

#ifdef TAG
#undef TAG
#endif
#define TAG "commu"

int begincommu = false;
int initThreadFlag = false;
int beginInit = false;
int igbhttpstate = -1;

//֤鹫Կ
static const char *iotx_ca_crt_yljh = \
{
    "-----BEGIN CERTIFICATE-----\r\n"
    "MIIEaTCCA1GgAwIBAgILBAAAAAABRE7wQkcwDQYJKoZIhvcNAQELBQAwVzELMAkG\r\n" \
    "A1UEBhMCQkUxGTAXBgNVBAoTEEdsb2JhbFNpZ24gbnYtc2ExEDAOBgNVBAsTB1Jv\r\n" \
    "b3QgQ0ExGzAZBgNVBAMTEkdsb2JhbFNpZ24gUm9vdCBDQTAeFw0xNDAyMjAxMDAw\r\n" \
    "MDBaFw0yNDAyMjAxMDAwMDBaMGYxCzAJBgNVBAYTAkJFMRkwFwYDVQQKExBHbG9i\r\n" \
    "YWxTaWduIG52LXNhMTwwOgYDVQQDEzNHbG9iYWxTaWduIE9yZ2FuaXphdGlvbiBW\r\n" \
    "YWxpZGF0aW9uIENBIC0gU0hBMjU2IC0gRzIwggEiMA0GCSqGSIb3DQEBAQUAA4IB\r\n" \
    "DwAwggEKAoIBAQDHDmw/I5N/zHClnSDDDlM/fsBOwphJykfVI+8DNIV0yKMCLkZc\r\n" \
    "C33JiJ1Pi/D4nGyMVTXbv/Kz6vvjVudKRtkTIso21ZvBqOOWQ5PyDLzm+ebomchj\r\n" \
    "SHh/VzZpGhkdWtHUfcKc1H/hgBKueuqI6lfYygoKOhJJomIZeg0k9zfrtHOSewUj\r\n" \
    "mxK1zusp36QUArkBpdSmnENkiN74fv7j9R7l/tyjqORmMdlMJekYuYlZCa7pnRxt\r\n" \
    "Nw9KHjUgKOKv1CGLAcRFrW4rY6uSa2EKTSDtc7p8zv4WtdufgPDWi2zZCHlKT3hl\r\n" \
    "2pK8vjX5s8T5J4BO/5ZS5gIg4Qdz6V0rvbLxAgMBAAGjggElMIIBITAOBgNVHQ8B\r\n" \
    "Af8EBAMCAQYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHQ4EFgQUlt5h8b0cFilT\r\n" \
    "HMDMfTuDAEDmGnwwRwYDVR0gBEAwPjA8BgRVHSAAMDQwMgYIKwYBBQUHAgEWJmh0\r\n" \
    "dHBzOi8vd3d3Lmdsb2JhbHNpZ24uY29tL3JlcG9zaXRvcnkvMDMGA1UdHwQsMCow\r\n" \
    "KKAmoCSGImh0dHA6Ly9jcmwuZ2xvYmFsc2lnbi5uZXQvcm9vdC5jcmwwPQYIKwYB\r\n" \
    "BQUHAQEEMTAvMC0GCCsGAQUFBzABhiFodHRwOi8vb2NzcC5nbG9iYWxzaWduLmNv\r\n" \
    "bS9yb290cjEwHwYDVR0jBBgwFoAUYHtmGkUNl8qJUC99BM00qP/8/UswDQYJKoZI\r\n" \
    "hvcNAQELBQADggEBAEYq7l69rgFgNzERhnF0tkZJyBAW/i9iIxerH4f4gu3K3w4s\r\n" \
    "32R1juUYcqeMOovJrKV3UPfvnqTgoI8UV6MqX+x+bRDmuo2wCId2Dkyy2VG7EQLy\r\n" \
    "XN0cvfNVlg/UBsD84iOKJHDTu/B5GqdhcIOKrwbFINihY9Bsrk8y1658GEV1BSl3\r\n" \
    "30JAZGSGvip2CTFvHST0mdCF/vIhCPnG9vHQWe3WVjwIKANnuvD58ZAWR65n5ryA\r\n" \
    "SOlCdjSXVWkkDoPWoC209fN5ikkodBpBocLTJIg1MGCUF7ThBCIxPTsvFwayuJ2G\r\n" \
    "K1pp74P1S8SqtCr4fKGxhZSM9AyHDPSsQPhZSZg=\r\n" \
    "-----END CERTIFICATE-----"
};

//â֤鹫Կ
static const char *iotx_ca_crt_qm = \
{
    "-----BEGIN CERTIFICATE-----\r\n"
	"MIIEsTCCA5mgAwIBAgIQCKWiRs1LXIyD1wK0u6tTSTANBgkqhkiG9w0BAQsFADBh\r\n" \
	"MQswCQYDVQQGEwJVUzEVMBMGA1UEChMMRGlnaUNlcnQgSW5jMRkwFwYDVQQLExB3\r\n" \
	"d3cuZGlnaWNlcnQuY29tMSAwHgYDVQQDExdEaWdpQ2VydCBHbG9iYWwgUm9vdCBD\r\n" \
	"QTAeFw0xNzExMDYxMjIzMzNaFw0yNzExMDYxMjIzMzNaMF4xCzAJBgNVBAYTAlVT\r\n" \
	"MRUwEwYDVQQKEwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5j\r\n" \
	"b20xHTAbBgNVBAMTFFJhcGlkU1NMIFJTQSBDQSAyMDE4MIIBIjANBgkqhkiG9w0B\r\n" \
	"AQEFAAOCAQ8AMIIBCgKCAQEA5S2oihEo9nnpezoziDtx4WWLLCll/e0t1EYemE5n\r\n" \
	"+MgP5viaHLy+VpHP+ndX5D18INIuuAV8wFq26KF5U0WNIZiQp6mLtIWjUeWDPA28\r\n" \
	"OeyhTlj9TLk2beytbtFU6ypbpWUltmvY5V8ngspC7nFRNCjpfnDED2kRyJzO8yoK\r\n" \
	"MFz4J4JE8N7NA1uJwUEFMUvHLs0scLoPZkKcewIRm1RV2AxmFQxJkdf7YN9Pckki\r\n" \
	"f2Xgm3b48BZn0zf0qXsSeGu84ua9gwzjzI7tbTBjayTpT+/XpWuBVv6fvarI6bik\r\n" \
	"KB859OSGQuw73XXgeuFwEPHTIRoUtkzu3/EQ+LtwznkkdQIDAQABo4IBZjCCAWIw\r\n" \
	"HQYDVR0OBBYEFFPKF1n8a8ADIS8aruSqqByCVtp1MB8GA1UdIwQYMBaAFAPeUDVW\r\n" \
	"0Uy7ZvCj4hsbw5eyPdFVMA4GA1UdDwEB/wQEAwIBhjAdBgNVHSUEFjAUBggrBgEF\r\n" \
	"BQcDAQYIKwYBBQUHAwIwEgYDVR0TAQH/BAgwBgEB/wIBADA0BggrBgEFBQcBAQQo\r\n" \
	"MCYwJAYIKwYBBQUHMAGGGGh0dHA6Ly9vY3NwLmRpZ2ljZXJ0LmNvbTBCBgNVHR8E\r\n" \
	"OzA5MDegNaAzhjFodHRwOi8vY3JsMy5kaWdpY2VydC5jb20vRGlnaUNlcnRHbG9i\r\n" \
	"YWxSb290Q0EuY3JsMGMGA1UdIARcMFowNwYJYIZIAYb9bAECMCowKAYIKwYBBQUH\r\n" \
	"AgEWHGh0dHBzOi8vd3d3LmRpZ2ljZXJ0LmNvbS9DUFMwCwYJYIZIAYb9bAEBMAgG\r\n" \
	"BmeBDAECATAIBgZngQwBAgIwDQYJKoZIhvcNAQELBQADggEBAH4jx/LKNW5ZklFc\r\n" \
	"YWs8Ejbm0nyzKeZC2KOVYR7P8gevKyslWm4Xo4BSzKr235FsJ4aFt6yAiv1eY0tZ\r\n" \
	"/ZN18bOGSGStoEc/JE4ocIzr8P5Mg11kRYHbmgYnr1Rxeki5mSeb39DGxTpJD4kG\r\n" \
	"hs5lXNoo4conUiiJwKaqH7vh2baryd8pMISag83JUqyVGc2tWPpO0329/CWq2kry\r\n" \
	"qv66OSMjwulUz0dXf4OHQasR7CNfIr+4KScc6ABlQ5RDF86PGeE6kdwSQkFiB/cQ\r\n" \
	"ysNyq0jEDQTkfa2pjmuWtMCNbBnhFXBYejfubIhaUbEv2FOQB3dCav+FPg5eEveX\r\n" \
	"TVyMnGo=\r\n" \
	"-----END CERTIFICATE-----"
};

//С̨֤鹫Կ
static const char *iotx_ca_crt_dl = \
{
	"-----BEGIN CERTIFICATE-----\r\n"
	"MIIETjCCAzagAwIBAgINAe5fIh38YjvUMzqFVzANBgkqhkiG9w0BAQsFADBMMSAw\r\n" \
	"HgYDVQQLExdHbG9iYWxTaWduIFJvb3QgQ0EgLSBSMzETMBEGA1UEChMKR2xvYmFs\r\n" \
	"U2lnbjETMBEGA1UEAxMKR2xvYmFsU2lnbjAeFw0xODExMjEwMDAwMDBaFw0yODEx\r\n" \
	"MjEwMDAwMDBaMFAxCzAJBgNVBAYTAkJFMRkwFwYDVQQKExBHbG9iYWxTaWduIG52\r\n" \
	"LXNhMSYwJAYDVQQDEx1HbG9iYWxTaWduIFJTQSBPViBTU0wgQ0EgMjAxODCCASIw\r\n" \
	"DQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAKdaydUMGCEAI9WXD+uu3Vxoa2uP\r\n" \
	"UGATeoHLl+6OimGUSyZ59gSnKvuk2la77qCk8HuKf1UfR5NhDW5xUTolJAgvjOH3\r\n" \
	"idaSz6+zpz8w7bXfIa7+9UQX/dhj2S/TgVprX9NHsKzyqzskeU8fxy7quRU6fBhM\r\n" \
	"abO1IFkJXinDY+YuRluqlJBJDrnw9UqhCS98NE3QvADFBlV5Bs6i0BDxSEPouVq1\r\n" \
	"lVW9MdIbPYa+oewNEtssmSStR8JvA+Z6cLVwzM0nLKWMjsIYPJLJLnNvBhBWk0Cq\r\n" \
	"o8VS++XFBdZpaFwGue5RieGKDkFNm5KQConpFmvv73W+eka440eKHRwup08CAwEA\r\n" \
	"AaOCASkwggElMA4GA1UdDwEB/wQEAwIBhjASBgNVHRMBAf8ECDAGAQH/AgEAMB0G\r\n" \
	"A1UdDgQWBBT473/yzXhnqN5vjySNiPGHAwKz6zAfBgNVHSMEGDAWgBSP8Et/qC5F\r\n" \
	"JK5NUPpjmove4t0bvDA+BggrBgEFBQcBAQQyMDAwLgYIKwYBBQUHMAGGImh0dHA6\r\n" \
	"Ly9vY3NwMi5nbG9iYWxzaWduLmNvbS9yb290cjMwNgYDVR0fBC8wLTAroCmgJ4Yl\r\n" \
	"aHR0cDovL2NybC5nbG9iYWxzaWduLmNvbS9yb290LXIzLmNybDBHBgNVHSAEQDA+\r\n" \
	"MDwGBFUdIAAwNDAyBggrBgEFBQcCARYmaHR0cHM6Ly93d3cuZ2xvYmFsc2lnbi5j\r\n" \
	"b20vcmVwb3NpdG9yeS8wDQYJKoZIhvcNAQELBQADggEBAJmQyC1fQorUC2bbmANz\r\n" \
	"EdSIhlIoU4r7rd/9c446ZwTbw1MUcBQJfMPg+NccmBqixD7b6QDjynCy8SIwIVbb\r\n" \
	"0615XoFYC20UgDX1b10d65pHBf9ZjQCxQNqQmJYaumxtf4z1s4DfjGRzNpZ5eWl0\r\n" \
	"6r/4ngGPoJVpjemEuunl1Ig423g7mNA2eymw0lIYkN5SQwCuaifIFJ6GlazhgDEw\r\n" \
	"fpolu4usBCOmmQDo8dIm7A9+O4orkjgTHY+GzYZSR+Y0fFukAj6KYXwidlNalFMz\r\n" \
	"hriSqHKvoflShx8xpfywgVcvzfTO3PYkz6fiNJBonf6q8amaEsybwMbDqKWwIX7e\r\n" \
	"SPY=\r\n" \
	"-----END CERTIFICATE-----"
};

const char *iotx_dzc_ca_get(void)
{
    return iotx_ca_crt_yljh;
}

const char *iotx_qm_ca_get(void)
{
    return iotx_ca_crt_qm;
}

const char *iotx_dl_ca_get(void)
{
    return iotx_ca_crt_dl;
}

int count = 0;

int initOk = false;
char *hostName;
int port;
char* ca_crt;
int ca_crt_len;
HTTP_MODE_CTX *hmc1 = NULL;


void init_commu(ULONG argc, LPVOID lpThreadParameter)
{
    int ret = -1;
    int cnt = 0;
    LOGD("[%s:%d]", __FUNCTION__, __LINE__);
    while(1)
    {
        //LOGD("[%s:%d]cnt[%d]beginInit[%d]", __FUNCTION__, __LINE__, cnt, beginInit);
        if(beginInit == false)
        {
            DelayMs(500);
            continue;
        }
        if(hmc1)
        {
            httpClose(&hmc1);
            hmc1 = NULL;
        }
        igbhttpstate = -1;
		if(!memberCardT.memCardFlag){
	        if(!nfcFlag){//ɨ
		        LOGD("[%s:%d][%d]Ԥſʼ", __FUNCTION__, __LINE__, cnt+1);
		        ret = httpsInitHandshakeEx(hostName,port,ca_crt,ca_crt_len, &igbhttpstate);
		    }else{//ǽ
		    	LOGD("[%s:%d][%d]Ԥſʼ", __FUNCTION__, __LINE__, cnt+1);
		        ret = httpsInitHandshake(hostName,port,NULL,0);
		    }
		}else{			
			ret = httpsInitHandshakeEx(hostName,port,NULL,0, &igbhttpstate);
		}
        if(ret == 0)
        {
            LOGD("[%s:%d][%d]Ԥųɹ!!!", __FUNCTION__, __LINE__, cnt+1);
            initOk = true;
            beginInit = false;
            nfcFlag = 0;
            cnt = 0;
        }
        else
        {
            DelayMs(50);
            cnt++;
            LOGD("[%s:%d][%d]Ԥʧ!!!", __FUNCTION__, __LINE__, cnt);
            if(cnt >= 10)
            {
                beginInit = false;
                nfcFlag = 0;
                cnt = 0;

            }
        }

    }
}

int CommuInit(char* host,int hostport,char* ca,int ca_len)
{
    if(beginInit == true)
    {
        LOGD("[%s:%d]Ԥ....", __FUNCTION__, __LINE__);
        return NORMAL;
    }
    LOGD("[%s:%d]ʼԤ....", __FUNCTION__, __LINE__);
    DWORD threadID;
    HANDLE initThread = NULL;
    hostName = host;
    port = hostport;
    ca_crt = ca;
    ca_crt_len = ca_len;
    initOk = false;
    beginInit = true;
    if(initThreadFlag == false)
    {
        LOGD("[%s:%d]Ԥ߳", __FUNCTION__, __LINE__);
        initThread = CreateThread(NULL, 1*1024, init_commu, 0, NULL, CREATE_SUSPENDED, &threadID);
        if (NULL != initThread)
        {
            SetThreadPriority(initThread, 200);
            ResumeThread(initThread);
            initThreadFlag = true;
        }
    }
    return 0;
}



void trans_DisplayPro(char *Str);

#define DEBUG_COMMU         0
#define HOST    DataSave.CommuPar.httpURL


int sendHttpUrlData_7(char *psendData, int sendLen, int post, char *purl, char *precdata, int *recvLen, int showopen)
{
    HTTP_MODE_CTX *hmc = NULL;
    T_SOFTTIMER checkNet;
    int conCount = 0;
    int ret = 0;
    int dataLen = 0;
    int *psize = NULL;
    int  ihttpstate = -1;
    int key = 0;

    while(begincommu)
    {
        Sleep(20);
        continue;
    }
startCommuhttpNfc:
	count = 0;
    LOGD("[%s:%d]initOk[%d]", __FUNCTION__, __LINE__, initOk);
    while(initOk != true)
    {

        LOGD("[%s:%d]initOk != true", __FUNCTION__, __LINE__);
        key = KbWaitKey(300);
        if (key == KEY_CANCEL)
        {
            return CONNECTFAIL;
        }
        LOGD("[%s:%d]count[%d]", __FUNCTION__, __LINE__, count);
        if((count ++) >= 50)
            return CONNECTFAIL;
    }
	
    httpInit(&hmc, HOST, sizeof(HOST), post, purl, strlen(purl) + 1, 1);
    ihttpstate = hmc->hc->net.socket_id;
#if DEBUG_COMMU
    LOGD("[%s:%d]httpState[%d]\n", __FUNCTION__, __LINE__, hmc->httpState);
    LOGD("[%s:%d]hmc->hc->net.socket_id[%d]\n", __FUNCTION__, __LINE__, ihttpstate);
#endif
    if (!hmc->httpState)
    {
        httpClose(&hmc);
        return CONNECTFAIL;
    }

    httpHeadPar(hmc,"Content-Type",strlen("Content-Type"),"application/x-www-form-urlencoded;charset=gbk",strlen("application/x-www-form-urlencoded;charset=gbk"));
    httpSetAlive(&hmc,0);

#if DEBUG_COMMU
    LOGD("purl:%d\n", strlen(purl) + 1);
    LOGD("httpState:%d\n", hmc->httpState);
#endif

    if (showopen && (DataSave2.runData.ucTransType != TRANS_TYPE_ACTIVE))
    {
        trans_DisplayPro("ڷ...");
    }

    s_TimerSet(&checkNet, 5*1000);
    while (s_TimerCheck(&checkNet))
    {
        ret = NetSocketCheck(ihttpstate);
        LOGD("*********check net state******ret:[%d]\n", ret);
        if(ret)
        {
            break;
        }
        Sleep(50);
    }
    if(!ret)
    {
        LOGD("##########check net state fail########ret:[%d]\n",ret);
        httpClose(&hmc);
        hmc = NULL;
        ihttpstate = -1;
        if(!conCount)
        {
            conCount = 1;
            goto startCommuhttpNfc;
        }
        else
        {
            httpClose(&hmc);
            hmc = NULL;
            return SENDFAIL;
        }
    }

    httpWrite(hmc, psendData, sendLen);
    begincommu = true;

    if (!hmc->httpState)
    {
        httpClose(&hmc);
        begincommu = false;
        return SENDFAIL;
    }

    if (showopen && (DataSave2.runData.ucTransType != TRANS_TYPE_ACTIVE) )
    {
        trans_DisplayPro("ڽ...");
    }

    httpRead(hmc, precdata, psize);
    begincommu = false;
    dataLen = strlen(precdata);
    *recvLen = dataLen;
#if DEBUG_COMMU
    LOGD("[%s:%d]hmc->hc->net.handle[%d]\n", __FUNCTION__, __LINE__, hmc->hc->net.socket_id);
    LOGD("real len:[%d] precdata:[%s]\n", *recvLen, precdata);
#endif
    begincommu = false;
    if (!dataLen)
    {
        httpClose(&hmc);
        return RECVFAIL;
    }
    httpClose(&hmc);
    return NORMAL;
}

int sendHttpsUrlData_7(char *psendData, int sendLen, int post, char *purl, char *precdata, int *recvLen, int showopen)
{
    //HTTP_MODE_CTX *hmc = NULL;
    int key = 0;
    T_SOFTTIMER checkNet;
    int conCount = 0;
    int ret = 0;
    int dataLen = 0;
    int *psize = NULL;

    while(begincommu)
    {
        Sleep(20);
        continue;
    }

startCommuhttps:

    count = 0;
    LOGD("[%s:%d]initOk[%d]", __FUNCTION__, __LINE__, initOk);
    while(initOk != true)
    {

        LOGD("[%s:%d]initOk != true", __FUNCTION__, __LINE__);
        key = KbWaitKey(300);
        if (key == KEY_CANCEL)
        {
            return CONNECTFAIL;
        }
        LOGD("[%s:%d]count[%d]", __FUNCTION__, __LINE__, count);
        if((count ++) >= 50)
            return CONNECTFAIL;
    }

	setTimeout(60);
	if(!memberCardT.memCardFlag){
		if((!DataSave.PosPar.scan_yard) && (unionFlag == 0)){
			LOGD("BaBaTe server router way");
	   	 	httpInit(&hmc1, "dct.semoor.cn", strlen("dct.semoor.cn"), post, purl, strlen(purl) + 1, 0);
	   	}else if((2 == DataSave.PosPar.scan_yard) && (unionFlag == 0)){
	   		LOGD("Qingmang server router way");
	   	 	httpInit(&hmc1, "api.greenmangodata.com", strlen("api.greenmangodata.com"), post, purl, strlen(purl) + 1, 1);
			httpHeadPar(hmc1,"Content-Type",strlen("Content-Type"),"application/json",strlen("application/json"));
	   	}else if((3 == DataSave.PosPar.scan_yard) && (4 == NormalTrans.scan_yard)){
			//С̨
			LOGD("Dili server router way");
			httpInit(&hmc1, "atestapi.mrfresh.com", strlen("atestapi.mrfresh.com"), post, purl, strlen(purl) + 1, 1);
			//httpInit(&hmc1, "testapi.mrfresh.com", strlen("testapi.mrfresh.com"), post, purl, strlen(purl) + 1, 1);
			httpHeadPar(hmc1, "Content-Type", strlen("Content-Type"), "application/json;charset=UTF-8", 30);
		}else{
			LOGD("Yinlian server router way");
	    	httpInit(&hmc1, "qra.95516.com", strlen("qra.95516.com"), post, purl, strlen(purl) + 1, 1);
	    }
	}else{
		if(strlen(psendData)){
			httpInit(&hmc1, (char*)DataProtect.member_cardIp, strlen((char*)DataProtect.member_cardIp), post, purl, strlen(purl) + 1, 1);
		}else{
			httpInit(&hmc1, (char*)DataProtect.member_cardIp, strlen((char*)DataProtect.member_cardIp), post, purl, strlen(purl) + 1, 0);
		}
	}

    igbhttpstate = hmc1->hc->net.socket_id;
#if DEBUG_COMMU
    LOGD("[%s:%d]httpState[%d]\n", __FUNCTION__, __LINE__, hmc1->httpState);
    LOGD("[%s:%d]hmc->hc->net.socket_id[%d]\n", __FUNCTION__, __LINE__, hmc1->hc->net.socket_id);
#endif

    if (!hmc1->httpState)
    {
        httpClose(&hmc1);
        hmc1 = NULL;
        return CONNECTFAIL;
    }

#if DEBUG_COMMU
    LOGD("purl:%s len:%d\n", purl, strlen(purl));
    LOGD("httpState:%d\n", hmc1->httpState);
    LOGD("[%s:%d]hmc->hc->net.socket_id[%d]\n", __FUNCTION__, __LINE__, hmc1->hc->net.socket_id);
#endif

    if (showopen)
    {
        trans_DisplayPro("ڷ...");
    }

    s_TimerSet(&checkNet, 3*1000);
    while (s_TimerCheck(&checkNet))
    {
        ret = NetSocketCheck(igbhttpstate);
        LOGD("*****************check net state**************ret:[%d]\n", ret);
        if(ret)
        {
            break;
        }
        Sleep(50);
    }
    if(!ret)
    {
        LOGD("#############check net state fail###############ret:[%d]\n",ret);
        httpClose(&hmc1);
        hmc1 = NULL;
        igbhttpstate = -1;
        if(!conCount)
        {
            conCount = 1;
			if(!memberCardT.memCardFlag){
				if((!DataSave.PosPar.scan_yard) && (unionFlag == 0)){
			        httpInit(&hmc1, "dct.semoor.cn", strlen("dct.semoor.cn"), post, purl, strlen(purl) + 1, 0);
			    }else if((2 == DataSave.PosPar.scan_yard) && (unionFlag == 0)){
			    	httpInit(&hmc1, "api.greenmangodata.com", strlen("api.greenmangodata.com"), post, purl, strlen(purl) + 1, 1);
			    }else{
			        httpInit(&hmc1, "qra.95516.com", strlen("qra.95516.com"), post, purl, strlen(purl) + 1, 1);
			    }
			}else{
				if(strlen(psendData)){
					httpInit(&hmc1, (char*)DataProtect.member_cardIp, strlen((char*)DataProtect.member_cardIp), post, purl, strlen(purl) + 1, 1);
				}else{
					httpInit(&hmc1, (char*)DataProtect.member_cardIp, strlen((char*)DataProtect.member_cardIp), post, purl, strlen(purl) + 1, 0);
				}
			}
        }
        else
        {
            httpClose(&hmc1);
            hmc1 = NULL;
            igbhttpstate = -1;
            return SENDFAIL;
        }
    }

    httpWrite(hmc1, psendData, sendLen);
    igbhttpstate = hmc1->hc->net.socket_id;
#if DEBUG_COMMU
    LOGD("[%s:%d]httpState[%d]\n", __FUNCTION__, __LINE__, hmc1->httpState);
    LOGD("[%s:%d]hmc->hc->net.socket_id[%d]\n", __FUNCTION__, __LINE__, hmc1->hc->net.socket_id);
#endif

    begincommu = true;

    if (!hmc1->httpState)
    {
        LOGD("[%s:%d] send error\n", __FUNCTION__, __LINE__);
        httpClose(&hmc1);
        hmc1 = NULL;
        begincommu = false;
        return SENDFAIL;
    }

    if (showopen)
    {
        trans_DisplayPro("ڽ...");
    }
#if DEBUG_COMMU
    LOGD("[%s:%d] start read data\n", __FUNCTION__, __LINE__);
#endif

    httpReadEx(hmc1, precdata, 4096,psize);
    igbhttpstate = hmc1->hc->net.socket_id;
    begincommu = false;
    dataLen = strlen(precdata);
    *recvLen = dataLen;
#if DEBUG_COMMU
    LOGD("[%s:%d]hmc->hc->net.handle[%d]\n", __FUNCTION__, __LINE__, hmc1->hc->net.socket_id);
    LOGD("real len:[%d] precdata:%s\n", *recvLen, precdata);
#endif

    if (!dataLen)
    {
        httpClose(&hmc1);
        hmc1 = NULL;
        return RECVFAIL;
    }
    return NORMAL;
}

int commuSocketGetHeadLen(void)
{
    //һsocketͷ2ֽ
    return 2;
}

int commuSocketGetBodyLen(uchar *head, int len)
{
    return (head[0] * 256 + head[1]);
}

void commuSetStatus(int stateCode, int timeout)
{
    uchar buffer[30] = {0,};

    switch (stateCode)
    {
    case COMMUBEGIN:
        menuShowTextRow(2, (uchar *) "׼ͨѶ");
        break;
    case PPPDIALING:
        menuShowTextRow(2, (uchar *) "ʼ");
        break;
    case PPPDIALSUC:
//            menuShowTextRow(2, (uchar *) "ųɹ");
        break;
    case PPPCLOSE:
//            menuShowTextRow(2, (uchar *) "");
        break;
    case CONNECTING:
        menuShowTextRow(2, (uchar *) "    ʼ      ");
        break;
    case CONNECTED:
        menuShowTextRow(2, (uchar *) "    ӳɹ      ");
        break;
    case SENDING:
        menuShowTextRow(2, (uchar *) " ڷ...  ");
        break;
    case RECVING:
        snprintf((char *) buffer, sizeof(buffer), "ڽ...%d", timeout);
        menuShowTextRow(2, (uchar *) buffer);
        break;
    case RECVSUC:
        menuShowTextRow(2, (uchar *) "           ");
        break;
    }
}


/*
 * ͨѶ
 * :
 *		params  ͨѶ
 *		sendbuff 
 *		sendLen ݳ
 *		recvbuff  ݵַ
 *		recvLen ݳȵַ
 *		getHeadSizeȡͷȺָ룬֪ײ㣬㳤ȵıͷ
 *		getBodySizeȡĳȺָ룬ȡ㱨ͷȵݣĳ
 *		doCommuStatus ͨѶ״ָ̬룬һ״̬룬ڶǽյʱ
 * ֵ
 *  	int
 *		NORMAL   EXCEPTION 
 */
int sendSocketData(tsCommuPar *params, uchar *sendbuff, int sendLen, uchar *recvbuff, int *recvLen, int (*getHeadSize)(void),
          int (*getBodySize)(uchar *, int), void (*setCommuStatus)(int, int))
	{
		int ret, count = 0;
		int socket;
		int headLen;
		int bodyLen;
		int dataLen;
		if (params == NULL || sendbuff == NULL || sendLen <= 0 || recvbuff == NULL || recvLen == NULL ||
			setCommuStatus == NULL)
			return ARGSERROR;
		if (params->type != TCP && params->type != UDP)
			return ARGSERROR;
		if (params->apntype != CMNET && params->apntype != CMWAP)
			return ARGSERROR;
		if (params->flag != IPADDRESS && params->flag != DOMAINADDRESS)
			return ARGSERROR;
		if (0 == params->timeout)
			return ARGSERROR;
	
		//豸ģ
		setCommuStatus(COMMUBEGIN, params->timeout);
		//PPP
		setCommuStatus(PPPDIALING, params->timeout);
#if 0
		//ȴֱPPPųɹ
		count = 0;
		while (1)
		{
			ret = NetDeviceGetConnectionStatus();
			LOGD("~NetDeviceGetConnectionStatus:%d", ret);
			if (ret)
			{
				break;
			}
			else
			{
				Sleep(100);
				count++;
				if (count == 100)
				{
					LOGD("~~~~~~~~~~~~~~~~~:%d", ret);
					continue;
				}
				else if (count > 300)
				{
					menuShowTextRow(2, (uchar *)"ʧܣȡֶ");
					if (KEY_CANCEL == KbWaitKey(50))
					{
						return CONNECTFAIL;
					}
				}
				if (KEY_CANCEL == KbWaitKey(50))
				{
					break;
				}
			}
		}
#endif
	
		setCommuStatus(PPPDIALSUC, params->timeout);
		//ӷ
		setCommuStatus(CONNECTING, params->timeout);
	    socket = NetSocketConnect(params->type, params->ip, params->port, params->flag);
	   
		if (socket < 0)
		{
		    LOGD("Socket connect fail   socket=  %d \n",socket);
			return CONNECTFAIL;
		}
		setCommuStatus(CONNECTED, params->timeout);
	
		//Socket״̬
		ret = NetSocketWaitConnet(socket, 5000);
		if (!ret){
			LOGD("Socket wait connect fail     ret= %d \n",ret);
			NetSocketClose(socket);
			return CONNECTFAIL;
		}
			
			
	
		//
		setCommuStatus(SENDING, params->timeout);
		ret = NetSocketSend(socket, sendbuff, sendLen);
		if (ret < 0)
		{
			LOGD("Socket send fail\n");
			LOGD("Socket error code:%d\n", SocketErrNo(socket));
			LOGD("System error code:%ul\n", GetLastError());
			NetSocketClose(socket);
			return SENDFAIL;
		}
		LOGD("Socket send ret : %d\n", ret);
	
		Sleep(100);
	
		//
		setCommuStatus(RECVING, params->timeout);
        count = 0;
		while (count < 30)
		{
            ret = NetSocketCheck(socket);
            LOGD("Socket status: %d\n", ret);
			ret = NetSocketGetOption(socket, SOCKET_RXDATA, &dataLen);
			LOGD("Socket data length to receive: %d\n", dataLen);
			
			if (dataLen>0)
			{
				//Ȼȡͷ
				headLen = getHeadSize();
				LOGD("Socket NetSocketCheck headLen : %d\n", headLen);
				//ͷȴ0ȥȡͷ
				if (headLen > 0)
				{
					ret = NetSocketRecv(socket, recvbuff, headLen);
					if (ret == headLen)
					{
						bodyLen = getBodySize(recvbuff, headLen);
						if (bodyLen > 0)
						{
							BUFCLR(recvbuff);
							ret = NetSocketRecv(socket, recvbuff, bodyLen);
							//ǿƱȶbodyLen,ΪЩĳ쳣
							if (ret > 0)
							{
								setCommuStatus(RECVSUC, params->timeout);
								*recvLen = bodyLen;
								NetSocketClose(socket);
								return NORMAL;
							}
						}
					}
				}
				else
				{
					//ıģЩûбͷȵģֱӻȡĳ
					bodyLen = getBodySize(recvbuff, headLen);
					if (bodyLen > 0)
					{
						BUFCLR(recvbuff);
						ret = NetSocketRecv(socket, recvbuff, bodyLen);
	
						//ǿƱȶbodyLen,ΪЩĳ쳣
						if (ret > 0)
						{
							setCommuStatus(RECVSUC, params->timeout);
							*recvLen = bodyLen;
							NetSocketClose(socket);
							return NORMAL;
						}
					}
				}
				NetSocketClose(socket);
				return RECVFAIL;
			}
			else
			{
			    //ײûݿԽգȴ1ٴȥ
			    Sleep(1000);
                count ++;
//				NetSocketClose(socket);
//				return RECVFAIL;
			}
		}
        NetSocketClose(socket);
		return RECVFAIL;
	}


