#include "MercurySystem.h"
#include "bwsdk.h"
#include "bwquics.h"
#include "cJSON.h"
#include "global.h"
#include "dzcUtils.h"
//#include "EmvRsa.h"
#include "pack_Base64.h"
#include "logger.h"
#include "md5c.h"
#include "Pos_global.h"


#define KQ_PRODECU_ENV



#ifdef TAG
#undef TAG
#endif
#define TAG "zhUtils"


#ifdef uchar
#undef uchar
#endif
#define uchar unsigned char

static char temp[1024];


/************/

// p1p2 typevaluestringstringֶ
static void swapJsonPos(cJSON **pA, cJSON **pB);

/*ֶJSONе
*jsonObj  in - Ҫjson󣬱cJSON_Object
*retun źjsonָ*/
static cJSON* jsonObjSortByKey(cJSON* jsonObj);


static void delQuoMark(char* pinData, char* poutData);

static void GetXmlKey(const char* pNext, char* poutKey);

static void GetXmlValueFromKey(const char* pXml, const char* pKey, char* poutValue);

/*JSONתASC
*root  in - json
*psign out - ݵASC
*retun ASC*/

int JsontoAsc(cJSON* root, char* psign)
{
    char sign[32];
    MD5_CTX md5;
    int ret = -1;

    //ǩ
    BUFCLR(temp);
    BUFCLR(sign);
    ret = JsonTrans(root, temp);
    strcat(temp, "&key=");
	if((2 == DataSave.PosPar.scan_yard) && (0== unionFlag)){
		strcat(temp, SECRETKEY_QM);
	}else{
    	strcat(temp, DataSave.PosPar.aucACQINS);
	}
    ret += strlen("&key=");
	if((2 == DataSave.PosPar.scan_yard) && (0== unionFlag)){
		ret += strlen(SECRETKEY_QM);
	}else{
    	ret += strlen(DataSave.PosPar.aucACQINS);
	}
    // תĳ
    memset(&md5, 0, sizeof(MD5_CTX));
    MD5Init(&md5);
    MD5Update(&md5, (unsigned char*)temp, ret);
    MD5Final((unsigned char*)sign,&md5);
    ret = utilsBcd2Asc((uchar *) sign, 16, (uchar * )psign);

    return ret;
}

/*JSONʽת
*item  in - json
*psign out - ת
*retun ת*/
int JsonTrans(cJSON *root, char *psign)
{
    int flagFirst = 0;
    int flagSecond = 0;
    int offset = 0;
    int isFirst = 1;
    cJSON *sortObj = NULL;
    char *sznum[20];

    cJSON *item = root->child;
    while(item)
    {
        flagFirst = 0;

        switch(item->type)
        {
            case cJSON_NULL:
            {
                break;
            }
            case cJSON_String:
            {
                //LOGD("item->string:[%s], offset:[%d]\n", item->string, offset);
                if(strlen(item->string) == 4 && !memcmp(item->string, "sign", 4) )
                {
                    break;
                }
                if(strlen(item->valuestring) != 0 )
                {
                    if(isFirst)

                    {
                        sprintf(psign + offset, "%s", item->string);
                        offset += strlen(item->string);
                        //LOGD("111psign:[%s], offset:[%d]\n", psign, offset);
                        isFirst = 0;
                    }
                    else
                    {
                        sprintf(psign + offset, "&%s", item->string);
                        offset += strlen(item->string) + 1;
                    }
                    sprintf(psign + offset, "=%s", item->valuestring);
                    offset += strlen(item->valuestring) + 1;
                    //LOGD("222psign:[%s], offset:[%d]\n", psign, offset);
                }
                break;
            }
            case cJSON_Number:
            {
                if(isFirst)

                {
                    sprintf(psign + offset, "%s", item->string);
                    offset += strlen(item->string);
                    //LOGD("111psign:[%s], offset:[%d]\n", psign, offset);
                    isFirst = 0;
                }
                else
                {
                    sprintf(psign + offset, "&%s", item->string);
                    offset += strlen(item->string) + 1;
                }
                sprintf(psign + offset, "=%d", item->valueint);
                BUFCLR(sznum);
                sprintf(sznum, "%d", item->valueint);
                offset += strlen(sznum) + 1;
                //LOGD("222psign:[%s], offset:[%d]\n", psign, offset);

                break;
            }
            case cJSON_Object:
            {
                //JsonTrans(item->value);
                if(cJSON_NULL == item->type)
                {
                    break;
                }
                //ȡ
                cJSON *itemSonRoot = cJSON_GetObjectItem(root, item->string);
                if(cJSON_NULL == itemSonRoot->type)
                {
                    //jsonΪnull, ƴװ˶
                    break;
                }
                cJSON *itemSon = itemSonRoot->child;
                while(itemSon)
                {
                    flagSecond = 0;

                    switch(itemSon->type)
                    {
                        case cJSON_NULL:
                        {
                            break;
                        }
                        case cJSON_String:
                        {
                            if(strlen(itemSon->valuestring) != 0 )
                            {
                                if(!flagFirst)
                                {
                                    sprintf(psign + offset, "&%s={", item->string);
                                    offset += strlen(item->string) + 3;
                                    flagFirst = 1;

                                    sprintf(psign + offset, "\"%s\"", itemSon->string);
                                    offset += strlen(itemSon->string) + 2;
                                }
                                else
                                {
                                    sprintf(psign + offset, ",\"%s\"", itemSon->string);
                                    offset += strlen(itemSon->string) + 3;
                                }

                                sprintf(psign + offset, ":\"%s\"", itemSon->valuestring);
                                offset += strlen(itemSon->valuestring) + 3;
                            }
                            break;
                        }
                        case cJSON_Number:
                        {
                            //LOGD("111psign:[%s], offset:[%d]\n", psign, offset);
                            if(!flagFirst)

                            {
                                sprintf(psign + offset, "&%s={", item->string);
                                offset += strlen(item->string) + 3;
                                flagFirst = 1;

                                sprintf(psign + offset, "\"%s\"", itemSon->string);
                                offset += strlen(itemSon->string) + 2;
                            }
                            else
                            {
                                sprintf(psign + offset, ",\"%s\"", itemSon->string);
                                offset += strlen(itemSon->string) + 3;
                            }
                            sprintf(psign + offset, ":%d", itemSon->valueint);
                            BUFCLR(sznum);
                            sprintf(sznum, ":%d", itemSon->valueint);
                            offset += strlen(sznum);
                            //LOGD("222offset:[%d], psign:[%s], flagFirst:[%d]\n", offset, psign, flagFirst);

                            break;
                        }
                        case cJSON_Object:
                        {
                            if(cJSON_NULL == itemSon->type)
                            {
                                break;
                            }
                            //ȡ
                            cJSON *itemSonSonRoot = cJSON_GetObjectItem(itemSonRoot, itemSon->string);
                            if(cJSON_NULL == itemSonSonRoot->type)
                            {
                                //jsonΪnull, ƴװ˶
                                break;
                            }

                            sortObj = jsonObjSortByKey(itemSonSonRoot);

                            cJSON *itemSonSon = sortObj->child;
                            while(itemSonSon)
                            {
                                switch(itemSonSon->type)
                                {
                                    case cJSON_NULL:
                                    {
                                        break;
                                    }
                                    case cJSON_String:
                                    {
                                        if(strlen(itemSonSon->valuestring) != 0 )
                                        {
                                            if(!flagSecond)
                                            {
                                                sprintf(psign + offset, "&%s={", itemSon->string);
                                                offset += strlen(itemSon->string) + 3;
                                                flagSecond = 1;

                                                sprintf(psign + offset, "{\"%s\"", itemSon->string);
                                                offset += strlen(itemSon->string) + 3;
                                            }
                                            else
                                            {
                                                sprintf(psign + offset, ",\"%s\"", itemSon->string);
                                                offset += strlen(itemSon->string) + 3;
                                            }

                                            sprintf(psign + offset, ":\"%s\"", itemSon->valuestring);
                                            offset += strlen(itemSon->valuestring) + 3;
                                        }
                                        break;
                                    }
                                }

                                itemSonSon = itemSonSon->next;
                            }
                            //ڲjson'}'
                            if(flagSecond)
                            {
                                sprintf(psign + offset, "%s", "}");
                                offset++;
                            }
                            itemSonSon = NULL;
                            break;
                        }
                    }
                    itemSon = itemSon->next;
                }
                //json'}'
                //LOGD("333offset:[%d],psign:[%s],  flagFirst:[%d]\n", offset, psign, flagFirst);
                if(flagFirst)
                {
                    sprintf(psign + offset, "%s", "}");
                    offset++;
                }
                //LOGD("444offset:[%d],psign:[%s], flagFirst:[%d]\n", offset, psign, flagFirst);
                itemSon = NULL;
                break;
            }
        }

        item = item->next;
    }

    cJSON_Delete(sortObj);
    sortObj = NULL;
    return offset;
}

/*ֶJSONе
*jsonObj  in - Ҫjson󣬱cJSON_Object
*retun źjsonָ,ҪcJSON_Deleteͷ
*֧objectǶ*/
cJSON* jsonObjSortByKey(cJSON* jsonObj)
{

    cJSON *pItem = NULL;
    cJSON *pWalk = NULL;
    cJSON *pMin = NULL;
    cJSON *pObj = NULL;
    char firstRound = 1;
    cJSON *childTmp = NULL;

    if (jsonObj == NULL || jsonObj->type != cJSON_Object) return NULL;

    pObj = cJSON_Duplicate(jsonObj, 1);

    /*
    char* p;
    p = cJSON_PrintUnformatted(pObj);
    LOGD("-----------after cJSON_Duplicate----pObj == [%s]\n", p);
    */

    if(!pObj) return NULL;

    // ѡ
    for (pItem = pObj->child; pItem != NULL; pItem = pItem->next)
    {
        pMin = pItem;
        for (pWalk = pItem->next; pWalk != NULL; pWalk = pWalk->next)
        {
            if (strcmp(pWalk->string, pMin->string) < 0)
                pMin = pWalk;
        }
        // ȲҪ
        if (strcmp(pItem->string, pMin->string) == 0) continue;

        swapJsonPos(&pItem, &pMin);

        if(firstRound)
        {
            // Сĵַ긳objectchildָ
            childTmp = pItem;
            firstRound = 0;
        }
    }

    pObj->child = childTmp;
    return pObj;
}

// jsonλ
void swapJsonPos(cJSON **pA, cJSON **pB)
{
    cJSON *a, *aNext, *aPrev;
    cJSON *b, *bNext, *bPrev;
    cJSON *t;

    if(*pA == NULL || *pB == NULL || *pA == *pB) return;

    a = *pA;
    aNext = a->next;
    aPrev = a->prev;

    b = *pB;
    bNext = b->next;
    bPrev = b->prev;

    // ָabָ
    if(aNext && aNext != b) aNext->prev = b;
    if(aPrev && aPrev != b) aPrev->next = b;

    if(bNext && bNext != a) bNext->prev = a;
    if(bPrev && bPrev != a) bPrev->next = a;

    // abָָ
    t = a->next;
    a->next = b->next;
    b->next = t;
    if(a->next == a) a->next = b;
    if(b->next == b) b->next = a;

    t = a->prev;
    a->prev = b->prev;
    b->prev = t;
    if(a->prev==a) a->prev = b;
    if(b->prev==b) b->prev = a;

    // ޸ָ룬λý
    if (a==*pA) *pA=b;
    if (b==*pB) *pB=a;
}

//jsonʽתΪxmlʽ
int Json2Xml(const char* pJsonFarmat, char* pXmlFarmat)
{
    int iLen = 0;
    char szSubValue[128];
    char *pobjValue = NULL;
    cJSON *pRoot = cJSON_Parse(pJsonFarmat);

    if (NULL == pRoot)
    {
        return 0;
    }
    cJSON *pChild = pRoot->child;
    sprintf(pXmlFarmat + iLen, "%s", "<xml>");
    iLen += 5;
    while (pChild != NULL)
    {
        if (pChild->child != NULL) //ӽڵ
        {
            char* pSubKey = pChild->string; //ȡļ
            BUFCLR(szSubValue);
            pobjValue = cJSON_Print(pChild);
            delQuoMark(Json2Xml(pobjValue, NULL), szSubValue); //ȡֵ עﴫ⣬öҪ޸
            if(pobjValue)
            {
                free(pobjValue);
                pobjValue = NULL;
            }
            sprintf(pXmlFarmat + iLen, "<%s>%s</%s>", pSubKey, szSubValue, pSubKey);
            iLen += strlen(pSubKey);
            iLen += strlen(pSubKey);
            iLen += strlen(szSubValue);
            iLen += 5;
            //LOGD("pXmlFarmat1[%s] iLen:[%d]\n", pXmlFarmat, iLen);
        }
        else
        {
            char* pKey = pChild->string;
            BUFCLR(szSubValue);
            pobjValue = cJSON_Print(pChild);

            delQuoMark(pobjValue, szSubValue);

            if(pobjValue)
            {
                free(pobjValue);
                pobjValue = NULL;
            }

            sprintf(pXmlFarmat + iLen, "<%s>%s</%s>", pKey, szSubValue, pKey);
            iLen += strlen(pKey);
            iLen += strlen(pKey);
            iLen += strlen(szSubValue);
            iLen += 5;
            //LOGD("pXmlFarmat2[%s] iLen:[%d]\n", pXmlFarmat, iLen);
        }

        pChild = pChild->next;
    }
    sprintf(pXmlFarmat + iLen, "%s", "</xml>");
    iLen += 6;
    if(NULL != pRoot)
    {
        cJSON_Delete(pRoot);
        pRoot = NULL;
    }

    return iLen;
}


void delQuoMark(char* pinData, char* poutData)
{
    if(strchr(pinData, '\"'))
    {
        memcpy(poutData, pinData+1, strlen(pinData)-2);
        //LOGD("poutData:[%s]\n", poutData);
    }
    else
    {
        memcpy(poutData, pinData, strlen(pinData)+1);
    }
    return;
}

//ȡxml keyֵ
void GetXmlKey(const char* pNext, char* poutKey)
{
    char* pKeyS = strstr(pNext, "<");
    char* pKeyE = strstr(pNext, ">");

    if (pKeyS == NULL || pKeyE == NULL)
    {
        return;
    }
    memcpy(poutKey, pKeyS + 1, pKeyE - pKeyS - 1);
    return;
}

//ȡxml valueֵ
void GetXmlValueFromKey(const char* pXml, const char* pKey, char* poutValue)
{
    char szValueE[64];
    char* pValueE = NULL;
    char* pValueS = NULL;

    BUFCLR(szValueE);
    sprintf(szValueE, "</%s>", pKey);
    pValueE = strstr(pXml, szValueE);
    pValueS = strstr(pXml, ">");
    if (NULL == pValueE || pValueS == NULL) //ûнβǩ
    {
        return;
    }
    memcpy(poutValue, pValueS + 1, pValueE - pValueS - 1);
    return;
}

//xmlʽתΪjsonʽ
cJSON *Xml2Json(const char* pXmlFarmat)
{
    char szKey[32];
    char szValue[256];
    char szKeyEnd[64];

    cJSON *pJsonRoot = cJSON_CreateObject();

    char *pNext = pXmlFarmat;

    while (strstr(pNext, "<") != NULL)
    {
        if(!memcmp(pNext, "<xml>", strlen("<xml>")))
        {
            pNext += strlen("<xml>");
            continue;
        }
        if(!memcmp(pNext, "</xml>", strlen("</xml>")))
        {
            pNext += strlen("</xml>");
            continue;
        }

        BUFCLR(szKey);
        BUFCLR(szValue);
        GetXmlKey(pNext, szKey);
        GetXmlValueFromKey(pNext, szKey, szValue);

        BUFCLR(szKeyEnd);
        sprintf(szKeyEnd, "</%s>", szKey);
        pNext = strstr(pNext, szKeyEnd);
        pNext = pNext + strlen(szKey) + 3;
        if(!strlen(szKey) || !strlen(szValue))
        {
            continue;
        }
        cJSON_AddStringToObject(pJsonRoot, szKey, szValue);

    }
    return pJsonRoot;
}

//
void maniData(const char* pin, char* pout)
{
    char* pValueS = strstr(pin, "CDATA[");
    char* pValueE = strstr(pin, "]]");
    if (NULL == pValueE || pValueS == NULL)
    {
        return;
    }
    memcpy(pout, pValueS + 6, pValueE - pValueS - 6);
    return;
}



