#ifndef EMV_AID_H_
#define EMV_AID_H_

#include "EmvAidList.h"
#include "EmvRevocationIPKList.h"
#include "EmvExceptionFileList.h"

#define MAX_EXCEPTION_LIST 5 
#define MAX_IPK_LIST       5
#define MAX_AID_LIST	   20



extern struct EMV_AID_ITEM _AID_LIST[MAX_AID_LIST];

extern struct EMV_REVO_IPK_ITEM _IPK_LIST[MAX_IPK_LIST];

extern struct EMV_EXCEPT_ITEM _EXT_LIST[MAX_EXCEPTION_LIST];




int EMV_Aid_Load(void);
int EMV_Revocation_Load(void);
int EMV_Exception_Load(void);


int EMV_AIDList_Clear(void);
int EMV_IPKList_Clear(void);
int EMV_EXTList_Clear(void);


int EMV_AIDList_Add(LPC_EMV_AID_ITEM pItem);
int EMV_IPKList_Add(LPC_EMV_REVO_IPK_ITEM pItem);
int EMV_EXTList_Add(LPC_EMV_EXCEPT_ITEM pItem);

#endif
