#ifndef EMV_CALLBACK_H_
#define EMV_CALLBACK_H_


#include "Pos_Scan.h"
#include "Pos_Param.h"

void Kernel_Log_Printf(const char * pszMessage, int len);

void Kernel_GetCurrentTime(LP_EMV_TIME pCurrentTime);

void Kernel_GetRandomData(unsigned char* pRandBuff,
	int uiSize);

unsigned char Kernel_DetectBreak(void);

char Kernel_ExchangeApdu(const unsigned char *pApdu, unsigned short uiApdu,
                         unsigned char *pResp, unsigned short *puiResp);

char Kernel_SelectApplication(const char ** ppAppNames,
	const char ** ppAppAids,unsigned short uiAppCount,
	unsigned short *  puiSelected);

char Kernel_CardHolderConfirm(const char * pAID,
	const char * pAppName,
	const char * pPreferAppName);

char Kernel_TryOtherApplication(void);

void Kernel_AskRemoveCard(void);

unsigned char Kernel_GetOnlinePin(unsigned char bAllowBypass,
		const char * pszPAN, char * pszPinBlock,
		unsigned short uiPinBlockBuffSize, unsigned char * pbBypass);
		
void Kernel_Display_Trans_Report(int uiErrorCode, char bSignatureNeeded);

void Kernel_AuthorisationRequest(
	const char * szSendBuff, int uiSendBuff,
	const char * pszOnlineEncipherPIN,
	unsigned char * pOnlineResult,
	char *		pszIssueAuthData,
	int			uiIssueAuthDataBuffSize,
	char *		pszAC,
	int			uiACBuffSize,
	char *		pszAuthCode,
	int           uiAuthCode,
	char *		pszIssueScript,
	int			uiScriptBuffSize);


#endif
