#ifndef EMV_TAG_DEFINE_H
#define EMV_TAG_DEFINE_H
#include "MercurySystem.h"

#include "EmvDataType.h"
//#include <string.h>
/************************************************************************/
/* EMV                                                                  */
/************************************************************************/
#define TAG_IIN                                               0x42
#define TAG_AID                                               0x4F 
#define TAG_APP_LABEL                                         0x50
#define TAG_TRACK2_EQUIVALENT_DATA                            0x57
#define TAG_PAN                                               0x5A 
#define TAG_APP_TEMPLATE                                      0x61
#define TAG_FCI_TEMPLATE                                      0x6F 
#define TAG_RECORD_TEMPLATE                                   0x70
#define TAG_ISSUER_SCRIPT_TEMPLATE1                           0x71
#define TAG_ISSUER_SCRIPT_TEMPLATE2                           0x72
#define TAG_DIRECTORY_DISCRETIONARY_TEMPLATE                  0x73
#define TAG_RESPONSE_MSG_FORMAT2                              0x77
#define TAG_RESPONSE_MSG_FORMAT1                              0x80
#define TAG_AMOUNT_AUTHORISED_B                               0x81
#define TAG_AIP                                               0x82
#define TAG_COMMAND_TEMPLATE                                  0x83
#define TAG_DF_NAME                                           0x84
#define TAG_ISSUER_SCRIPT_COMMAND                             0x86
#define TAG_APP_PRIORITY_IDENTIFIER                           0x87
#define TAG_SFI                                               0x88
#define TAG_AUTHORISATION_CODE                                0x89
#define TAG_ARC                                               0x8A 
#define TAG_CDOL1                                             0x8C 
#define TAG_CDOL2                                             0x8D 
#define TAG_CVM_LIST                                          0x8E 
#define TAG_CAPK_INDEX                                        0x8F 
#define TAG_IPKC                                              0x90
#define TAG_IAD                                               0x91
#define TAG_IPK_REMAINDER                                     0x92
#define TAG_SSAD                                              0x93
#define TAG_AFL                                               0x94
#define TAG_TVR                                               0x95
#define TAG_TDOL                                              0x97
#define TAG_TC_HASH                                           0x98
#define TAG_TRANS_PIN_DATA                                    0x99
#define TAG_TRANSACTION_DATE                                  0x9A 
#define TAG_TSI                                               0x9B 
#define TAG_TRANSACTION_TYPE                                  0x9C 
#define TAG_DDF_NAME                                          0x9D 
#define TAG_FCI_PROPRIETARY_TEMPLATE                          0xA5 
#define TAG_CARDHOLDER_NAME                                   0x5F20 
#define TAG_APP_EXPIRATION_DATE                               0x5F24 
#define TAG_APP_EFFECTIVE_DATE                                0x5F25 
#define TAG_ISSUER_COUNTRY_CODE                               0x5F28 
#define TAG_TRANSACTION_CURRENCY_CODE                         0x5F2A 
#define TAG_LANGUAGE_PREFERENCE                               0x5F2D 
#define TAG_SERVICE_CODE                                      0x5F30 
#define TAG_PAN_SEQ                                           0x5F34 
#define TAG_TRANSACTION_CURRENCY_EXPONENT                     0x5F36 
#define TAG_ISSUER_URL                                        0x5F50 
#define TAG_IBAN                                              0x5F53 
#define TAG_BIC                                               0x5F54 
#define TAG_ISSUER_COUNTRY_CODE_ALPHA2                        0x5F55 
#define TAG_ISSUER_COUNTRY_CODE_ALPHA3                        0x5F56 
#define TAG_ACCOUNT_TYPE                                      0x5F57
#define TAG_ACQUIRER_IDENTIFIER                               0x9F01 
#define TAG_AMOUNT_AUTHORISED_N                               0x9F02 
#define TAG_AMOUNT_OTHER_N                                    0x9F03 
#define TAG_AMOUNT_OTHER_B                                    0x9F04 
#define TAG_APP_DISCRETIONARY_DATA                            0x9F05 
#define TAG_AID_TERMINAL                                      0x9F06 
#define TAG_AUC                                               0x9F07 
#define TAG_APP_VERSION_NUMBER                                0x9F08 
#define TAG_APP_VERSION_NUMBER_TERMINAL                       0x9F09 
#define TAG_CARDHOLDER_NAME_EXTENDED                          0x9F0B 
#define TAG_IAC_DEFAULT                                       0x9F0D 
#define TAG_IAC_DENIAL                                        0x9F0E 
#define TAG_IAC_ONLINE                                        0x9F0F 
#define TAG_ISSUER_APPLICATION_DATA                           0x9F10 
#define TAG_ISSUER_CODE_TABLE_INDEX                           0x9F11 
#define TAG_APP_PREFERRED_NAME                                0x9F12 
#define TAG_LAST_ATC                                          0x9F13 
#define TAG_LOWER_CONSECUTIVE_OFFLINE_LIMIT                   0x9F14 
#define TAG_MERCHANT_CATEGORY_CODE                            0x9F15 
#define TAG_MERCHANT_IDENTIFIER                               0x9F16 
#define TAG_PIN_TRY_COUNTER                                   0x9F17 
#define TAG_ISSUER_SCRIPT_IDENTIFIER                          0x9F18 
#define TAG_TERMINAL_COUNTRY_CODE                             0x9F1A 
#define TAG_TERMINAL_FLOOR_LIMIT                              0x9F1B 
#define TAG_TERMINAL_ID                                       0x9F1C 
#define TAG_TERMINAL_RISK_MANAGEMENT_DATA                     0x9F1D 
#define TAG_IFD_SERIAL_NUMBER                                 0x9F1E 
#define TAG_TRACK1_DESCRETIONARY_DATA                         0x9F1F 
#define TAG_TRACK2_DESCRETIONARY_DATA                         0x9F20 
#define TAG_TRANSACTION_TIME                                  0x9F21 
#define TAG_CAPK_INDEX_TERMINAL                               0x9F22 
#define TAG_UPPER_CONSECUTIVE_OFFLINE_LIMIT                   0x9F23
#define TAG_PAYMENT_ACCOUNT_REFERENCE                         0x9F24
#define TAG_APP_CRYPTOGRAM                                    0x9F26 
#define TAG_CID                                               0x9F27 
#define TAG_PEKC                                              0x9F2D 
#define TAG_PEK_EXPONENT                                      0x9F2E 
#define TAG_PEK_REMAINDER                                     0x9F2F 
#define TAG_IPK_EXPONENT                                      0x9F32 
#define TAG_TERMINAL_CAPABILITIES                             0x9F33 
#define TAG_CVM_RESULT                                        0x9F34 
#define TAG_TERMINAL_TYPE                                     0x9F35 
#define TAG_ATC                                               0x9F36 
#define TAG_UNPREDICTABLE_NUMBER                              0x9F37 
#define TAG_PDOL                                              0x9F38 
#define TAG_POS_ENTRY_MODE                                    0x9F39 
#define TAG_AMOUNT_REFERENCE_CURRENCY                         0x9F3A 
#define TAG_APPL_REFERENCE_CURRENCY                           0x9F3B 
#define TAG_TRANSACTION_REFERENCE_CURRENCY_CODE               0x9F3C 
#define TAG_TRANSACTION_REFERENCE_CURRENTY_EXPONENT           0x9F3D 
#define TAG_ADDITIONAL_TERMINAL_CAPABILITIES                  0x9F40 
#define TAG_TRANSACTION_SEQUENCE_COUNTER                      0x9F41 
#define TAG_APP_CURRENCY_CODE                                 0x9F42 
#define TAG_APP_REFERENCE_CURRENCY_EXPONENT                   0x9F43 
#define TAG_APP_CURRENCY_EXPONENT                             0x9F44 
#define TAG_DAC                                               0x9F45 
#define TAG_ICCPKC                                            0x9F46 
#define TAG_ICCPK_EXPONENT                                    0x9F47 
#define TAG_ICCPK_REMAINDER                                   0x9F48 
#define TAG_DDOL                                              0x9F49 
#define TAG_SDA_TAG_LIST                                      0x9F4A 
#define TAG_SDAD                                              0x9F4B 
#define TAG_ICC_DYNAMIC_NUMBER                                0x9F4C 
#define TAG_LOG_ENTRY                                         0x9F4D 
#define TAG_MERCHANT_NAME_AND_LOCATION                        0x9F4E 
#define TAG_LOG_FORMAT                                        0x9F4F 
#define TAG_APP_PROGRAME_ID									  0x9F5A
#define TAG_AOSA				              				  0x9F5D
#define TAG_TERMINAL_TRANSACTION_QUALIFIERS               	  0x9F66
#define TAG_CARD_AUTH_RELATED_DATA 							  0x9F69
#define TAG_CARD_TRANSACTION_QUALIFIERS 				  	  0x9F6C
#define TAG_FORM_FACTOR_INDICATOR                             0x9F6E
#define TAG_CUSTOMER_EXCLUSIVE_DATA                           0x9F7C
#define TAG_FCI_ISSUER_DISCRETIONARY_DATA                     0xBF0C 
#define TAG_TRACK2_DATA                                       0xDF03

#define TAG_SM_NA                                       	  0xDF60  // add by wl 20171214 ӹ
#define TAG_SM_FLAG                                       	  0xDF69  // add by wl 20171214 ӹ


#define TAG_PBOC_PRODUCT_INFO               				  0x9F63

#endif

