#ifndef POS_API_H_
#define POS_API_H_


#define POS_OK         0
#define POS_ERR        1

#define IS_PRINT_COM		0 // ͨڴӡ
#define IS_LOG				0 // ӡ־
#define IS_USB_COM			0 // USB ͨѶʽ.


#if !defined(NULL)
#define NULL (void*)0
#endif

#if !defined(EMV_TRUE)
#define EMV_TRUE  1
#endif

#if !defined(EMV_FALSE)
#define EMV_FALSE  0
#endif

#if !defined(TRUE)
#define TRUE  1
#endif

#if !defined(FALSE)
#define FALSE  0
#endif

#if !defined(EMV_OK)
#define EMV_OK					0
#endif

#define LOG(fmt, args...) PrintLogToCom(fmt, ##args)


/************************************************************************/
typedef enum {
	FS_SEEK_SET, FS_SEEK_CUR, FS_SEEK_END
} FS_OPS;

int  FS_Open(const char * pszFileName, unsigned char bReadOnly);
void FS_Close(int uiFileID);
int  FS_Write(int uiFileID, const void * pvData, int uiSize);
int  FS_Read(int uiFileID, const void * pvBuffer, int uiBuffsize);
void FS_Seek(int uiFileID, long uiOffSet, FS_OPS Ops);
int  FS_Size(const char * pszFileName);
int  FS_Delete(const char * pszFileName);
/************************************************************************/

/* OS                                                                   */
/************************************************************************/
struct OS_TIME {
	unsigned short m_Year;
	unsigned char m_Month;
	unsigned char m_Day;
	unsigned char m_Hour;
	unsigned char m_Minute;
	unsigned char m_Second;
};

typedef struct OS_TIME * LP_OS_TIME;

typedef enum {
	BLUE,
	YELLOW,
	GREEN,
	RED
}OS_LED;

void OS_GetCurrentTime(LP_OS_TIME pTime);
void OS_Generate_Rand(void * pvBuffer, int uiSize);
void OS_Beep(char *ptext);
int OS_LedOff(OS_LED);
int OS_LedOn(OS_LED);
void *OS_Malloc(int uiSize);
void OS_Free(void * pvPointer);


/************************************************************************/
typedef enum
{
    CLS_OK,
    CLS_NO_CARD,
    CLS_MULTI_CARD,
    CLS_ERROR
} CL_STATUS; // ǽӿʱ, ĸ״̬. 

int  CL_Open(void);
void CL_Close(void);
CL_STATUS CL_GetStatus(void);//࿨
CL_STATUS CL_GetStatusNoDelay(void);
void CL_RemoveCard(void);
int CL_ExchangeApdu(const unsigned char* pApdu,
                    unsigned short uiApdu,
                    unsigned char* pResponse,
                    unsigned short* uiResponse,
                    unsigned short* pSW);

/************************************************************************/
int PrintLogToCom(const char *fmt, ...);// ͨڴӡlog


/************************************************************************/

char* getadminPwd(void);


#endif

