#ifndef POS_PARAM_H_
#define POS_PARAM_H_


#include "EMVTransHandle.h"
#include "Kernel_Param.h"

#define SUPPORT_NFC				1	 //NFC
#define SUPPORT_SCAN_CODE		1	 //ɨ
#define SUPPORT_GENERATE_CODE	1	 //ɶά


#define	VERSION_1_0_0		1
#define VERSION_5_0_0		2
#define VERSION_5_0_1		3
#define VERSION_5_1_0		4

#define SIGNMETHOD_RSA		1
#define SIGNMETHOD_SHA256	11
#define SIGNMETHOD_SM3		12
#define SIGNMETHOD_SM2		21

#define UTF					0x01
#define GBK					0x02


#define TRANS_SALE		 "01"
#define TRANS_REVOKE	 "31"
#define TRANS_RETURN	 "04"
#define TRANS_CASH		 "02"

//==ʹ
#if 0
#define SECRET_KEY	"5C971CC216FCAE9F9DEEBCD743A671AD5ACE52AE52767DE9694B55AEFA39B846"
#define SM2_PUBLIC_KEY_X "982F641D8F95F255C2FFF26EA282E43AC399ECF56DA0AE507F1F20B2999EFB87"
#define SM2_PUBLIC_KEY_Y "410B57B9C798C524716B91AA7508197F1C344700A537412D05E2B396CD7421A1"
#else
#define SECRET_KEY	"1126e9f37e8bd3bef6dcbf5685d0f8472b3ad2c274d49ec99ceaa5e24862912e"
#define SM2_PUBLIC_KEY_X "cd5cc9a6439c150c695999e6bd10cce1614a9c457cd8a2ddedb63e2981350735"
#define SM2_PUBLIC_KEY_Y "9f4a39ba8f4178d452e9b2c1269bdb7a9634264d325788b11af53ec47684143c"
#endif

#define SCAN_URL "https://qr.95516.com/00010009/"


#define BCTC_TEST_VERSION	0 //BCTC ԰汾


//==
extern struct EMV_TERMINAL_INFO	EMV_TERMINAL_INFO;
extern struct EMV_KERNEL_CONFIG	KERNEL_CONFIG;
extern struct QPBOC_PARAMETER	QPBOC_PARAMETER;


extern char SIGN_METHOD; //ǩģʽ 
extern char ENCODING; 

extern unsigned char TestScanMode; // 0 ѻģʽ, 1 ģʽ
extern unsigned int CodeRefreshTime;// άˢʱ
extern unsigned int TRANSACTION_COUNTER;



//ɨ 
typedef enum {
	TRANS_TYPE_SALE = 0x00,
	TRANS_TYPE_REVOKE,
	TRANS_TYPE_RETURN,
	TRANS_TYPE_CASH_RECEIPTS,
	TRANS_TYPE_QUERY,
	TRANS_TYPE_ACTIVE
} SCAN_TRANS_TYPE;

typedef enum
{
    PAY_GENERATE_CODE = 0x00,   //ɨ
    PAY_NFC,                    //ǽ
    PAY_SCAN_CODE,              //ɨ
    PAY_CASH_RECEIPTS           //ֽ
} SCAN_PAYMENT;


struct POS_TERMINAL_INFO
{
    char    TXNSUBTYPE[2 + 1];          //
    char	ACQ_INS_CODE[8 + 1];        //յ
    char	MERCHANT_ID[15 + 1];        //̻
    char	MERCHANT_LOCATION[225 + 1]; //̻
    char	MERCHANT_CAT_CODE[4 + 1];   //̻
    char	BIZ_TYPE[6 + 1];            //Ʒ
    char    TERM_ID[8 + 1];             //ն˺
    char	CHANNEL_TYPE[2 + 1];        // 08ֻ
    char    CURRENCY_CODE[5];           //̶̻
    char	BACK_URL[56];               //ַ̨֪ͨ
    char    TERM_SERIAL_NUM[50];        //նк
    int		PAY_TIMEOUT;                //֧ʱʱ
    char	BUSS_CODE[12];              //ҵ
    char    BILL_NO[65];                //˵
    char    REQ_RESERVED[57];           //󷽱
    char    CERT_ID[128];               //֤ͬID
};

 
void  POS_Get_OrderId(char * OrderId);

void  POS_Get_Time(char * Time);

void  POS_Get_Sn(char * Sn);


#endif
