/* MD5.H - header file for MD5C.C
 */

/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
   rights reserved.

   License to copy and use this software is granted provided that it
   is identified as the "RSA Data Security, Inc. MD5 Message-Digest
   Algorithm" in all material mentioning or referencing this software
   or this function.

   License is also granted to make and use derivative works provided
   that such works are identified as "derived from the RSA Data
   Security, Inc. MD5 Message-Digest Algorithm" in all material
   mentioning or referencing the derived work.

   RSA Data Security, Inc. makes no representations concerning either
   the merchantability of this software or the suitability of this
   software for any particular purpose. It is provided "as is"
   without express or implied warranty of any kind.

   These notices must be retained in any copies of any part of this
   documentation and/or software.
 */
#ifndef _MD5T_H_
#define _MD5T_H_

#define R_memset(x, y, z) memset(x, y, z)
#define R_memcpy(x, y, z) memcpy(x, y, z)
#define R_memcmp(x, y, z) memcmp(x, y, z)

typedef unsigned long UINT4;
typedef unsigned char *POINTER;

/* MD5 context. */
typedef struct {
    /* state (ABCD) */
    /*ĸ32bitsڴռõϢժҪϢȡ512bitsʱҲڴÿ512bitsм*/
    UINT4 state[4];

    /* number of bits, modulo 2^64 (lsb first) */
    /*洢ԭʼϢbits,bitsΪ 2^64 bitsΪ2^64һ64λֵ*/
    UINT4 count[2];

    /* input buffer */
    /*ϢĻ512bits*/
    unsigned char buffer[64];
} MD5_CTX;

void MD5Init(MD5_CTX *);

void MD5Update(MD5_CTX *, unsigned char *, unsigned int);

void MD5Final(unsigned char [16], MD5_CTX *);

#endif /* _MD5_H_ */  


