#ifndef UTILAPI_H
#define UTILAPI_H

#if defined(QR200) || defined(QR300) || defined(QR80ST)
#define LCD_WIDTH   (320)
#define SCREEN_WIDTH (26)
#else
#define LCD_WIDTH   (240)
#define SCREEN_WIDTH (20)
#endif

#define min(a, b)           (((a) < (b)) ? (a) : (b))
#define max(a, b)           (((a) > (b)) ? (a) : (b))

//*******************  *********************

typedef enum __INPUT_RET_CODE
{
    INPUT_OK            = 0,	/*ɹ*/
    INPUT_BYPASS        = -1,   /*ƹ*/
    INPUT_USER_ABORT 	= -2,	/*ûֹ*/
    INPUT_TIMEOUT       = -3,	/*ʱ*/
    INPUT_FAIL          = -4	/*ʧ*/
}InputRetCode;

int utilInput_GetKey(int timeout);

int Keyboard_WaitKey(int uiCount, int Key,...);

int utilInput_String(int line,
                     int column,
                    unsigned char ucMin,
                    unsigned char ucMax,
                    unsigned char ucType,
                    char *pucBuf,
                    char *pucMask,
                    int usWaitSec);

int utilInput_StringAndScan(int line,
                            int column,
                            unsigned char bMIF,
                            unsigned char ucMin,
                            unsigned char ucMax,
                            unsigned char ucType,
                            unsigned char *pDrvType,
                            char *pucBuf,
                            int usWaitSec);

int utilInput_Amount(int line, int _minAmount, int maxAmount, unsigned long *pulAmount, int timeout);

void util_spLock(void);
void util_spULock(void);

#endif
