/*˵*/
#ifndef UTILMENU_H
#define UTILMENU_H

#define UTIL_MENU_MAX_ITEM           25
#if !defined(QR100)
#define UTIL_MENU_MAX_LINE           5
#else
#define UTIL_MENU_MAX_LINE           9
#endif

typedef struct
{
    unsigned char   *text;
    int  (*pfnProc)(void);       //˵к
    unsigned short  usValue;
}tsUtilMenuItem;

typedef struct
{
    int             key;
    unsigned char   bGoBack;    //Ƿ񷵻ϲ
    int  (*pfnProc)(void);      //˵к
}tsUtilMenuQKey;

typedef struct
{
    unsigned char   bFlag;
    unsigned char   font;                               //
    unsigned char   *text;
}tsUtilMenuCaption;

typedef struct
{
    unsigned char   itemCnt;                            //item count
    unsigned char   qKeyCnt;

    unsigned char   bTowItem;                           //Ƿ2ʾ
    unsigned short  usTimeout;                          //ʱʱ
    unsigned char   ucMaxRow;                           //ʾ
    unsigned char   ucMaxItem;

    int             ucPageUpKey;                        //Ϸҳ
    int             ucPageDnKey;                        //·ҳ
    unsigned char   ucPage;                             //current page
    unsigned char   ucPageMaxItem[20];                  //ÿҳ
}tsUtilMenuPrivate;

typedef struct
{
    unsigned char   bGoBack;                            //Ƿ񷵻ϲ
    unsigned char   bOneRunItem;                        //һItemǷֱִ
    unsigned char   bEnterPage;                         //ȷϼ·ҳ
    unsigned char   bEnterDefValue;                     //ȷϼѡĬֵ
    //----
    unsigned char   font;                               //
    unsigned char   point;                              //.
    unsigned char   bNextContinue;                      //ҳǷ
    //----
    void            (*GetValue)(unsigned short);        //ȡѡֵ
    unsigned char   *pGetValue;
    int             (*ReadFile)(void);                  //ļ
    int             (*Err)(int);                        //ʾ
    unsigned short  (*RunEndFn)(void);                  //ִ
}tsUtilMenuPublic;

typedef struct
{
    tsUtilMenuPublic    pbparam;                        //޸Ĳ
    tsUtilMenuPrivate   prparam;                        //˽вⲿ޸
    tsUtilMenuCaption   title;
    tsUtilMenuCaption   caption;
    tsUtilMenuItem      item[UTIL_MENU_MAX_ITEM];       //˵ṹ
    tsUtilMenuQKey      QKey[8];                        //ݼ
}tsUtilMenu;

void UtilMenu_Init(unsigned short usTimeout, tsUtilMenu *pSMenu);
void UtilMenu_AddCaption(unsigned char bTitle, unsigned char ucFont, const char *pText, tsUtilMenu *slMenu);
void UtilMenu_AddQKey(unsigned char ucKey, unsigned char bGoBack, int (*pfnProc)(void), tsUtilMenu *slMenu);
void UtilMenu_AddItem(const char *pText, int (*pfnProc)(void), unsigned short usValue, unsigned char pucFlag, tsUtilMenu *slMenu);

int UtilMenu_DispMenu(unsigned char bTitle,
                    unsigned char ucTitleFont,
                    const char *pTitleText,
                    unsigned char bTowItem,
                    tsUtilMenu *slMenu);

#endif
