#include "global.h"
#include "global_fv.h"
#include "bwsdk_api.h"
#include "macropar.h"

#include "views.h"

#include "Pos_Api.h"
#include "Pos_Storage.h"

#include "utilAPI.h"
#include "mmi_util.h"
#include "Pos_Ui.h"

#include "Pos_global.h"
#include "Pos_Data.h"
#include "commu.h"
#include "command.h"

#ifdef TAG
#undef TAG
#endif
#define TAG "main_code"

//ʼ 
void initCommu(void)
{
    //NetDeviceActive(NET_DEV_GPRS); // ѡGPRS

    POS_LoadParameters();
    POS_CartParameters();
    POS_EmvParameters();

    memset(TERMINAL_INFO.MERCHANT_ID, 0, sizeof(TERMINAL_INFO.MERCHANT_ID));
    strcpy(TERMINAL_INFO.MERCHANT_ID, DataSave.PosPar.aucMerchant);

    memset(TERMINAL_INFO.ACQ_INS_CODE, 0, sizeof(TERMINAL_INFO.ACQ_INS_CODE));
    strcpy(TERMINAL_INFO.ACQ_INS_CODE, DataSave.PosPar.aucTerminal);

	memset(TERMINAL_INFO.CERT_ID, 0, sizeof(TERMINAL_INFO.CERT_ID));
	strcpy(TERMINAL_INFO.CERT_ID, DataSave.PosPar.cert_id);

    TERMINAL_INFO.PAY_TIMEOUT = DataSave.PosPar.PAY_TIMEOUT;

    ENCODING = GBK;
    POS_SaveParameters();
}

#if defined(QR100)
void main_showLogo(unsigned char bDisplay, unsigned char bTimeout)
{
    tsRect rectLogo = {12, 32*3, 120, 80};
    tsSysTime time;

    //ʾʱ
    if (bDisplay)
    {
        mmi_clearLine(255);
        mmi_display(3, 12, "%4s", (char *)DataSave.PosPar.aucACQINS);
        mmi_display(5, ALIG_RIGHT, (char *)_APP_VERSION);
        mmi_display(7, ALIG_CENTER, (char *)DataSave.PosPar.aucMerchantName);
        ScrBitMap(&rectLogo, (unsigned char *)ImgData.standbyLogo.imgData);
    }

    if (bTimeout || bDisplay)
    {
        memset(&time, 0, sizeof(tsSysTime));
        GetSysLocalTime(&time);
        mmi_display(ALIG_BOTTOM, ALIG_CENTER, "%04d-%02d-%02d", time.year, time.mon, time.day);
    }
}
#else
void main_showLogo(unsigned char bDisplay, unsigned char bTimeout)
{
    tsRect rectLogo = {12*3, 32*2, 120, 80};
    tsSysTime time;
    char szelec_title[16];

    //ʾʱ
    if (bDisplay)
    {
    	BUFCLR(szelec_title);
    	if(strlen(DataSave.PosPar.elec_title) && strlen(DataSave.PosPar.elec_title) <= 7){
	    	
	    	snprintf(szelec_title, sizeof(szelec_title),"Ӻ:%s", DataSave.PosPar.elec_title);
    	}
        mmi_clearLine(255);
        mmi_display(2, 14, szelec_title);
        mmi_display(4, 14, (char *)_APP_VERSION);
        mmi_display(5, ALIG_CENTER, (char *)DataSave.PosPar.aucMerchantName);
        ScrBitMap(&rectLogo, (unsigned char *)ImgData.standbyLogo.imgData);
    }

    if (bTimeout || bDisplay)
    {
        memset(&time, 0, sizeof(tsSysTime));
        GetSysLocalTime(&time);
        mmi_display(ALIG_BOTTOM, ALIG_CENTER, "%04d-%02d-%02d", time.year, time.mon, time.day);
    }
}
#endif

void main_initData(void)
{
    /*___________ ʼ ______________*/
    mmi_init(MERCURY_ANTIQUE_WHITE, MERCURY_BLACK, NULL);

    /*___________ ʼȫֱ ____________*/
    memset(&DataSave, 0x00, sizeof(DataSave));
    memset(&DataSave2, 0x00, sizeof(DataSave2));
    memset(&DataSave3, 0x00, sizeof(DataSave3));
	memset(&memberCardT, 0x00, sizeof(memberCardT));

    /*___________ Դ _____________*/
    ImgData.qrCodeLogo.imgData = fcgGetResource("yinlianqr", &ImgData.qrCodeLogo.imgW, &ImgData.qrCodeLogo.imgH);
    ImgData.standbyLogo.imgData = fcgGetResource("yinlianlogo", &ImgData.standbyLogo.imgW, &ImgData.standbyLogo.imgH);

    /*___________  ________________*/
    DATA_checkAllValidFiles();
    initCommu();

}

void main_code(ULONG argc, LPVOID lpThreadParameter)
{
    int iKey;
    unsigned char iDispFlag, iTimeoutFlag, iTimerStart;
	inputFlag = 0;
	char orderId[30] = { 0 };
    char txnTime[15] = { 0 };
	char domain[50] = {0};

	//ʼ籣
   	FVFileLoadFile(MODULE_NAME,(char*)&DataSavekey,sizeof(DataSavekey));
	FVFileLoadFile(SAVE_FILE,(char*)&DataProtect,sizeof(DataProtect));
	
   	AudioSetVolumeOEM(AUDIO_VOLUME_LEVEL9,1); //
	SetLcdBacklightNV(14);//Ļ
    ScrSetBackLight(14);//󱳹
    main_initData();

	memset(domain, 0, sizeof(domain));
#ifdef LIAONING
	strcpy(domain, MEMBERCARDIP_LN);
#endif
#ifdef JILIN
	strcpy(domain, MEMBERCARDIP_JL);
#endif
#ifdef HAERBIN
	strcpy(domain, MEMBERCARDIP_HEB);
#endif
#ifdef GUIYANG
	strcpy(domain, MEMBERCARDIP_GY);
#endif
#ifdef DEBUG_TEST
	strcpy(domain, MEMBERCARDIP_TEST);
#endif

	LOGD("Current domain:%s\r\n", domain);

	//»Աַ̨
	//if(strncmp((char*)DataProtect.member_cardIp, MEMBERCARDIP, strlen(MEMBERCARDIP)))
	if(strncmp((char*)DataProtect.member_cardIp, domain, strlen(domain)))//
	{
		memset((char*)DataProtect.member_cardIp, 0, 32);
		strcpy((char*)DataProtect.member_cardIp, domain);
		FVFileWriteFile(SAVE_FILE,(char*)&DataProtect, sizeof(DataProtect));
	}

	//ʼԱipַ
	if(!strlen((char*)DataProtect.member_cardIp)){
		//Աϵͳipַ
		strcpy((char*)DataProtect.member_cardIp, "118.190.136.36");

		FVFileWriteFile(SAVE_FILE,(char*)&DataProtect, sizeof(DataProtect));		
	}
	
	//Ĭͨ
	DataSave.PosPar.scan_yard = 3;
	DATA_writeFile(FileCnstnt);
    Sleep(30*1000);
    
	memberCardFlag = 0;
    iDispFlag = 1;
    iTimeoutFlag = 1;
	
    int ret = 0;
    int icDataLen = 0;// icݵĳ
	
#if defined(HAVE_CHARGING_FEATURE)
	SetSysSleepEnabled(0);
#endif

	/*if(0 == NetDeviceGetConnectionStatus()){
		while(1)
        {
            ret = autoRunView(MERCURY_BLACK, netModeV, 60);
            LOGD("[%s:%d]ret[%d]", __FUNCTION__, __LINE__, ret);      
            Sleep(40);
            if(ret == 1)
            {
                break;
            }
            else
            {
               continue;
            }
        }
	}*/
	strcpy(TERMINAL_INFO.CERT_ID, "16406041241824256729");
	if(1 == NetDeviceGetConnectionStatus()){
			
		if(!DataSave.PosPar.scan_yard){
			if(!strlen(DataSavekey.key)){
				DataSave2.runData.ucTransType = TRANS_TYPE_ACTIVE;
				TRANS_BBT_Active(DataSave.PosPar.ucActiveCode);
			}
		    TRANS_BBT_GetPayConfig();//ÿοҪȡһ֧
		}
		Sleep(500);
		memberCardT.memCardFlag = 1;
		CommuInit((char*)DataProtect.member_cardIp, MEMBERCARD_PORT, NULL, 0);
		TRANS_MemberICard_GetPayConfig();
		memberCardT.memCardFlag = 0;
		Sleep(500);
		POS_Get_OrderId(orderId);
	    POS_Get_Time(txnTime);
	    memcpy(NormalTrans.Trans_Time, txnTime, strlen(txnTime));
	    memcpy(NormalTrans.Trans_Order, orderId, strlen(orderId));
		
		nfcFlag = 1;
		DataSave2.runData.ucTransType = TRANS_TYPE_ACTIVE;
		CommuInit(DataSave.CommuPar.httpURL, 80, NULL, 0);
	    TRANS_Cup_OnlineNfcQueryPackage();//ȡǽԿ
		
	}
    
	
	menuClear();
	mmi_dsiplay_timer_start(ALIG_BOTTOM, ALIG_RIGHT, MMI_ENABLED, 10);
	menuShowTextCenter(2, " ʱ10s봮ģʽ"); 
	menuShowTextCenter(3, "̲ģʽ");
	iKey = utilInput_GetKey(10);
	mmi_dsiplay_timer_stop();
    if (INPUT_TIMEOUT == iKey){

    	while(1){
        	GetCMD();
        }
    }
	menuClear();
    while (1)
    {
        if (iTimeoutFlag)
        {
            ota_update_handle_message();
        }
		
        inputFlag = 0;
        //ʾ
        main_showLogo(iDispFlag, iTimeoutFlag);

        iTimeoutFlag = 0;
        iDispFlag = 0;
		
        if (KbHit())
        {
            Sleep(500);
            continue;
        }
        iKey = KbGetKey();
        KbFlush();

        iDispFlag = 1;

        /* ܼ */
        if (iKey == KEY_ENTER)
        {
            MainMenu();
        }
        else if (iKey >= '1' && iKey <= '9')
        {
            ClearTransData(KEY_ASCII1);
            NormalTrans.Trans_Amt = iKey - '0';
            trans_SalePro(0);
        }
        else
        {
            iDispFlag = 1;
            iTimeoutFlag = 1;
        }
    }
}

