#include "bwsdk_api.h"
#include "logger.h"
#include "Pos_global.h"
#include "Pos_x509crt.h"
#include "Pos_Api.h"
#include "Pos_Util.h"
#include "Pos_Scan.h"
#include "mmi_util.h"
#include "tools_util.h"
#include "Pos_Data.h"

#ifdef TAG
#undef TAG
#endif
#define TAG __func__
#define OPEN_DEBUG_PCDOWN       1


#define CHAR_STX        0xA2
#define CHAR_ETX        0xA3

/*************************** ĸʽ *************************
* ͷ|ݰ|к|||β|Уλ
* 0xA2|2ֽ|1ֽ|1ֽ|nֽ|OxA3|1ֽ
*
*1.ֽڵݰȱʾֽкŵݵܳ
*2.УλǶ԰ͷβͷͰβݽXOR
*3.TLVʽ
*
*************************************************************/
//ݸʽ
typedef struct
{
    unsigned char   ucSTX;
    unsigned char   ucETX;
    unsigned char   ucLRC;
    unsigned int    uiLen;          //ݰ
    unsigned int    uiOffset;       //λ
    unsigned char   ucCommand;      //
    unsigned char   ucData[1024];   //
} PCDOWN_DATA;

//ӦĴ
typedef struct
{
    unsigned char ucCommand;                        //
    int (*commandFunc)(PCDOWN_DATA *pDownData);     //ָĴ
} PCDOWN_CMD_PRO;

//Ӧ
typedef enum
{
    PC_ERR_SUCCESS  = 0x00,
    PC_ERR_ERROR    = 0x01,
    PC_ERR_MAX
} PCDOWN_ERR_CODE;

//ڳʼ
int PCDown_CommInit(void)
{
    QCMD_Init(PORT_USBAT);
    return STATE_KEEPON;
}

//ڽ
int PCDown_CommRecv(int iTimeout)
{
    int iRet = -1;
    T_SOFTTIMER tm;

    s_TimerSet(&tm, iTimeout * 1000);
    while(1/*s_TimerCheck(&tm)*/)
    {
        memset(recvBuf, 0x00, sizeof(recvBuf));
        iRet = QCMD_Get(recvBuf, sizeof(recvBuf), 1000);
        if (iRet > 0)
            break;

//
#if 1
        if (KbHit())
        {
            Sleep(10);
            continue;
        }
        //ȡ
        if (KbGetKey() == KEY_CANCEL)
        {
            iRet = -1;
            break;
        }
        KbFlush();
#endif
    }

    if (iRet <= 0)
        return STATE_TIMEOUT;
    return STATE_KEEPON;
}

//ڹر
int PCDown_CommClose(void)
{
    QCMD_Deinit();
    return STATE_KEEPON;
}
//=======================================================================
static int PCDown_TlvGetData(unsigned char *tlvData, unsigned short tlvLen)
{
    unsigned char mTAG[4], mLen[4];
    unsigned short tmpLen;
    unsigned short offset;
    int iLen;

    if(tlvLen <= 4)
    {
        return -1;
    }

//    *dataLen = 0;
    offset = 0;
    while(offset < tlvLen)
    {
        //Tag
        memset(mTAG, 0, sizeof(mTAG));
        memcpy(mTAG, tlvData+offset, 2);
        offset += 2;

        //
        memset(mLen, 0, sizeof(mLen));
        memcpy(mLen, tlvData+offset, 2);
        tmpLen = mLen[0] * 256 + mLen[1];
        offset += 2;

#if OPEN_DEBUG_PCDOWN
        LOGD("[%5d]TAG[%02x %02x]\n", __LINE__, mTAG[0], mTAG[1]);
        logger_serial_dump_buff("tag data:", tlvData+offset, tmpLen);
#endif
        if(!memcmp(mTAG, "\xA0\x01", 2) && tmpLen)    //̻ӿ
        {
            iLen = tmpLen > 15 ? 15 : tmpLen;
            memset(TERMINAL_INFO.MERCHANT_ID, 0, sizeof(TERMINAL_INFO.MERCHANT_ID));
            memcpy(TERMINAL_INFO.MERCHANT_ID, tlvData+offset, iLen);
//            POS_SaveParameters();

            memset(DataSave.PosPar.aucMerchant, 0, sizeof(DataSave.PosPar.aucMerchant));
            memcpy(DataSave.PosPar.aucMerchant, tlvData+offset, iLen);
            DATA_writeFile(FileCnstnt);
        }
        else if(!memcmp(mTAG, "\xA0\x07", 2) && tmpLen)    //̻ɨ
        {
            iLen = tmpLen > 15 ? 15 : tmpLen;
            memset(DataSave.PosPar.aucMerchantCode, 0, sizeof(DataSave.PosPar.aucMerchantCode));
            memcpy(DataSave.PosPar.aucMerchantCode, tlvData+offset, iLen);
            DATA_writeFile(FileCnstnt);
        }
        else if(!memcmp(mTAG, "\xA0\x02", 2) && tmpLen)     //̻
        {
            iLen = tmpLen > 40 ? 40 : tmpLen;
            memset(DataSave.PosPar.aucMerchantName, 0, sizeof(DataSave.PosPar.aucMerchantName));
            memcpy(DataSave.PosPar.aucMerchantName, tlvData+offset, iLen);

            LOGD("[%s:%d]aucMerchantName:[%d]\n", __func__,__LINE__, DataSave.PosPar.aucMerchantName);

            DATA_writeFile(FileCnstnt);
        }
        else if(!memcmp(mTAG, "\xA0\x03", 2) && tmpLen)     //
        {
            iLen = tmpLen > 8 ? 8 : tmpLen;

            memset(TERMINAL_INFO.ACQ_INS_CODE, 0, sizeof(TERMINAL_INFO.ACQ_INS_CODE));
            memcpy(TERMINAL_INFO.ACQ_INS_CODE, tlvData+offset, iLen);

            memset(DataSave.PosPar.aucTerminal, 0, sizeof(DataSave.PosPar.aucTerminal));
            memcpy(DataSave.PosPar.aucTerminal, tlvData+offset, iLen);
            DATA_writeFile(FileCnstnt);
        }
        else if(!memcmp(mTAG, "\xA0\x04", 2) && tmpLen)     //
        {
            iLen = tmpLen > 40 ? 40 : tmpLen;

            memset(DataSave.PosPar.aucACQINS, 0, sizeof(DataSave.PosPar.aucACQINS));
            memcpy(DataSave.PosPar.aucACQINS, tlvData+offset, iLen);
            DATA_writeFile(FileCnstnt);
        }
        else if(!memcmp(mTAG, "\xA0\x05", 2) && tmpLen)     //ά뼤
        {
            iLen = tmpLen > 255 ? 255 : tmpLen;

            memset(DataSave.PosPar.aucAURL, 0, sizeof(DataSave.PosPar.aucAURL));
            memcpy(DataSave.PosPar.aucAURL, tlvData+offset, iLen);
            DATA_writeFile(FileCnstnt);
        }
        else if(!memcmp(mTAG, "\xA0\x06", 2) && tmpLen)     //Ͱؼ
        {
            iLen = tmpLen > 32 ? 32 : tmpLen;

            memset(DataSave.PosPar.ucActiveCode, 0, sizeof(DataSave.PosPar.ucActiveCode));
            memcpy(DataSave.PosPar.ucActiveCode, tlvData+offset, iLen);
            DATA_writeFile(FileCnstnt);
        }
		else if(!memcmp(mTAG, "\xA0\x08", 2) && tmpLen)     //Կ
        {
            iLen = tmpLen > 32 ? 32 : tmpLen;

            memset(DataSave.PosPar.aucACQINS, 0, sizeof(DataSave.PosPar.aucACQINS));
            memcpy(DataSave.PosPar.aucACQINS, tlvData+offset, iLen);
            DATA_writeFile(FileCnstnt);
        }
        else if(!memcmp(mTAG, "\xB0\x01", 2) && tmpLen)     //άЧʱ
        {
            DataSave.PosPar.PAY_TIMEOUT = tools_asc_long(tlvData+offset, iLen);

            TERMINAL_INFO.PAY_TIMEOUT = DataSave.PosPar.PAY_TIMEOUT;
            DATA_writeFile(FileCnstnt);
        }
        else if(!memcmp(mTAG, "\xB0\x02", 2) && tmpLen)     //׽ַ֪ͨ
        {
            iLen = tmpLen > 255 ? 255 : tmpLen;
			
            memset(DataSave.PosPar.BACK_URL, 0, sizeof(DataSave.PosPar.BACK_URL));
            memcpy(DataSave.PosPar.BACK_URL, tlvData+offset, iLen);
            LOGD("[%s:%d]BACK_URL:[%d]\n", __func__,__LINE__, DataSave.PosPar.BACK_URL);
            DATA_writeFile(FileCnstnt);
        }
        else if(!memcmp(mTAG, "\xB0\x03", 2) && tmpLen)     //̨׵ַ
        {
            iLen = tmpLen > sizeof(DataSave.CommuPar.httpURL) ? sizeof(DataSave.CommuPar.httpURL) : tmpLen;

            memset(DataSave.CommuPar.httpURL, 0, sizeof(DataSave.CommuPar.httpURL));
            memcpy(DataSave.CommuPar.httpURL, tlvData+offset, iLen);
            DATA_writeFile(FileCnstnt);
        }
        else if(!memcmp(mTAG, "\xE0\x01", 2) && tmpLen)     //֤
        {
            mbedtls_x509_crt crt509_ca;
            char pszRecord[256] = { 0 };
            char SortBuff[30] = { 0 };

            memset(&crt509_ca, 0, sizeof(mbedtls_x509_crt));
            if (0 != pos_x509_crt_parse(&crt509_ca, (const unsigned char *)tlvData + offset, tmpLen + 1))
            {
                mmi_clearLine(255);
                mmi_display(ALIG_CENTER, ALIG_CENTER, "֤ʧ");
                Keyboard_WaitKey(2, KEY_CANCEL, KEY_ENTER);
                return -1;
            }

            memset(pszRecord, 0, sizeof(pszRecord));
            memcpy(pszRecord, crt509_ca.pk.p, crt509_ca.pk.len);
            vOneTwo((unsigned char *)pszRecord, 32, (unsigned char *)Txn_CertPublicX);
            vOneTwo((unsigned char *)pszRecord + 32, 32, (unsigned char *)Txn_CertPublicY);

            if (crt509_ca.serial.len != 0)
            {
                vOneTwo((unsigned char *)crt509_ca.serial.p, crt509_ca.serial.len, (unsigned char *)SortBuff);
                //LOG("HexToDec [ %s ]", SortBuff);
                HexToDec(SortBuff, TERMINAL_INFO.CERT_ID);
				strcpy(DataSave.PosPar.cert_id, TERMINAL_INFO.CERT_ID);
				DATA_writeFile(FileCnstnt);
                //LOG("HexToDec [ %s ]", Txn_EncryptCertId);
            }
            pos_x509_crt_free(&crt509_ca);
            POS_SaveParameters();
            POS_SaveCartParameters();
        }
        offset += tmpLen;
    }
//    if (*dataLen < 1)
//    {
//        return -1;
//    }
    return 0;
}

int PCDown_POSShakeHand(PCDOWN_DATA *pDownData)
{
    memset(pDownData->ucData, 0, sizeof(pDownData->ucData));
    pDownData->uiLen = sprintf((char *)pDownData->ucData, "SUCCESS");
    return STATE_FINISH;
}

//ʼն
int PCDown_POSInit(PCDOWN_DATA *pDownData)
{
#if OPEN_DEBUG_PCDOWN
    LOGD("[%5d]>>>\n", __LINE__);
    logger_serial_dump_buff("recv data:", pDownData->ucData, pDownData->uiLen);
#endif

    pDownData->uiLen = 0;
    return STATE_FINISH;
}

//²
int PCDown_POSUpdataParam(PCDOWN_DATA *pDownData)
{
#if OPEN_DEBUG_PCDOWN
    LOGD("[%5d]>>>\n", __LINE__);
    logger_serial_dump_buff("recv data:", pDownData->ucData, pDownData->uiLen);
#endif

    PCDown_TlvGetData(pDownData->ucData, pDownData->uiLen);
    pDownData->uiLen = 0;
    return STATE_FINISH;
}

//˽ԿϢ
int PCDown_POSUpLoadPrivateKeyInfo(PCDOWN_DATA *pDownData)
{
    int iRet = -1;
    char uiBuff[512];

#if OPEN_DEBUG_PCDOWN
    LOGD("[%5d]>>>\n", __LINE__);
    logger_serial_dump_buff("recv data:", pDownData->ucData, pDownData->uiLen);
#endif

    memset(pDownData->ucData, 0, sizeof(pDownData->ucData));
    //ͳһʹ
    /* iRet = sm2_KeyGen(pDownData->ucData);
       if (iRet > 0)
       {
           pDownData->uiLen = iRet;

       }*/

    iRet = sizeof(uiBuff);
    memset(uiBuff, 0, sizeof(uiBuff));
    sprintf(uiBuff, "%s%s%s", Txn_CertPublicX, Txn_CertPublicY, Txn_CertKey);
    HexStringToBytes(uiBuff, strlen(uiBuff), pDownData->ucData, &iRet);
    pDownData->uiLen = iRet;

#if OPEN_DEBUG_PCDOWN
    LOGD("[%5d]>>>\n", __LINE__);
    logger_serial_dump_buff("sm2_KeyGen:", pDownData->ucData, iRet);
#endif
	menuSpeak((uchar *) "֤ѵ鿴Զʾ");
    return STATE_FINISH;
}

int PCDown_POSUpData(PCDOWN_DATA *pDownData)
{
    memset(pDownData->ucData, 0, sizeof(pDownData->ucData));
    pDownData->uiLen = sprintf((char *)pDownData->ucData, "SUCCESS");
    return STATE_FINISH;
}

static PCDOWN_CMD_PRO PCDown_CmdProTab[] =
{
    {0x01, PCDown_POSShakeHand},    //
    {0x02, PCDown_POSUpdataParam},  //ز
    {0x03, PCDown_POSUpLoadPrivateKeyInfo}, //ԿϢ
    {0x04, PCDown_POSUpData},       //
    {0xFF, 0} //β
};

unsigned char PCDown_LRC(unsigned char *pData, unsigned short uiDataLen)
{
    int i;
    unsigned char ucLRC = 0;

    for (i = 0, ucLRC = 0; i < uiDataLen; i++)
    {
        ucLRC ^= pData[i];
    }
    return ucLRC;
}

//ݴ
int PCDown_UnPackProcess(PCDOWN_DATA *pDownData)
{
    int iRet = PC_ERR_ERROR;
    int i, iMax, iOffset;

    iOffset = 0;
    //ʼ
    pDownData->ucSTX = recvBuf[iOffset];
    iOffset += 1;
    //
    pDownData->uiLen = recvBuf[iOffset] * 256 + recvBuf[iOffset+1];
    pDownData->uiLen -= 2;  //к+ָ
    //жһ³,
    if ((pDownData->uiLen < 0) || (pDownData->uiLen > sizeof(pDownData->ucData)))
        return STATE_ERROR;
    iOffset += 2;
    //к
    iOffset += 1;
    //ָ
    pDownData->ucCommand = recvBuf[iOffset];
    iOffset += 1;
    //
    memset(pDownData->ucData, 0, sizeof(pDownData->ucData));
    memcpy(pDownData->ucData, &recvBuf[iOffset], pDownData->uiLen);
    iOffset += pDownData->uiLen;
    //
    pDownData->ucETX = recvBuf[iOffset];
    iOffset += 1;
    //LRC
    pDownData->ucLRC = recvBuf[iOffset];
    iOffset += 1;

    LOGD("[%5d]>>>recv len:%d\n", __LINE__, iOffset);
    logger_serial_dump_buff("recv data:", recvBuf, iOffset);

    if (pDownData->ucSTX != CHAR_STX)
        return STATE_ERROR;
    if (pDownData->ucETX != CHAR_ETX)
        return STATE_ERROR;
    if (PCDown_LRC(recvBuf, iOffset-1) != pDownData->ucLRC)
        return STATE_ERROR;

    LOGD("[%5d]>>>\n", __LINE__);

    //ָ
    iMax = sizeof(PCDown_CmdProTab) / sizeof(PCDown_CmdProTab[0]);
    for (i = 0; i < iMax; i++)
    {
        //ҵ
        if (PCDown_CmdProTab[i].ucCommand == pDownData->ucCommand)
        {
            //ʵִ,ûʵ˳
            if (PCDown_CmdProTab[i].commandFunc)
                return PCDown_CmdProTab[i].commandFunc(pDownData);
        }
    }
    return iRet;
}

//
int PCDown_SendRespone(int iRet, unsigned char *pData, unsigned short iDataLen)
{
    unsigned int iLen;

    iRet = 0;
#if OPEN_DEBUG_PCDOWN
    LOGD("[%5d]>>>\n", __LINE__);
    logger_serial_dump_buff("wait send data:", pData, iDataLen);
#endif
    memset(sendBuf, 0x00, sizeof(sendBuf));

    iLen = 0;
    //ʼ
    sendBuf[iLen] = CHAR_STX;
    iLen += 1;
    //
    sendBuf[iLen] = (iDataLen+2)/256;
    sendBuf[iLen+1] = (iDataLen+2)%256;
    iLen += 2;
    //к
    sendBuf[iLen] = 0x00;
    iLen += 1;
    //Ӧ
    sendBuf[iLen] = (!iRet ? 0x01 : 0x02);
    iLen += 1;
    //
    memcpy(&sendBuf[iLen], pData, iDataLen);
    iLen += iDataLen;
    //
    sendBuf[iLen] = CHAR_ETX;
    iLen += 1;
    //LRC
    sendBuf[iLen] = PCDown_LRC(sendBuf, iLen);
    iLen += 1;

#if OPEN_DEBUG_PCDOWN
    LOGD("[%5d]>>>\n", __LINE__);
    logger_serial_dump_buff("send data:", sendBuf, iLen);
#endif
    QCMD_Send(sendBuf, iLen);

    return STATE_FINISH;
}

int PCDown_Pro(void)
{
    int iRet;
    PCDOWN_DATA downData;

    KbFlush();

    mmi_clearLine(255);
    while(1)
    {
        memset(&downData, 0x00, sizeof(downData));

        //ʼ

        mmi_clearLine(255);
        mmi_display(ALIG_CENTER, ALIG_CENTER, "ʼ");
        iRet = PCDown_CommInit();
        if(iRet != STATE_KEEPON)
            return iRet;

        //ݽ
        mmi_clearLine(255);
        mmi_display(ALIG_CENTER, ALIG_CENTER, "ȴָ");
        iRet = PCDown_CommRecv(60);
        if(iRet != STATE_KEEPON)
        {
            PCDown_CommClose();
            return iRet;
        }

        //ݴ
        mmi_clearLine(255);
        mmi_display(ALIG_CENTER, ALIG_CENTER, "ָ");
        iRet = PCDown_UnPackProcess(&downData);

        //Ӧλ
        mmi_clearLine(255);
        mmi_display(ALIG_CENTER, ALIG_CENTER, "ָ");
        PCDown_SendRespone(iRet, downData.ucData, downData.uiLen);

        //
        if (downData.ucCommand == 0x04)
        {
            //,Ժ...
            mmi_clearLine(255);
            mmi_display(ALIG_CENTER, ALIG_CENTER, ",Ժ...");
            PCDown_CommClose();
            while(1)
            {
                if (KbHit())
                {
                    Sleep(10);
                    continue;
                }

                //ȡ
                if (KbGetKey() == KEY_CANCEL)
                {
                    return STATE_KEEPON;
                }
                KbFlush();
            }
        }
    }
    return iRet;
}


