#include "bwsdk_api.h"
#include "tools_util.h"

static unsigned char tools_char_hex(unsigned char charBuff)
{
    if (charBuff >= 0x41)
        return ((charBuff - 7) & 0x0F);

    return (charBuff & 0x0F);
}

void tools_asc_bcd(unsigned char *dest, unsigned int destLen, unsigned char *sour, unsigned int sourLen)
{
    unsigned int i;

    if (dest == NULL || sour == NULL)
    {
        return;
    }

    if (destLen > sourLen/2)
    {
        memset(dest, 0x00, destLen);
        dest = dest + destLen - ((sourLen + 1) / 2);
    }

    for (i = 0; i < ((sourLen+1) / 2); i++)
    {
        if ((!(sourLen % 2) && !i) || i)
        {
            *dest = (*sour++ << 4) & 0xF0;
        }
        *dest = *dest + (*sour++ & 0x0F);
        dest++;
    }
}

void tools_asc_hex(unsigned char *dest, unsigned int destLen, unsigned char *sour, unsigned int sourLen)
{
    unsigned int i;

    memset(dest, 0x00, destLen);
    dest = dest + destLen - ((sourLen + 1) / 2);
    if (sourLen % 2)
    {
        *dest++ = tools_char_hex(*sour++) & 0x0F;
    }

    for (i = 0; i < (sourLen / 2); i++)
    {
        *dest = (tools_char_hex(*sour++) << 4) & 0xF0;
        *dest = *dest + (tools_char_hex(*sour++) & 0x0F);
        dest ++;
    }
}

unsigned long tools_asc_long(unsigned char *sour, unsigned int len)
{
    unsigned int i;
    unsigned long m_long, m_tmp;

    m_long = 0;
    m_tmp = 1;
    sour += len;
    for (i = 0; i< len; i++)
    {
        m_long += (m_tmp * (*--sour & 0x0F));
        m_tmp *= 10;
    }
    return (m_long);
}

void tools_bcd_asc(unsigned char *dest, unsigned char *sour, unsigned int destLen)
{
    unsigned int i;

    if(destLen % 2)
    {
        *dest++ = (*sour++ & 0x0F) + 0x30;
    }

    for(i = 0; i < (destLen / 2); i++)
    {
        *dest++ = ((*sour & 0xF0) >> 4) + 0x30;
        *dest++ = (*sour++ & 0x0F) + 0x30;
    }
}

unsigned long tools_bcd_long(unsigned char *sour, unsigned int sourLen)
{
    unsigned int uiI;
    unsigned char m_charTmp;
    unsigned long m_long, m_longTmp;

    m_long = 0;
    m_longTmp = 1;
    sour += (sourLen+1)/2;
    for (uiI = 0; uiI< sourLen ; uiI++)
    {
        if(uiI % 2)
            m_charTmp = (*sour >> 4 ) & 0x0F;
        else
            m_charTmp = *--sour & 0x0F;
        m_long += m_longTmp * m_charTmp;
        if(m_longTmp == 1000000000L)
            m_longTmp = 0;
        else
            m_longTmp *= 10;
    }
    return (m_long);
}

void tools_long_asc(unsigned char *dest, unsigned int len, unsigned long *sour)
{
    unsigned int uiI;
    unsigned char ucCh;
    unsigned char aucTab[10];
    unsigned char *pucPtr;
    unsigned long ulTmp1,ulTmp2;

    ulTmp1 = *sour;
    ulTmp2 = 100000000L;
    for (uiI = 0; uiI< 5; uiI++)
    {
        ucCh = (unsigned char)(ulTmp1 / ulTmp2);
        aucTab[2*uiI] = ucCh / 10 + 0x30 ;
        aucTab[2*uiI+1] = ucCh % 10 + 0x30;
        ulTmp1 = ulTmp1 % ulTmp2;
        ulTmp2 = ulTmp2 / 100;
    }

    memset(dest, 0x30, len);
    dest += len;
    pucPtr = dest;
    if (len > 10)
    {
        len = 10;
    }
    for( uiI=0; uiI < len; uiI++)
    {
        *--dest = aucTab[9-uiI];
    }
}


