#include "bwsdk_api.h"
#include "mmi_util.h"
#include "utilAPI.h"

#include "logger.h"
#ifdef TAG
#undef TAG
#endif
#define TAG __func__


#define OPEN_DEBUG_UTIL_API      0

#define fgColor MERCURY_ANTIQUE_WHITE
#define bgColor MERCURY_BLACK

/**
* @brief    ȡֵģʽ
* @brief Get key, blocking mode
* @author   XuZhou.Chen
* @retval  > 0 ʵʼֵ key value
* @retval  < 0 ʱ timeout
*/
int utilInput_GetKey(int timeout)
{
    char bOpenTimer = timeout > 0 ? 1 : 0;
    int kb;
    T_SOFTTIMER tm;

    KbFlush();

    /* ȴû */
    //ðʱ
    if (bOpenTimer)
        s_TimerSet(&tm, timeout * 1000);

    while (1)
    {
        if (bOpenTimer)
        {
            if (!s_TimerCheck(&tm))
                break;
        }

        if (KbHit())
        {
            Sleep(10);
            continue;
        }
        kb = KbGetKey();
        KbFlush();
        return kb;
    }

    KbFlush();
    return INPUT_TIMEOUT;
}

int Keyboard_WaitKey(int uiCount, int Key,...)
{
    int PressedKey = KEY_NONE;
    int TempKey;
    va_list arg_ptr;
    int i;
    char bLoop = 1;

    while (1 == bLoop)
    {
        if (!KbHit())
        {
            PressedKey = KbGetKey();
            if (Key == PressedKey)
            {
                bLoop = 0;
            }
            else
            {
                va_start(arg_ptr, Key);
                for (i = 0; i < uiCount - 1; i++)
                {
                    TempKey = (int)va_arg(arg_ptr, int);
                    if (TempKey == PressedKey)
                    {
                        bLoop = 0;
                        break;
                    }
                }
                va_end(arg_ptr);
            }
        }
        Sleep(10);
    }
    return PressedKey;
}

int utilInput_GetKeyAndScan(unsigned char bOpenScan, unsigned char bMif, unsigned char *pType, unsigned char *pScanBarCode, int *pBarCodeLen, int timeout)
{
    char bOpenTimer = timeout > 0 ? 1 : 0;
    int kb;
    int real_len = 0, iMaxLen;
    T_SOFTTIMER tm;

    *pType = 0;
    iMaxLen = *pBarCodeLen;
    *pBarCodeLen = 0;
    KbFlush();

    /* ȴû */
    //ðʱ
    if (bOpenTimer)
        s_TimerSet(&tm, timeout * 1000);

    while (1)
    {
        if (bOpenTimer)
        {
            if (!s_TimerCheck(&tm))
                break;
        }

        if (bOpenScan)
        {
            if (bMif)
            {
                if (Detect_Picc(0x01) == 1)
                {
                    *pType = 2;
                    return INPUT_BYPASS;
                }
            }

            real_len = ScanBarGetData(pScanBarCode, iMaxLen, 200);
            if (real_len > 0)
            {
                *pType = 1;
                *pBarCodeLen = real_len;
                pScanBarCode[real_len] = 0x00;
                return INPUT_BYPASS;
            }
        }

        if (KbHit())
        {
            Sleep(10);
            continue;
        }
        kb = KbGetKey();
        Sleep(10);
        KbFlush();
        return kb;
    }

    KbFlush();
    return INPUT_TIMEOUT;
}

/**
* @brief    ַ
* @brief    input string
* @author   XuZhou.Chen
* @param    line [in] ʾ
* @param    ucMin [in] С(Сֵ)
* @param    ucMax [in] 󳤶(ֵ)
* @param    ucType [in] (N-,A-ĸ,H-16,P-*)
* @retval   INPUT_OK ɹ INPUT_OK for success
* @retval   INPUT_TIMEOUT ʱ INPUT_TIMEOUT for timeout
* @retval   INPUT_USER_ABORT ûֹ INPUT_USER_ABORT for user abort
* @retval   INPUT_BYPASS ƹ INPUT_BYPASS for bypass
*/
int utilInput_String(int line,
                     int column,
                     unsigned char ucMin,
                     unsigned char ucMax,
                     unsigned char ucType,
                     char *pucBuf,
                     char *pucMask,
                     int usWaitSec)
{
    const unsigned char aucKeyTab[][8] =
    {
        {"0 *-,."},
        {"1QZqz#"},
        {"2ABCabc"},
        {"3DEFdef"},
        {"4GHIghi"},
        {"5JKLjkl"},
        {"6MNOmno"},
        {"7PRSprs"},
        {"8TUVtuv"},
        {"9WXYwxy"},
        {"0,._"}
    };
    unsigned char aucDisp[60];  /* Buffer for Display */
    unsigned char aucInput[60]; /* Buffer for Key Input */
    unsigned char ucDispMaxLen;
    unsigned char ucLastKey;
    unsigned char ucKeyTabOffset = 0;
    unsigned char ucRedraw; //ػ(0-, 1-)
    unsigned char ucCount;
    unsigned char ucOffset;
    int ucKey;
    unsigned int ucTime, uiTimeout;
    T_SOFTTIMER tm;

    memset(aucDisp, 0, sizeof(aucDisp));
    memset(aucInput, 0, sizeof(aucInput));

    ucTime          = 1*1000;
    ucDispMaxLen    = SCREEN_WIDTH;
    ucLastKey       = 0;
    ucRedraw        = 0;
    ucCount         = 0;
    uiTimeout       = ucTime;

    if (strlen((char *)pucBuf))
    {
        ucRedraw = 1;
        ucCount = strlen((char *)pucBuf);
        if(ucCount > sizeof(aucInput))
        {
            ucCount = sizeof(aucInput);
        }
        memcpy(aucInput, pucBuf, ucCount);
    }
    else
    {
        memset(&aucDisp[0], 0, sizeof(aucDisp));
//        aucDisp[ucCount] = '_';

        mmi_clearLine(line);
        mmi_display(line, column, (char *)&aucDisp[0]);
    }

    while(1)
    {
        if (ucRedraw == 1)
        {
            memset(&aucDisp[0], 0, sizeof(aucDisp));
            if (ucCount > ucDispMaxLen)
            {
                if(ucType == 'p' || ucType == 'P')
                {
                    memset(&aucDisp[0], '*', ucDispMaxLen-1);
                }
                else
                {
                    memcpy(&aucDisp[0], &aucInput[ucCount - (ucDispMaxLen-1)], (ucDispMaxLen-1));
                }
//                aucDisp[ucDispMaxLen - 1] = '_';
            }
            else
            {
                if (ucType == 'p' || ucType == 'P')
                {
                    memset(&aucDisp[0], '*', ucCount);
                }
                else
                {
                    memcpy(&aucDisp[0], &aucInput[0], ucCount);
                }
//                aucDisp[ucCount] = '_';
            }

            mmi_clearLine(line);
            mmi_display(line, column, (char *)&aucDisp[0]);
            ucRedraw = 0;
        }

#if OPEN_DEBUG_UTIL_API
        LOGD((char *)"\n[%5d]uiTimeout:%d\n", __LINE__, uiTimeout);
#endif
        //ðʱ
        s_TimerSet(&tm, uiTimeout);
        ucKey = utilInput_GetKey(usWaitSec);
        uiTimeout = s_TimerCheck(&tm);
#if OPEN_DEBUG_UTIL_API
        LOGD((char *)"\n[%5d]ucKey:%d\n", __LINE__, ucKey);
        LOGD((char *)"\n[%5d]uiTimeout:%d\n", __LINE__, uiTimeout);
#endif
        if (ucKey == INPUT_TIMEOUT)
        {
            return INPUT_TIMEOUT;
        }
        else if(ucKey >= '0' && ucKey <= '9')
        {
            if (pucMask)
            {
                if (!strchr((char *)pucMask, ucKey))
                {
                    uiTimeout = ucTime;
                    continue;
                }
            }

            switch(ucType)
            {
                case 'h':
                case 'H':
                    if (ucCount > ucMax)
                    {
                        break;
                    }
                    if (ucLastKey != ucKey)
                    {
                        ucLastKey = ucKey;
                        ucKeyTabOffset = 0;
                        if (ucCount >= ucMax)
                        {
                            ucLastKey = 0;
                            break;
                        }
                        aucInput[ucCount++] = ucKey;
                        ucRedraw = 1;
                    }
                    else
                    {
                        if (uiTimeout)
                        {
                            if(ucCount)
                            {
                                ucOffset = ucCount - 1;
                            }
                            else
                            {
                                ucOffset = 0;
                            }
                            if (ucKey >= '2' && ucKey <= '3')
                            {
                                if (ucKeyTabOffset < strlen((char *)aucKeyTab[ucKey-'0'])-1)
                                {
                                    ucKeyTabOffset ++;
                                    ucRedraw = 1;
                                }
                                else
                                {
                                    if (ucKeyTabOffset)
                                    {
                                        ucKeyTabOffset = 0;
                                        ucRedraw = 1;
                                    }
                                }
                                aucInput[ucOffset] = aucKeyTab[ucKey-'0'][ucKeyTabOffset];
                            }
                            else
                            {
                                ucLastKey = ucKey;
                                ucKeyTabOffset = 0;
                                aucInput[ucCount++] = ucKey;
                                ucRedraw = 1;
                            }
                        }
                        else
                        {
                            if (ucCount >= ucMax)
                            {
                                break;
                            }
                            ucLastKey = ucKey;
                            ucKeyTabOffset = 0;
                            aucInput[ucCount++] = ucKey;
                            ucRedraw = 1;
                        }
                    }
                    break;
                case 'a':
                case 'A':
                    if (ucCount > ucMax)
                    {
                        break;
                    }
                    if (ucLastKey != ucKey)
                    {
                        ucLastKey = ucKey;
                        ucKeyTabOffset = 0;
                        if (ucCount >= ucMax)
                        {
                            ucLastKey = 0;
                            break;
                        }
                        aucInput[ucCount++] = ucKey;
                        ucRedraw = 1;
                    }
                    else
                    {
                        if (uiTimeout)
                        {
                            if (ucCount)
                            {
                                ucOffset = ucCount - 1;
                            }
                            else
                            {
                                ucOffset = 0;
                            }
                            if (ucKeyTabOffset < strlen((char *)aucKeyTab[ucKey-'0'])-1)
                            {
                                ucKeyTabOffset ++;
                                ucRedraw = 1;
                            }
                            else
                            {
                                if (ucKeyTabOffset != 0)
                                {
                                    ucKeyTabOffset = 0;
                                    ucRedraw = 1;
                                }
                            }
                            aucInput[ucOffset] = aucKeyTab[ucKey-'0'][ucKeyTabOffset];
                        }
                        else
                        {
                            if (ucCount >= ucMax)
                            {
                                break;
                            }
                            ucLastKey = ucKey;
                            ucKeyTabOffset = 0;
                            aucInput[ucCount++] = ucKey;
                            ucRedraw = 1;
                        }
                    }
                    break;
                default:
                    if (ucCount >= ucMax)
                    {
                        break;
                    }
                    aucInput[ucCount++] = ucKey;
                    ucRedraw = 1;
                    break;
            }
        }
        else
        {
            switch(ucKey)
            {
                case KEY_CANCEL:
                    if (ucCount)
                    {
                        ucCount = 0;
                        ucLastKey = 0;
                        memset(&aucInput[0],0,sizeof(aucInput));
                        memset(&aucDisp[0],0,sizeof(aucDisp));
                        ucRedraw = 1;
                    }
                    else
                    {
                        return INPUT_USER_ABORT;
                    }
                    break;
                case KEY_00:
                    if (ucType == 'h' || ucType == 'H'
                        ||ucType == 'a' || ucType == 'A'
                       )
                    {
                        if (ucCount < strlen((char *)&aucInput[0]))
                            ucCount ++;
                    }
                    else
                    {
                        //
                        if(ucCount > (ucMax-2))
                        {
                            break;
                        }
                        memcpy(&aucInput[ucCount], "00", 2);
                        ucCount += 2;
                        ucRedraw = 1;
                    }
                    break;
                case KEY_CLEAR:
                    ucLastKey = 0;
                    if (ucCount)
                    {
                        ucCount --;
                        aucInput[ucCount] = 0;
                        ucRedraw = 1;
                    }
                    break;
                case KEY_ENTER:
                    ucLastKey = 0;
                    if (ucType == 'p' || ucType == 'P')
                    {
                        if (ucCount == 0)
                        {
                            return INPUT_BYPASS;
                        }
                    }

                    if (ucCount < ucMin)
                    {

                    }
                    else
                    {
                        memset((char *)pucBuf, 0x00, ucMax);
                        memcpy((char *)pucBuf, (char *)aucInput, ucCount);
                        return INPUT_OK;
                    }
                    break;
                default :
                    break;
            }
        }
        uiTimeout = ucTime;
    }
}

/**
* @brief    ַ
* @brief    input string
* @author   XuZhou.Chen
* @param    line [in] ʾ
* @param    ucMin [in] С(Сֵ)
* @param    ucMax [in] 󳤶(ֵ)
* @param    ucType [in] (N-,A-ĸ,H-16,P-*)
* @retval   INPUT_OK ɹ INPUT_OK for success
* @retval   INPUT_TIMEOUT ʱ INPUT_TIMEOUT for timeout
* @retval   INPUT_USER_ABORT ûֹ INPUT_USER_ABORT for user abort
* @retval   INPUT_BYPASS ƹ INPUT_BYPASS for bypass
*/
int utilInput_StringAndScan(int line,
                            int column,
                            unsigned char bMIF,
                            unsigned char ucMin,
                            unsigned char ucMax,
                            unsigned char ucType,
                            unsigned char *pDrvType,
                            char *pucBuf,
                            int usWaitSec)
{
    const unsigned char aucKeyTab[][8] =
    {
        {"0 *-,."},
        {"1QZ#"},
        {"2ABC"},
        {"3DEF"},
        {"4GHI"},
        {"5JKL"},
        {"6MNO"},
        {"7PRS"},
        {"8TUV"},
        {"9WXY"},
        {"0,._"}
    };
    int iRet;
    unsigned char aucDisp[60];  /* Buffer for Display */
    unsigned char aucInput[60]; /* Buffer for Key Input */
    unsigned char ucDispMaxLen;
    unsigned char ucLastKey;
    unsigned char ucKeyTabOffset = 0;
    unsigned char ucRedraw; //ػ(0-, 1-)
    unsigned char ucCount;
    unsigned char ucOffset;
    unsigned char bOpenScan;
    int ucKey;
    unsigned int ucTime, uiTimeout;
    int iMaxLen;
    T_SOFTTIMER tm;

    memset(aucDisp, 0, sizeof(aucDisp));
    memset(aucInput, 0, sizeof(aucInput));

    ucTime          = 1*1000;
    ucDispMaxLen    = SCREEN_WIDTH;
    ucLastKey       = 0;
    ucRedraw        = 0;
    ucCount         = 0;
    bOpenScan       = 0;
    uiTimeout       = ucTime;
    *pDrvType       = 0;

    if (strlen((char *)pucBuf))
    {
        ucRedraw = 1;
        ucCount = strlen((char *)pucBuf);
        if(ucCount > sizeof(aucInput))
        {
            ucCount = sizeof(aucInput);
        }
        memcpy(aucInput, pucBuf, ucCount);
    }
    else
    {
        memset(&aucDisp[0], 0, sizeof(aucDisp));
//        aucDisp[ucCount] = '_';

        mmi_clearLine(line);
        mmi_display(line, column, (char *)&aucDisp[0]);
    }

    while(1)
    {
        if (ucRedraw == 1)
        {
            memset(&aucDisp[0], 0, sizeof(aucDisp));
            if (ucCount > ucDispMaxLen)
            {
                if(ucType == 'p' || ucType == 'P')
                {
                    memset(&aucDisp[0], '*', ucDispMaxLen-1);
                }
                else
                {
                    memcpy(&aucDisp[0], &aucInput[ucCount - (ucDispMaxLen-1)], (ucDispMaxLen-1));
                }
//                aucDisp[ucDispMaxLen - 1] = '_';
            }
            else
            {
                if (ucType == 'p' || ucType == 'P')
                {
                    memset(&aucDisp[0], '*', ucCount);
                }
                else
                {
                    memcpy(&aucDisp[0], &aucInput[0], ucCount);
                }
//                aucDisp[ucCount] = '_';
            }

            mmi_clearLine(line);
            mmi_display(line, column, (char *)&aucDisp[0]);
            ucRedraw = 0;
        }

#if OPEN_DEBUG_UTIL_API
        LOG((char *)"\n[%5d]uiTimeout:%d\n", __LINE__, uiTimeout);
#endif
        //ðʱ
        s_TimerSet(&tm, uiTimeout);
        iMaxLen = 30;
        if (!bOpenScan && !ucCount)
        {
            if (bMIF)
            {
                if (Open_Picc() != 1)
                {
                    return INPUT_FAIL;
                }
            }

            bOpenScan = 1;
            if (ScanBarStart() < 0)
            {
                if (bMIF)
                    Close_Picc();
                return INPUT_FAIL;
            }
            //ú⡢
            ScanBarLightSet(SCANBAR_WLED | SCANBAR_RLED, 1);
        }
        else if (bOpenScan && ucCount)
        {
            if (bMIF)
                Close_Picc();

            bOpenScan = 0;

            //ָ⡢
            ScanBarLightSet(SCANBAR_WLED | SCANBAR_RLED, 0);
            ScanBarStop();
        }

        *pDrvType = 0;

        ucKey = utilInput_GetKeyAndScan(bOpenScan, bMIF, pDrvType, (unsigned char *)pucBuf, &iMaxLen, usWaitSec);
        uiTimeout = s_TimerCheck(&tm);
#if OPEN_DEBUG_UTIL_API
        LOG((char *)"\n[%5d]ucKey:%d\n", __LINE__, ucKey);
        LOG((char *)"\n[%5d]uiTimeout:%d\n", __LINE__, uiTimeout);
#endif
        if (ucKey == INPUT_TIMEOUT)
        {
            iRet = INPUT_TIMEOUT;
            goto DO_END;
        }
        else if (ucKey == INPUT_BYPASS)
        {
            iRet = INPUT_OK;
            if (*pDrvType == 2)
            {
                goto DO_MIF_END;
            }
            goto DO_END;
        }
        else if(ucKey >= '0' && ucKey <= '9')
        {
            switch(ucType)
            {
                case 'a':
                case 'A':
                    if (ucCount > ucMax)
                    {
                        break;
                    }
                    if (ucLastKey != ucKey)
                    {
                        ucLastKey = ucKey;
                        ucKeyTabOffset = 0;
                        if (ucCount >= ucMax)
                        {
                            ucLastKey = 0;
                            break;
                        }
                        aucInput[ucCount++] = ucKey;
                        ucRedraw = 1;
                    }
                    else
                    {
                        if (uiTimeout)
                        {
                            if (ucCount)
                            {
                                ucOffset = ucCount - 1;
                            }
                            else
                            {
                                ucOffset = 0;
                            }
                            if (ucKeyTabOffset < strlen((char *)aucKeyTab[ucKey-'0'])-1)
                            {
                                ucKeyTabOffset ++;
                                ucRedraw = 1;
                            }
                            else
                            {
                                if (ucKeyTabOffset != 0)
                                {
                                    ucKeyTabOffset = 0;
                                    ucRedraw = 1;
                                }
                            }
                            aucInput[ucOffset] = aucKeyTab[ucKey-'0'][ucKeyTabOffset];
                        }
                        else
                        {
                            if (ucCount >= ucMax)
                            {
                                break;
                            }
                            ucLastKey = ucKey;
                            ucKeyTabOffset = 0;
                            aucInput[ucCount++] = ucKey;
                            ucRedraw = 1;
                        }
                    }
                    break;
                default:
                    if (ucCount >= ucMax)
                    {
                        break;
                    }
                    aucInput[ucCount++] = ucKey;
                    ucRedraw = 1;
                    break;
            }
        }
        else
        {
            switch(ucKey)
            {
                case KEY_CANCEL:
                    if (ucCount)
                    {
                        ucCount = 0;
                        ucLastKey = 0;
                        memset(&aucInput[0],0,sizeof(aucInput));
                        memset(&aucDisp[0],0,sizeof(aucDisp));
                        ucRedraw = 1;
                    }
                    else
                    {
                        iRet = INPUT_USER_ABORT;
                        goto DO_END;
                    }
                    break;
                case KEY_00:
                    if (ucType == 'a' || ucType == 'A'
                       )
                    {
                        if (ucCount < strlen((char *)&aucInput[0]))
                            ucCount ++;
                    }
                    else
                    {
                        //
                        if(ucCount > (ucMax-2))
                        {
                            break;
                        }
                        memcpy(&aucInput[ucCount], "00", 2);
                        ucCount += 2;
                        ucRedraw = 1;
                    }
                    break;
                case KEY_CLEAR:
                    ucLastKey = 0;
                    if (ucCount)
                    {
                        ucCount --;
                        aucInput[ucCount] = 0;
                        ucRedraw = 1;
                    }
                    else
                    {

                    }
                    break;
                case KEY_ENTER:
                    ucLastKey = 0;
                    if (ucType == 'p' || ucType == 'P')
                    {
                        if (ucCount == 0)
                        {
                            iRet = INPUT_BYPASS;
                            goto DO_END;
                        }
                    }

                    if (ucCount < ucMin)
                    {

                    }
                    else
                    {
                        memset((char *)pucBuf, 0x00, ucMax);
                        memcpy((char *)pucBuf, (char *)aucInput, ucCount);
                        iRet = INPUT_OK;
                        goto DO_END;
                    }
                    break;
                default :
                    break;
            }
        }
        uiTimeout = ucTime;
    }

DO_END:
    if (bMIF)
        Close_Picc();
DO_MIF_END:
    //ָ⡢
    ScanBarLightSet(SCANBAR_WLED | SCANBAR_RLED, 0);
    ScanBarStop();
    return iRet;
}

int utilInput_Amount(int line, int minAmount, int maxAmount, unsigned long *pulAmount, int timeout)
{
    char amount[15];
    char tmp[20];
    char *p = amount;
    int amt = 0;
    int need_refresh = 1;
    int kb;

    memset(tmp, 0x00, sizeof(tmp));
    memset(amount, 0x00, sizeof(amount));
    p = amount;

    if (*pulAmount > 0)
    {
        sprintf(amount, "%d", *pulAmount);
        p += strlen((char *)amount);
    }

#if defined(QR200)
    KpdScrCls();
    KpdScrSetNumber(0, 0);
    KpdScrSync();
#endif
    KbFlush();

    /* 尴 */
    while (1)
    {
        if (need_refresh)
        {
            amt = utilsAsc2Int(amount);
            mmi_clearLine(line);
            memset(tmp, 0, sizeof(tmp));
            sprintf(tmp, "%d.%02d", amt / 100, amt % 100);
            mmi_display(line, (16 - strlen((char *)tmp)), tmp);
#if defined(QR200)
            KpdScrSetNumber((amt / 100), (amt % 100));
            KpdScrSync();
#endif
        }
        need_refresh = 0;

        /* ȴû */
        kb = utilInput_GetKey(timeout);
        if (INPUT_TIMEOUT == kb)
        {
            return INPUT_TIMEOUT;
        }

        /* ȷϼ */
        if (KEY_ENTER == kb)
        {
            memset(amount, 0x00, sizeof(amount));
            if (amt < minAmount)
            {
                mmi_clearLine(line);
                if (amt == 0)
                {
                    mmi_display(line, ALIG_CENTER, "Ϊ,");
                }
                else
                {
                    mmi_display(line, ALIG_CENTER, "СС%d.%02d", minAmount/100, minAmount%100);
                }
                Sleep(500);
                mmi_clearLine(line);
                mmi_clearLine(line+1);
                p = amount;
                need_refresh = 1;
                continue;
            }
            else if (amt > maxAmount)
            {
                mmi_clearLine(line);
                mmi_display(line, ALIG_CENTER, "ܳ׶");

                Sleep(500);
                p = amount;
                need_refresh = 1;
                continue;
            }
            *pulAmount = amt;
            return INPUT_OK;
        }

        /*  */
        if (KEY_CLEAR == kb)
        {
            if (p > amount)
            {
                p--;
                *p = '\0';
                need_refresh = 1;
            }
        }

        /* ȡ */
        if (KEY_CANCEL == kb)
        {
            memset(amount, 0x00, sizeof(amount));
            return INPUT_USER_ABORT;
        }

        /*  */
        if ((p - amount) >= 8)
            continue;

        if (!amount[0] && kb == '0')
            continue;

        /* Ч */
        if ((kb >= '0') && (kb <= '9'))
        {
            *p++ = kb;
            *p = '\0';
            need_refresh = 1;
        }
    }
}

static int s_splock = 0;
void util_spLock(void)
{
    while(s_splock)
    {
        Sleep(50);
    }
    s_splock = 1;
}

void util_spULock(void)
{
    s_splock = 0;
}
