#include "bwsdk_api.h"
#include "utilMenu.h"
#include "utilAPI.h"
#include "mmi_util.h"
#include "macropar.h"


#define DEBUG_UTIL_MENU               0

static unsigned char __UtilMenu_GetCol(unsigned int iMaxLen, unsigned int iLastLen, unsigned int iTheLen)
{
    unsigned char ucCol, ucLen;
    unsigned char halfLen;

    //һһ볤
    halfLen = iMaxLen/2;

    //һлʣ
    ucLen = iMaxLen - min(iMaxLen, (iTheLen + iLastLen));
    //2߶Сڰ
    if (iLastLen < halfLen && iTheLen < halfLen)
    {
        ucCol = halfLen + 1;
    }
    //ǰߴڰ
    else if (iLastLen > halfLen)
    {
        ucCol = iLastLen + ucLen;
    }
    //ߴڰ
    else if (iTheLen > halfLen)
    {
        ucCol = iMaxLen - iTheLen;
    }
    else
    {
        ucCol = halfLen + 1;
    }
    return ucCol;
}

static void __UtilMenu_DisplayItem(unsigned char *pRow,
                                   unsigned char ucIndex,
                                   unsigned char ucItemIndex,
                                   unsigned int *pLastLen,
                                   tsUtilMenu *pSelItem)
{
    unsigned char ucOffset = 0;
    unsigned char ucRow, ucCol;
    unsigned char aucBuf[100];
    unsigned int iItemNameLen, iMaxLen;

    memset(aucBuf, 0, sizeof(aucBuf));
    aucBuf[ucOffset++] = ucIndex+'1';
    aucBuf[ucOffset++] = pSelItem->pbparam.point;

    iMaxLen = SCREEN_WIDTH;
    iItemNameLen = strlen((char *)pSelItem->item[ucItemIndex].text);
    memcpy(&aucBuf[ucOffset], pSelItem->item[ucItemIndex].text, iItemNameLen);
    ucOffset += iItemNameLen;

    ucRow = *pRow;
    ucCol = 0;
    if (pSelItem->prparam.bTowItem      //˫
        && (*pLastLen)                      //ַ󳤶
        && (ucIndex < pSelItem->prparam.itemCnt && (ucOffset+*pLastLen) <= iMaxLen))
    {
        ucCol = __UtilMenu_GetCol(iMaxLen, *pLastLen, ucOffset);
        ucRow -= 1;
        *pLastLen = 0;
    }
    else
    {
        *pLastLen = ucOffset;
    }

    mmi_display(ucRow, ucCol, (char *)aucBuf);
    if (*pLastLen > 0)
    {
        *pRow += 1;
    }
}

static void __UtilMenu_DisplayItemLines(tsUtilMenu *pSelItem)
{
    unsigned char ucRow;
    unsigned char ucI, ucIndex, mI;
    unsigned int nLength;

    ucRow = 1;
    ucIndex     = pSelItem->prparam.ucPageMaxItem[pSelItem->prparam.ucPage];
    ucI         = pSelItem->pbparam.bNextContinue ? ucIndex : 0;

    mmi_clearLine(255);
    /*------------------------------ ͷ ------------------------------*/
    if (pSelItem->title.bFlag)
    {
        mmi_display(ucRow++, ALIG_CENTER, (char *)pSelItem->title.text);
    }
    /*------------------------------ ʾ ------------------------------*/
    if (pSelItem->caption.bFlag)
    {
        mmi_display(ucRow++, 1, (char *)pSelItem->caption.text);
    }

    //----
    mI = 0;
    nLength = 0;
    while(ucIndex < pSelItem->prparam.itemCnt)
    {
        __UtilMenu_DisplayItem(&ucRow, ucI, ucIndex, &nLength, pSelItem);
        mI++;
        ucI++;
        ucIndex++;

        if (mI > pSelItem->prparam.ucMaxItem)
        {
            break;
        }
    }

#if !defined(QR100)
    if (!pSelItem->prparam.ucPage)
    {
        if (ucIndex < pSelItem->prparam.itemCnt)
        {
            mmi_display(ALIG_BOTTOM, ALIG_RIGHT, ">");
        }
    }
    else
    {
        if (ucIndex < pSelItem->prparam.itemCnt)
        {

        }
        else
        {
            mmi_display(ALIG_BOTTOM, ALIG_RIGHT, "<");
        }
    }
#endif
    pSelItem->prparam.ucPageMaxItem[pSelItem->prparam.ucPage+1] = ucIndex;
}

static int __UtilMenu_Page(int ucKey, tsUtilMenu *pMenu)
{
    int iRet;
    unsigned char ucPage;

    ucPage = pMenu->prparam.ucPage;
    if (!pMenu->prparam.ucPageUpKey)
        pMenu->prparam.ucPageUpKey = KEY_UP;
    if (!pMenu->prparam.ucPageDnKey)
        pMenu->prparam.ucPageDnKey = KEY_DOWN;

    //·ҳ
    if (pMenu->prparam.ucPageDnKey == ucKey)
    {
        ucPage++;
        if (ucPage > sizeof(pMenu->prparam.ucPageMaxItem))
        {
            ucPage = 0;
        }
        else if (pMenu->prparam.ucPageMaxItem[ucPage] == 0
                 || pMenu->prparam.ucPageMaxItem[ucPage] >= pMenu->prparam.itemCnt)
        {
            ucPage--;
        }
    }
    //Ϸҳ
    else if (pMenu->prparam.ucPageUpKey == ucKey)
    {
        if(ucPage)
        {
            ucPage--;
        }
    }

    iRet = 1;
    if (pMenu->prparam.ucPage != ucPage)
    {
        iRet = 0;
    }
    pMenu->prparam.ucPage = ucPage;
    return iRet;
}

static unsigned char __UtilMenu_FindKey(int ucKey, unsigned char *pIndex, tsUtilMenu *pMenu)
{
    unsigned char i;

    for (i = 0; i < pMenu->prparam.qKeyCnt; i++)
    {
        if (pMenu->QKey[i].key == ucKey && pMenu->QKey[i].pfnProc)
        {
            *pIndex = i;
            return 1;
        }
    }
    return 0;
}

static int __UtilMenu_DispMenu(tsUtilMenu *pMenu, unsigned char bTowItem)
{
    int iRet;
    unsigned char ucSelectIndex, ucPageMaxItem, bRefresh;
    int ucKey = 0, ucActivType;

    pMenu->prparam.bTowItem = bTowItem;
    if(!pMenu->prparam.itemCnt)
    {
        return STATE_LOADAGAIN;
    }
    else if (pMenu->prparam.itemCnt == 1 && pMenu->pbparam.bOneRunItem)
    {
        if (pMenu->item[0].pfnProc)
        {
            if (pMenu->pbparam.ReadFile)
            {
                iRet = (*(pMenu->pbparam.ReadFile))();
                if (iRet != SUCCESS)
                {
                    return STATE_LOADAGAIN;
                }
            }
            return (*(pMenu->item[0].pfnProc))();
        }
        else
        {
            return STATE_LOADAGAIN;
        }
    }

    pMenu->prparam.ucMaxItem = pMenu->prparam.ucMaxRow;
    if (pMenu->title.bFlag)
    {
        pMenu->prparam.ucMaxItem --;
    }
    if (pMenu->caption.bFlag)
    {
        pMenu->prparam.ucMaxItem --;
    }
    pMenu->prparam.ucMaxItem *= (pMenu->prparam.bTowItem ? 2 : 1);

    bRefresh = 1;
    do
    {
        ucActivType = 0;

        //ˢ
        if (bRefresh)
        {
            __UtilMenu_DisplayItemLines(pMenu);
            bRefresh = 0;
        }

        ucKey = utilInput_GetKey(pMenu->prparam.usTimeout);

        //˳
        if (ucKey == KEY_CANCEL)
        {
            return STATE_BACK;
        }
        //ʱ
        else if (ucKey == INPUT_TIMEOUT)
        {
            return STATE_TIMEOUT;
        }
        //ҳ
        else if (!__UtilMenu_Page(ucKey, pMenu))
        {
            bRefresh = 1;
            continue;
        }
        //ȷϼĬֵ
        else if (ucKey == KEY_ENTER && pMenu->pbparam.bEnterDefValue)
        {
            return STATE_KEEPON;
        }
        //ݼ
        else if (__UtilMenu_FindKey(ucKey, &ucSelectIndex, pMenu))
        {
            ucActivType = 2;
        }
        //ְ
        else if (ucKey >= '1' && ucKey <= '9')
        {
            ucPageMaxItem = pMenu->prparam.ucPageMaxItem[pMenu->prparam.ucPage];
            ucSelectIndex = (ucKey - '1') + (pMenu->pbparam.bNextContinue ? 0 : ucPageMaxItem);
            if(ucSelectIndex < pMenu->prparam.itemCnt)
            {
                ucActivType = 1;
            }
        }

        //󴥷¼
        if (ucActivType)
        {
            bRefresh = 1;
            iRet = STATE_KEEPON;

            //ļ
            if (pMenu->pbparam.ReadFile)
            {
                iRet = (*(pMenu->pbparam.ReadFile))();
            }

            //ְ¼
            if (STATE_KEEPON == iRet && ucActivType == 1)
            {
                //ȡѡӦֵ
                if (pMenu->pbparam.GetValue)
                {
                    (*(pMenu->pbparam.GetValue))(pMenu->item[ucSelectIndex].usValue);
                }
                else if (pMenu->pbparam.pGetValue)
                {
                    *pMenu->pbparam.pGetValue = pMenu->item[ucSelectIndex].usValue;
                }

                //ִк
                if (pMenu->item[ucSelectIndex].pfnProc)
                {
                    iRet = (*(pMenu->item[ucSelectIndex].pfnProc))();
                }
            }
            //ݰ¼
            else if (STATE_KEEPON == iRet && ucActivType == 2)
            {
                //ִк
                if (pMenu->QKey[ucSelectIndex].pfnProc)
                {
                    iRet = (*(pMenu->QKey[ucSelectIndex].pfnProc))();
                    //Ƿϲ
                    if (pMenu->QKey[ucSelectIndex].bGoBack)
                    {
                        return iRet;
                    }
                }
            }

            //Ƿϲ
            if (pMenu->pbparam.bGoBack)
            {
                return iRet;
            }
            //ʾ
            else if (pMenu->pbparam.Err)
            {
                (*(pMenu->pbparam.Err))(iRet);
            }
        }
    }
    while(1);
}

void UtilMenu_Init(unsigned short usTimeout, tsUtilMenu *pSMenu)
{
    memset(pSMenu, 0, sizeof(tsUtilMenu));

#if defined(QR300)
    pSMenu->prparam.ucPageUpKey = KEY_FUNC;
    pSMenu->prparam.ucPageDnKey = KEY_ALPHA;
#elif defined(QR200)
    pSMenu->prparam.ucPageUpKey = KEY_SUB;
    pSMenu->prparam.ucPageDnKey = KEY_ADD;
#else
    pSMenu->prparam.ucPageUpKey = KEY_ALPHA;
    pSMenu->prparam.ucPageDnKey = KEY_FUNC;
#endif
    //----
    pSMenu->prparam.ucMaxRow        = UTIL_MENU_MAX_LINE;
    pSMenu->prparam.usTimeout       = usTimeout;
    //----
//    pSMenu->pbparam.font            = FONT_LARGE;
    pSMenu->pbparam.point           = '.';
    pSMenu->pbparam.bNextContinue   = 1;
}

void UtilMenu_AddQKey(unsigned char ucKey, unsigned char bGoBack, int (*pfnProc)(void), tsUtilMenu *slMenu)
{
    if(slMenu->prparam.qKeyCnt > 8)
    {
        return;
    }

    slMenu->QKey[slMenu->prparam.qKeyCnt].key = ucKey;
    slMenu->QKey[slMenu->prparam.qKeyCnt].bGoBack = bGoBack;
    slMenu->QKey[slMenu->prparam.qKeyCnt].pfnProc = pfnProc;
    slMenu->prparam.qKeyCnt++;
}

void UtilMenu_AddItem(const char *pText,
                      int (*pfnProc)(void),
                      unsigned short usValue,
                      unsigned char pucFlag,
                      tsUtilMenu *slMenu)
{
    if(slMenu->prparam.itemCnt > UTIL_MENU_MAX_ITEM)
    {
        return;
    }
    else if(pucFlag)
    {
        return;
    }

    slMenu->item[slMenu->prparam.itemCnt].text = (unsigned char *)pText;
    slMenu->item[slMenu->prparam.itemCnt].pfnProc = pfnProc;
    slMenu->item[slMenu->prparam.itemCnt].usValue = usValue;
    slMenu->prparam.itemCnt++;
}

void UtilMenu_AddCaption(unsigned char bTitle, unsigned char ucFont, const char *pText, tsUtilMenu *slMenu)
{
    tsUtilMenuCaption  *pCaption;

    pCaption = bTitle ? &slMenu->title : &slMenu->caption;

    pCaption->bFlag = 1;
    pCaption->font  = ucFont;
    pCaption->text  = (unsigned char *)pText;
}

int UtilMenu_DispMenu(unsigned char bTitle,
                      unsigned char ucTitleFont,
                      const char *pTitleText,
                      unsigned char bTowItem,
                      tsUtilMenu *slMenu)
{
    int iRet;

    if (slMenu->prparam.itemCnt > 9)
    {
        slMenu->pbparam.bNextContinue = 0;
    }

    if (bTowItem > 2)
    {
        slMenu->prparam.ucMaxRow = bTowItem;
        bTowItem = 0;
    }

    if (bTitle)
    {
        UtilMenu_AddCaption(1, ucTitleFont, pTitleText, slMenu);
    }

    iRet = __UtilMenu_DispMenu(slMenu, bTowItem);
    return iRet;
}
