//////////////////////////////////////////////////////////////////////////////
/// Copyright (C) 2018 ϺʢܿƼɷ޹˾
/// All rights reserved.
/// 
/// @file     bwsdk_api.h
/// @brief    ʢSDKͷļ
/// @brief    BaseWin SDK header
/// @author   Cedar.Diao
/// @copyright Shanghai Basewin Technology Co.,Ltd.
/// @version  1.0
/// @date     01/28/2018
//////////////////////////////////////////////////////////////////////////////

#ifndef _BWSDK_API_H_
#define _BWSDK_API_H_

#include "MercurySystem.h"

#ifdef __cplusplus
extern   "C"
{
#endif

/**
 * @defgroup utils utils
 * @brief ϵͳඨ
 * @brief System and tools define
 * @{
 */
 
#ifdef uchar
#undef uchar
#endif

#define uchar unsigned char

#ifdef ulong
#undef ulong
#endif
#define ulong unsigned long

#ifdef ushort
#undef ushort
#endif
#define ushort unsigned short

/**
 * @brief ϵͳûṩsnprintf
 * @brief there is no such interface within system
 */
int BW_snprintf(char *str, unsigned int size, const char *format, ...);

/**
 * @brief ϵͳûṩstrcasecmp
 * @brief there is no such interface within system
 */
int BW_strcasecmp(const char *s1, const char *s2);

/**
 * @brief ϵͳûṩstrncasecmp
 * @brief there is no such interface within system
 */
int BW_strncasecmp(const char *s1, const char *s2, int n);

//=============================================================
//#include "hexutile.h"
//=============================================================

/**
 * @brief ֽתΪ()
 * @brief Host to Network short (Big-endian) 
 */
unsigned short int htons(unsigned short int h);

/**
 * @brief ()תΪֽ
 * @brief Network (Big-endian) to Host short
 */
unsigned short int ntohs(unsigned short int n);

/**
 * @brief ֽתΪ()
 * @brief Host to Network long (Big-endian)
 */
unsigned long htonl(unsigned long h);

/**
 * @brief ()תΪֽ
 * @brief Network (Big-endian) to Host long
 */
unsigned long ntohl(unsigned long n);

/**
 * @brief жһַǷǴHEXַ(A-FСд)
 * @brief Determines whether A string is A pure HEX string (a-f allows case)
 * @param hexstr [in] ַ(hex string) 
 * @param hexstrlen [in] ַ(length of the hex string)
 * @retval 0 HEXִ(return value 0: not hex string)
 * @retval 1 HEXִ(return value 1: is hex string)
 */
int IsHexString(const char *hexstr, unsigned int hexstrlen);


/**
 * @brief HEXִתΪֽ
 * @brief Transfer Hex string to Byte array
 *  "12345678" -> {0x12, 0x34, 0x56, 0x78}
 * @param hexstr [in] HEXִ (Input Hex string)
 * @param hexstrlen [in] HEXִĳ (Input Hex string length)
 * @param buff [out] ֽݻ (Output buffer)
 * @param buffsize [in] ֽ (Buffer size)
 * @param buffsize [out] תֽ (Output Byte array size)
 * @retval 0 תɹ (return value 0: Transfer success)
 * @retval <0 תʧ (return valie <0: Transfer fail)
 */
int HexStringToBytes(const char *hexstr, unsigned int hexstrlen, void *buff, unsigned int *buffsize);

/**
 * @brief ֽתΪHEXִ
 * @brief Transfer Byte array to Hex string
 *  {0x12, 0x34, 0x56, 0x78} -> "12345678"
 * @param buff [in] ֽ (Input Byte array)
 * @param bufflen [in] ֽݳ (Input Byte array length)
 * @param hexstr [out] HEXִ (Output Hex string buffer)
 * @param hexstrlen [in] HEXִֽ (Hex string buffer size)
 * @param hexstrlen [out] תHEXִ (Output Hex string buffer size)
 * @retval 0 תɹ (return value 0: Transfer success)
 * @retval <0 תʧ (return value <0: Transfer fail)
 */
int BytesToHexString(const char *buff, unsigned int bufflen, char *hexstr, unsigned int *hexstrlen);

/**
 * @brief תֽ
 * @brief Transfer Byte Array sequence
 * BitEndian -> LittleEndian
 * LittleEndian -> BitEndian
 * fromtoһ (Input and Output buffer can be same)
 * {0x12, 0x34, 0x56} -> {0x56, 0x34, 0x12}
 * 0x123456 -> 0x563412
 * @param from [in] Դ (Input buffer)
 * @param to [in] ĿĻ (Output buffer)
 * @param len [in] Ҫתĳ(λ: Byte) (Transfer length)
 */
void SwapBytesOrder(void *from, void *to, unsigned int len);

/**
 * @brief ֽתΪHEXַ
 * @brief Transfer Byte array to Hex string
 * BytesToHexStringһ (Same with Function "BytesToHexString")
 * {0x12, 0x34} -> "1234"
 * @param One [in] Ҫתֽ (Input Byte array)
 * @param len [in] ֽ鳤 (Input Byte array length)
 * @param Two [out] HEXַ (Output Hex String)
 */
void vOneTwo(unsigned char *One, unsigned short len, unsigned char *Two);

/**
 * @brief HEXַתΪֽ
 * @brief Transfer Hex string to Byte array
 * HexStringToBytesһ (Same with Function "HexStringToBytes")
 * "1234" -> {0x12, 0x34}
 * @param in [in] ҪתHEXַ (Input Hex string)
 * @param in_len [in] HEXַ (Input Hex string length)
 * @param out [out] ֽ (Outout Byte array)
 * @retval תoutеֽڳ (return value: Output Byte array length)
 */
int vTwoOne(unsigned char *in, unsigned short in_len, unsigned char *out);


/**
 * @brief תֵ
 * @brief Large Number Converter
 * "010001" -> "65537"(16-10)
 * @param oldData [in] Ҫתԭ (Input Number)
 * @param oldDataConv [in] ԭݵֵ(2,8,10,16) (Input Number System, for example: binary, octal, decimal or hex)
 * @param conv [in] Ҫתֵ(2,8,10,16) (Output Number System, for example: binary, octal, decimal or hex)
 * @param convData [out] ת (Output)
 * @param sizeConvData [int] ݵĴС(sizeof(convData))
 * @retval >0 תݳ (return value > 0: length of data converted)
 * @retval <=0 תʧ (return value <= 0: convert fail)
 */
int bigNumberConv(char *oldData,int oldDataConv,int conv,char *convData,int sizeConvData);
// #include "gbk2utf8.h"
/**
 * @brief һGBKַתΪunicode
 * @brief Convert GBK code to Unicode
 */
unsigned short conv_char_gbk2unicode(unsigned short int gbkcode);

/**
 * @brief һunicodeַתΪGBK
 * @brief Convert Unicode to GBK code
 */
unsigned short conv_char_unicode2gbk(unsigned short int unicode);

/**
 * @brief ָȵGBKִתΪunicodeִ
 * @brief Convert specified length of GBK string to Unicode string
 */
int conv_string_gbk2unicode(unsigned short int *unicode, char *gbk, int len);

/**
 * @brief ָȵunicodeִתΪGBKִ
 * @brief Convert specified length of Unicode string to GBK string
 */
int conv_string_unicode2gbk(char *gbk, unsigned short int *unicode, int len);

/**
 * @brief ָunicodeִתΪutf8ִ
 * @brief Convert Unicode string to utf8 string
 */
int conv_string_UnicodeToUtf8(char *pInput, char *pOutput);

/**
 * @brief ָutf8ִתΪunicodeִ
 * @brief Convert utf8 string to Unicode string
 */
int conv_string_Utf8ToUnicode(char *pInput, char *pOutput);

/**
 * @brief ָgbkִתΪutf8ִ
 * @brief Convert GBK string to utf8 string
 */
int gbk2utf8(uchar *gbk, uchar *utf8);

/**
 * @brief ָutf8ִתΪgbkִ
 * @brief Convert utf8 string to GBK string
 */
int utf82gbk(uchar *utf8, uchar *gbk);
/** @} */

/**
 * @defgroup sp_commu sp_commu
 * @brief spؽӿ
 * @brief SP related interface
 * @{
 */

//=============================================================
//#include "sp_comm_api.h"
//=============================================================
// SPعзĴ (Error Code in SP downloading)
#define ERROR_SP_DLOAD_MALLOC_FAIL (-1) ///< ڴʧ (Fail to allocate memory)
#define ERROR_SP_DLOAD_FILE_ACCESS (-2) ///< ļʧ (Fail to access file)
#define ERROR_SP_DLOAD_BAD_PARAM   (-3) ///< Ƿ (invalid parameter)
#define ERROR_SP_DLOAD_FILE_SIZE   (-4) ///< ļߴ粻Ϸ (invalid file size)
#define ERROR_SP_DLOAD_CONN_FAIL   (-5) ///< ӶϿ (disconnected)
#define ERROR_SP_DLOAD_SEND_SIZE   (-6) ///< ݴСƥ (size of sent date not match)
#define ERROR_SP_DLOAD_SHELL_FAIL  (-7) ///< shellʧ (return shell fail)
#define ERROR_SP_DLOAD_VERIFY_FAIL (-8) ///< ֤ʧ (verification fail)
#define ERROR_SP_DLOAD_YMODEM_ENTER_FAIL (-9) // Ymodemģʽʧ (Fail to enter Ymodme mode)

/**
 * @brief ʼSP
 * @bried Initialize SP
 * @author diaoxuesong@basewin.com
 * @param mode: 0 - ͨٶȣ 1 - ģʽ (mode value: 0 for normal speed, 1 for high speed)
 * @retval 0 ɹ (return value: o -> Initialize Success)
 * @retval !0 ʧ (return value: 1 -> Initialize Fail)
 */
int BWSP_HW_Init(int mode);

/**
 * @brief SPµ
 * @brief Set SP on/off
 * @author diaoxuesong@basewin.com
 * @param onoff [in] 0-µ磬1-ϵ (onoff value: 0 for power off, 1 for power on)
 */
void BWSP_Power(int onoff);

/**
 * @brief SP
 * @brief Restart SP
 * @author diaoxuesong@basewin.com
 * @retval 0 (return value 0)
 */
int BWSP_Reboot(void);

/**
 * @brief ȡǰSPٶ
 * @bried Get current SP Baud rate
 * @author diaoxuesong@basewin.com
 * @retval ǰ (return value: Baud rate)
 */
int BWSP_GetCurrentSpeed(void);

/**
 * @brief лSP֮Ĳ
 * @brief Switch SP Baud rate
 * @param speed [in] ҪлĲ, 115200/500000/1000000 (Target Baud rate. For example: 115200,500000 and 1000000)
 * @retval 0 ɹ (return value 0: Switch Success)
 * @retval <0 ʧ (return value <0: Switch Fail)
 * @retval >0 лĲ (return value > 0: Baud Rate after switch)
 */
int BWSP_SwitchBaudRate(int speed);

/**
 * @brief ȡWIFIŽģʽĵǰ״̬
 * @brief Get WIFI Bridge State
 * @retval 0 δWIFIŽģʽ (return value 0: WIFI Bridge State OFF)
 * @retval !0 ѿWIFIŽģʽ (return value !0: WIFI Bridge State ON)
 */
int BWSP_GetWifiBridgeState(void);

/**
 * @brief /رSPWIFIŽģʽ
 * @brief Set WIFI Bridge State ON/OFF
 * @param onoff [in] 0-رWIFIŽģʽ, 1-WIFIŽģʽ (onoff value: 0 for WIFI Bridge State OFF, 1 for WIFI Bridge State ON)
 * @retval 0 ɹ (return value 0: Set up Success)
 * @retval !0 ʧ (return value !0: Set up Fail)
 */
int BWSP_Wifi_Bridge(int onoff);

/**
 * @brief жSPǷ
 * @brief Get SP updating state
 * @retval 0 SP is not updating (return value 0: not updating)
 * @retval 1 SP is updating (return value 1 : updating)
 */
int BWSP_IsUpdating(void);

/**
 * @brief ʼSP̼
 * @brief Updating SP firmware
 * @param fwfile [in] ¹̼ļ (New firmware file name)
 * @param res_cb [in] صӿڣ첽֪ͨ (result call back interface, for non-synchronous update result notice)
 * @param process_cb [in] Ȼصӿڣڸȣ0-100 (progress call back interface, for reporting updating progress percentage)
 * @retval 0 ɹ (return value 0: Update Success)
 * @retval <0 ʧܣ: ERROR_SP_DLOAD_XXX (return value < 0: Update Fail, Error Code)
 */
int BWSP_FirmwareUpdateStart(char *fwfile, void (*rescb)(int result), void (*process_cb)(int percent));

/**
 * @brief SPһ(Զط)
 * @brief Start a Message Exchange with SP
 * @param req [in] (ID+CMD+DATA)NULLʾ (request package, "NULL" for not sending)
 * @param reqlen [in] reqȣλ: ֽ (request package length)
 * @param rsp [out] Ӧ(ID+CMD+DATA)NULLʾ (response package, "NULL" for not receiving)
 * @param rsplen [in] Ӧ󳤶 (response package maximum length)
 * @param rsplen [out] յӦʵʴС (response package length)
 * @param timeoutms [in] Ӧʱʱ䣬λ (maximum response timeout in ms)
 * @retval 0 ɹ (return value 0: Message exchange success)
 * @retval -1 ֽ֧ (return value 1: Message exchange not supported)
 * @retval -2 ʱ (return value 2: Message exchange time out)
 * @retval -3 Ƿ (return value 3: invalid parameter)
 * @retval -4 豸δ (return value 4: device not ready)
 */
int BWSP_MsgExange(unsigned char *req, unsigned int reqlen, unsigned char *rsp, unsigned int *rsplen, unsigned int timeoutms);

/**
 * @brief ּصԭ
 * @brief Tamper detect call back prototype
 * @param p [in]  (parameter)
 */
typedef void (*tamper_callback)(void* p);

/**
 * @brief жSPǷѾ
 * @brief Check SP has been tampered or not
 * @retval 0 δ (return value 0: not been tampered)
 * @retval 1 Ѽ⵽ (return value 1: tamper detected)
 */
int BWSP_IsTampered(void);

/**
 * @brief עṥص
 * @brief Regist Tamper call back
 * @param cb [in] ܵʱҪõĻص (Call back function when get Tampered)
 * @param param [in] صĲ (Call back function parameter)
 * @retval ǰ (return value: current baud rate)
 */
int RegisterTamperCallback(tamper_callback cb, void* param);

/**
 * @brief صԭ
 * @brief Unlock call back prototype
 * @param p [in]  (parameter)
 */
typedef void (*unlock_callback)(void* p);

/**
 * @brief жSPǷѾ
 * @brief Check SP has been unlock or not
 * @retval 0 δ (return value: locked)
 * @retval 1 ѽ (return value: unlocked)
 */
int BWSP_IsUnlocked(void);

/**
 * @brief עص
 * @brief Regist unlock call back
 * @param cb [in] 豸ʱҪõĻص (call back function needed for unlock device)
 * @param param [in] صĲ (call back function parameter)
 */
int RegisterUnlockCallback(unlock_callback cb, void* param);

/**
 * @brief ȴֱSP
 * @brief Wait until SP ready
 */
void BWSDK_WaitUntilSpReady(void);

/**
 * Чͻص.
 */
typedef void (*invalid_customer_callback)(void* p);

/**
 * @brief עЧͻص
 * @param cb [in] ʱĻص
 * @param p [in] cbĲ
 */
void RegisterInvalidCustomerCallback(invalid_customer_callback cb, void* p);

/**
 * @brief Чͻ汾ʱͨ
 * @param password [in] 
 * @retval  0 -- ɹ 1 -- ʧ
 */
int Security_LocalUnlockByInvalidCustomer(const char* password);

/**
 * @brief ؼ򵥽
 * @retval  0 -- ɹ 1 -- ʧ
 */
int Security_LocalUnlockByDeviceTampered(void);

/**
 * @brief ЧͻԶ̽
 * @retval  0 -- ɹ 1 -- ʧ
 */
int Security_RemoteUnlockByInvalidCustomer(void);
 
/**
 * @brief 豸Զ̽
 * @param sensor_result [out] ʧܺsensorֵ
 * @param sensor_result_len [in] sensor_result
 * @retval  0 -- ɹ 1 -- ʧ
 */ 
int Security_RemoteUnlockByDeviceTempered(char* sensor_result, int sensor_result_len);

/**
 * @brief ЧӦԶ̽
 * @retval  0 -- ɹ 1 -- ʧ
 */
int Security_RemoteUnlockInvalidApp(void);

/** @} */

/**
 * @defgroup port_bridge port_bridge
 * @brief ˿ؽӿ
 * @brief Port Bridge related interface
 * @{
 */

//=============================================================
// "port_bridge.h"
//=============================================================
/** @brief ˿豸**/
/** @brief Port Device Definition**/
typedef enum {
    PORT_USB_AT,  ///< USB-AT˿ (USB - AT port)
    PORT_UART_0,  ///< UART0
    PORT_UART_1   ///< UART1
} port_dev_t;

/**
 * @brief Bridge the serial port A and B
 * @param portA [in] Serial Port A. refer port_dev_t
 * @param portA [in] Serial Port B. refer port_dev_t
 * @param pstComCfg [in] Physical serial port configuration
 * @retval 0 Success
 * @retval -1 Fail
 */
int port_bridge_start_ex(port_dev_t portA, port_dev_t portB, COM_CONFIG_T *pstComCfg);

/**
 * @brief Bridge the serial port A and B, baudrate 115200.
 * @param portA [in] Serial Port A. refer port_dev_t
 * @param portA [in] Serial Port B. refer port_dev_t
 * @retval 0 Success
 * @retval -1 Fail
 */
int port_bridge_start(port_dev_t portA, port_dev_t portB);

/**
 * @brief رŽ
 * @brief Stop Port Bridge
 * @retval 0 ɹ (return value 0: success)
 * @retval -1 ʧ (return value -1: fail)
 */
int port_bridge_stop(void);
/** @} */

/**
 * @defgroup softtimer softtimer
 * @brief timerؽӿ
 * @brief timer related interface
 * @{
 */
//=============================================================
//#include "softtimer.h"
//=============================================================

/**
 * @brief ʱݽṹ
 * @brief Timer data structure
 * @author diaoxuesong@basewin.com
 */
typedef struct {
    unsigned long start;  ///< ʼ (time start)
    unsigned long timeout; ///< ʱʱ (time out)
    unsigned long (*tick_fun)(void); ///< ʱcallback (timer call back)
} T_SOFTTIMER;

/**
 * @brief üʱ
 * @brief Timer setup
 * @author diaoxuesong@basewin.com
 * @param tm [in] T_SOFTTIMERָ (T_SOFTTIMER pointer)
 * @param lms [in] ʱ (time length in ms)
 */
void s_TimerSet(T_SOFTTIMER *tm, unsigned long lms);

/**
 * @brief ʱʣʱ
 * @brief Check Timer remain time
 * @author diaoxuesong@basewin.com
 * @param tm [in] T_SOFTTIMERָ (T_SOFTTIMER pointer)
 * @retval 0 ʱѾ (return value 0: timer end)
 * @retval !0 ʱʣms (return value !0: remain time)
 */
unsigned long s_TimerCheck(T_SOFTTIMER *tm);
/** @} */

/**
 * @defgroup filesystem filesystem
 * @brief ļؽӿ
 * @brief filesystem related interface
 * @{
 */
 
/**
 * @defgroup basefileapi basefileapi
 * @intogroup filesystem
 * @brief ļؽӿ
 * @brief Basic file operation related interface
 * @{
 */ 
//=============================================================
//#include "bwfs.h"
//=============================================================

#define O_RDWR          0x01 ///< дģʽļѾ (Read and Write Mode, file must exist)
#define O_CREATE        0x02 ///< ½ģʽļʱԶ (Create new file Mode, will auto-create new file if not exist)
#define O_RO            0x03 ///< ֻģʽļѾ (Read Only Mode, file must exist)

#define SEEK_CUR        0 ///< ӵǰλÿʼ (From current position)
#define SEEK_SET        1 ///< ָλÿʼ (From specified position) 
#define SEEK_END        2 ///< ļβʼ (From the end of file)

#define BWFS_ERR_BASE        (-5800)           ///< ļϵͳʼ (File system error code initial number)
#define FS_ERR_FILENAME_SIZE (BWFS_ERR_BASE-1) ///< ļС (File name size error)
#define FS_ERR_PARAM         (BWFS_ERR_BASE-2) ///<  (Parameter error)
#define FS_ERR_WRITE         (BWFS_ERR_BASE-3) ///< дļ (File write error)
#define FS_ERR_READ          (BWFS_ERR_BASE-4) ///< ļ (File read error)
#define FS_ERR_SEEK          (BWFS_ERR_BASE-5) ///< ļָ (File pointer setting error)
#define FS_ERR_MAXFILE_OPEN  (BWFS_ERR_BASE-6) ///< ļ (Maximum file opened error)
#define FS_ERR_OPEN          (BWFS_ERR_BASE-7) ///< ļʧ (Open file fail)
#define FS_ERR_NOT_OPEN      (BWFS_ERR_BASE-8) ///< ļδ (File not open yet error)

/**
 * @brief ļ
 * @brief Open File
 * @author diaoxuesong@basewin.com
 * @param filename [in] ļ16ַ (File name, no more than 16 character)
 * @param mode [in] ģʽѡ O_RDWR, O_CREATE  O_RO (Open mode: O_PDWR, O_CREATE or O_RO)
 * @retval >=0 ɹ,ļ (return value >= 0: open file success, file descriptor)
 * @retval 0 ʧ (return value != 0: open file fail)
 * @pre BWFS_Init
 */
int FsOpen(const char *filename, unsigned char mode);

/**
 * @brief رѴ򿪵ļ
 * @brief Close opened file
 * @author diaoxuesong@basewin.com
 * @param fd [in] ļ (file descriptor)
 * @retval 0 ɹ (return value 0: close file success)
 * @retval <0 ʧ (return value <0: close file fail)
 * @pre FsOpen
 */
int FsClose(int fd);

/**
 * @brief Ѿ򿪵ļд
 * @brief Write data into opened file
 * @author diaoxuesong@basewin.com
 * @param fd [in] ļ (file descriptor)
 * @param dat [in] Ҫд (data for written)
 * @param len [in] Ҫдֽ (length of data for written)
 * @retval >=0 ɹ,ʵдĳ (return value >=0 : data write in success, length of data written)
 * @retval <0 ʧ (return value <0: data write in fail)
 * @pre FsOpen
 */
int FsWrite(int fd, unsigned char *dat, int len);

/**
 * @brief Ѿ򿪵ļ
 * @brief Read data from opened file
 * @author diaoxuesong@basewin.com
 * @param fd [in] ļ (file descriptor)
 * @param dat [out] ݻ (buffer for data read)
 * @param len [in] Ҫֽ (length of date read)
 * @retval >=0 ɹ,ʵʶĳ (return value >= 0: data read success, length of data read)
 * @retval <0 ʧ (return value < 0: data read fail)
 * @pre FsOpen
 */
int FsRead(int fd, unsigned char *dat, int len);

/**
 * @brief Ѵļָλ
 * @brief Set up pointer position for opened file
 * @author diaoxuesong@basewin.com
 * @param fd [in] ļ (file descriptor)
 * @param offset [in] ƫ (offset)
 * @param origin [in] ƫĲολ (origin position)
 * @retval 0 ɹ,ʵʶĳ (return value 0: set up success, real length of data read)
 * @retval <0 ʧ (return value 0: set up fail)
 * @pre FsOpen
 */
int FsSeek(int fd, long offset, unsigned char origin);

/**
 * @brief Get current file pointer location
 * @param fd [in] file descriptor
 * @retval >=0 Success, offset from file begin
 * @retval <0 Fail
 */
int FsGetPointer(int fd);

/**
 * @brief Set file size, fill zero if bigger than original file length
 * @param fd [in] file descriptor
 * @param newsize [in] new file size in bytes
 * @retval 0 Success
 * @retval -1 Fail
 */
int FsSetSize(int fd, unsigned int newsize);

/**
 * @brief ɾļ
 * @brief Delete file
 * @author diaoxuesong@basewin.com
 * @param filename [in] ļ (file name)
 * @retval 0 ɹ (return value 0: delete success)
 * @retval <0 ʧ(return value < 0: delete fail)
 * @pre 
 */
int FsRemove(const char *filename);

/**
 * @brief Rename file from srcname to destname
 * @param srcname [in] the name of source file
 * @param destname [in] the name of destination file
 * @retval 0 Success
 * @retval !0 Fail
 */
int FsRename(char *srcname, char *destname);

/**
 * @brief ȡļС
 * @brief Get file size
 * @author diaoxuesong@basewin.com
 * @param filename [in] ļ (file name)
 * @retval >=0 ɹ,ļĴС (return value >= 0: get size success, file size)
 * @retval <0 ʧ (return value < 0: get size fail)
 * @pre 
 */
int FsSize(const char *filename);

/**
 * @brief Get file size from file descriptor
 * @param fd [in] file descriptor
 * @retval >=0 Success, the file size in byte
 * @retval <0 Fail
 */
int FsSizeFd(int fd);

/**
 * @brief Calc SHA256 of file
 * @param filename [in] file path
 * @param hash [out] HASH output
 * @param hashlen [in] Length of hash buffer in byte
 * @retval 0 Success
 * @retval !0 Fail
 */
int FsFileSha256Calc(char *filename, void *hashout, int hashlen);

/**
 * @brief Verify the SHA256 of specific file
 * @param filename [in] path of file
 * @param hash [in] Expected SHA256 HASH
 * @param hashlen [in] Length of hash in byte
 * @retval 0 Success
 * @retval !0 Fail
 */
int FsFileSha256Check(char *filename, void *hash, int hashlen);

/**
 * @brief ؽļϵͳ
 * @brief Rebuild file system
 * @author diaoxuesong@basewin.com
 * @retval 0 ɹ (return value 0: rebuild success)
 * @retval <0 ʧ (return value < 0: rebuild fail)
 * @pre BWFS_Init
 */
int FsRebuild(void);

/**
 * @brief ȡļϵͳʣռ
 * @brief Get file system free space
 * @retval >=0 ʣռ(λ: ֽ) (return value >= 0: Free space, unit: byte)
 * @retval <0 ȡʧ (return value <0: get free space fail)
 */
int FsGetFreeSpace(void);

/**
 * @brief ȡļϵͳʹÿռ
 * @brief Get file system used space
 * @retval >=0 ʹÿռ(λ: ֽ) (return value >= 0: Used space, unit: byte)
 * @retval <0 ȡʧ (return value < 0: get used space fail)
 */
int FsGetUsedSpace(void);

/**
 * @brief Create directory
 * @param pathName [in] Directory path
 * @retval 0 Success
 * @retval !0 Fail
 */
int FsCreateDir(const char *pathName);

/** @} */
/**
 * @defgroup filetools filetools
 * @intogroup filesystem
 * @brief ļؽӿ
 * @brief File operation tools related interface
 * @{
 */
/**
 * @brief ȡļеĽڵ
 * @brief Read node in configration file
 * @param [in] title ļͷһΪ[]е (Configration file title, usually be data in "[]")
 * @param [in] key keyֵ (key value)
 * @param [in] initfileName ļ (Initialize file name)
 * @param [in] des ȡݴλ (Get data storage location)
 * @retval NORMAL
 * @retval EXCEPTION 
 */ 
int fileCfgToolReadKey(char *title, char *key, const char *initfileName, char *des);
/**
 * @brief ȡļеĽڵ
 * @param [in] title ļͷһΪ[]е (Configration file title, usually be data in "[]")
 * @param [in] key keyֵ (key value)
 * @param [in] initfileName ļ (Initialize file name)
 * @param [in] des ȡݴλ (Get data storage location)
 * @retval NORMAL
 * @retval EXCEPTION 
 */ 
int fileCfgToolReadKeyInt(char *title, char *key, const char *initfileName, int *des);
/**
 * @brief ȡļеĽڵ
 * @param [in] title ļͷһΪ[]е (Configration file title, usually be data in "[]")
 * @param [in] key keyֵ (key value)
 * @param [in] initfileName ļ (Initialize file name)
 * @param [in] des ȡݴλ (Get data storage location)
 * @retval NORMAL
 * @retval EXCEPTION 
 */  
int fileCfgToolReadKeyChar(char *title, char *key, const char *initfileName, char *des);
/**
 * @brief ȡԴļ汾
 * @brief Get Resource file version
 * @param [in] sourceName ԴNAME (Resource name)
 * @retval 汾 (return value: version)
 */ 
int fcgGetResourceVersion(char* sourceName);
/**
 * @brief ȡԴļеĶӦԴ
 * @brief Get specified resource from resource file
 * @param [in] sourceName ԴNAME (resource name)
 * @param [in] width Դ (resource width)
 * @param [in] height Դ߶ (resource height)
 * @retval Դ (return value: resource data)
 * @note Ҫfree (need to free after use)
 */  
char* fcgGetResource(char* sourceName,int* width,int* height);
/**
 * @brief ȡļеĶӦԴ
 * @brief Get specified resource from language file
 * @param [in] language  ֧  "chinese  english " (Language: chinses, english and etc)
 * @param [in] id ַid (string ID)
 * @param [in] des ַĵַ (string storage address)
 * @retval NORMAL 
 * @retval EXCEPTION
 */  
int fcgGetStringResource(char* language,char* id,char* des);
/**
 * @brief ȡļеĶӦԴ
 * @brief Get specified resource from language file
 * @param [in] language  ֧  "chinese  english " (Language: chinses, english and etc)
 * @param [in] id ַid (string ID)
 * @param [in] des ַĵַ (string storage address)
 * @param [in] defaultS ԴļʹõĬַ (default string if id not exist)
 * @retval NORMAL 
 * @retval EXCEPTION
 */  
int fcgGetStringResourcePlus(char* language,char* id,char* des,char* defaultS);
/** @} */
/**
 * @defgroup FVfile FVfile
 * @intogroup filesystem
 * @brief FVļؽӿ
 * @brief FV file operation related interface
 * @{
 */
/**
 * @brief Ӧð汾
 * @brief Set up application language version
 * @param [in] version  ֧  "chinese  english " (version: chinese, english and etc)
 */ 
void FVFileSetAppVersion(char* version); 
/**
 * @brief жϳǷһУǵһУҪʼ籣ṹ \n
 *		жԭݰ汾VERSIONжϣÿαVERSIONȻжϽʧ
 * @brief Check whether the application is the first time to run. If it is, need to initialize
		the data structure of power off protection.
		Check method: Check the application version. So need to update VERSION after updating,
		or will cause check fail.
 * @retval true
 * @retval false
 */ 
int FVFileIsFirstRun(void);
/**
 * @brief жϳǷһУǵһУҪʼ籣ṹ \n
 *		жԭݰ汾VERSIONжϣÿαVERSIONȻжϽʧ
 * @brief Check whether the application is the first time to run. If it is, need to initialize
		the data structure of power off protection.
		Check method: Check the application version. So need to update VERSION after updating,
		or will cause check fail.
 * @retval true
 * @retval false
 */ 
int FVFileIsFirstRunForApp(void);
/**
 * @brief жϳǷ \n 
 *		жԭݰ汾VERSIONжϣÿαVERSIONȻжϽʧ
 * @brief Check whether the application is update. If it is, need to initialize
		the data structure of power off protection.
		Check method: Check the application version. So need to update VERSION after updating,
		or will cause check fail. 
 * @retval true
 * @retval false
 */ 
int FVFileIsUpdate(void);
/**
 * @brief жϳǷ \n
 *		жԭݰ汾VERSIONжϣÿαVERSIONȻжϽʧ
 * @brief Check whether the application is update. If it is, need to initialize
		the data structure of power off protection.
		Check method: Check the application version. So need to update VERSION after updating,
		or will cause check fail.  
 * @retval true
 * @retval false
 */ 
int FVFileIsUpdateForApp(void);
/**
 * @brief 籣
 * @brief Load Power off protection data structure
 * @param [in] fileName FVļ (FV file name)
 * @param [in] fv FVṹַ (FV structure address)
 * @param [in] size FVṹС (FV structure size)
 * @retval NORMAL
 * @retval EXCEPTION
 */ 
int FVFileLoadFile(char *fileName, void *fv, unsigned int size);
/**
 * @brief дһ籣
 * @brief Write in Power off protection data structure
 * @param [in] fileName FVļ (FV file name)
 * @param [in] address ַ (Variable address)
 * @param [in] len  (Variable length)
 * @retval NORMAL
 * @retval EXCEPTION
 */  
int FVFileWriteFile(char *fileName, void *address, unsigned int len);
/**
 * @brief ɾ籣ļ
 * @brief Delete Power off protection file
 * @param [in] fileName FVļ (FV file name)
 * @retval NORMAL
 * @retval EXCEPTION
 */ 
int FVFileDeleteFile(char *fileName);
/** @} */
/**
 * @defgroup tracefile tracefile
 * @intogroup filesystem
 * @brief ˮļؽӿ
 * @brief Transactions record file operation related interface
 * @{
 */
#define TRACESIZE_ERROR    -2        	///<TRACEDBݴС (Transactions record file size error)
#define TRACEDB_EXIST        -3        	///<TRACEDBļѴ (Transactions record file exist)
#define TRACEDBNAME_ERROR    -4    		///<TRACEDBļ쳣 (Transactions record file name error)
#define TRACEDBCREATE_ERROR -5        	///<TRACEDBļ쳣 (Create Transactions record file error)
#define TRACEDBOPEN_ERROR    -6        	///<TRACEDBļ쳣 (Open Transactions record file error)
#define TRACEDBWRITE_ERROR    -7        ///<TRACEDBļд쳣 (Write Transactions record file error)
#define TRACEDBREAD_ERROR    -7        	///<TRACEDBļȡ쳣 (Read Transactions record file error)
#define TRACEDBSEEK_ERROR    -8        	///<TRACEDBļλ쳣 (Locate Transactions record file error)
/**
 * @brief ˮDBļ
 * @brief Create Transactions record file
 * @param [in] fileName ˮļ (Transactions record file name)
 * @param [in] traceDbSize ˮݽṹС (Transactions record data structure size)
 * @retval NORMAL
 * @retval EXCEPTION/ (return value: EXCEPTION/other error code)
 */  
int transDBCreate(char *fileName, int traceDbSize);
/**
 * @brief ˮDBļ,
 * @brief Create Transactions record file and setup maximum Transactions record amount
 * @param [in] fileName ˮļ (Transactions record file name)
 * @param [in] traceDbSize ˮݽṹС (Transactions record data structure size)
 * @param [in] maxSize ˮļ (Maximum Transactions record amount)
 * @retval NORMAL
 * @retval EXCEPTION/ (return value: EXCEPTION/other error code)
 */ 
int transDBCreateWithThreshold(char *fileName, int traceDbSize,int maxSize);
/**
 * @brief ˮDBļ
 * @brief Open Transactions record file
 * @param [in] fileName ˮļ (Transactions record file name)
 * @retval ļ (File descriptor)
 */ 
int transDBOpen(char *fileName);
/**
 * @brief رˮDBļ
 * @brief Close Transactions record file
 * @param [in] fileName ˮļ (Transactions record file name)
 * @retval NORMAL
 * @retval EXCEPTION/ (return value: EXCEPTION/other error code)
 */  
int transDBClose(int fd);
/**
 * @brief ȡˮļС
 * @brief Get Transactions record file size
 * @param [in] fileName ˮļ (Transactions record file name)
 * @retval ˮ (return value: Transaction amount)
 */ 
int transDBGetMaxCount(char *fileName);
/**
 * @brief ˮ
 * @brief Add Transaction data
 * @param [in] dbFd ļ (File descriptor)
 * @param [in] des д (Data to write in)
 * @param [in] traceDbSize ˮݽṹС (Transaction data structure size)
 * @retval NORMAL
 * @retval EXCEPTION/ (return value: EXCEPTION/other error code)
 */ 
int transDBInsert(int dbFd, uchar *des, int traceDbSize);
/**
 * @brief ָˮ
 * @brief Updating Transaction data with specified index
 * @param [in] dbFd ļ (File descriptor)
 * @param [in] index  (index)
 * @param [in] des д (Data to write in)
 * @param [in] traceDbSize ˮݽṹС (Transaction data structure size)
 * @retval NORMAL
 * @retval EXCEPTION/ (return value: EXCEPTION/other error code)
 */ 
int transDBUpdate(int dbFd, int index, uchar *des, int traceDbSize);
/**
 * @brief ѯӦˮ
 * @breif Query Transaction data with specified index
 * @param [in] dbFd ļ (File descriptor)
 * @param [in] index  (index)
 * @param [in] des дָ (Pointer of data to write in)
 * @param [in] len ˮݴСַ (Address of Transaction data size)
 * @retval NORMAL
 * @retval EXCEPTION/ (return value: EXCEPTION/other error code)
 */  
int transDBQuery(int dbFd, int index, uchar *des, int *len);
/**
 * @brief ɾˮļ
 * @brief Delete Transactions record file
 * @param [in] fileName ļ (File name)
 * @retval NORMAL
 * @retval EXCEPTION/ (return value: EXCEPTION/other error code)
 */ 
int transDBDelete(char *fileName);
/** @} */
/** @} */


//=============================================================
//#include "bwfont.h"
//=============================================================

/**
 * @defgroup lcd lcd
 * @brief lcdؽӿ
 * @brief LCD operation related interfacce
 * @{
 */
//=============================================================
//#include "bwlcd.h"
//=============================================================
#define MERCURY_COLOR_NONE (0xFFFF) ///< ɫʹϵͳɫ (No color setup, using system color)

#define NON_TRANSPARENT (0)		///< ͸ (None-transparent)
#define TRANSPARENT (2)			///< ͸ (Transparent)

#define FONT_SIZE_NORMAL 0		///< normalС (Text font size normal)
#define FONT_SIZE_SMALL  1		///< smallС (Text font size small)

/**
 * @brief ʾԵ
 * @brief Data structure that describe text property
 * @author diaoxuesong@basewin.com
 */
typedef struct {
    unsigned int fColor; ///< ʾʱǰɫ (Text foreground color)
    unsigned int bColor; ///< ʾʱıɫ (Text background color)
    unsigned char Mode; ///< Mode - ʾʱ͸ǲ͸ (Mode setup for None-transparent or Transparent)
    unsigned char Type; ///<  (Font Type)
    unsigned char Size; ///< С (Font Size)
} tsFont;

/**
 * @brief һε
 * @brief Data structure that describe a rectangle
 * @author diaoxuesong@basewin.com
 */
typedef struct {
    short Left; ///<  (Horizontal coordinate)
    short Top; ///<  (Vertical coordinate)
    short Width; ///<  (Width)
    short Height; ///< ߶ (Height)
} tsRect;

/**
 * @brief ʾ
 * @brief Data structure that describe display screen
 * @author diaoxuesong@basewin.com
 */
typedef struct {
    short Width; ///< ʾĿ (λ: ) */ (Width, unit: pixel)
    short Height; ///< ʾĸ߶ (λ: ) (Height, unit: pixel)
} tsScrInfo;

/**
 * @brief ʾϢ ״̬
 * @brief Clean up all information on display screen, status bar can not be cleaned
 * @author diaoxuesong@basewin.com
 * @retval   (no return value)
 * @pre  
 */
void ScrCls(void);

/**
 * @brief ʾָ
 * @brief Clean up specified area on display screen
 * @note бʱñͼڸǣñɫڸ (If there is a background picture, use picture to cover. If not, use background color)
 * @note ״̬޷ (status bar can not be cleaned)
 * @param rect [in] Ҫľ (Area need to be cleaned up)
 */
void ScrClsArea(tsRect *rect);

/**
 * @brief ȡָıͼƬ
 * @brief Get background picture on specified area
 * @param rect [in] ָľ (specify area)
 * @param buff [out] þıݻ(ַ2ֽڶ) (Address of buffer that store the information in specified retangle area, Address must be groups of 2 bytes)
 * @param buflen [int] buffߴ(λ: ֽ) (Buffer size, unit: byte)
 * @retval 0 ɹ (return value 0: success)
 * @retval !0 ʧ (return value !0: fail)
 */
int ScrGetBgBitmapArea(tsRect *rect, void *buff, unsigned int buflen);

/**
 * @brief ȡ汳ͼƬַ
 * @brief Get address of main interface background picture
 * @note ͼƬʾֱһ,240x320320x240 (Picture must be same size with display screen, for example: 240x320 or 320x240)
 * @retval NULL ûбͼƬ (return value NULL: no background picture)
 * @retval !NULL ͼƬBitMapַ (return value !NULL: the address of background picture bitmap buffer
 */
void* ScrGetBgBitmap(void);

/**
 * @brief ıͼƬ
 * @brief Setup main interface background picture
 * @note ͼƬʾֱһ,240x320320x240 (Picture must be same size with display screen, for example: 240x320 or 320x240)
 * @param data [in] λͼRGB565ʽ(ÿռ2ֽ)  (Bitmap storage buffer, Bitmap in RGB565, every pixel take 2 bytes)
 * @retval 0 ɹ (return value 0: success)
 * @retval !0 ַǷ2ֽڶ (return value !0: invalid address, ???)
 */
int ScrSetBgBitmap(void *data);

/**
 * @brief ָǰʾʼλ
 * @brief Setup current displaying origin position
 * @author diaoxuesong@basewin.com
 * @param [in] x ָʾ豸Ϻλ (x for horizontal position)
 * @param [in] y ָʾ豸λ (y for vertical position)
 * @retval   (no return value)
 * @pre  
 */
void ScrGotoXY(unsigned short x, unsigned short y);

/**
 * @brief ȡǰַʾʼλ
 * @brief Get current displaying origin position 
 * @param [out] x ǰַʾĺ (x for horizontal position)
 * @param [out] x ǰַʾ (y for vertical position)
 */
void ScrGetXY(unsigned short *x, unsigned short *y);

/**
 * @brief ڵǰλÿʼʾָ
 * @brief Display specified text informaion in current location
 * @author diaoxuesong@basewin.com
 * @param [in] ptext Ҫʾ (text information)
 * @retval   (no return value)
 * @pre 
 */
void ScrTextOut(unsigned char *ptext);

/**
 * @brief ָʾ
 * @brief Setup property for following text
 * @author diaoxuesong@basewin.com
 * @param [in] pFont ֵʾ (text property)
 * @retval   (no return value)
 * @pre 
 */
void ScrSetFont(tsFont *pFont);

/**
 * @brief ȡǰʾ
 * @brief Get current text property
 * @author diaoxuesong@basewin.com
 * @param [in] pFont ֵʾ (text property)
 * @retval   (no return value)
 * @pre 
 */
void ScrGetFont(tsFont *pFont);

/**
 * @brief ָʾָʾBitmap
 * @brief Display bitmap in specified area
 * @author diaoxuesong@basewin.com
 * @param [in] pRect ָ (specify area)
 * @param [in] pBitmap Ҫʾbitmap (bitmap)
 * @retval  (no return value)
 * @pre 
 */
void ScrBitMap(tsRect *pRect, unsigned char *pBitmap);

/**
 * @brief ȡʾ豸״̬
 * @brief Get display device status
 * @author diaoxuesong@basewin.com
 * @param [out] pScrInfo ʾ豸Ϣ (display device information)
 * @retval  (no return value)
 * @pre 
 */
void ScrGetStatus(tsScrInfo *pScrInfo);

/**
 * @brief ڱ
 * @brief Adjust background brightness
 * @author diaoxuesong@basewin.com
 * @param [in] level ȣΧΪ0-14 (brightness level, from 0 - 14)
 * @retval  (no return value)
 * @pre 
 */
void ScrSetBackLight(unsigned short level);

/**
 * @brief Ļָ ͼ
 * @brief Clean up specified area, keep background picture
 * @author diaoxuesong@basewin.com
 * @param [in] prect Ҫľ (specified area)
 * @retval  no return value
 * @pre 
 */
void ScrRectClear(tsRect *prect);

/**
 * @brief Ļ
 * @brief Refresh Screen
 * @author diaoxuesong@basewin.com
 * @retval  no return value
 * @pre 
 */
void ScrRefresh(void);

/**
 * @brief ָʾصɫ
 * @brief Setup pixel color on specified coordinate
 * @author diaoxuesong@basewin.com
 * @param [in] color ʾɫο: MERCURY_PALETEE_ARRAY_INDEX_E (color, for example: MERCURY_PALETEE_ARRAY_INDEX_E)
 * @retval  no return value
 * @pre 
 */
void ScrSetPixel(unsigned short color);

/**
 * @brief ƿľο
 * @brief Draw rectangle frame without fill
 * @author diaoxuesong@basewin.com
 * @param [in] rect β rectangle information
 * @param [in] penw ߿ frame width
 * @param [in] color ߿ɫ frame color
 * @retval  no return value
 * @pre 
 */
void ScrDrawRect(tsRect *rect, short penw, short color);

/**
 * @brief 
 * @brief Fill rectangle
 * @author diaoxuesong@basewin.com
 * @param [in] rect β rectangule information
 * @param [in] color ɫ fill color
 * @retval  no return value
 * @pre 
 */
void ScrFillRect(tsRect *rect, short color);

/**
 * @brief Ļʽַ
 * @brief Screen displaying string
 * @author diaoxuesong@basewin.com
 * @param [in] fmt ʽַ String
 * @param [in] ... б parameter list
 * @retval  no return value
 * @pre 
 */
void ScrPrintf(char *fmt, ...);

/**
 * @brief Generat QR code, store the bitmap into buffer
 * @param paystr [in] string to make QR code
 * @param buf [out] the QR code bitmap buffer (1 dot per bit)
 * @param buflen [in] the max bytes of buf, [out] output bytes of QR code bitmap buffer
 * @param bitmap_width [out] the side length of QRbitmap in dot
 * @retval 0 Success
 * @retval <0 Fail
 */
int QrCodeGenBitmapBuf(char *paystr, void *buf, unsigned int *buflen, unsigned int *bitmap_width);

/**
 * @brief ɶά룬ʾָ
 * Ķάλָ룬Դ1صİױ
 * @brief Generate QR code and display on specified area
 * 		QR code will be sit in the middle of the area with the 1 pixel width white frame
 * @author diaoxuesong@basewin.com
 * @param [in] rect ʾ rectangle display area
 * @param [in] paystr ַ string
 * @retval 0 ɹ (return 0: success)
 * @retval <0 ʧ (return <0: fail)
 * @pre 
 */
int ScrShowQrCode(tsRect *rect, char *paystr);

/**
 * @brief ɶά룬ʾָ
 * Ķάλָ룬ױ߿ֶָ
 * @brief Generate QR code and display on specified area
 *		QR code will be sit in the middle of the area with the user input pixel width white frame
 * @author diaoxuesong@basewin.com
 * @param [in] rect ʾ rectangle display area
 * @param [in] paystr ַ string
 * @param [in] marginWidth ױ߿(λ) width of white frame, unit: pixel
 * @retval 0 ɹ return 0: success
 * @retval <0 ʧ return <0: fail
 * @pre 
 */
int ScrShowQrCodeExt(tsRect *rect, char *paystr, unsigned int marginWidth);

/**
 * @brief ȡǰıɫ
 * @brief Get current main interface background color
 * @retval ǰıɫ(MERCURYɫ) return value: current main interface background color, in MERCURY color
 */
unsigned short ScrGetMainBgColor(void);

/**
 * @brief ȡǰǰɫ
 * @brief Get current main interface foreground color
 * @retval ǰǰɫ(MERCURYɫ) renturn value: current main interface foreground color, in MERCURY color
 */
unsigned short ScrGetMainFgColor(void);

/**
 * @brief ıɫ
 * @brief Setup main interface background color
 * @param color [in] MERCURYɫ (MERCURY color)
 */
void ScrSetMainBgColor(unsigned short color);

/**
 * @brief ǰɫ
 * @brief Setup main interface foreground color
 * @param color [in] MERCURYɫ (MERCURY color)
 */
void ScrSetMainFgColor(unsigned short color);

/**
 * @brief ȡǰ״̬ıɫ
 * @brief Get current status bar backgroung color
 * @retval ǰ״̬ıɫ(MERCURYɫ) return value: MERCURY color
 */
unsigned short ScrGetStatusBarBgColor(void);

/**
 * @brief ȡǰ״̬ǰɫ
 * @brief Get current status bar foreground color
 * @retval ǰ״̬ǰɫ(MERCURYɫ) return value: MERCURY color
 */
unsigned short ScrGetStatusBarFgColor(void);

/**
 * @brief ״̬ıɫ
 * @brief Set up status bar background color
 * @param color [in] MERCURYɫ MERCURY color
 */
void ScrSetStatusBarBgColor(unsigned short color);

/**
 * @brief ״̬ǰɫ
 * @brief Set up status bar foroground color
 * @param color [in] MERCURYɫ MERCURY color
 */
void ScrSetStatusBarFgColor(unsigned short color);

/**
 * @brief ȡ״̬ĸ߶
 * @brief Get status bar height
 * @retval ǰ״̬ĸ߶(λ:) return value: stats bar height. Unit: pixel
 */
unsigned short ScrGetStatusBarHeight(void);

/**
 * @brief Enable/Disable status bar auto refresh
 * @param onoff [in] 0 - Disable auto-refresh, 1 - Enable auto-refresh
 */
void ScrSetStatusBarAutoRefresh(int onoff);

/**
 * @brief MERCURY_PALETTEɫתΪRGBɫ
 * @brief Transfer MERCURY color to RGB color
 * @author diaoxuesong@basewin.com
 * @param [in] color ɫο:MERCURY_PALETEE_ARRAY_INDEX_E (MERCURY color)
 * @retval rgb RGBɫ return value: RBG color
 * @pre 
 */
unsigned short MercuryColorToRGB(unsigned short color);

/**
 * @brief Ļɫ
 * @brief Screen color test
 * @author diaoxuesong@basewin.com
 * ----
 * RED-GREEN-BLUE-WHITE-BLACK
 */
void ScrTest(void);
void ScrQrCodeTest(void);

#define KPDSCR_RSSI_PREF_WLAN 0 ///< Show WLAN rssi on keypad screen
#define KPDSCR_RSSI_PREF_GPRS 1 ///< Show GPRS rssi on keypad screen
#define KPDSCR_RSSI_PREF_AUTO 2 ///< Show rssi on keypad screen which connected

/**
 * @brief ʾˢ(ӻ)
 * @brief Keyboard screen synchronization
 * @brief 
 */
void KpdScrSync(void);

/**
 * @brief ¼ʾGPRS״̬
 * @brief Refresh GPRS status of keyboard screen 
 * @param onoff [in] 0 - GPRSδӣ1 - GPRS (0 for GPRS disconnected, 1 for GPRS connecting)
 */
void KpdScrUpdateGprs(int onoff);

/**
 * @brief ¼ʾWIFI״̬
 * @breif Refresh WIFI status of keyboard screen
 * @param onoff [in] 0 - WIFIδӣ1 - WIFI (0 for WIFI disconnected, 1 for WIFI connecting)
 */
void KpdScrUpdateWlan(int onoff);

/**
 * @brief Set prefer rssi display on keypad screen
 * @param pref [in] the prefer rssi, KPDSCR_RSSI_PREF_XXX
 */
void KpdScrRssiPrefer(int pref);

/**
 * @brief ¼ʾźǿ
 * @brief Refresh RSSI of keyboard screen
 * @param rssi [in] ǰźǿ, ȡֵ0-4 (current rssi, value from 0 to 4)
 */
void KpdScrUpdateRssi(int rssi);

/**
 * @brief ո¼ʾֺС򣬲ıź
 * @brief Clean up integar and decimal part on keyboard screen, wont send any information to Host. 
 */
void KpdScrCls(void);

/**
 * @brief ʾԼ죬ʾ
 * @brief Keyboard screen self-check, display all information
 */
void KpdScrSelfTest(void);

/**
 * @brief Refresh integer and decimal part on keyboard screen
 * @param integer [in] Integar part (<1,000,000), binary, none-BCD code
 * @param decimal [in] Two decimal part, binary, none-BCD code, for example: 23 mains 0.23. Maximum: 99
 * @param isNegative [in] Negative flag, 0-Positive, 1-Negative
 * @param LeadChar [in] Set the lead character, '\0' or ' ' means not set lead character.
 * @retval 0 Success
 * @retval <0 Fail
 */
int KpdScrSetNumberEx1(unsigned long integer, unsigned char decimal, int isNegative, char LeadChar);

/**
 * @brief Refresh integer and decimal part on keyboard screen
 * @param integer [in] Integar part (<1,000,000), binary, none-BCD code
 * @param decimal [in] Two decimal part, binary, none-BCD code, for example: 23 mains 0.23. Maximum: 99
 * @param isNegative [in] Negative flag, 0-Positive, 1-Negative
 * @retval 0 Success
 * @retval <0 Fail
 */
int KpdScrSetNumberEx(unsigned long integer, unsigned char decimal, int isNegative);

/**
 * @brief ¼ʾС
 * @brief Refresh integer and decimal part on keyboard screen
 * @param integer [in] (С100)ƣBCD integar part, binary, none-BCD code
 * @param decimal [in] С(2λ, ƣBCD, :23ʾ0.2399) 2 digit decimal part, binary, none-BCD code, for example: 23 mains 0.23. Maximum: 99
 * @retval 0 ɹ return 0: success
 * @retval <0 ʧ return <0 fail
 */
int KpdScrSetNumber(unsigned long integer, unsigned char decimal);

/**
 * @brief ʾַ
 * @brief Refresh string on keyboard screen
 * @note ʾĸ'K/M/V/W'ʾ
 * @note Cause the lcd limit the 'K/M/V/W' can not display
 * @param s [in] string (not more than 10 char)
 * @retval 0 ɹ
 * @retval <0 ʧ
 */
int KpdScrSetString(char *s);
/** @} */
/**
 * @defgroup keyboard keyboard
 * @brief ؽӿ
 * @brief Keyboard operation related interface
 * @{
 */
//=============================================================
//#include "bwkb.h"
//=============================================================
#define KEY_NONE           (0x00) ///< ް 
#define KEY_ASCII1         (0x31) ///< "1"ļֵ
#define KEY_ASCII2         (0x32) ///< "2"ļֵ
#define KEY_ASCII3         (0x33) ///< "3"ļֵ
#define KEY_ASCII4         (0x34) ///< "4"ļֵ
#define KEY_ASCII5         (0x35) ///< "5"ļֵ
#define KEY_ASCII6         (0x36) ///< "6"ļֵ
#define KEY_ASCII7         (0x37) ///< "7"ļֵ
#define KEY_ASCII8         (0x38) ///< "8"ļֵ
#define KEY_ASCII9         (0x39) ///< "9"ļֵ
#define KEY_ASCII0         (0x30) ///< "0"ļֵ
#define KEY_ALPHA          (0x04) ///< "ĸ"ļֵ
#define KEY_FUNC           (0x05) ///< ""ļֵQR200϶ӦF1϶Ӧ"" (For QR200 device, it links to F1. For external keyboard device,it links to "setting")
#define KEY_CANCEL         (0x1B) ///< "ȡ"ļֵ
#define KEY_CLEAR          (0x03) ///< ""ļֵ
#define KEY_ENTER          (0x0D) ///< "ȷ"ļֵ
#define KEY_SCAN           (0x0B) ///< "ɨ"ļֵ
#define KEY_UP             (0x26) ///< "F2"ļֵ
#define KEY_DOWN           (0x28) ///< "F3"ļֵ
#define KEY_00			   (0x08) ///< "00"ļֵ
#define KEY_MENU		   (0x02) ///< "F4"ļֵ
#define KEY_DIV            (0x2F) ///<  ""
#define KEY_MUL            (0x2A) ///<  ""
#define KEY_ADD            (0x2B) ///<  "+"
#define KEY_SUB            (0x2D) ///<  "-"
#define KEY_REPLAY         (0x12) ///<  "ز"
#define KEY_REFUND         (0x13) ///<  "˿"
#define KEY_COLLECTION     (0x14) ///<  "տ"
#define KEY_DOT            (0x2E) ///<  "."
#define KEY_F1             (0x41) ///<  "F1"
#define KEY_F2             (0x42) ///<  "F2"
#define KEY_F3             (0x43) ///<  "F3"

/**
 * @brief հ ֮ǰеİ¼
 * @brief Clean up keyboard buffer, clean up all previous press record
 * @author diaoxuesong@basewin.com
 * @retval  no return value
 * @pre 
 */
void KbFlush(void);

/**
 * @brief ѯǷа
 * @brief Check is there keyboard hit record or not
 * @author diaoxuesong@basewin.com
 * @retval  0 а¼ return 0: has hit record
 * @retval  1 ް¼ return 1: no hit record
 * @pre 
 */
int KbHit(void);

/**
 * @brief ȴ
 * @brief Wait for press
 * @author diaoxuesong@basewin.com
 * @param timeoutms [in] ʱʱ (Maximum wait time)
 *         0:  (return right now)
 *        -1: һֱȴֱа (wait until pressed)
 *        >0: аʱذֵȴtimeoutms (when pressed, return pressed value, or wait "timeoutms"
 * @retval KEY_NONE ûаʱ no key pressed or time out
 * @retval KEY_XXXX ʵʼֵ,KEY_ENTER (key pressed)
 * @pre 
 */
int KbWaitKey(int timeoutms);

/**
 * @brief ȡֵģʽ
 * @brief Get key, blocking mode
 * @author diaoxuesong@basewin.com
 * @retval  ʵʼֵ key value
 * @pre 
 */
int KbGetKey(void);

/**
 * @brief ð
 * @brief Setup key background light
 * @author diaoxuesong@basewin.com
 * @param onoff [in] 0-أ1- (0 for OFF, 1 for ON)
 */
void KbSetBackLight(int onoff);

/**
 * @brief ʾ
 * @brief Keyboard sound switch
 * @author diaoxuesong@basewin.com
 * @param onoff [in] 0-أ1- (0 for OFF, 1 for ON)
 */
void KbTone(int onoff);

/**
 * @brief Keyboard sound switch, and store this config to NV
 * @param onoff [in] 0-OFF1-ON
 */
void KbToneNV(int onoff);

/**
 * @brief Play Keyboard sound
 */
void KbTonePlay(void);

/**
 * @brief жϵǰʹ̬
 * @brief Get current keyboard sound switch status
 * @retval 0 δ 0 for keyboard sound OFF
 * @retval 1 ѿ 1 for keyboard sound ON
 */
int IsKbToneEnable(void);

/**
 * @brief ָĻѹ
 * @breif Setup system wake up for specified button
 * @param onoff [in] 0 ˰ϵͳ 0 for wake up when button get pressed
 * @param onoff [in] 1 ˰ỽϵͳ 1 for none-wake up when button get pressed
 */
void KbWakeEnable(int key, int onoff);

/**
 * @brief ȡָǷܻϵͳ
 * @brief Get the system wake up status for specified button
 * @param key [in] ֵ button
 * @retval 0 ˰ỽϵͳ 0 for the specified button will NOT wake system up
 * @retval 1 ˰ỽϵͳ 1 for the specified button will wake system up
 */
int IsKbWakeEnable(int key);

/**
 * @brief ص
 * @brief Encrypted call back
 * @param p [in] 
 */
typedef void (*KeyHitCallBack)(void* p);

/**
 * @brief עһص
 * @brief Regist a Encrypted call back
 * @param keystr [in]  Encrypted string
 * @param cb [in] صΪNULLʾע˰ Call back function, if NULL, write off the  Encrypted string
 * @param p [in] cbʱĲ parameter for running call back function
 * @retval 0 ɹ 0 for success
 * @retval <0 ʧ <0 for fail
 */
int SecretKeyRegister(char *keystr, KeyHitCallBack cb, void *p);
/** @} */
/**
 * @defgroup scan scan
 * @brief ɨؽӿ
 * @brief Scanning opreation related interface
 * @{
 */
//=============================================================
// #include "bwscan.h"
//=============================================================
#define SCANBAR_RLED    (0x01) ///<  (RED LED)
#define SCANBAR_WLED    (0x02) ///< ׹⣬Ҳв (WRITE LED)

/**
 * @brief ScanBar parameter
 */
typedef struct {
    int power_mode; ///< 0 - Abort after success, 1 - Suspend after success
    int scan_mode;  ///< refer BARSCAN_MODE_VALUE_E, Scan mode
    int feature;    ///< refer BARSCAN_FEATURE_CONFIGURE_E, Scan feature config
} scanbar_param_t;

/**
 * @brief Set scan bar parameter
 * @param param [in] the parameter
 * @note After set, the param will take effect immediately till power off
 */
void ScanBarSetParam(scanbar_param_t *param);

/**
 * @brief 豸ʼɨ
 * @brief Start the device and scanning
 * @author diaoxuesong@basewin.com
 * @retval  0 ɨ豸ɹ 0 for start device success
 * @retval -1 ɨ豸ʧܻɨ豸 -1 for start device fail or no scanning device
 * @pre 
 */
int ScanBarStart(void);

/**
 * @brief Turn on/off the scan success notice tone
 * @note Notice tone is default ON after device power on
 * @param onoff [in] 0-OFF, 1-ON
 */
void ScanBarEnableNoticeTone(int onoff);

/**
 * @brief 豸ʼɨ룬 
 * @brief Start the device and scanning, none-blocking mode
 * @author diaoxuesong@basewin.com
 * @param [out] pdata ɨɹ ɨ if scan success, output scan result
 * @param [in] buf_sz ӦɨݻС application scanning buffer size
 * @param [in] tov_ms ʱʱ timeout time
 * @retval >=0 ɨʵݳ return value >=0: length of data scanned
 * @retval <0 ɨʧܻɨ豸 return value <0: scan fail or no scanning device
 * @pre 
 */
int ScanBarGetData(unsigned char *pdata, int buf_sz, int tov_ms);

/**
 * @brief Pause scanning
 * @note Suspend the scanner
 * @author diaoxuesong@basewin.com
 * @retval =0 Success
 * @retval <0 Fail or no scanner
 */
int ScanBarPause(void);

/**
 * @brief ֹɨ
 * @brief Stop scanning
 * @note Power off the scanner
 * @author diaoxuesong@basewin.com
 * @retval =0 ɨֹɹ return value = 0: stop scanning success
 * @retval <0 ɨֹʧܻɨ豸 return value <0: stop scanning fail or no scanning device
 * @pre 
 */
int ScanBarStop(void);

/**
 * @brief úͲ⣬ Ĭϴ򿪺⡢ رղ
 * @brief Setup RED LED and WHITE LED. RED LED ON and WHITH LED OFF for default
 * @author diaoxuesong@basewin.com
 * @param [in] conf_param 
 *              SCANBAR_RLED  (RED LED)
 *              SCANBAR_WLED  (WHITE LED)
 * @param [in] onoff
 *              1  ON
 *              0 ر OFF
 *
 * @retval =0 ɹ return value = 0: success
 * @retval <0 ʧ return value < 0: fail
 * @pre 
 */
int ScanBarLightSet(unsigned int conf_param, unsigned int onoff);
/** @} */
/**
 * @defgroup system system
 * @brief ϵͳؽӿ
 * @brief System operation related interface
 * @{
 */
//=============================================================
//#include "bwsys.h"
//=============================================================

/**
 * @brief ϵͳʱ
 * @brief System time
 * @author diaoxuesong@basewin.com
 */
typedef struct {
    unsigned short year;    ///< 2000 ~ 2049
    unsigned short mon;        ///< 1 - 12
    unsigned short day;        ///< 1 - 31
    unsigned short hour;    ///< ʱ0 - 23
    unsigned short min;        ///< 0 - 59
    unsigned short sec;        ///< 0 - 59
    unsigned short wday;    ///< 0 - 6 (week days, from 0 to 6)
} tsSysTime;

/**
 * @brief ʱcallback
 * @brief Call back function for reset sleeping time
 * @author diaoxuesong@basewin.com
 * @retval tickcnt ǰϵͳļֵ1ms/tick
 * @pre 
 */
typedef void (*reset_sleep_timer_cb)(void);

/**
 * @brief ϱ¼callback
 * @brief Call back function for notification
 * @author diaoxuesong@basewin.com
 * @param id [in] ֪ͨ¼ID event ID
 * @param pData [in] ֪ͨ event information
 * @param dataLen [in] ֪ͨݵĳ event information length
 */
typedef void (*class_notify_cb)(WORD id, void *pData, DWORD dataLen);

/**
 * @brief Դ¼callback
 * @brief Call back function for long pressing power button
 * @param p [in]  parameter
 */
typedef void (*pwrkey_long_press_callback)(void *p);

/**
 * @brief עָϱ¼callback
 * @bfief Regist call back function for event from specified class
 * @author diaoxuesong@basewin.com
 * @param cls [in] ֪ͨ¼ specified class
 * @param cb [in] ¼Ӧcallback (call back function related event)
 */
void RegSysClassNotify(WORD cls, class_notify_cb cb);

/**
 * @brief עԴcallback
 * @brief Regist call back function for long pressing power button
 * @param cb [in] callback
 * @param param [in] cbʹõĲ parameter for call back function
 */
void RegisterPowerKeyLongPressCallback(pwrkey_long_press_callback cb,void * param);

/**
 * @brief ȡ豸ӿǰϵͳļֵ
 * @brief Get system tick count from power on to current
 * @author diaoxuesong@basewin.com
 * @retval tickcnt ǰϵͳļֵ1ms/tick return value: tick count
 * @pre 
 */
unsigned int GetSysTickCount(void);

/**
 * @brief ȡصϢ ԱжǷԼ
 * @brief Get battery status, in order to check whether devicec can continue transaction or not
 * @author diaoxuesong@basewin.com
 * @retval  0 - ,ܽף1 - ,Խ 0 for low battery, can not continue transaction. 1 for battery normal, can continue transaction.
 * @pre 
 */
int GetSysbatteryState(void);

/**
 * @brief ñʱ
 * @brief Setup system local time
 * @author diaoxuesong@basewin.com
 * @param time [in] õϵͳʱ system time want to set to
 * @retval 0 ɹ return 0: success
 * @retval <0 ʧ return <0: fail
 * @pre 
 */
int SetSysLocalTime(tsSysTime *time);

/**
 * @brief ȡʱ
 * @brief Get system local time
 * @author diaoxuesong@basewin.com
 * @param time [out] ȡϵͳʱ  system time got
 * @retval 0 ɹ return 0: success
 * @retval <0 ʧ return <0: fail
 * @pre 
 */
int GetSysLocalTime(tsSysTime *time);

/**
 * @brief ȡϵͳϢ
 * @brief Get system information
 * @author diaoxuesong@basewin.com
 * @param info [out] ȡϵͳϢ system information got
 * @param flag [in] Ϣ 0-ismi, 1-ccid, 2-imei, 3-version (information type)
 * @retval 0 ɹ return 0: success
 * @retval <0 ʧ return <0: fail
 * @pre 
 */
int GetSysInfo(char *info, int flag);

/**
 * @brief ȡϵͳ״̬
 * @brief Get system sleeping status
 * @author diaoxuesong@basewin.com
 * @retval 0 ϵͳѴ״̬ return 0: system sleeping
 * @retval 1 ϵͳڷ״̬ return 1: system NOT sleeping
 * @pre 
 */
int GetSysStatus(void);

/**
 * @brief ϵͳǷڳ
 * @brief Get system charging status
 * @author diaoxuesong@basewin.com
 * @retval 0 δ return 0: NOT charging
 * @retval 1  return 1: charging
 */
int IsCharging(void);

/**
 * @brief Check if the charger existing
 * @retval 0 Charger not exist
 * @retval 1 Charger exist
 */
int IsChargerExist(void);

/**
 * @brief 豸Ĵģʽ
 * @brief Setup device allowed to get Sleeping mode
 * @author diaoxuesong@basewin.com
 * @param sleep_level [in] 0-; 1-һ; 2-(0 for no sleeping, 1 for normal sleeping, 2 for deep sleeping)
 * @retval  no return value
 * @pre 
 */
void SetSysSleepEnabled(int sleep_level);

/**
 * @brief ȡǰģʽ
 * @brief Get the current sleep level
 * @retval sleep_level, 0 - no sleeping, 1 - normal sleeping, 2 - deep sleeping
 * @pre 
 */
int GetSysSleepEnabled(void);

/**
 * @brief ϵͳȴʱ, ϵͳĬ޲ָ
 * @brief Setup system waiting time, will sleep after a none-operation of user specified second
 * @author diaoxuesong@basewin.com
 * @param tsec [in] , С10 (seconds, minimum 10 second)
 * @retval  no return value
 * @pre 
 */
void SetSysSleepTime(int tsec);

/**
 * @brief ϵͳȴʱÿʼ
 * @brief System sleeping timer restart
 * @author diaoxuesong@basewin.com
 * @retval  no return value
 * @pre 
 */
void ResetSysSleepTimer(void);

/**
 * @brief ȴָʱ
 * @brief Delay specified ms
 * @author diaoxuesong@basewin.com
 * @param ms [in]  (ms)
 * @retval  no return value
 * @pre 
 */
void DelayMs(unsigned int ms);

/**
 * @brief UI߳̾
 * @brief Setup UI thread handles
 * @param hThread [in] UI߳̾ UI thread handles
 */
void SetMainUIThread(HANDLE hThread);

/**
 * @brief ȡUI߳̾
 * @brief Get UI thread handles
 * @retval NULL ûUI߳ return NULL: no UI thread been setup
 * @retval UI߳ return: UI thread
 */
HANDLE GetMainUIThread(void);

/**
 * @brief ͣUI߳
 * @brief UI thread pause
 */
void SuspendMainUI(void);

/**
 * @brief ָUI߳
 * @brief UI thread resume
 */
void ResumeMainUI(void);

/**
 * @brief ϵͳģĳʼ
 * @brief System blocks initialize
 *  Ӧóһʼһ (Only run once when application start)
 */
int BWSDK_Init(void);

/**
 * @brief ϵͳģĳʼ(ư汾)
 * @brief System blocks initialize(for customize version)
 * @note Ӧóһʼһ (Only run once when application start)
 * @note BWSDK_Initظ (Can not be used with "BWSDK Init")
 * @param cb1 [in] ʱĻص Call back function when triggered
 * @param p1 [in] cb1Ĳ Parameter for call back function #1
 * @param cb2 [in] 豸Ļص Call back function when unlock device
 * @param p2 [in] cb2Ĳ Parameter for call back function #2
 */
int BWSDK_Init_OEM(tamper_callback cb1, void*p1, unlock_callback cb2, void *p2);

/**
 * @brief ϵͳģĳʼ(ư汾)
 * @note Ӧóһʼһ
 * @note BWSDK_Initظ
 * @param cb1 [in] ʱĻص
 * @param p1 [in] cb1Ĳ
 * @param cb2 [in] 豸Ļص
 * @param p2 [in] cb2Ĳ
 * @param cb3 [in] Чͻ汾Ļص
 * @param p3 [in] cb3Ĳ
 */
int BWSDK_Init_Ex(tamper_callback cb1, void*p1, unlock_callback cb2, void *p2, invalid_customer_callback cb3, void*p3);

/**
 * @brief Get system platform version
 * @retval platform version (Binary code)
 * @example 0x00010901 is V1.9.1
 */
unsigned int GetMercuryPlatformVer(void);

/**
 * @brief Get the system lib version
 * @retval string of syslib version
 */
char* BWSDK_GetSysLibVersion(void);

/**
 * @brief ȡBWSDK汾ţ01.00.01
 * @brief Get BWSDK version number
 * @param maj 汾Ÿλ high part of version number
 * @param mid 汾λ middle part of version number
 * @param min 汾ŵλ low part of version number
 * @retval 汾ַͷ return value: version number string, no need to free
 */
char *BWSDK_GetVersion(unsigned char *maj, unsigned char *mid, unsigned char *min);

typedef enum {
    AUDIO_PREFER_POLICY_TTS = 0, ///< TTS first
    AUDIO_PREFER_POLICY_DTMF = 1, ///< DTMF first
} audio_prefer_policy_t;

/**
 * @brief Set audio preference policy
 * @param policy [in] refer to audio_prefer_policy_t
 */
void AudioSetPreferPolicy(audio_prefer_policy_t policy);

/**
 * @brief Set audio volume level
 * @param volume [in] volume level from 1 to 9
 * @param nvstore [in] 0-Do not store this config to NV1-Store this config to NV
 * @retval 0 Success
 * @retval <0 Fail
 */
int AudioSetVolumeOEM(unsigned int volume, unsigned int nvstore);

/**
 * @brief Get the TTS volume level stored in NV
 * @retval TTS Volume, 0-9, 0 means muted.
 */
unsigned short GetTtsVolNV(void);

/**
 * @brief Set DTMF volume
 * @param volume [in] volume from 0 to 65535
 * @param nvstore [in] 0-Do not store this config to NV, 1-Store this config to NV
 * @retval 0 Success
 * @retval <0 Fail
 */
int DtmfSetVolumeOEM(unsigned int volume, unsigned int nvstore);

/**
 * @brief Abort DTMF sound, mutex mode
 */
void AudioDtmfAbort_OEM(void);

/**
 * @brief Play DTMF sound, mutex mode
 * @param tone [in] DTMF tone, refer to MERCURY_DTMF_TONE_ID_E
 * @param time [in] time, unit: 100 millisecond)
 */
int AudioDtmfPlay_OEM(MERCURY_DTMF_TONE_ID_E tone, BYTE time_100ms);

/**
 * @brief Play DTMF sound, mutex mode
 * @param tone [in] DTMF tone, refer to MERCURY_DTMF_TONE_ID_E
 * @param time [in] time, unit: 100 millisecond)
 * @param blocked [in] 0-Not block while playing, 1-Block while playing
 */
int AudioDtmfPlay_OEM1(MERCURY_DTMF_TONE_ID_E tone, BYTE time_100ms, int blocked);

/**
 * @brief Abort TTS sound, mutex mode
 */
int TTS_Abort_OEM(void);

/**
 * @brief TTS(ⷽʽ)
 * @brief Play TTS sound, mutex mode
 * @param text [in] Ҫŵַ(text string to play)
 * @param len [in] ַĳ (length of text string to play)
 */
int TTS_PlayText_OEM(const uint8 * text,int len);

/**
 * @brief ȵTTSƵɻֱʱ
 * @brief Wait for TTS playing finish or timeout
 * @param timeout_ms [in] ȴʱ(Maximum waiting time)
 */
void WaitTtsComplete(int timeout_ms);

/**
 * @brief Wait until DTMF tone complete or timeout
 * @param timeout_ms [in] Max waiting time
 */
void WaitDtmfComplete(int timeout_ms);

//#include "bw_system_cmd.h"
#undef    LED_RED
#define LED_RED    0x80		///< 
#undef LED_YELLOW
#define LED_YELLOW 0x40		///< Ƶ
#undef LED_GREEN
#define LED_GREEN  0x20		///< ̵
#undef LED_BLUE
#define LED_BLUE   0x10		///< 

#define TAG_SP_SYSINFO_BATTVOLT     0xA1

/**
 * @brief spõĳʼ(һε)
 * @brief SP system initialize
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int SP_Sys_Init(void);


/**
 * @brief ӲԼ
 * @brief Hardware self-check
 * @param [in] checkbyte Ҫѯ豸λ ÿֻһ (Device byte want to check, can only check on device every time)
 * Mag: 0x01 - ģ Magnetic stripe card module
 *Icc : 0x02 - IC ģ IC card module
 *Picc : 0x04 - ǽӶģ PICC module
 *Flash 0x08 - FLASH 洢 Flash memory
 *KEY: 0x10 - Կ Encrypted key check
 *SMX: 0x20 - ģ Chinese standard Encrypted key module
 *ALL: 0XFF Լȫ豸 Self-check all device
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int HD_SelfCheck(unsigned char checkbyte);


/**
 * @brief 
 * @brief Parameter setup 
 * @param [in] paraTLV Ҫò parameter data
 * @param [in] paralen Ҫòݳ parameter data length
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int SysParaSet(unsigned char *paraTLV, int paralen);

/**
 * @brief SPڿ
 * @note ˽ӿڿSPUART0 (RJ9ӿ)м̹
 * @param onoff [in] 0 - رм̣1 - м
 * @retval TRUE Success
 * @retval FALSE Fail 
 */
int SpUartRJ9Ctrl(int onoff);

/**
 * @brief ݵRJ9
 * @retval TRUE Success
 * @retval FALSE Fail 
 */
int SpUartRJ9Tx(void *data, unsigned int len);

/**
 * @brief RJ9϶ȡ
 * @param data [out] data buffer read from RJ9
 * @param explen [in] expect length of read
 * @retval Count of data read
 */
int SpUartRJ9Rx(void *data, unsigned int explen);

/**
 * @brief 򵥽
 * @brief System Unlock
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int SysUnLock(void);


/**
 * @brief ò
 * @brief Setup baud rate
 * @param [in] baund ֵ baud rate
 * @retval  ʧ,1 ɹ return 1 for success, other for fail
 * @pre 
 */
int SetSpUartBaund(int baund);

/**
 * @brief  SENSOR 
 * @brief Anti-remove sensor check
 * @param [in] pBuf  input data
 * @retval <0 SPͨѶʧ, return < 0 for communicate with SP fail
 * @retval 1 ɹ return 1 for success
 * @retval  (Response Code) return other for response code
 * @pre 
 */
int SensorCheck(unsigned char *pBuf);

/** 
 * @brief ȫ 
 * @brief Active security function
 * @param outBuf [out]  Output information
 * @retval 0 - ɹ return 0 for Active success
 * @retval <0 - ͨѶʧ return <0 for communication fail
 * @retval 0x9999 - 豸δ return 0x9999 for device locked
 * @retval 0xFFFE - п· return 0xFFFE for break circuit in Anti-remove module
 * @retval 0xEEEE - 豸 return 0xEEEE for device is in triggered processing
 */
int ActSecurity(unsigned char *outBuf);

/**
 * @brief ȫ
 * @brief Active security function
 * @param [in] inBuf رָ lock specified data
 * @param [out] outBuf ؼһֽΪ, ֵΪ 4, 2  5 ֽΪ return check result, first byte is length, second to fifth is check result.
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int ActSecurityExt(unsigned char *inBuf, unsigned char *outBuf);


/**
 * @brief //ֻQPBOC L2жQǷбϹ
 * @brief Only be used in QPBOC for L2 to check the Q processing whether has been interrupted or not
 * @retval 0 ûд,other д return 0 for NOT been interrupted, 1 for has been interrupted
 * @pre 
 */
int SysGetCurrentDev(void);


/**
 * @brief ȡsp汾
 * @brief Get SP version
 * @param [out] spversion صİ汾Ϣ Returned SP version information
 * @retval >0 汾Ч, <=0 ȡʧ return >0: valid version length; return <= 0: get version fail
 * @pre 
 */
int GetSpVersion(unsigned char *spversion);


/**
 * @brief ָ
 * @brief Exchange command
 * @param [in] cmdType spָ sp command type
 * @param [in] apduS Ҫ͵ data need to be sent
 * @param [in] apduSLen Ҫ͵ݳ length of data need to be sent
 * @param [out] adpuR ܽ Encrypt result
 * @retval >0Ч, <=0ȡʧ return >0: valid feed back data length; return <=0: get feed back fail
 * @pre 
 */
int ExchangeApudCmd(unsigned char cmdType, unsigned char *apduS, int apduSLen, unsigned char *adpuR);

/**
 * @brief Get external keypad firmware version
 * @retval NULL Fail
 * @retval !NULL Version string
 */
char* GetExtKpdFwVersion(void);

/**
 * @brief ȡspϵͳ
 * @brief Get SP system data
 * @param [out] timebuf ȡ get returned data
 * @retval >0Ч, <=0ȡʧ return >0: valid feed back data length; return <=0: get feed back fail
 * @pre 
 */
int SpTimeGet(unsigned char *timebuf);


/**
 * @brief spϵͳʱ(eg:180201151232)
 * @brief Setup SP system time
 * @param [in] timebuf Ҫõspʱ time want to set to
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int SpTimeSet(unsigned char *timebuf);

/**
 * @brief led(eg:180201151232)
 * @brief Turn on LED
 * @param [in] led LED LED_RED|LED_YELLOW|LED_GREEN|LED_BLUE (LED code)
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int SysCmd_LedOn(int led);

/**
 * @brief رled()
 * @brief Turn off LED
 * @param [in] led LED LED_RED|LED_YELLOW|LED_GREEN|LED_BLUE (LED code)
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int SysCmd_LedOff(int led);

/**
 * @brief led˸
 * @brief LED blinking
 * @param [in] led LED LED_RED|LED_YELLOW|LED_GREEN|LED_BLUE (LED code)
 * @param [in] onTimes onʱ (Power ON time)
 * @param [in] offTimes offʱ (Power OFF time)
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int SysCmd_LedFlash(int led, int onTimes, int offTimes);

/**
 * @brief رշ
 * @brief Turn off beeper
 * @param  no parameter
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int SysCmd_BeepOff(void);

/**
 * @brief 
 * @brief Turn on beeper
 * @param [in] freq Ƶ beeper frequency
 * @param [in] time_ms ʱ beeper power on time
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int SysCmd_BeepOn(int freq,int time_ms);

/**
 * @brief ȡSPϵͳϢ
 * @param [in]  ucInfoTag  ҪȡϢTAG
 * @param [out] pacSysInfo ȡϢ
 * @retval 0ʧܣ 1 ɹ
 * @pre 
 */
int GetSpSystemInformation(unsigned char ucInfoTag, unsigned char *pacSysInfo);

/**
 * @brief ĴϢ
 * @brief Clean up saved error information
 * @retval  on return value
 * @pre 
 */
void ClrLastErrno(void);


/**
 * @brief ֵ
 * @brief Save error value
 * @param [in] myerrno ֵ(error value)
 * @retval  no return value
 * @pre 
 */
void SetLastErrno(int myerrno);


/**
 * @brief ȡϢ
 * @brief Get error information
 * @retval ֵ return error information
 * @pre 
 */
int GetLastErrno(void);
/** @} */
/**
 * @defgroup sn sn
 * @brief snؽӿ
 * @brief SN operation related interface
 * @{
 */
//=============================================================
//#include "bwsn.h"
//=============================================================

#define SN_SIZE_MAX  (64)   ///< SN󳤶

/**
 * @brief ȡAPģΨһID
 * @brief Get the unique ID of AP module
 * AC35ģΨһID: MercuryID(Unique ID in AC35 module: Mercury ID)
 * @param snData [out] к, СС19ֽ Serial number data, buffer size no less than 19 bytes
 * @param len [in] кݳ length of serial number data
 * @retval 0 ɹ return 0 for success
 * @retval -1 ʧ return -1 for fail
 */
int GetAPSN(unsigned char *snData, unsigned int len);

/**
 * @brief ȡɵPCB-SN
 * @brief Get old PCB-SN number
 * @param snData [out] к Serial number data
 * @param len [in] кݳ length of serial number data
 * @retval 0 ɹ return 0 for success
 * @retval -1 ʧ return -1 for fail
 */
int GetPSN_Prev(unsigned char *snData, unsigned int len);

/**
 * @brief ȡPCB-SN
 * @brief Get new PCB-SB number
 * @param snData [out] к Serial number data
 * @param len [in] кݳ length of serial number data
 * @retval 0 ɹ return 0 for success
 * @retval -1 ʧ return -1 for fail
 */
int GetPSN(unsigned char *snData, unsigned int len);

/**
 * @brief ȡɵSN
 * @brief Get old Device SN number
 * @param snData [out] к Serial number data
 * @param len [in] кݳ length of serial number data
 * @retval 0 ɹ return 0 for success
 * @retval -1 ʧ return -1 for fail
 */
int GetDSN_Prev(unsigned char *snData, unsigned int len);

/**
 * @brief ȡSN(=TUSN)
 * @brief Get device SN number
 * @param snData [out] к Serial number data
 * @param len [in] кݳ length of serial number data
 * @retval 0 ɹ return 0 for success
 * @retval -1 ʧ return -1 for fail
 */
int GetDSN(unsigned char *snData, unsigned int len);

/**
 * @brief ȡɵKSN
 * @brief Get old device KSN number
 * @param snData [out] к Serial number data
 * @param len [in] кݳ length of serial number data
 * @retval 0 ɹ return 0 for success
 * @retval -1 ʧ return -1 for fail
 */
int GetKSN_Prev(unsigned char *snData, unsigned int len);

/**
 * @brief ȡͻSN(=DSN2)
 * @brief Get customer SN number
 * @param snData [out] к Serial number data
 * @param len [in] кݳ length of serial number data
 * @retval 0 ɹ return 0 for success
 * @retval -1 ʧ return -1 for fail
 */
int GetKSN(unsigned char *snData, unsigned int len);

/**
 * @brief дPSN (PCB-SN)
 * @brief Write in PSB
 * @param snData [in] к Serial number data
 * @param len [in] кݳ length of serial number data
 * @retval 0 ɹ return 0 for success
 * @retval -1 ʧ return -1 for fail
 */
int WritePSN(unsigned char *snData, unsigned int len);

/**
 * @brief дDSN (TUSN)
 * @brief Write in DSN(TUSN)
 * @param snData [in] к Serial number Data
 * @param len [in] кݳ length of serial number data
 * @retval 0 ɹ return 0 for success
 * @retval -1 ʧ return -1 for fail
 */
int WriteDSN(unsigned char *snData, unsigned int len);

/**
 * @brief дKSN (=DSN2)
 * @brief Write in KSN(=DSN2)
 * @param snData [in] к Serial number data
 * @param len [in] кݳ length of serial number data
 * @retval 0 ɹ return 0 for success
 * @retval -1 ʧ return -1 for fail
 */
int WriteKSN(unsigned char *snData, unsigned int len);

/**
 * @brief ȡNVд洢ķģʽ״̬
 * @brief Get flight mode status stored in NV
 * @retval 0 OnlineMode 
 * @retval 1 FlightMode
 */
int GetFlightModeNV(void);

/**
 * @brief NVд洢ķģʽ״̬
 * @brief Setup flight mode status stored in NV
 * @param mode [in] 0 OnlineMode
 * @param mode [in] 1 FlightMode
 * @retval 1 FlightMode
 */
void SetFlightModeNV(int mode);

/**
 * @brief ȡNVд洢Ļ
 * @brief Get screen brightness stored in NV
 * @retval ϵͳĻ return system screen brightness
 */
unsigned short GetLcdBacklightNV(void);

/**
 * @brief NVд洢Ļ
 * @brief Setup screen brightness stored in NV
 * @param level [in] Ļ screen background brightness
 */
void SetLcdBacklightNV(unsigned short level);

/**
 * @brief NVд洢Ŀͻ
 * @brief Setup customer name stored in NV
 * @param name [in] ͻó64ַ customer name, no more than 64 bytes
 * @param len [in] nameַ('\0') length of name, '\0' not included
 */
//void SetCustomerName(char *name, int len);

/**
 * @brief ȡNVд洢Ŀͻ
 * @brief Get customer name stored in NV
 * @param name [out] ͻᳬ64ַûд򷵻صַΪ0. customer name, no more than 64 bytes
 * @param len [in] nameߴ磬λ: ֽ maximum length of name, unit: byte
 */
void GetCustomerName(char *name, int len);

/**
 * @brief NVд洢ӿͻ
 * @brief Setup sub-customer name stored in NV
 * @param name [in] ӿͻó64ַ sub-customer name, no more than 64 bytes
 * @param len [in] nameַ('\0') length of name, '\0' not included
 */
//void SetSubCustomerName(char *name, int len);

/**
 * @brief ȡNVд洢ӿͻ
 * @brief Get sub-customer name stored in NV
 * @param name [out] ͻᳬ64ַûд򷵻صַΪ0. customer name, no more than 64 bytes. If not written before, will return 0
 * @param len [in] nameߴ磬λ: ֽ maximum length fo name, unit: byte
 */
void GetSubCustomerName(char *name, int len);

typedef struct {
    unsigned char hw_version[32];   ///< Ӳ汾
    unsigned char is_spt_gprs;      ///< GPRS
    unsigned char is_spt_wifi;      ///< WIFI
    unsigned char is_spt_bt;        ///< 
    unsigned char is_spt_printer;   ///< ӡ
    unsigned char is_spt_gm;        ///< 
    unsigned char is_spt_nfc;       ///< ǽ
    unsigned char is_spt_hid;       ///< HID
    unsigned char is_spt_rs232;     ///< RS232
    unsigned char is_spt_sensor_kb; ///< sensor
    unsigned char is_spt_k_type_pa; ///< K๦
    unsigned char is_spt_no_sp;///< ްȫоƬ
    unsigned char is_spt_no_psam; ///< PSAM
} tsDeviceHwInfo;

/**
 * @brief ȡӲϢ
 * @param deviceInfo [out] ӲϢ
 * @return 0 -- ɹʧ
 */
int GetDeviceHwInfo(tsDeviceHwInfo* hwInfo);

/** @} */
/**
 * @defgroup usb_at usb_at
 * @brief usbڲؽӿ
 * @brief USB serial port operation related interface
 * @{
 */
//=============================================================
//#include "bwusbat.h"
//=============================================================
/**
 * @brief USBATʼ
 * @brief USBAT command initialize
 */
void USBAT_Init(void);

/**
 * @brief USBATȥʼ
 * @brief USBAT command deinitialize
 */
void USBAT_Deinit(void);

/**
 * @brief ݵUSBATӿ
 * @brief Send data to USBAT port
 * @param buff [in] Ҫ͵ data to send
 * @param len [in] Ҫ͵ݳ length of data to send
 */
void USBATSend(BYTE *buff, UINT len);

/**
 * @brief USBATӿڻȡ
 * @brief Get data from USBAT port
 * @param buff [in] ջ data receiving buffer
 * @param len [in] Ҫյֽ maximum length of receiving
 * @param timeout_ms [in] ʱʱ䣬λ: time out in ms
 */
INT USBATGet(BYTE *buff, UINT len, ULONG timeout_ms);

//=============================================================
//#include "bwqcmd.h"
//=============================================================
#define CMD_ERROR_STX_INEXISTENCE (-1) 	///< ͷ
#define CMD_ERROR_BUFFER_OVERFLOW (-2)	///< 
#define CMD_ERROR_TIMEOUT         (-3)	///< ʱ

/** @brief ֵ֧˿ **/
/** @brief Supported output port **/
typedef enum {
    PORT_USBAT = 0UL,  ///< AT AT port
    PORT_UNKNOWN       ///< δ֪ Unknow port
} hw_port_type;

/**
 * @brief ʼ
 * @brief Initialize
 */
void QCMD_Init(hw_port_type port);

/**
 * @brief ȥʼ
 * @brief Deinitialize
 */
void QCMD_Deinit(void);

/**
 * @brief Ӷ˿ڻȡ
 * @brief Get data from port
 */
INT QCMD_Get(BYTE *buff, UINT len, ULONG timeout);

/**
 * @brief Ӷ˿ڷ
 * @brief Send data from port
 */
void QCMD_Send(void *buff, unsigned int len);

/**
 * @brief ȡ
 * @brief Get command
 */
INT QCMD_GetCmdData(BYTE *buff, UINT maxbufsize);

/**
 * @brief ȡ־
 * @brief Get flag size
 */
ULONG QCMD_GetCfgFlagSize(void);

/**
 * @brief 豸
 * @brief Check is the device configuration command or not
 * @return < 0 - 豸 return 0 for not a device configuration command
 */
INT QCMD_IsCfgFlag(char *code, ULONG code_len);

/**
 * @brief ȡ豸Ϣ
 * @bried Get Device configuration information
 * @return < 0 - ǻȡ豸Ϣ return 0 for command is nor for get device configuration information
 */
int QCMD_CmdToGetCfg(char *code, ULONG code_len, char *cfg_info, ULONG *cfg_info_len);


/**
 * @brief SN
 * @brief Setup SN number
 * @return < 0 - SN return <0 for not the command for setup SN number
 */
INT QCMD_CmdToSetSN(char *code, ULONG code_len);

/**
 * @brief SDM Service start
 * @param port [in] serial port
 * @retval 0 Success
 * @retval <0 Fail
 */
int sdm_start(port_dev_t port);

/**
 * @brief SDM Service stop
 * @param port [in] serial port
 * @retval 0 Success
 * @retval <0 Fail
 */
int sdm_stop(port_dev_t port);

/**
 * @brief Check if the SDM is running
 * @param port [in] serial port
 * @retval 1 Running
 * @retval 0 Not running
 */
int sdm_isrunning(port_dev_t port);
/** @} */

/**
 * @defgroup pinpad pinpad
 * @brief ̲ؽӿ
 * @brief Pinpad operation related interface
 * @{
 */
//=============================================================
//#include "bw_ped.h"
//=============================================================

/*************Կϵ****************/
/**********Password System************/
// TLK (Loading Key)
#ifdef PED_TLK
#undef PED_TLK
#endif
#define PED_TLK 0x01 	 ///< Կ Transmitting Key

//TMK (master key)
#ifdef PED_TMK
#undef PED_TMK
#endif
#define PED_TMK 0x02	 ///< Կ Main Key

// tpk PIN Key
#ifdef PED_TPK
#undef PED_TPK
#endif
#define PED_TPK 0x03	 ///< pinԿ Pin Encrypt Key

// tak MAC Key
#ifdef PED_TAK
#undef PED_TAK
#endif
#define PED_TAK 0x04	///< macԿ Mac Encrypt Key

// tdk DES Key ()
#ifdef PED_TDK
#undef PED_TDK
#endif
#define PED_TDK 0x05	///< ŵԿ Magnetic stripe Encrypt Key

// tek DES Key ()
#ifdef PED_TEK
#undef PED_TEK
#endif
#define PED_TEK 0x06	///< DESԿ DES Encrypt Key

// ttk Dukpt Key
#ifdef PED_TTK
#undef PED_TTK
#endif
#define PED_TTK 0x09	///< dukptԿ dukpt Encrypt Key


/*************дԿ㷨ʶ****************/
#ifdef PED_TDES
#undef PED_TDES
#endif
#define PED_TDES 0x00  ///< 3des

#ifdef PED_AES
#undef PED_AES
#endif
#define PED_AES 0x10  ///< AES

#ifdef PED_SM4
#undef PED_SM4
#endif
#define PED_SM4 0x20 ///< sm4

/*************ӽģʽ****************/

// ecb 
#ifdef PED_ECB_DEC
#undef PED_ECB_DEC
#endif
#define PED_ECB_DEC 0x00	///< ECB ECB Decrypt


// ecb 
#ifdef PED_ECB_ENC
#undef PED_ECB_ENC
#endif
#define PED_ECB_ENC 0x01	///< ECB ECB Encrypt


// cbc 
#ifdef PED_CBC_DEC
#undef PED_CBC_DEC
#endif
#define PED_CBC_DEC 0x02	///< CBC CBC Decrypt



// cbc 
#ifdef PED_CBC_ENC
#undef PED_CBC_ENC
#endif
#define PED_CBC_ENC 0x03	///< CBC CBC Encrypt

// ecb (ǿƵ DES)
#ifdef PED_ECB_SINGLE_DEC
#undef PED_ECB_SINGLE_DEC
#endif
#define PED_ECB_SINGLE_DEC 0x10	///< ECB,ǿƵDES. ECB Decrypt, force to single DES

// ecb (ǿƵ DES)
#ifdef PED_ECB_SINGLE_ENC
#undef PED_ECB_SINGLE_ENC
#endif
#define PED_ECB_SINGLE_ENC 0x11	///< ECB,ǿƵDES. ECB Encrypt, force to single DES

// cbc (ǿƵ DES)
#ifdef PED_CBC_SINGLE_DEC
#undef PED_CBC_SINGLE_DEC
#endif
#define PED_CBC_SINGLE_DEC 0x12	///< CBC,ǿƵDES. CBC Decrypt, force to single DES

// cbc (ǿƵ DES)
#ifdef PED_CBC_SINGLE_ENC
#undef PED_CBC_SINGLE_ENC
#endif
#define PED_CBC_SINGLE_ENC 0x13	///< CBC,ǿƵDES. CBC Encrypt, force to single DES

typedef enum {
    KEY_ARCH_MKSK = 0x01,
    KEY_ARCH_DUKPT = 0x02,
} Key_Arch_Type;

typedef enum {
    PIN_EVENT_NONE = 0x0,
    PIN_EVENT_LEN,
    PIN_EVENT_PINBLOCK,
    PIN_EVENT_PINFREE,
    PIN_EVENT_INVALID,
    PIN_EVENT_EXIT,
    PIN_EVENT_ERR,
} Pin_Block_Event;

typedef struct {
    uchar ucPinLen;     // ¼ΪPIN_EVENT_LENʱָʾǰpin
    uchar ucPinBlkLen;  // ¼ΪPIN_EVENT_PINBLOCKPIN_EVENT_PINFREEʱָʾpinblock 
    uchar ucKsnLen;     // ¼ΪPIN_EVENT_PINBLOCKPIN_EVENT_PINFREEʹDUKPTʱָʾpinblock 
    int iErrCode;       // ¼ΪPIN_EVENT_ERRʱָʾԭ
    uchar aucPinBlock[32]; // ¼ΪPIN_EVENT_PINBLOCKPIN_EVENT_PINFREEʱ PINBLOCKĳ
    uchar aucKsn[10];      // ¼ΪPIN_EVENT_PINBLOCKPIN_EVENT_PINFREEʹDUKPTʱKSNĳ
} Pin_Block_Data;

typedef struct {
    uchar KeyArch;  // Key_Arch_Type
    uchar KeyIdx;
    uchar Mode;
    uchar PanLen;
    uchar TradeInfoLen;
    uchar ListLen;
    ulong TimeoutMs;
    uchar Pan[20];      // Уλ
    uchar TradeInfo[8];
    uchar ExpPinLenList[8];
} Pin_Block_Material_Type;

// ͺʱ
typedef void (*PinBlockEventCB)(Pin_Block_Event , Pin_Block_Data *);

/**
 * @brief Կ
 * @brief Key type
 * @author wl
 */
typedef struct {
    uchar ucSrcKeyType; ///< Կ, PED_TLK,PED_TMK,PED_TPK,PED_TAK,PED_TDK, õucDstKeyTypeڵԿ
						///parent key type: PED_TLK,PED_TMK,PED_TPK,PED_TAK,PED_TDK. Security level no less than ucDstKeyType
    uchar ucDstKeyType; ///< ĿԿԿ, PED_TLK,PED_TMK,PED_TPK,PED_TAK,PED_TDK  
						///target key type: PED_TLK,PED_TMK,PED_TPK,PED_TAK,PED_TDK  
    uchar ucSrcKeyIdx; ///< Կ,һ1ʼ, ñΪ0,ʾԿдʽ 
					   ///parent key index, normally start from 1, if veriable is 0, means the key was written in clear text
    uchar ucDstKeyIdx; ///< ĿԿ 
					   ///target key index
    uchar ucDstKeyLen; ///< ĿԿ,8,16,24,32 
					   ///target key length: 8, 16, 24, 32
    uchar Algorithm; ///< 㷨־ PED_TDEA PED_AES PED_SM4  
					 ///Algorithm: PED_TDEA PED_AES PED_SM4  
    uchar RFU[10]; ///<  Reserved object
    uchar ucDstKeyValue[32]; ///< дԿ Data written in key
} ST_KEY_INFO;

/**
 * @brief Уֵ
 * @brief Check Mode
 * @author wl
 */
typedef struct {
    int iCheckMode;    ///< Уģʽ 0x00 - У \No check mode
    ///0x01 - ʹ Key ȫ 0  3DES 	\3DES encrypt mode, using key with all 0.
    /// ǰ 4 ֽڼΪ KCV	\ Result: first 4 letters are KCV.
    ///0x02 - ԿУ飬Ȼģʽ 1 	\ Odd parity check then check in Mode 1
    ///У	\
    ///0x03 - ԿżУ飬Ȼģʽ 1 	\ Even parity check then check in Mode 1
    ///У	\
    ///0x04 - ģʽ K21 ƽ̨֧	\ ICBC mode, can only supported by K21 platform.
    ///֣ ԴԿУݣĿ	\ Using origin key to check the sum of standard key and
    ///Կ+  8	\ ICBC index. If the length is not the integral multiple of 8,
    ///ֽڱ㵽 8 ֽڱ	\ fill up tp integral multiple of 8 and do x9.19 Mac calculation.
    /// x9.19  mac 	\
    ///0x05 - CMAC ģʽ MAX32555 ֧֣	\ CMAC mode, can only supported by MAX32555
    ///0x80 - TR-31 ģʽ*/ TR-31 Mode

    int iDataLen; ///<Уݳ ݵĳm. Length of data to be checked, 
    uchar szCheckBuf[128];	///<kcvУݻ. Buffer for KCV check
} ST_KCV_INFO;

/**
 * @brief rsaԿ(ʹ)
 * @brief rsa key type(usage)
 * @author wl
 */
typedef struct {
    unsigned int modlen; ///<PINܹԿģ  length of Pin encrypt public key modulus
    unsigned char mod[256]; ///<ģ modulus
    unsigned int explen; ///<PINܹԿָ  length of Pin encrypt public key exponent
    unsigned char exp[4]; ///<PINܹԿָ Pin encrypt public key exponent
    unsigned char iccrandomlen; ///<ӿȡõ length of random number get from ICC
    unsigned char iccrandom[8]; ///<ӿȡõ random number get from ICC
} RSA_PINKEY;

/**
 * @brief rsaԿ(д)
 * @brief rsa key type(write)
 * @author wl
 */
typedef struct {
	int iModulusLen; ///< ģλȣλ: Byte. Length of modulus, unit: byte
	uchar aucModulus[512]; ///< ģ,ģС512ֽʱ,洢,˱ʾModulus, when length of modulus less than 512 bytes, stored from left.
	int iExponentLen; ///< ָλȣλ: Byte. Length of Exponent, unit: byte
	uchar aucExponent[512];///< ָ,С512ֽʱ,,洢,˱ʾExponent, when less than 512 bytes, stored from left
	uchar aucKeyInfo[128]; ///< ԿϢ,ӦԶ塣Key information, setup by appliction
} ST_RSA_KEY;


/**
 * @brief rsaԿʱԿָģʽ
 * @brief public key exponential mode when rsa key generate
 * @author wl
 */
typedef enum{
	RSA_PUBLIC_EXP_MODE_01=0,///< ָΪ01 exponential length 01
	RSA_PUBLIC_EXP_MODE_03 ,///< ָΪ03 exponential length 03
}RSA_PUBLIC_EXP_MODE;


/**
 * @brief rsaԿ()
 * @brief rsa key type(generation)
 * @author wl
 */
typedef struct {
	int bits;///< Կλ key length in byte
	int modulusLen; ///< ģλȣλ: Byte Modulus length, unit: byte
	uchar modulus[512]; ///< ģ,ģС512ֽʱ,洢,˱ʾModulus, when length is less than 512 bytes, stored from left
	int pubExpLen; ///< Կָλ(1/3)λ: Byte. Public key exponent length, unit: byte
	uchar pubExp[3];///< Կָ,С512ֽʱ,,洢,˱ʾ Public key exponent length, when length is less than 512 bytes, stored from left
	int priExpLen; ///< ˽Կָλȣλ: Byte. Private key exponent length, unit: byte
	uchar priExp[512];///< ˽Կָ,С512ֽʱ,,洢,˱ʾPrivate key exponent, when length is less than 512 bytes, stored from left
} ST_GEN_RSA_KEY;// ɹԿ Data type of generated public key

/**
 * @brief Write in Key
 * @param KeyInfoIn [in] Key structure.
 * @param KcvInfoIn [in] KCV structure.
 * @retval 0 Fail
 * @retval 1 Success
 */
int PedWriteKeyEx(ST_KEY_INFO * KeyInfoIn, ST_KCV_INFO * KcvInfoIn, unsigned int timeout_ms);

/**
 * @brief Կע
 * @brief Write in Key
 * @param [in] KeyInfoIn дԿĽṹ structure in key
 * @param [in] KcvInfoIn дkcvṹ write in KCV structure
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedWriteKey(ST_KEY_INFO *KeyInfoIn, ST_KCV_INFO *KcvInfoIn);

/**
 * @brief DUKPT ע TIK
 * @brief DUKPT write in TIK
 * @param [in] GroupIdx DUKPT Կ,Χ [1,10]. Key group index number, from 1 to 10
 * @param [in] SrcKeyIdx TLK  TIK index number
 * @param [in] KeyLen TIK ĳ TIK length
 * @param [in] KeyValueIn TIK  Key value in TIK
 * @param [in] KsnIn ʼksn Initialize KSN
 * @param [in] KcvInfoIn Уֵṹ Check value structure
 * @retval >0=ݳ,<0=ʧϢ return > 0: call back data length; return < 0: fail information
 * @pre 
 */
int PedWriteTIK(uchar GroupIdx, uchar SrcKeyIdx, uchar KeyLen,
                uchar *KeyValueIn, uchar *KsnIn, ST_KCV_INFO *KcvInfoIn);

/**
 * @brief ȡ PINBLOCK 
 * @param [in] pstMaterial PINBLOCK ز
 * @param [in] callback    PIN¼ص
 * @param [in] pData       PIN¼ݽṹָ
 * @retval 0 ʧ,1 ɹ
 * @pre 
 */
int PedGetPinBlock(Pin_Block_Material_Type *pstMaterial, PinBlockEventCB callback, void *pData);

/**
 * ʱò temporary not useful
 * @brief ȡ PINBLOCK (tpktʽ)
 * @brief Get PINBLOCK Key(tpkt method)
 * @param [in] KeyIdx TPK  TPK key index
 * @param [in] ExpPinLenIn PINʼ볤 Initialize the length of input
 * @param [in] DataInLen   
 * @param [in] DataIn öû볤 enumerate the length of user typed in
 * @param [in] Mode  ģʽ Mode
 * @param [in] TimeoutMs  ʱʱ timeout time in ms
 * @param [out] keys  ؽ return result
 * @retval >0ݳ,<0=ʧϢ return >0 :return data length; return < 0: error information
 * @pre 
 */
int PedGetOnlinePinBlockInitTP(uchar KeyIdx, uchar *ExpPinLenIn,
                               uchar DataInLen, uchar *DataIn, uchar Mode, unsigned long TimeoutMs,
                               uchar *keys);

/**
 * ʱò temporary not useful
 * @brief ѻpin֤
 * @brief Offline clear text pin check
 * @param [in] IccSlot ۱ Icc slot
 * @param [in] ExpPinLenIn PINʼ볤 Length of pin that allowed to input when initialize
 * @param [in] IccRespOut  ʱûõ temporary not useful
 * @param [in] Mode  ģʽ Mode
 * @param [in] TimeoutMs  ʱʱ timeout time in ms
 * @param [out] keys  ؽ return result
 * @retval >0ݳ,<0=ʧϢ return > 0: return data length; return < 0: error information
 * @pre 
 */
int PedVerifyPlainPin_TP(uchar IccSlot, uchar *ExpPinLenIn, uchar *IccRespOut,
                         uchar Mode, ulong TimeoutMs, uchar *keys);

/**
 * ʱò temporary not useful
 * @brief ѻpin֤
 * @brief Offline Encrypted text pin check
 * @param [in] IccSlot ۱ Icc slot
 * @param [in] ExpPinLenIn PINʼ볤 Length of pin that allowed to input when initialize
 * @param [in] RsaPinKeyIn ܵĹԿϢ Encrypted public key information
 * @param [in] IccRespOut   ʱû temporary not useful
 * @param [in] Mode  ģʽ Mode
 * @param [in] TimeoutMs  ʱʱ timeout time in ms
 * @param [out] keys  ؽ return result
 * @retval >0ݳ,<0=ʧϢ return > 0: return data length; return <= 0: error information
 * @pre 
 */
int PedVerifyCipherPin_TP(uchar IccSlot, uchar *ExpPinLenIn,
                          RSA_PINKEY *RsaPinKeyIn, uchar *IccRespOut, uchar Mode, ulong TimeoutMs,
                          uchar *keys);


/**
 * @brief ȡʹ PSAM ܵ PINBLOCK
 * @brief Get PSAM encrypted PINBLOCK
 * @param [in] ExpPinLen  
 * @param [in] ExpPinLenIn PINʼ볤 Length of pin that allowed to input when initialize
 * @param [in] cardDataInLen λɵ 16 λʺų length of main account number after card number shift
 * @param [in] cardDataIn   λɵ 16 λʺ main account number after card number shift
 * @param [in] pinBlockFmt  ʽ PINBLOCK format
 * @param [in] apduInLen  apduָ length of apdu command length
 * @param [in] apduIn   apduָ apdu command
 * @param [in] Mode  ģʽ Mode
 * @param [in] TimeoutMs  ʱʱ timeout time in ms
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedGetPsamPinBlock(uchar ExpPinLen, uchar *ExpPinLenIn, uchar cardDataInLen,
                       uchar *cardDataIn, uchar *pinBlockFmt, uchar apduInLen,
                       uchar *apduIn, uchar Mode, ulong TimeoutMs);


/**
 * @brief  MAC
 * @brief MAC calculation
 * @param [in] KeyIdx TAK (MAC Key)  Index for KeyIdx TAK(MAC Key)
 * @param [in] DataIn Ҫ Data need to calculate
 * @param [in] DataInLen Ҫݳ Length of data need to calculate
 * @param [out] MacOut ؼĽ(16byte) Returned calculate result(Array buffer larger than 16 bytes)
 * @param [in] Mode ģʽ 00H -ANSI9.9,01H - XOR-ECB-MAC,02H - X9.19 (Calculation Mode)
 * @retval >0=ݳ,<0=ʧϢ return > 0: length of returned information; return <0: error information
 * @pre 
 */
int PedGetMac(uchar KeyIdx, uchar *DataIn, ushort DataInLen, uchar *MacOut,
              uchar Mode);


/**
 * @brief ݼӽ 
 * @brief Data Encrypt and Decrypt calculation
 * @param [in] KeyIdx TDK TDK index
 * @param [in] DataInLen ݳ Data length
 * @param [in] DataIn  Data input
 * @param [in] Mode ӽܵķʽ Encrypt Mode
 * @param [out] DataOut ؽ Data output
 * @retval >0=ݳ,<0=ʧϢ return > 0: length of returned data; return <0: error information
 * @pre 
 */
int PedCalcDES(uchar KeyIdx, ushort DataInLen, uchar *DataIn, uchar *DataOut,
               uchar Mode);


/**
 * @brief DES
 * @brief Calculate DES
 * @param key [in] DES/TDES key
 * @param keylen [in] Length of key in Bytes 8/16/24
 * @param dataIn [in] input data to calc
 * @param inLen [in] length of input data, hava to mutiple of 8
 * @param dataOut [out] output data after calc
 * @param outBuffSize [in] Max size of dataOut
 * @param mode [in] 0 - ECB, 1 - CBC;
 * @param encrypt [in] 0 - Decrypt, 1 - Encrypt
 */
int CalcDes(unsigned char *key, 
            unsigned char keylen, 
            unsigned char *dataIn, 
            unsigned char inLen, 
            unsigned char *dataOut, 
            int outBuffSize, 
            unsigned char mode,
            unsigned char encrypt);

/**
 * @brief Calculate AES
 * @param key [in] AES key
 * @param keylen [in] Length of key in Bytes 16/24/32
 * @param dataIn [in] input data to calc
 * @param inLen [in] length of input data, hava to mutiple of 16
 * @param dataOut [out] output data after calc
 * @param outBuffSize [in] Max size of dataOut
 * @param mode [in] 0 - ECB, 1 - CBC;
 * @param encrypt [in] 0 - Decrypt, 1 - Encrypt
 */
int CalcAes(unsigned char *key, 
            unsigned char keylen, 
            unsigned char *dataIn, 
            unsigned char inLen, 
            unsigned char *dataOut, 
            int outBuffSize, 
            unsigned char mode,
            unsigned char encrypt);

/**
 * ʱò temporary not useful
 * @brief ȡ PINBLOCK(Dukptʽ)
 * @brief Get PINBLOCK(Dukpt method)
 * @param [in] GroupIdx 	Dukpt Dukpt group index
 * @param [in] ExpPinLenIn PINʼ볤 Length of pin that allowed to input when initialize
 * @param [in] DataInLen ݳ Data length
 * @param [in] DataIn    Data input
 * @param [out] KsnOut  ks.n KSN output
 * @param [out] PinBlockOut   PINBLOCK. PINBLOCK output
 * @param [in] Mode  ģʽ Mode
 * @param [in] TimeoutMs  ʱʱ timeout time in ms
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedGetPinDukpt(uchar GroupIdx, uchar *ExpPinLenIn, uchar DataInLen,
                   uchar *DataIn, uchar *KsnOut, uchar *PinBlockOut, uchar Mode,
                   ulong TimeoutMs);


/**
 * ʱò temporary not useful
 * @brief ȡ PINBLOCK(Dukptʽ)
 * @brief Get PINBLOCK(Dukpt method)
 * @param [in] GroupIdx 	Dukpt Dukpt groud index
 * @param [in] ExpPinLenIn PINʼ볤 Length of pin that allowed to input when initialize
 * @param [in] DataInLen ݳ Data length
 * @param [in] DataIn    Data input
 * @param [out] KsnOut  ksn. KSN output
 * @param [out] PinBlockOut   PINBLOCK. PINBLOCK output
 * @param [in] Mode  ģʽ Mode
 * @param [in] TimeoutMs  ʱʱ timeout time in ms
 * @param [out] keys
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedGetPinDukptTP(uchar GroupIdx, uchar *ExpPinLenIn, uchar DataInLen,
                     uchar *DataIn, uchar *KsnOut, uchar *PinBlockOut, uchar Mode,
                     ulong TimeoutMs, uchar *keys);


/**
 * @brief  MAC(Dukptʽ)
 * @brief Calculate MAC(Dukpt method)
 * @param [in] GroupIdx Dukpt Dukpt group index
 * @param [in] DataIn Ҫ Data input
 * @param [in] DataInLen Ҫݳ Length of data input
 * @param [out] MacOut ؼĽ Calculated MAC output
 * @param [out] KsnOut ؼksn Calculated KSN output
 * @param [in] Mode ģʽ Calculate Mode
 * @retval >0=ݳ,<0=ʧϢ return > 0: length of returned data; return <0: error information
 * @pre 
 */
int PedGetMacDukpt(uchar GroupIdx, uchar *DataIn, ushort DataInLen,
                   uchar *MacOut, uchar *KsnOut, uchar Mode);


/**
 * ʱò temporary not useful
 * @brief ѻpin֤
 * @brief Offline clear text pin check
 * @param [in] IccSlot ۱ Icc slot
 * @param [in] ExpPinLenIn PINʼ볤 Length of pin that allowed to input when initialize
 * @param [in] IccRespOut  ʱûõ temporary not useful
 * @param [in] Mode  ģʽ Mode
 * @param [in] TimeoutMs  ʱʱ timeout time in ms
 * @retval >0ݳ,<0=ʧϢ return value >0: returned data length; return <0: error information
 * @pre 
 */
int PedVerifyPlainPin(uchar IccSlot, uchar *ExpPinLenIn, uchar *IccRespOut,
                      uchar Mode, ulong TimeoutMs);


/**
 * ʱò temporary not useful
 * @brief ѻpin֤
 * @brief Offline Encrypted text pin check
 * @param [in] IccSlot ۱ Icc slot
 * @param [in] ExpPinLenIn PINʼ볤 Length of pin that allowed to input when initialize
 * @param [in] RsaPinKeyIn ܵĹԿϢ Encrypted public key information
 * @param [in] IccRespOut   ʱû temporary not useful
 * @param [in] Mode  ģʽ Mode
 * @param [in] TimeoutMs  ʱʱ timeout time in ms
 * @retval >0ݳ,<0=ʧϢ return value >0: returned data length; return <0: error information
 * @pre 
 */
int PedVerifyCipherPin(uchar IccSlot, uchar *ExpPinLenIn,
                       RSA_PINKEY *RsaPinKeyIn, uchar *IccRespOut, uchar Mode,
                       ulong TimeoutMs);


/**
 * @brief ȡԿ KCV
 * @brief Get Key's KCV
 * @param [in] KeyType Կ key type
 * @param [in] KeyIdx Կ key index
 * @param [out] KcvInfo ģʽṹ 00H - ׼ KCV 㷨Կȫ 0  ECB ܣ,֧. Calculation mode structure: 00H-Standard KCV calculation method. (key will all 0s and do ECB Encrypt)
 * @param [out] KcvOut  KCV output
 * @retval >0=ݳ,<0=ʧϢ return value >0: returned data length; return <0: error information
 * @pre 
 */
int PedGetKcv(uchar KeyType, uchar KeyIdx, ST_KCV_INFO *KcvInfo, uchar *KcvOut);


/**
 * @brief Կ(Կ)
 * @brief Key configuration setup(add key constituent)
 * @param [in] KeyType Կ key type
 * @param [in] SrcKeyIdx ԴԿ key index
 * @param [in] DstKeyIdx ĿԿ target key index
 * @param [in] XorVarInLen ҪӲԿ  Length of key constituent that needed to be add into XOR
 * @param [in] XorVarIn ҪӲԿ key constituent that needed to be add into XOR
 * @param [in] KcvInfoIn kcv
 * @retval >0=ݳ,<0=ʧϢ return value >0: returned data length; return <0: error information
 * @pre 
 */
int PedWriteKeyVar(uchar KeyType, uchar SrcKeyIdx, uchar DstKeyIdx,
                   int XorVarInLen, uchar *XorVarIn, ST_KCV_INFO *KcvInfoIn);


/**
 * @brief ѴԿ
 * @brief Clean all exist key
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedErase(void);


/**
 * @brief  Կ(Կʹʱ)
 * @brief Key configuration setup(interval between every use)
 * @param [in] TPKIntervalTimeMs TPK ʹüʱ. TPK time interval
 * @param [in] TAKIntervalTimeMs TAK ʹüʱ. TAK time interval
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedSetIntervaltime(ulong TPKIntervalTimeMs, ulong TAKIntervalTimeMs);


/**
 * @brief  Կ(趨ǰûԿǩ)
 * @brief Key configuration setup(setup currnt user key tag)
 * @param [in] len ǩݳ length of tag data
 * @param [in] KeyTagIn Կǩ tag data
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedSetKeyTag(int len, uchar *KeyTagIn);


/**
 * @brief д RSA Կ
 * @brief Write in RSA key
 * @param [in] RSAKeyIndex Կ RSA key index
 * @param [in] pstRsakeyIn Կݸʽ Key data structure
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedWriteRsaKey(uchar RSAKeyIndex, ST_RSA_KEY *pstRsakeyIn);


/**
 * @brief ʹ RSA Կм
 * @brief Using RSA key to calculate
 * @param [in] RSAKeyIndex Կ RSA key index
 * @param [in] pucDataInLen Ҫݳ length of data input
 * @param [in] pucDataIn  Ҫ data input
 * @param [out] pucDataOut ؽ data output
 * @retval >0=ݳ,<0=ʧϢ return>0: length of return data; return < 0: error information
 * @pre 
 */
int PedRsaRecover(uchar RSAKeyIndex, int pucDataInLen, uchar *pucDataIn,
                  uchar *pucDataOut);

/*
*@brief RSAɹ˽Կ
*@brief Used for RSA generate Public and Private key pair
*@param [in] RsaPriKeyIdx ˽Կ[0-4],0->洢(˽Կ͹Կͬᱻ) Private key index, option value from 0 to 4, 0 means not save. Index of public key and private key can not be same, or will be covered
*@param [in] RsaPubKeyIdx Կ[0-4],0->洢 Public key index, option value from 0 to 4, 0 means not save
*@param [in] RsaBit RSAԿλ(bit) length of RSA key(bit)
*@param [in] expMode:Կָģʽ(RSA_PUBLIC_EXP_MODE_01=0,// ָΪ01RSA_PUBLIC_EXP_MODE_03 ,// ָΪ03)(Modes of Public key exponent)
*@param [out] genRsaKey rsa returned generated RSA type
*@retval 1 ݳ,0 ʧ return>0: length of return data; return = 0: error information
*/
int PedRsaGenerateKey(uchar RsaPriKeyIdx,uchar RsaPubKeyIdx,int RsaBit,RSA_PUBLIC_EXP_MODE expMode,ST_GEN_RSA_KEY *genRsaKey);

/**
 * @brief ʹ DUKPT  MAC Կ DES Կ 뻺ݽмܻ
 * @brief Using MAC or DES key(DUKPT) to Encrypt pr Decrypt the Data in memory
 * @param [in] GroupIdx DUKPT group ID
 * @param [in] KeyVarType DUKPT Կѡ0x00  Ӧ MAC Կ 0x01  DUKPT DES Կ(Key type: 0x00 for MAC, 0x01 for DUKPT DES)
 * @param [in] ivlen ʼ length of initial vector
 * @param [in] pucIV ʼ initial vector
 * @param [in] DataInLen Ҫݳ length of data input
 * @param [in] DataIn Ҫ data input
 * @param [out] DataOut ؽ data output
 * @param [out] KsnOut ksn. KSN output
 * @param [in] Mode ӽܷʽ Mode
 * @retval >0=ݳ,<0=ʧϢ return>0: length of return data; return < 0: error information
 * @pre 
 */
int PedDukptDes(uchar GroupIdx, uchar KeyVarType, int ivlen, uchar *pucIV,
                ushort DataInLen, uchar *DataIn, uchar *DataOut, uchar *KsnOut,
                uchar Mode);

/**
 * @brief ȡ DUKPT ǰ KSN
 * @brief Read currnt KSN from DUKPT
 * @param [in] GroupIdx DUKPT group ID
 * @param [out] KsnOut KSN KSN output
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedGetDukptKSN(uchar GroupIdx, uchar *KsnOut);

/**
 * @brief DUKPT KSN  1 
 * @brief DUKPT KSN + 1
 * @param [in] GroupIdx DUKPT group ID
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedDukptIncreaseKsn(uchar GroupIdx);


/**
 * @brief ȡ
 * @brief Get random number
 * @param [in] iLen Ҫȡĳ length of random number
 * @param [out] random ȡ random number output 
 * @retval >0=ݳ,<0=ʧϢ return>0: length of return data; return < 0: error information
 * @pre 
 */
int PedGetRandom(int iLen, uchar *random);


/**
 * @brief ȡ
 * @brief Read result
 * @param [out] KeyInfo  Key information output
 * @retval >0=ݳ,<0=ʧϢ return>0: length of return data; return < 0: error information
 * @pre 
 */
int ReadResult(uchar *KeyInfo);


/**
 *ped (TP) Password Management
 *:
 *10x80 ն Terminal unlock password
 *20x81 ԱA Administrator A password
 *30x82 ԱB Administrator B password
 *40x84 ն new Terminal unlock password
 *50x85 ԱA new Administrator A password
 *60x86 ԱB new Administrator B password
 * @brief PED зȨ
 * @brief PED password management and sensitive service authorization
 * @param [in] cmdtype ָ command type
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedKeyManageTP(unsigned char cmdtype);


/**
 * @brief PED 
 * @brief PED password management
 *ped (keyboard)
 *:
 *10x80 ն Terminal unlock password
 *20x81 ԱA Administrator A password
 *30x82 ԱB Administrator B password
 *40x84 ն new Terminal unlock password
 *50x85 ԱA new Administrator A password
 *60x86 ԱB new Administrator B password
 * @param [in] cmdtype  command type
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int PedKeyManage(unsigned char cmdtype);

// SP HASH HASH calculation
#define PED_HASH_ALGO_SHA1   0  ///<SHA1
#define PED_HASH_ALGO_SHA256 1	///<SHA256
#define PED_HASH_ALGO_MD5    2	///<MD5
#define PED_HASH_ALGO_SM3    3	///<SM3

/**
 * @brief Hash㷨ṹ
 */
typedef struct  {
    unsigned char hashAlgo;	///<HASH㷨 HASH algorithm
    unsigned int hashStep;	///<HASH HASH steps
} PedHashCtx;

/**
 * @brief ʼHASH
 * @brief Initialize HASH calculation
 * @param hashAlgo [in] 㷨PED_HASH_ALGO_XXX (Algorithm Serial: PED_HASH_ALGO_XXX)
 * @retval 0 ʧ return 0 for fail
 * @retval !0 ɹ return !0 for success
 */
int PedHashInit(PedHashCtx *ctx, unsigned char hashAlgo);

/**
 * @brief ʼHASH
 * @brief Initialize HASH calculation
 * @param len [in] ˴μֽ Bytes of data used in this calculation
 * @param data [in] ˴β data used in this calculation
 * @retval 0 ʧ return 0 for fail
 * @retval !0 ɹ return !0 for success
 */
int PedHashUpdate(PedHashCtx *ctx, unsigned short len, void *data);

/**
 * @brief ʼHASH Initialize HASH calculation
 * @param hashOut [out] HASH HASH output
 * @param hashOutLen [in] hashOutֽ Maximum HASH output
 * @param hashOutLen [out] HASHʵʳȣNULLʾ Length of HASH real output, NULL for ignore
 * @retval 0 ʧ return 0 for fail
 * @retval !0 ɹHASHʵʳ return !0 for length of HASH real output
 */
int PedHashFinal(PedHashCtx *ctx, void *hashOut, unsigned short *hashOutLen);

/**
 * @brief Set remote auth mode
 * @param mode [in] mode, 0 - RSA1024_SHA1, 2 - RSA2048_SHA1
 */
void PedSetRmtAuthAlgo(unsigned char mode);

/**
 * @brief Get remote auth mode
 * @retval mode, 0 - RSA1024_SHA1, 2 - RSA2048_SHA1
 */
unsigned char PedGetRmtAuthAlgo(void);

/**
 * @brief ȡԶȨ
 * @brief Get remote auth request code
 * @param req [out]  request code
 * @param len [in] req󳤶 length of req
 * @param len [out] req length of req got
 * @retval TRUE success
 * @retval FALSE fail
 */
int PedGetRmtAuthReqCode(void* req, int *len);

/**
 * @brief ֤ԶȨ
 * @brief Verify remote auth code
 * @param authcode [in] Ȩ auth code
 * @param len [in] authcodeĳ length of authcode
 * @retval TRUE success
 * @retval FALSE fail
 */
int PedVerifyAuthCode(void *authcode, int len);

/** @} */


/**
 * @defgroup MagCard
 * @brief ؽӿ
 * @brief Magcard reader operation related interface
 * @{
 */
//=============================================================
//#include "bw_magcard.h"
//=============================================================
// The maximum allowed is: track1 = 79; track2 = 40; track3 = 107.
#define MAG_TRACK1_SIZE     80
#define MAG_TRACK2_SIZE     42
#define MAG_TRACK3_SIZE     108

#define MAG_TRACK1_MASK     (1<<0)
#define MAG_TRACK2_MASK     (1<<1)
#define MAG_TRACK3_MASK     (1<<2)

typedef struct {
    unsigned char ucNr;
    unsigned char ucTrackMask;
    unsigned char aucTrack1[MAG_TRACK1_SIZE];
    unsigned char aucTrack2[MAG_TRACK2_SIZE];
    unsigned char aucTrack3[MAG_TRACK3_SIZE];
} MagTrack_T;

/**
 * @brief 򿪴ģ
 * @param [in] 
 * @retval 1 ɹ, 0 ʧ
 * @pre 
 */
int MagCardOpen(void);


/**
 * @brief رմģ
 * @param [in] 
 * @retval 1 ɹ, 0 ʧ
 * @pre 
 */
int MagCardClose(void);

/**
 * @brief 
 * @param [out] paucTracks: Ϣ
 * @retval 1 ɹ, 0 ʧ
 * @pre 
 */
int MagCardRead(MagTrack_T *pstTracks);
/** @} */


/**
 * @defgroup picc picc
 * @brief ǽӶؽӿ
 * @brief Contactless card reader operation related interface
 * @{
 */
//=============================================================
//#include "bw_picc.h"
//=============================================================

/*******************Ϣ******************************/


#define ICC_RESET_ERR     -1         ///<ICλʧ
#define ICC_CMD_ERR       -2         ///<IC
#define ICC_BLOCK         -3         ///<IC


/**
 * @brief apduָ()
 * @brief apdu command(request)
 * @author wl
 */
typedef struct {
    unsigned char Command[4];	///<APDUָ APDU command
    unsigned short Lc;			///<Lc
    unsigned char DataIn[512];	///<dataIn Data input
    unsigned short Le;			///<Le
} APDU_SEND;

/**
 * @brief apduָ(Ӧ)
 * @brief apducommand (response)
 * @author wl
 */
typedef struct {
    unsigned short LenOut;		///<len lenght of returned data 
    unsigned char DataOut[512];	///< returned data
    unsigned char SWA;			///<SW1 SW1 data
    unsigned char SWB;			///<SW2 SW2 data
} APDU_RESP;		


/**
 * @brief 򿪷ǽģ
 * @brief Open contactless card reader module
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int Open_Picc(void);


/**
 * @brief ǽӿǷ볡
 * @brief Check card in area or not
 * @param [in] mode 񿨷ʽ 00-->ǿģʽ01-->emvģʽ (mode: 00 for reenforced mode, 01 for emv normal mode)
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int Detect_Picc(unsigned char mode);


/**
 * @brief ͽapduָ
 * @brief Send exchange apdu command
 * @param [in] apdu Ҫ͵ָ command to send
 * @param [in] apdulen ָ command length
 * @param [in] rsp ص returned data
 * @param [in] sw ص״̬ 2byte returned status, 2 bytes
 * @retval >0 ݳ,<0=ʧϢ return>0: length of return data; return < 0: error information
 * @pre 
 */
int SendCmd_Picc(unsigned char *apdu, int apdulen, unsigned char *rsp,
                 unsigned char *sw);


/**
 * @brief ƳƬ
 * @brief Remove card
 * @param [in] mode Ƴģʽ remove mode
 * @param [in] logicchannel Ƭ߼ͨ card logic channel
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre  
 */
int Remove_Picc(unsigned char mode, unsigned char logicchannel);


/**
 * @brief رշǽģ()
 * @brief Close contactless card reader module(card pick)
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int Close_Picc(void);


/**
 * @brief ȡƬ(A/B)
 * @bried Get card type(A/B)
 * @retval ؿƬ return card type
 * @pre 
 */
unsigned char getpicccardtype(void);


/**
 * @brief Ƭ߼ͨ
 * @bried Get card logic channel
 * @retval ߼ͨ returned logic channel
 * @pre 
 */
unsigned char getpicclogicchannel(void);


/**
 * @brief ȡƬsn
 * @brief Get card SN number
 * @retval sn returned SN number
 * @pre 
 */
int getpiccsn(unsigned char *sn);


/**
 * @brief ȡƬϢ
 * @brief Get card information
 * @param [out] info ƬϢ card information output
 * @retval ƬϢ length of card information
 * @pre 
 */
int getpiccinfo(unsigned char *info);


#define TAG_CMD_AUTH        'A' // Authenticate
#define TAG_CMD_RAED        'R' // Read block
#define TAG_CMD_WRITE       'W' // Write block
#define TAG_CMD_PAGE        'P' // Write page
#define TAG_CMD_INC         '+' // Value increment
#define TAG_CMD_DEC         '-' // Value decrement
#define TAG_CMD_RESTORE     '>' // Value restore

#define TAG_IDX_AUTH_KEYA           'A' // M1 KeyA
#define TAG_IDX_AUTH_KEYB           'B' // M1 KeyB
#define TAG_IDX_TRANSPARENT_MODE    0x90    // For define transparent mode
#define TAG_PSEUDO_APDU_CLS         TAG_IDX_TRANSPARENT_MODE


#define TAG_M1_KEY_LEN      6
#define TAG_M1_BLOCK_LEN    0x10
#define TAG_M1_VALUE_LEN    4

/**
 * @brief TAG ͸ӿ
 * @param [in] pucCmd TAG
 * @param [in] uiCmdLen TAGĳ
 * @param [in] pucResp TAGӦ
 * @retval >=0=TAGӦĳ,<0=ʧϢ
 * @pre 
 */
int Picc_Tag_Iso14443_TransparentMode(unsigned char *pucCmd, unsigned int uiCmdLen, unsigned char *pucResp);

/**
 * @brief TAG ģAPDUʽ͸ӿ
 * @param [in] pucCapdu APDU: CLA: 0x90, INS: TagCmd, P1: Ignored, P2: Ignored, P3: Lc
 * @param [in] uiCapduLen APDUĳ
 * @param [in] pucRapdu ӦAPDU
 * @param [in] pucSW ״̬
 * @retval >=0=ӦAPDUĳ,<0=ʧϢ
 * @pre 
 */
int Picc_Tag_Iso14443_PseudoAPDU(unsigned char *pucCapdu, unsigned int uiCapduLen,
                unsigned char *pucRapdu, unsigned char *pucSW);

/**
 * @brief M1 Կ֤
 * @param [in] keyType A/B
 * @param [in] blockNo ʵĿ
 * @param [in] keyLen 볤
 * @param [in] pKey 
 * @param [in] seriNoLen Ƭкų
 * @param [in] pSeriNo Ƭк
 * @retval 0 ʧ,1 ɹ
 * @pre 
 */
int Picc_M1_KeyAuth_With_SN(unsigned int keyType, unsigned int blockNo,
                    unsigned int keyLen, unsigned char *pKey, int seriNoLen,
                    unsigned char *pSeriNo);

/**
 * @brief M1 Կ֤
 * @param [in] keyType A/B
 * @param [in] blockNo ʵĿ
 * @param [in] keyLen 볤
 * @param [in] pKey 
 * @retval 0 ʧ,1 ɹ
 * @pre 
 */
int Picc_M1_KeyAuth(unsigned int keyType, unsigned int blockNo, unsigned int keyLen, unsigned char *pKey);

/**
 * @brief  M1  
 * @brief Read M1 card data
 * @param [in] blockNo ָҪʵĿ specify visit block number
 * @param [out] pDataRead ضȡ returned data
 * @retval >0=ݳ,<0=ʧϢ return>0: length of return data; return < 0: error information
 * @pre 
 */
int Picc_M1_ReadBlock(unsigned int blockNo, unsigned char *pDataRead);

/**
 * @brief  M1 
 * @param [in] blockNo ҪʵĿ
 * @param [out] piCents (ԷΪλ)
 * @retval 0 ʧ,1 ɹ
 * @pre 
 */
int Picc_M1_ReadValue(unsigned int blkNo, int *piCents);

/**
 * @brief д M1 
 * @brief Write M1 card data
 * @param [in] blkNo  specify block number
 * @param [in] iDataWriteLen Ҫдݳ length of data write in
 * @param [in] pDataWrite Ҫд data write in
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int Picc_M1_WriteBlock(unsigned int blkNo, unsigned int iDataWriteLen,
                       unsigned char *pDataWrite);

/**
 * @brief M1ʼ
 * @param [in] blkNo ʼĿ
 * @param [in] iCents ʼ(ԷΪλ)
 * @param [in] ucAdr ֵеУ
 * @retval 0 ʧ,1 ɹ
 * @pre 
 */
int Picc_M1_InitValue(unsigned int blkNo, int iCents, unsigned char ucAdr);

/**
 * @brief M1ֵ
 * @param [in] BlkNoSrc ֵԴ
 * @param [in] uiCentsDec ֵĽ(ԷΪλ)
 * @param [in] BlkNoDst ֵĿ
 * @retval 0 ʧ,1 ɹ
 * @pre 
 */
int Picc_M1_Increment(unsigned int blkNoSrc, unsigned int blkNoDst, unsigned int uiCentsInc);

/**
 * @brief M1ֵ
 * @param [in] BlkNoSrc ֵԴ
 * @param [in] uiCentsDec ֵĽ(ԷΪλ)
 * @param [in] BlkNoDst ֵĿ
 * @retval 0 ʧ,1 ɹ
 * @pre 
 */
int Picc_M1_Decrement(unsigned int blkNoSrc, unsigned int blkNoDst, unsigned int uiCentsDec);

/**
 * @brief M1ת
 * @param [in] BlkNoSrc תԴ
 * @param [in] BlkNoDst תĿ
 * @retval 0 ʧ,1 ɹ
 * @pre 
 */
int Picc_M1_Restore(unsigned int blkNoSrc, unsigned int blkNoDst);

/**
 * @brief 򿪷ǽģ
 * @brief Open contactless card reader module
 * @retval  no return value
 * @pre 
 */
int Picc_sid_open(void);


/**
 * @brief ȡpicc sn(Mֽ,ṩ PICC ֱӽ )
 * @brief Get PICC SN(Send M bytes data, provide PICC directly data exchange command)
 * @param [out] snr sn return SN data
 * @param [out] snrlen sn length of SN
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int Picc_sid_getSnrNum(char *snr, short *snrlen);


/**
 * @brief ṩ PICC ֱӽ
 * @brief Provide PICC directly data exchange command
 * @param [in] pdata Ҫ sending data 
 * @param [in] datalen  Ҫݳ length of sending data
 * @param [out] rsp  return data
 * @param [out] rsplen ݳ length of return data
 * @retval 0 ʧ,1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int Picc_sid_transceive(const char *pdata, const short datalen, char *rsp,
                        short *rsplen);


/**
 * @brief Mifare ָ
 * @brief Mifare Command
 * @param [in] iDataWriteLen Ҫдݳ length of data write in
 * @param [in] pDataWrite Ҫд data write in
 * @param [out] pDataRead  return data
 * @retval >0=ݳ,<0=ʧϢ return>0: length of return data; return < 0: error information
 * @pre 
 */
int Picc_MF_Transceive(unsigned int iDataWriteLen, unsigned char *pDataWrite, unsigned char *pDataRead);
/** @} */
/**
 * @defgroup icc icc
 * @brief Ӵʽؽӿ
 * @brief Contacted card reader operation related interface
 * @{
 */
//=============================================================
//#include "bw_icc.h"
//=============================================================
#define ICC_RESET_ERR     -1         ///<ICλʧ
#define ICC_CMD_ERR       -2         ///<ICʧ
#define ICC_BLOCK         -3         ///<IC    
#define ICC_NO_RECORD     -4		 ///<޼¼
#define ICC_RSP_6985	  -5		 ///<6985

// ÿ۷ʽ bit[3-0]
#define USERICCSLOT					0x00	///<ic Check IC card
#define PSAMICCSLOT					0x01	///<PSAM PSAM check

// λʽ bit[7-6]
#define SLOT_RESET_TYPE_DEFAULT     0x00	///< ׼ 7816Ĭϣ
#define SLOT_RESET_TYPE_CITY_CARD   0x40	///<ͨ λֱӸ TA1 ͨѶ City card, will communicate based on TA1 after reset
#define SLOT_RESET_TYPE_EMV     	0x80	///< EMV λ

// PPS  bit[5]
#define SLOT_PPSE_SET_DEFAULT    	0x00	///< Ĭϲ֧ Not support as default
#define SLOT_PPSE_SET_SUPPORT    	0x20	///<֧pps PPS support setup

//TA1
#define SLOT_TA_SET_01    	"\x41\x01\x11"	///< Ĭϲ֧ Not support as default
#define SLOT_TA_SET_02    	"\x41\x01\x12"	///< Ĭϲ֧ Not support as default
#define SLOT_TA_SET_03		"\x41\x01\x13"	///< Ĭϲ֧ Not support as default

/**
 * @brief ⿨Ƿп
 * @brief Check card exist or not
 * @param [in]  null
 * @retval 1 ⵽,0 ޿ return 1 for card exist, 0 for card not exist
 * @pre 
 */
int IccStatus(void);

/**
 * @brief 񿨸λƬͬʱatrͿƬ
 * @brief Pick and reset card. Save art and card type as the same time
 * @param [in]  null
 * @retval 1 ݳ,0 ʧϢ return 1: return data length; return 0: error information
 * @pre 
 */
int IccReset(void);

/**
 * @brief µ
 * @brief Power OFF
 * @param [in]  null 
 * @retval 1 ݳ,0 ʧϢ return 1: return data length; return 0: error information
 * @pre 
 */
int IccClose(void);

/**
 * @brief ȡatrֵ
 * @brief Get art value
 * @param [out] pAtr:صatrֵ returned atr value
 * @retval >0 ݳ,0<= ʧϢ return>0: length of return data; return < 0: error information
 * @pre 
 */
int IccGetAtr(unsigned char *pAtr);

/**
 * @brief ȡƬ
 * @brief Get card type
 * @param [in]  null
 * @retval >0 ݳ,<0=ʧϢ return>0: length of return data; return < 0: error information
 * @pre 
 */
int IccGetCardType(void);

/**
 * @briefָ(ʱ֧ÿ) 
 * @brief Check specified card slot(temporary not support setting card slot)
 * @param [in] slot:ѡ񿨲(USERICCSLOT,PSAMICCSLOT)(choose card slot)
 * @retval 1 ⵽Ƭ,<0=ʧϢ return 1 for card found; return <0 for error information
 * @pre 
 */
int IccSelectSlot(unsigned char slot);

/**
 * @brief ָÿ(ʱ֧ÿ) 
 * @brief Setup card slot with specified data (temporary not support setting card slot)
 * @param [in] slot:ѡ񿨲(USERICCSLOT,PSAMICCSLOT) (choose card slot)
 * @param [in] param :(Ƭ) (data: card baud rate)
 * @param [in] paramLen: ݳ (data length)
 * @retval 1 ⵽Ƭ,<0=ʧϢ return 1 for card found; return <0 for error information
 * @pre 
 */
int IccSelectSlotByParamter(unsigned char slot, const char* param, const int paramLen);

/**
 * @brief icǷԶʹ
 * @brief Set IC card enable to response or not
 * @param [in] AutoFlag:0:disable,1:enable
 * @retval 1 ⵽Ƭ,<0=ʧϢ return 1 for card found; return <0 for error information
 * @pre 
 */
int IccGetResponseEnable(unsigned char AutoFlag);//0:disable,1:enable

/**
 * @brief ͽapduָ
 * @brief Send exchange apdu command
 * @param [in] cmd: Ҫapduָ apdu command want to send
 * @param [in] cmdlen :apduָ length of apdu command
 * @param [in] rsp :ص response data
 * @param [in] sw :ص״̬ 2byte(response status, 2 bytes)
 * @retval >0 ݳ,<0=ʧϢ return>0: length of return data; return < 0: error information
 * @pre 
 */
int	IccApduTransmit(unsigned char *cmd,int cmdlen,unsigned char *rsp,unsigned char *sw);
/** @} */
/**
 * @defgroup sm4 sm4
 * @brief sm4ܲؽӿ
 * @brief sm4 encrypt operation related interface
 * @{
 */
//=============================================================
//#include "bw_sm.h"
//=============================================================

#ifdef SM4_ECB
#undef SM4_ECB
#endif
#define SM4_ECB 0x01		///< ECB㷨 ECB algorithm

#ifdef SM4_CBC
#undef SM4_CBC
#endif
#define SM4_CBC 0x02		///< CBC㷨 CBC algorithm

/**
 * @brief ȡsm2Ĺ˽Կ
 * @bried Get sm2 public and private key pair
 * @param [out] outdata ܽ(pub 64+pri 32) Encrypt result
 * @retval >0 ʵݳ,<=0 ʧ return>0: length of return data; return < 0: fail
 * @pre 
 */
int sm2_KeyGen(unsigned char *outdata);


/**
 * @brief ʹsm2ܲ
 * @brief Encrypt operation with SM2
 * @param [in] ecpoint_PBx Կǰ32byte(ַ) Public key first 32 bytes
 * @param [in] ecpoint_PBy Կ32byte(ַ) Public key following 32 bytes
 * @param [in] M Ҫܵ Data to encrypted
 * @param [in] mLen Ҫܵݳ length of data to encrypted
 * @param [out] encdata ܽ encrypt result
 * @retval >0 ʵݳ <=0 ʧ return>0: length of return data; return < 0: fail
 * @pre 
 */
int sm2_encrypt(char *ecpoint_PBx, char *ecpoint_PBy, const char *M, int mLen,
                unsigned char *encdata);


/**
 * @brief ʹsm2
 * @brief Decrypt with SM2
 * @param [in] decdata Ҫܵ Data to decrypt
 * @param [in] decdataLen Ҫܵݳ lenght of data to decrypt
 * @param [in] dB sm˽Կ SM private key
 * @param [out] M صĽܵĽ returned decrypt result
 * @retval >0 ʵݳ <=0 ʧ return>0: length of return data; return < 0: fail
 * @pre 
 */
int sm2_decrypt(const char * decdata,int decdataLen, const char * dB, unsigned char * M);


/**
 * @brief ʹsm2ǩ
 * @brief SM2 signature
 * @param [in] dA sm2˽Կ(64byte)(ַ) SM2 private key(64 bytes)
 * @param [in] dgst Ҫǩ Data need to be signatured
 * @param [in] dlen Ҫǩݳ Length of data need to be signatured
 * @param [out] signature ǩĽ(32byte) Signature result(32 bytes)
 * @param [out] sig_len ǩĳ Length of signature result
 * @retval >0 ʵݳ <=0 ʧ return>0: length of return data; return < 0: fail
 * @pre 
 */
int sm2_sign(char *dA, unsigned char *dgst, int dlen,
             unsigned char *signature, unsigned int *sig_len);


/**
 * @brief ʹsm2֤ǩǷȷ
 * @brief Using SM2 to check the signature
 * @param [in] dgst ͨԿԤĽ(32byte) Result from pre-processing with public key(32 bytes)
 * @param [in] dgst_len ͨԿԤĽ length of result from pre-processing with public key
 * @param [in] sigbuf Ҫ֤ǩ(64byte) signatured data need to be checked (64 bytes)
 * @param [in] sig_len Ҫ֤ǩݳ length of signatured data need to be checked
 * @param [in] PAx Կǰ32byte First 32 bytes of public key
 * @param [in] PAy Կݺ32byte Following 32 bytes of public key
 * @retval 0 ʧ, 1 ɹ return 0 for fail, 1 for success
 * @pre 
 */
int sm2_verify(unsigned char *dgst, int dgst_len, unsigned char *sigbuf,
               int sig_len, char *PAx, char *PAy);


/**
 * @brief ʹsm2ԿԤҪǩ,ǩĵһ 
 * @brief Using SM2 public key to pre-processing the data need to be checked, as the first step of the signature check
 * @param [in] PAx Կǰ32byte(ַ) First 32 bytes of public key(in string)
 * @param [in] PAy Կݺ32byte(ַ) Following 32 bytes of public key(in string)
 * @param [in] Id ǩid(ĬΪ:1234567812345678) ID(default: 1234567812345678)
 * @param [in] id_len ǩid Length of signature
 * @param [in] signdata ҪԤ Data need to be pre-processed
 * @param [in] sign_len ҪԤݳ Length of data need to be pre-processed
 * @param [out] dgst صԤĽ returned pre-process result
 * @retval >0 ʵݳ <=0 ʧ return>0: length of return data; return < 0: fail
 * @pre 
 */
int sm2_digest(char *PAx, char *PAy, char *Id, int id_len,
               unsigned char *signdata, int sign_len, unsigned char *dgst);


/**
 * @brief ʹsm3hashֵ
 * @brief Using SM3 to calculate hash value
 * @param [in] indata Ҫ͵ָ command need to send
 * @param [in] indata_len ָ length of command
 * @param [out] outdata ص(32byte) returned data (32 bytes)
 * @retval >0 ʵݳ <=0 ʧ return>0: length of return data; return < 0: fail
 * @pre 
 */
int sm3(unsigned char *indata, int indata_len, unsigned char *outdata);


/**
 * @brief SM4(cbcecb)
 * @brief SM4 encrypt(CBC and ECB)
 * @param [in] sm4_key sm4Կ SM4 encrypt key
 * @param [in] mode ECB/cbc (SM4_ECB/SM4_CBC)
 * @param [in] indata Ҫ data need to be encrypted
 * @param [in] indatalen Ҫݳ length of data need to be encrypted
 * @param [in] iv cbcģʽʼ initial vector for CBC mode
 * @param [in] ivlen cbcģʽʼ length of initial vector for CBC mode
 * @param [out] outdata ܽ encrypted result
 * @retval >0 ʵݳ <=0 ʧ return>0: length of return data; return < 0: fail
 * @pre 
 */
int sm4_encrypt(char *sm4_key, char mode, const char *indata, int indatalen, unsigned char *iv, int ivlen,
                unsigned char *outdata);

/**
 * @brief SM4(cbcecb)
 * @brief SMD decrypt(CBC and ECB)
 * @param [in] sm4_key sm4Կ SM4 decrypt key
 * @param [in] mode ECB/cbc (SM4_ECB/SM4_CBC)
 * @param [in] indata Ҫܵ data need to be decrypted
 * @param [in] indatalen Ҫܵݳ length of data need to be decrypted
 * @param [in] iv cbcģʽʼ initial vector for CBC mode
 * @param [in] ivlen cbcģʽʼ length of initial vector for CBC mode
 * @param [out] outdata ܽ decrypted result
 * @retval >0 ʵݳ <=0 ʧ return>0: length of return data; return < 0: fail
 * @pre 
 */
int sm4_Decrypt(char *sm4_key, char mode, const char *indata, int indatalen, unsigned char *iv, int ivlen,
                unsigned char *outdata);
/** @} */

/**
 * @defgroup net net
 * @brief ؽӿ
 * @brief Network operation related interface
 * @{
 */
// include "bwnet.h"
//ͨŴ
//Network Communication Error code
#define NET_ERR_NOSUPPORT		(-5000)			///<޶
#define NET_ERR_PARAMETER 		(-5001)			///< parameter error
#define NET_ERR_TIMEOUT 		(-5002)			///<糬ʱ
#define NET_ERR_DISCON 			(-5003)			///<ӶϿ
#define NET_ERR_SOCKETCREATE 	(-5004)			///<socketʧ
#define NET_ERR_SOCKETCON 		(-5005)			///<socketʧ
#define NET_ERR_NOPDP 			(-5006)			///<PDPʧ PDP fail
#define NET_ERR_OPENPDP 		(-5007)			///<PDPʧ open PDP fail
#define NET_ERR_SETAPN 			(-5008)			///<APNʧ APN setup fail
#define NET_ERR_CONMAX 			(-5009)			///<ӳ Exceed Limit of connection
#define NET_ERR_NONET 			(-5010)			///< no network
#define NET_ERR_IP 				(-5011)			///<IP

#define NET_ERR_CONNECT_TIMEOUT     (-5012)     //APʱ
#define NET_ERR_CONNECT_PASSWORD    (-5013)     //AP
#define NET_ERR_CONNECT_NOAP        (-5014)     //ӵAP
#define NET_ERR_CONNECT_UNKNOW      (-5015)     //APδ֪
#define NET_ERR_CONNECT_CONNECTING  (-5016)     //AP
#define NET_ERR_NO_READY            (-5017)     //豸δ

#define NET_ERR_SEND                (-5018)     //
#define NET_ERR_READ                (-5019)     //


/**
 * @brief ֵ֧豸
 * @brief Supported Network device type
 */
typedef enum {
    NET_DEV_NONE, ///< 豸 no device
    NET_DEV_GPRS, ///< GPRS GPRS network
    NET_DEV_WIFI, ///< WLAN WLAN network
	NET_DEV_SERIAL,///< Serial port
    NET_DEV_NUM
} net_dev_t;

/**
 * @brief Supported type of socket connection
 */
typedef enum {
    NET_SOCKET_TYPE_TCP = 0, ///< TCP connection
    NET_SOCKET_TYPE_UDP = 1, ///< UDP connection
    NET_SOCKET_TYPE_MAX
} net_socket_type;

/**
 * @brief Supported event of net device
 */
typedef enum
{
    NETDEV_EVT_CONN_STATUS_GPRS = 0, ///< The event denote GPRS connection status change. 
    NETDEV_EVT_CONN_STATUS_WIFI = 1, ///< The event denote WLAN connection status change.
    NETDEV_EVT_GPRS_READY = 2, ///< The event denote GPRS device is ready to open.
    NETDEV_EVT_MAX
}netdev_evt_t;

/**
 * @brief GPRS豸
 * @brief GPRS device configuration
 */
typedef struct {
    net_dev_t devtype; ///< 豸 Network device type
    char *apn;  ///< APN, "CMNET" APN. For example,"CMNET"
    char *user; ///< ûΪNULL. Dail username, can be NULL
    char *pass; ///< 룬ΪNULL. Dail password can be NULL
} gprs_dev_param_t;

/**
 * @brief WLAN豸
 * @brief WLAN device configuration
 */
typedef struct {
    net_dev_t devtype; ///< 豸 Network device type
    char *ssid; ///< APSSID. Access porint name
    char *pass; ///< AP룬ΪNULL. Access point password, can NOT be NULL
    char *mac;  ///< APMACַΪNULL Access point Mac address, can be NULL
} wlan_dev_param_t;

/**
 * @brief 豸
 * @brief Network Device configuration
 */
typedef union {
    net_dev_t devtype; ///< 豸 Network device type
    gprs_dev_param_t gprs; ///< GPRS豸 GPRS device configuration
    wlan_dev_param_t wlan; ///< WLAN豸 WLAN device configuration
} net_dev_param_t;

/**
 * @brief Ӳ
 * @brief Network hardware configuration
 */
typedef struct {
    char *ipaddr;  ///< IPַ IP address
    char *mask;    ///<  Net mask
    char *gateway; ///< IPַ Gatway IP address
    char *dns;     ///<  DNS address
    char *mac;     ///< MACַWIFIЧ Local Mac address, only valid for WIFI
    char *ap_ssid; ///< SSID, WIFIЧ SSID only valid for WIFI
    char *ap_mac;  ///< MACַ, WIFIЧ Gateway Mac address, only valid for WIFI
    int  ap_rssi;  ///< źǿ, WIFIЧ RSSI value, only valid for WIFI
    unsigned char ap_ch;    ///< ͨ, WIFIЧ Channel, only valid for WIFI
    unsigned char station_dhcp_en; ///< station DHCP״̬, WIFIЧ station DHCP status, only valid for WIFI
} net_dev_hwinfo_t;

/**
 * @brief ȡǰڼ״̬豸ID
 * @brief Get current activated device ID
 * @retval NET_DEV_NONE û豸ڼ̬(No activated device ID)
 * @retval NET_DEV_GPRS GPRSڼ̬ (GPRS activated)
 * @retval NET_DEV_WIFI WIFIڼ̬ (WIFI activated)
 * @pre 
 */
net_dev_t NetDeviceGetActive(void);

/**
 * @brief ѡ񼤻ĸ豸
 * @brief Choose to active device
 *  ͬһʱ̽һ豸(Only one device can connect to network at the same time)
 * @param [in] idҪʹõ豸ţNET_DEX_XXX (Device ID)
 * @retval 0 ɹ return 0 for success
 * @retval <0  retrun <0 for error code
 * @pre 
 */
int NetDeviceActive(net_dev_t id);

/**
 * @brief 򿪼ͨѶ豸
 * @brief Open activated communication device
 * @retval 0 򿪳ɹ return 0 for open success
 * @retval 0 ʧ return !0 for open fail
 * @pre NetDeviceSetParameter
 */
int NetDeviceOpen(void);

/**
 * @brief Open specific communication device
 * @param id [in] NET_DEX_XXX (Device ID)
 * @retval 0 - open success
 * @retval !0 - open fail
 * @pre NetDeviceSetParameter
 */
int NetDeviceOpenEx(net_dev_t id);

/**
 * @brief رͨѶ豸
 * @brief Close communication device
 * @retval 0 رճɹ return 0 for close success
 * @retval 0 رʧ return !0 for close fail
 */
int NetDeviceClose(void);

/**
 * @brief Close specific communication device
 * @param id [in] NET_DEX_XXX (Device ID)
 * @retval 0 Close success
 * @retval !0 Close fail
 */
int NetDeviceCloseEx(net_dev_t id);

/**
 * @brief ȡ豸ϢIPַ//DNSϢ
 * @brief Get device information, IP/Net mask/DNS and etc
 * @param info [out] ӲϢ hardware information
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧܣ return <0 for fail, error code
 */
int NetDeviceGetHwInfo(net_dev_hwinfo_t *info);

/**
 * @brief õǰ豸
 * @brief Setup current device configuration
 * @param param [in] Ҫõ豸 Device ID
 * @retval 0 ɹ return 0 for success
 * @retval <0  return <0 for error code
 */
int NetDeviceSetParameter(net_dev_param_t *param);

/**
 * @brief Setup specific device configuration
 * @param param [in] parameters neet to set
 * @retval 0 Success
 * @retval <0 Error code
 */
int NetDeviceSetParameterEx(net_dev_param_t *param);

/**
 * @brief Get host of specific device
 * @param evt [in] the event need to get
 * @retval 0 successful
 * @retval other fail.
 */
int NetDeviceGetHostByName(const char* domainName, char* ipAddr);


/**
 * @brief ȡ豸״̬
 * @brief Get activated device network status
 * @retval 0 δ return 0 for not connected
 * @retval 1  return 1 for connected
 * @retval <0  return < 0 for error
 */
int NetDeviceGetConnectionStatus(void);

/**
 * @brief Get specific net device connection status
 * @param id Net device ID
 * @retval 0 Not connected
 * @retval 1 Connected
 * @retval <0 Error code
 */
int NetDeviceGetConnectionStatusEx(net_dev_t id);

/**
 * @brief Get event of specific device
 * @param evt [in] the event need to get
 * @retval -1 Fail
 * @retval event handler
 */
HANDLE NetDeviceGetEvent(netdev_evt_t evt);

/**
 * @brief socket
 * @brief Create socket connection
 * @param type [in] socketͣTCPUDP Socket type(TCP of UDP)
 * @param remote_addr [in] ԶIPַ (remote IP address)
 * @param  port [in] Զ˿ (Port number)
 * @param flag [in] Զ˵ַ (remote address type)
 * @retval 0 socketɹ return > 0 for success
 * @retval С0 ʧ return <0 for fail
 */
int NetSocketConnect(net_socket_type type, char *remote_addr, unsigned short port, int flag);

/**
 * @brief ȴsocketӣֱɹʱ
 * @brief Wait for socket connection, until success or timeout
 * @param ctx [in] socket context
 * @param timeout_ms [in] ʱʱ, 0:, -1:ȴֱ timeout time
 * @retval 1 socket return 1 for socket alreay connected
 * @retval 0 socketδ return 0 for socket not connected
 */
int NetSocketWaitConnet(int ctx, int timeout_ms);

/**
 * @brief socket
 * @brief Receiving socket data
 * @param ctx [in] socket context
 * @param recvbuf [out] socketݵĻ buffer for receiving socket data
 * @param len [in] Ԥڽյݳ expected data length
 * @retval 0 ճɹ return > 0 for receive success
 * @retval С0 ʧ return < 0 for receive fail
 */
int NetSocketRecv(int ctx, void *recvbuf, int len);

/**
 * @brief ڵǰ豸Ͻsocket
 * @brief Receiving socket data with timeout
 * @param ctx [in] socket context
 * @param recvbuf [out] socketݵĻ buffer for receiving socket data
 * @param len [in] Ԥڽյݳ expected data length
 * @param timeout [in] ʱʱ䣬0ʾأ-1ʾȴֱ Max timeout to wait receive data, 0 means return immediatly, -1 means wait until receive data
 * @retval 0 ճɹ return > 0 for receive success
 * @retval С0 ʧ return < 0 for receive fail
 */
int NetSocketRecvEx(int ctx, void *recvbuf, int len, int timeout);

/**
 * @brief socket
 * @brief Send socket data
 * @param ctx [in] socket context
 * @param sendbuf [in] socketݵĻ buffer for sending socket data
 * @param len [in] Ԥڷ͵ݳ expected data length
 * @retval 0 ͳɹ return > 0 for sending success
 * @retval С0 ʧ return < 0 for sending fail
 */
int NetSocketSend(int ctx, void *sendbuf, int len);

/**
 * @brief Send data to socket context with specific timeout
 * @param ctx [in] socket context
 * @param sendbuf [in] buffer for sending
 * @param len [in] length of data to send in sendbuf
 * @param timeout [in] sending timeout in millisecond, 0 means return immediately, -1 means wait until send finish.
 * @retval 0 Success
 * @retval <0 Fail
 */
int NetSocketSendEx(int ctx, void *sendbuf, int len, int timeout_ms);

/**
 * @brief رsocket
 * @brief Close socket connection
 * @param ctx [in] socket context
 * @retval 0 رճɹ return 0 for close success
 * @retval <0 رʧ return < 0 for close fail
 */
int NetSocketClose(int ctx);

/**
 * @brief 鵱ǰ豸ϵsocket
 * @brief Check socket connection on current activated device
 * @param ctx [in] socket context
 * @retval 0 Ͽ״̬ return 0 for disconnected
 * @retval 1 ״̬ return 1 for connected
 */
int NetSocketCheck(int ctx);

/**
 * @brief ȡָsocketָѡ
 * @brief Get specified option for specified socket connection
 * @param ctx [in] socket context
 * @param opt [in] ָѡSOCKET_TXDATA, SOCKET_RXDATA (Specify option: SOCKET_TXDATA, SOCKET_RXDATA)
 * @param pdata [out] صѡ returned option information
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧܣ return <0 for fail, error code
 */
int NetSocketGetOption(int ctx, SOCKET_OPT_E opt, unsigned int *pdata);

/**
 * @brief ȡָsocketĴ
 * @brief Get error code for specified socket connection
 * @param ctx [in] socket context
 * @retval Socket return error code
 */
int NetSocketErrNo(int ctx);

/**
 * @brief Close all socket on specific net device
 * @param dev [in] net device
 */
void NetSocketCloseDev(net_dev_t dev);

/** @} */

/**
 * @defgroup http http
 * @brief httpؽӿ
 * @brief http operation related interface
 * @{
 */
#define HTTP_CONTENT_TYPE_XML	0
#define HTTP_CONTENT_TYPE_JSON	1

#include "utils_httpc.h"
/**
 * @brief http/httpsͨķͽսӿ
 * @brief http/https normal sending and receiving port
 * @param [in] client httpclient_tṹָ, httpclient_t structure pointer, store request data
 * @param [in] url 	  ַ server address
 * @param [in] port 	˿ server port
 * @param [in] ca_crt ֤ certification
 * @param [in] method  @see HTTPCLIENT_REQUEST_TYPE (exchange method)
 * @param [in] timeout_ms ʱ timeout time
 * @param [in] client_data httpclient_data_tṹָ,ŷŻ (structure pointer, store returned data)
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧܣ return <0 for fail, error code
 */
int httpclient_common(httpclient_t *client, const char *url, int port, const char *ca_crt,
                      HTTPCLIENT_REQUEST_TYPE method, uint32_t timeout_ms, httpclient_data_t *client_data);
/**
 * @brief http/httpsݽӿ
 * @brief http/https receiving data port
 * @param [in] client httpclient_tṹָ, structure pointer, store request data
 * @param [in] timeout_ms ʱ timeout time
 * @param [in] client_data httpclient_data_tṹָ,ŷŻ structure pointer, store returned data
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧܣ return <0 for fail, error code
 */
int httpclient_recv_response(httpclient_t *client, uint32_t timeout_ms, httpclient_data_t *client_data);
/**
 * @brief http/httpsر
 * @brief http/https close
 * @param [in] client httpclient_tṹָ, structure pointer, store request data
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧܣ return < 0 for fail, error code
 */
void httpclient_close(httpclient_t *client);
/**
 * @brief http/https postӿ
 * @brief http/https post exchange port
 * @param [in] client httpclient_tṹָ, structure pointer, store request data
 * @param [in] url 	  ַ server address
 * @param [in] port 	˿ server port
 * @param [in] ca_crt ֤ certification
 * @param [in] timeout_ms ʱ timeout time
 * @param [in] client_data httpclient_data_tṹָ,ŷŻ structure pointer, store returned data
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧܣ return < 0 for fail, error code
 */
int httpclient_post_data(httpclient_t *client, const char *url, int port, const char *ca_crt, httpclient_data_t *client_data);
/**
 * @brief HTTPͷеHOSTֶ
 * @brief Assemble HOST data for HTTP message header
 * @param [in] url 	  ַ server address
 * @param [in] scheme 	  urlЭͷ url scheme
 * @param [in] max_scheme_len 	  urlЭͷ󳤶 url scheme maximum length
 * @param [in] host 	  ַ host address
 * @param [in] maxhost_len  ַ󳤶 host address maximum length
 * @param [in] port 	˿ host port
 * @param [in] path · path
 * @param [in] max_path_len ·󳤶 maximum path length
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧܣ return < 0 for fail, error code
 */
int httpclient_parse_url(const char *url, char *scheme, uint32_t max_scheme_len, 
    char *host, uint32_t maxhost_len, int *port, char *path, uint32_t max_path_len);

typedef struct {
    httpclient_t *hc;              /* http client */
    httpclient_data_t *hc_data;    /* http client data */

    //from BW_HTTP
    int httpState;
} HTTP_MODE_CTX;
/**
 * @brief HTTP/HTTPSʼӿ
 * @brief HTTP/HTTPS port initialize
 * @param [in] pp_hmc 	  HTTP_MODE_CTXṹָ HTTP MODE CTX structure pointer
 * @param [in] host 	  ַ Server address
 * @param [in] port 	  ˿ Server port
 * @param [in] ca_crt 	  ֤ Certification
 * @param [in] url  	  ӿurl Port url
 * @param [in] method 	  Э Scheme method
 */
void httpInitEx(HTTP_MODE_CTX **pp_hmc, const char *host, unsigned short port,
        const char *ca_crt, const char *url, int method);
/**
 * @brief HTTP/HTTPSʼӿ
 * @brief HTTP?HTTPS port initialize
 * @param [in] pp_hmc 	  HTTP_MODE_CTXṹָ HTTP MODE CTX structure pointer
 * @param [in] host 	  ַ Server address
 * @param [in] hostSize   ַ Server address length
 * @param [in] port 	  ˿ Server port
 * @param [in] url  	  ӿurl Port url
 * @param [in] urlSize  	  ӿurl Port url length
 * @param [in] method 	  Э Scheme method
 * @code
	(Example):httpInit(&hmc, "111.222.333.444",strlen("111.222.333.444")+1, 80, "/xposp/online/v2/transfers", strlen("/xposp/online/v2/transfers")+1, 1);
 * @endcode
 */
void httpInit(HTTP_MODE_CTX **pp_hmc, const char *host, int hostSize, unsigned short port,
        const char *url, int urlSize, int method);
/**
 * @brief HTTP/HTTPS
 * @brief HTTP/HTTPS handshake
 * @param [in] host 	  ַ Server address
 * @param [in] port 	  ˿ Server port
 * @param [in] ca_crt  	  	  ֤ Certification
 * @param [in] ca_crt_len  	  ֤鳤 Certification length
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧܣ return < 0 for fail, error code
 */		
int httpsInitHandshake(const char *host, unsigned short port,char *ca_crt, int ca_crt_len);
/**
 * @brief HTTP/HTTPS
 * @brief HTTP/HTTPS handshake
 * @param [in] host 	  ַ Server address
 * @param [in] port 	  ˿ Server port
 * @param [in] ca_crt  	  	  ֤ Certification
 * @param [in] ca_crt_len  	  ֤鳤 Certification length
 * @param [in] socketId			ųɹ󷵻صsocket id
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧܣ return < 0 for fail, error code
 */		
int httpsInitHandshakeEx(const char *host, unsigned short port, char *ca_crt, int ca_crt_len, int *socketId);

/**
 * @brief ر
 * @brief Close connection
 * @param [in] pp_hmc 	  HTTP_MODE_CTXṹָ HTTP MODE CTX structure pointer
 */
void httpClose(HTTP_MODE_CTX **pp_hmc);
/**
 * @brief Ƿ
 * @brief Set connection as long time connection or not
 * @param [in] pp_hmc 	  HTTP_MODE_CTXṹָ HTTP MODE CTX structure pointer
 * @param [in] keepalive  1.  0. (1 for long time connection, 0 for short time connection)
 */
void httpSetAlive(HTTP_MODE_CTX **pp_hmc, int keepalive);
/**
 * @brief HTTPͷ
 * @brief Set HTTP message header configuration
 * @param [in] hmc 	  HTTP_MODE_CTXṹָ HTTP MODE CTX structure pointer
 * @param [in] key 	  ֶ  key
 * @param [in] keySize 	  ֶƳ  key length
 * @param [in] value  	  	  ֵ value
 * @param [in] valueSize  	  ֵ value length
 */
void httpHeadPar(HTTP_MODE_CTX *hmc, const char *key, int keySize, const char *value, int valueSize);
/**
 * @brief HTTP POST
 * @brief Set HTTP POST configuration 
 * @param [in] hmc 	  HTTP_MODE_CTXṹָ HTTP MODE CTX structure pointer
 * @param [in] key 	  ֶ key
 * @param [in] keySize 	  ֶƳ key length
 * @param [in] value  	  	  ֵ value
 * @param [in] valueSize  	  ֵ value length
 */
void httpPar(HTTP_MODE_CTX *hmc, const char *key, int keySize, const char *value, int valueSize);
/**
 * @brief ȡHTTP/HTTPS
 * @brief Read HTTP/HTTPS large data
 * @param [in] hmc 	  HTTP_MODE_CTXṹָ HTTP MODE CTX structure pointer
 * @param [in] buf 	  ָ pointer for data storage
 * @param [in] buf_len 	  ݿռС size of data storage
 * @param [in] p_read_len  	  ȡݳ size of data read
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧܣ return <0 for fail, error code
 */
int httpReadEx(HTTP_MODE_CTX *hmc, char *buf, int buf_len, int *p_read_len);
/**
 * @brief ȡHTTP/HTTPSһ
 * @brief Read HTTP/HTTPS normal data
 * @param [in] hmc 	  HTTP_MODE_CTXṹָ HTTP MODE CTX structure pointer
 * @param [in] buf 	  ָ pointer for data storage
 * @param [in] size   ȡݳ size of data read
 * @retval 0 ɹ return 0 for success
 * @retval !0 ʧ return !0 for fail
 */
int httpRead(HTTP_MODE_CTX *hmc, char *buf, int *size);
/**
 * @brief HTTP/HTTPS
 * @brief Send HTTP/HTTPS data
 * @param [in] hmc 	  HTTP_MODE_CTXṹָ HTTP MODE CTX structure pointer
 * @param [in] buf 	  ָ pointer for data ready to send
 * @param [in] size   ݳ length of data ready to send
 * @retval 0 ɹ return 0 for success
 * @retval !0 ʧ return !0 for fail
 */
int httpWrite(HTTP_MODE_CTX *hmc, const char *buf, int size);
/**
 * @brief ȡHTTP/HTTPSرͷеֶ
 * @brief Get data from HTTP/HTTPS return message header
 * @param [in] hmc 	  HTTP_MODE_CTXṹָ HTTP MODE CTX structure pointer
 * @param [in] header 	 ͷֶ message header name
 * @param [in] size   ͷֶ length of message header name
 * @code
 *		(For example) char *authToken=httpResponseGetHead(hmc,"Cookie",sizeof("Cookie"));
 * @endcode
 * @retval ͷָ,ʧܷNULL return pointer for message header data, if fail, return NULL
 */
const char* httpResponseGetHead(HTTP_MODE_CTX *hmc, const char *header, int size);
/**
 * @brief HTTP/HTTPSʱʱ
 * @brief Setup HTTP/HTTPS exchange timeout time
 * @param [in] time   ʱʱ timeout time
 */
void setTimeout(int time);

/** @} */
/**
 * @defgroup wlan wlan
 * @brief wlanؽӿ
 * @brief wlan operation related interface
 * @{
 */
// include "bwwlan.h"

// 
#define WLAN_OK			     (0)	///<
#define WLAN_ERROR			 (-1)	///<
#define WLAN_FAIL			 (-2)	///<ʧ
#define WLAN_ERR_UNKNOW      (-3)	///<δ֪
#define WLAN_ERR_OTHER       (-4)	///<
#define WLAN_ERR_BUSY_S      (-5)
#define WLAN_ERR_HW          (-6)

#define WLAN_ERR_WRITE       (-10)	///< ʹ Send Command ERR
#define WLAN_ERR_READ        (-11)	///< մ Receive Command ERR
#define WLAN_ERR_OVERFLOW    (-12)	///< С Buffer Size ERR
#define WLAN_ERR_NULL        (-13)	///< NULL
#define WLAN_ERR_PARA        (-14)

#define WLAN_ERR_SSID_LEN    (-20)	///< SSIDȴ 
#define WLAN_ERR_MAC_LEN     (-21)	///< MACȴ
#define WLAN_ERR_NOIP        (-22)	///< 

#define WLAN_ERR_CONNECT_BASE       (-30)
#define WLAN_ERR_CONNECT_TIMEOUT    (-30)	///< ӳʱ
#define WLAN_ERR_CONNECT_PASSWORD   (-31)	///< 
#define WLAN_ERR_CONNECT_NOAP       (-32)	///< ҲĿAP Can not find targe access point
#define WLAN_ERR_CONNECT_FAIL       (-33)	///< ʧ
#define WLAN_ERR_CONNECT_CONNECTING (-34)	///<  

#define WLAN_ERR_LINK_TYPE          (-40)   ///< ͣLINK_TYPE_E
#define WLAN_ERR_LINK_REMOTE_IP     (-41)   ///< ԶIP
#define WLAN_ERR_LINK_STATUS        (-42)   ///< ѯ״̬
#define WLAN_ERR_LINK_MODE_SINGLE   (-43)   ///< ǰΪӣʹö Current: single connect, can not use multi-connection command
#define WLAN_ERR_LINK_MODE_MUX      (-44)   ///< ǰΪӣʹõ Current: multi-connect, can not use single connetion command

#define WLAN_ERR_SENDEX_NOIPD           (-50)   ///< 
#define WLAN_ERR_SENDEX_TIMEOUT         (-51)   ///< 
#define WLAN_ERR_SENDEX_OVERFLOW        (-52)   ///<

#define WLAN_ERR_SENDEX_RXLINKID        (-53)   ///< 
#define WLAN_ERR_SENDEX_RXLEN           (-54)   ///<
#define WLAN_ERR_SENDEX_RXCOLON         (-55)
#define WLAN_ERR_SENDEX_RXDATA_OVERFLOW (-56)
#define WLAN_ERR_SENDEX_UNKNOW          (-57)

#define WLAN_ERR_NEED_RESET             (-58)

// wifi mode
#define WIFI_MODE_STATION           (1)
#define WIFI_MODE_SOFTAP            (2)
#define WIFI_MODE_STATION_SOFTAP    (3)

// wifi scan option
#define SCAN_OPT_ECN                (0x01)
#define SCAN_OPT_SSID               (0x02)
#define SCAN_OPT_RSSI               (0x04)
#define SCAN_OPT_MAC                (0x08)
#define SCAN_OPT_CH                 (0x10)
#define SCAN_OPT_FREQ_OFFSET        (0x20)
#define SCAN_OPT_FREQ_CALIBRATION   (0x40)

/** @brief wifi encrypt mode **/
typedef enum {
    WIFI_ENCRYPT_MODE_MIN = 0,
    WIFI_ENCRYPT_MODE_OPEN = 0,
    WIFI_ENCRYPT_MODE_WEP,
    WIFI_ENCRYPT_MODE_WPA_PSK,
    WIFI_ENCRYPT_MODE_WPA2_PSK,
    WIFI_ENCRYPT_MODE_WPA_WPA2_PSK,
    WIFI_ENCRYPT_MODE_WPA2_Enterprise,
    WIFI_ENCRYPT_MODE_MAX
} WIFI_ENCRYPT_MODE_E;

#define INFO_SSID_SIZE_MAX  (32) ///< ssid32ַ 
#define INFO_MAC_SIZE       (17) ///< macΪ̶17ֽ
#define INFO_CHANNEL_MIN    (1) ///< channel,802.1114ŵ,1-14 For 802.11, Maximum 14 channel.
#define INFO_CHANNEL_MAX    (14)///< channel,802.1114ŵ,1-14

typedef struct {
    char ssid[INFO_SSID_SIZE_MAX+1];
    char mac[INFO_MAC_SIZE+1];
    unsigned char ch;
    int rssi;
    int freq_offset;
    int freq_calibration;
    WIFI_ENCRYPT_MODE_E encrypt_mode;
} WIFI_INFO_T;

#define LINK_ID_UONUSE  (-1)///<  Single connect
#define LINK_ID_MIN     (0) ///< ӣСLINK ID (Multi-connect, minimum link ID)
#define LINK_ID_MAX     (4) ///< ӣLINK ID (Multi-connect, maximum link ID)
#define LINK_ID_MUX_ALL (5) ///< ӣرȫ (Multi-connect, shut down all)

#define TCP_KEPP_ALIVE_MIN (1)
#define TCP_KEPP_ALIVE_MAX (7200)
/** @brief **/
/** @brief Connection type**/
typedef enum {
    LINK_TYPE_TCP = 0, 	///<  TCP
    LINK_TYPE_UDP,		///<  UDP
    LINK_TYPE_SSL,		///<  SSL
    LINK_TYPE_UNKNOW	///<  δ֪	Unknown
} LINK_TYPE_E;
/** @brief TE**/
/** @brirf TE type**/
typedef enum {
    TE_TYPE_CLIENT = 0,
    TE_TYPE_SERVER,
    TE_TYPE_UNKNOW
} TE_TYPE_E;

#define REMOTE_IP_MAX_SIZE  (15)	///<IPַ Maximum IP address size
typedef struct {
    unsigned char link_id;
    char remote_ip[REMOTE_IP_MAX_SIZE+1];
    TE_TYPE_E tetype;
    LINK_TYPE_E link_type;
    unsigned int remote_port;
    unsigned int local_port;
} WIFI_LINK_INFO_T;
#define WLAN_LINK_STATUS_REMOTE_LINKED   (0) ///< ѽTCPUDP Already connected as TCP or UDP
#define WLAN_LINK_STATUS_AP_CONNECTED    (1) ///< AP,ipַ Already connected to access point, get IP address
#define WLAN_LINK_STATUS_REMOTE_UNLINKED (2) ///< ѶϿԶ Already disconnected
#define WLAN_LINK_STATUS_AP_DISCONNECTED (3) ///< δAP Access point not connected
/** @brief ͨѶ**/
/** @brief Transmission type **/
typedef enum {
    CIPMODE_NORMAL = 0,
    CIPMODE_PASSTHROUGH, ///< ͸ Pass through transmission
    CIPMODE_UNKNOW
} CIPMODE_TYPE_E;
/** @brief **/
/** @brief Connection type**/
typedef enum {
    CIPMUX_SINGLE = 0,  ///<  Single connect
    CIPMUX_MUX,         ///<  Multi-connect
    CIPMUX_UNKNOW
} CIPMUX_TYPE_E;


/**
 * @brief WIFIȡWIFIб 
 * @brief Search WIFI and get WIFI list
 * @param info [out] WIFIб WIFI list buffer
 * @param info_size [in]  WIFIбֵ Maximum WIFI list buffer size
                    [out] ȡWIFIб Size of WIFI list got
 * @retval 0 ɹ return 0 for success
 * @retval !0 ʧ return !0 for fail
 */
int BW_Wlan_GetWifiList(WIFI_INFO_T* info, unsigned int* info_len);

/**
 * @brief WLAN_SetDHCP
 * @param [in] enable - !0:Զȡ Automatic get DHCP
 *                    - 0:ֶ Manually setup
 * param [in] ip:enable==0òڣenable==1,òЧ (when enable = 0, that value must exist, when enable = 1, that value invalid)
 * param [in] gateway:enable==0òѡenable==1,òЧ (when enable = 0, that value is optional, when enable = 1, that value invalid)
 * param [in] netmask:enable==0òѡ(gateway)enable==1,òЧ (when enable = 0, that value is optional, when enable = 1, that value invalid)
 * @retval 0 ɹ
 * @retval !0 
 */
int WLAN_SetDHCP(unsigned char enable, char* ip, char* gateway, char* netmask);

/**
 * @brief WLAN_SetDNS
 * @param [in] autoEnable - !0:Զȡ Automatic get DNS
 *                        - 0:ֶ Manually setup
 * param [in] dns_server0:autoEnable==0òѡautoEnable==1,òЧ (when enable = 0, that value is optional, when enable = 1, that value invalid)
 * param [in] dns_server1:autoEnable==0òѡautoEnable==1,òЧ (when enable = 0, that value is optional, when enable = 1, that value invalid)
 * @note ĬdnsΪ208.67.222.222openDNS(Default DNS address is 208.67.222.222, belongs to open DNS)
 * @retval 0 ɹ return 0 for success
 * @retval !0  return !0 for error code
 * @todo ĿǰɹİſģΪ汾֧ͣdnsãýӿΪʵ (Current ai-thinker WLAN module is in low version, DNS setup not supported)
 */
int WLAN_SetDNS(unsigned char autoEnable, char* dns_server0, char* dns_server1);

/**
 * @brief WLANĿ״̬
 * @retval 0 
 * @retval !0 
 */
int WLAN_NetGetAtStatus(void);

#define WLAN_SLEEP_MODE_POWER_OFF       (0) // ߺر
#define WLAN_SLEEP_MODE_DEEP_SLEEP      (1) // ʹdeep sleepģʽ

/**
 * @brief WLAN_SleepModeSet
 * @param [in] mode:WLAN_SLEEP_MODE_POWER_OFF,ߺرյԴ
 *                  WLAN_SLEEP_MODE_DEEP_SLEEP,ߺʹdeep sleepģʽ
 * @retval 0 ɹ
 * @retval !0 
 */
int WLAN_SleepModeSet(int mode);

/** @} */

/**
 * @defgroup bluetooth bluetooth
 * @brief ؽӿ
 * @brief Bluetooth operation related interface
 * @{
 */
//#include "bwbt.h"
#define BT_NAME_MAX_LEN 20 ///< 豸ַ
#define BT_PIN_MAX_LEN 4   ///< PINַ
#define BT_ADDR_LEN 17     ///< ַַ

typedef struct {
    char *name; ///< 豸20ַ, : "QR150BT" (Bluetooth device name)
    char *addr; ///< ַΪ17ֽڣ: "00:A1:B2:33:44:55""00-A1-B2-33-44-55"(Bluetooth device address)
    char *pin;  ///< PIN룬4ASCIIַ, : "1234" (Bluetooth device pin)
} btconfig_t;

/**
 * @brief BTģµ
 * @brief Swith Bluetooth module ON/OFF
 * @param onoff [in] 0 - µ磬 1 - ϵ (0 for OFF, 1 for ON)
 * @retval !0 ʧܣд return !0 for fail and error
 * @retval 0 ɹ return 0 for success
 */
int BW_BlueTooth_Power(int onoff);

/**
 * @brief ȡBTģ鵱ǰ״̬
 * @brief Get Bluetooth module current connection status
 * @retval 0 δ return 0 for unconnected
 * @retval 1  retrun 1 for connected
 */
int BW_BlueTooth_IsConnect(void);

/**
 * @brief BTģģʽ
 * @brief Open/Close Bluetooth module command mode
 * ⵽ģʱرģʽ
 * When bluetoothed connection detected, please close the command mode
 * @param onoff [in] 0-أ1- 0 for OFF, 1 for ON
 * @retval 0 ɹ return for success
 * @retval <0 ʧ return <0 for fail
 */
int BW_BlueToothCmdEnable(int onoff);

/**
 * @brief 
 * @brief Get Bluetooth name
 * @retval NULL ȡʧ return NULL for get name fail
 * @retval ַָ룬ͷ return Bluetooth name string pointer, no need to free
 */
char* BW_BlueTooth_GetName(void);

/**
 * @brief ַ
 * @brief Get Bluetooth address
 * @retval NULL ȡַʧ return NULL for get Bluetooth address fail
 * @retval ַַָ룬ʽΪ: "1a:2b:3c:4d:5e:6f"ͷ return Bluetooth address string pointer, no need to free
 */
char* BW_BlueTooth_GetAddr(void);

/**
 * @brief BTģ
 * @bried Setup Bluetooth module property
 * ӿڻпģʽ Interface will automatic open command mode
 * @param cfg [in] Ҫõ bluetooth configuration
 * @retval 0 ɹ return 0 for success
 * @retval <0 ʧ return <0 for fail
 */
int BW_BlueTooth_SetConfig(btconfig_t *cfg);

/**
 * @brief ģ
 * @brief Get data from Bluetooth module
 * δʱ޷ͨģ鴫 if there is no bluetooth connect, wont transfer data through bluetooth
 * @param buff [out]  data output
 * @param bufflen [in] buffĴС length of data output
 * @param timeout_ms [in] ʱʱ timeout time in ms
 * @retval <0 ʧܣд return <0: fail,error
 * @retval >=0 ʵʶֽ return>=0: length of data output
 */
int BW_BlueTooth_Read(void *buff, unsigned int bufflen, unsigned int timeout_ms);

/**
 * @brief ģд
 * @brief Write data to bluetooth module
 * δʱ޷ͨģ鴫 if there is no bluetooth connect, wont transfer data through bluetooth
 * @param buff [in] Ҫд data to write
 * @param bufflen [in] Ҫдֽ length of data to write
 * @retval <0 ʧܣд return < 0: fail, error
 * @retval >=0 ʵдֽ return >= 0: length of data written
 */
int BW_BlueTooth_Write(void *buff, unsigned int bufflen);


/**
 * @brief Flash
 * @brief Flash inside
 * @param filename [in] ļ16ַ File name, no more than 16 bytes
 * @param breakPointMode[in] ǷΪϵģʽ 1 -- ǣ 0 --  Check whether break point mode, 1 for yes, 0 for no
 * @retval 0 ɹ return 0 for success
 * @retval 0 ʧ return !0 for fail
 * @pre 
 */
int BWOTA_FlashInside(const char* file_name, int breakPointMode);

/**
 * @brief Flashļϵͳ
 * @brief Flash File System
 * @param filename [in] ļ128ַ File name, no more than 128 bytes
 * @retval >=0 ɹ,ļ return >= 0: success, file descriptor
 * @retval 0 ʧ return !0 :fail
 * @pre BWFS_Init
 */
int BWOTA_FlashFileSystem(const char *filename);

/**
 * @brief FlashӦ
 * @brief Flash sub application
 * @param filename [in] ļ128ַ File name, no more than 128 bytes
 * @retval >=0 ɹ return >= 0: success
 * @retval 0 ʧ return != : fail
 * @pre BWFS_Init
 */
int BWOTA_FlashSubApp(const char *filename);

/**
 * @brief ȡFlashӦý
 * @bried Get Flash sub application update result
 * @param filename [in] ļ128ַ File name, no more than 128 bytes
 * @retval =0 ɹ return = 0: success
 * @retval 0 ʧ return !0: fail
 * @pre BWFS_Init
 */
int BWOTA_GetFlashSubAppResult(const char *filename);

/** @} */
/**
 * @defgroup led led
 * @brief ledؽӿ,ǽӵƲڴ˽ӿڿ
 * @brief LED operation related interface, contactless card reader LED is not controlled by this interface
 * @{
 */
//#include "bwled.h"
/** @brief ͨLED  \n
* ǽӵƲڴ˽ӿڿ General LED control,contactless card reader LED is not controlled by this interface
**/
typedef enum {
    LED_CHG_R, ///< ChargLED Red
    LED_CHG_G, ///< ChargLED Green
    LED_CHG_B, ///< ChargLED Blue
    
    LED_SCAN_R, ///< ScanLED Red
    LED_SCAN_G, ///< ScanLED Green
    LED_SCAN_B, ///< ScanLED Blue

    LED_WORK_R, ///< WorkLED Red
    LED_WORK_G, ///< WorkLED Green
    LED_WORK_B, ///< WorkLED Blue

    LED_ID_MAX,	///< ID 
} led_id_type;

/**
 * @brief LEDָʾƵĿ
 * @brief Signale LED switdh
 * @param id [in] LEDƱled_id_type (LED serial number)
 * @param onoff [in] 0-أ1- (0 for OFF, 1 for ON)
 * @retval 0 ɹ return 0 for success
 * @retval -1 ֧ return -1 for not supported
 */
int LedCtrl(led_id_type id, int onoff);
/** @} */
/**
 * @defgroup hid hid
 * @brief hidؽӿ
 * @brief hid operation related interface
 * @{
 */
// #include "bwhid.h"
/**
 * @brief ݵUSB-HID
 * @brief Send data to USB-HID
 * @param buff [in] Ҫ͵ data need to be sent
 * @param len [in] Ҫ͵ݳ length of data to be sent
 */
void USBHIDSend(unsigned char *buff, unsigned int len);
/** @} */
/**
 * @defgroup views views
 * @brief ؽӿ
 * @brief UI operation related interface
 * @{
 */
#define FONTPIX 24   ///<ֿΪ24*24ʹôΪлеλ
#define LINEPIX 32   ///<м

#define MERCURY_NONE 0xFFFF  ///<ɫʾڣʹô˱ʾ͸ Color for null, when background using this, means transparent
#define WIDGETMAX	10	///<һҳжٿؼʱ֧10 maximum widget amount, temporal value: 10

/**
 * @brief ƽṹ
 * @brief UI drawing structure
 */
typedef struct{
	int x;	///< xλ x-axis
	int y;	///< yλ y-axis
	int len;	///< ݳ data length
}DrawPoint;

/**
 * @brief λö
 * @brief position difine
 */
typedef enum  
{
	NOALIGN = 0,     ///<޶뷽ʽ no align
	LEFT = 1,		 ///< to left
	CENTER = 2,		 ///<УԺʹ to center
	RIGHT = 3,		 ///< to right
	TOP = 4,		 ///< to top
	BOTTOM = 5		 ///< to buttom
}ALIGN;

/**
 * @brief ж
 * @brief Change line define
 */
typedef enum  
{
	FEEDLINE = 0, ///< change line
	NOFEED = 1    ///< not change line
}LINEFEED;

/**
 * @brief ÿпؼͶ
 * @brief widget type define
 */
typedef enum  
{
	STATICTEXT = 0,	///<̬ı
	DYNAMICTEXT,	///<̬ı
	PICTURE,		///<ͼƬ
	PIXS,			///<ص
	QRPAYCODE,		///<ά
	EMPTYRECT,		///<ο
	FUNC			///<ܺ
}LINE_TYPE;

/**
 * @brief ÿпؼͶ
 */
typedef enum  
{
	STATE_KEEPON = 0,	///<
	STATE_BACK,			///<
	STATE_TIMEOUT,		///<ʱ
	STATE_ERROR,		///<
	STATE_FINISH,		///<,صϲ˵
	STATE_FINISHALL,	///<,ȫ,˵
	STATE_LOADAGAIN		///<¼ҳ
}STATE;


/**
 * @brief ݷΪ̬ \n
 *		1.̬(ְ֧Ϊյʱ򣬿ֱӼذռÿռ)   \n
 *		2.̬֣ˢţݣռÿռ    \n
 *		3.ռÿռ
 
 * @brief There are 3 mode for data in line.
		1. Pure static text(can support click listener, when data is empty, can listen button directly and not take any space
		2. Dynamic text, can refresh input amount, order number, process on data and take space
		3. Pure function trigged, do not take space
 * @note ȼ triggerFunc > dynamicFresh > beforeTrigger > keyCode (Triggered Priority)
 */
typedef struct STVIEW{
	int 	viewId;											///<IDͬҳIDظͬһIDͬ,0-255*/ View ID, different View must have different ID, same interface must have same ID
	char 	type;         									///<*/ Data type
	char* 	text;		  									///<*/ Text information
	int     bgcolor;										///<屳ɫ*/ Font background color
	int  	color;		  									///<ɫ*/ Font color
	short int width; 		  								///<ͼƬ,ά,ο,(0,Ļ]*/ picture, QR, rectangle width, (0,screen width)
	short int height;		  								///<ͼƬ,ά,ο߶,(0,Ļ߶]*/ picture, QR, rectangle height, (0, scren height)
	char 	alianL;	 										///<ˮƽλ*/ relative horizontal position
	char 	bNewLine;										///<Ƿ*/ change line or not
	char 	alianV;	 										///<ֱλ*/ relative vertical position
	char 	marginLeft; 									///<࣬λ,255*/ space to left, unit: pixel, no more than 255
	char 	marginRight;									///<Ҳ࣬λ,255*/ space to right, unit: pixel, no more than 255
	char 	marginTop; 										///<Զ࣬λ,255*/ space to top, unit: pixel, no more than 255
	char 	marginBottom;									///<Եײ࣬λ,255*/ space to buttom, unit: pixel, no more than 255	
	char 	keyCode; 										///<д*/ This line will trigger button
	struct STVIEW* keepOnView; 								///<VIEW*/ View entered after been triggered
	struct STVIEW* errorView;								///<״̬ΪSTATE_ERRORʱVIEW*/	View Entered when state error
	int 	(*dynamicFresh)(void (*freshViewData)(int,char*));	///<ΪDYNAMICTEXTʱԴݵͬʱˢʾ*/ Processing Function when data type is DYNAMICTEXT, can refresh display information when processing
	int 	(*triggerFunc)(void);							///<ΪFUNCʱ򣬻ȼֵΪ״̬*/ When type is function, after finish create the view, will get the highest triggered priority. return value will be status.
	int 	(*beforeTrigger)(char*,char);					///<ǰִд˽ӿڣٽһ棬һЩؼ*/ Will ususlly run after button triggered, then enter the next view. Always used to save important data
	char*   (*initDynamicText)(struct STVIEW* view);					///<ΪDYNAMICTEXTΪPICTUREʱ򣬻ƽ֮ǰִд˽ӿڣʼtextȡͼƬԴ*/ When data type is DYNAMICTEXT or PICTURE, will run before initialize the UI, initialize text to get picture resources
}VIEW;

 /**
 * @brief ģVIEW_ID_BASE
 * @brief VIEW_ID_BASE module define
 */
enum
{
   VIEW_ID_BASE_APP             = 0x0000,	///<ʼidλ ID initial position
   VIEW_ID_BASE_SYSTEM_UI       = 0x0080,	///<ϵͳidʼλ System UI id initial position
   VIEW_ID_BASE_OTAUPDATE       = 0x00B0,	///<OTAidʼλ OTA update id initial position
   VIEW_ID_BASE_ABOUT_DEVICE    = 0x00C0,	///<豸idʼλ About device id initial position
   VIEW_ID_BASE_MDM_MQ          = 0x00D0,	///<MDMMQTTʼidλ MDM and MQTT id initial position
   VIEW_ID_BASE_SECURITY        = 0x00E0,	///<ȫʼidλ Security id initial position
   VIEW_ID_BASE_DATETIME        = 0x00F0,	///<ʱʼidλ Date time id initial position
   VIEW_ID_MAX                  = 0xFFFF,	///<idֵ Maximum id value
};

/**
 * @brief SDKɫԴͳһӦò
 * @brief Setup SDK color resource, unify the style of appliction layer
 * @param [in] fg ǰɫ foreground color
 * @param [in] bg ɫ background color
 * @param [in] fontbg 屳ɫ fond background color
 */
void setSdkColorResource(int fg,int bg,int fontbg);
/**
 * @brief ӦView Auto adjust view frame
 * @param [in] backColor ɫ background color
 * @param [in] view Viewַ view address
 * @param [in] timeout ʱʱ timeout time
 * @retval STATE @see STATE
 */
int autoRunView(int backColor,VIEW* view,int timeout);
/**
 * @brief صǰ
 * @retval void
 */
void autoFreshView(void);
/**
 * @brief VIEWǷ Check problem in VIEW difine
 * @param [in] top Viewַ.  top View address
 * @param [in] msg 쳣ʱ򷵻Ϣ (return information when get exceptions)
 * @retval NORMAL
 * @retval EXCEPTION 
 */
int checkViewDefine(VIEW* top,char* msg);
/** @} */
/**
 * @defgroup json json
 * @brief json,ֶ,ȡjsonַ
 * @brief create json, add information, get json
 * @code
	cJSON *root,*pointer;
	root = cJSON_CreateObject();
	cJSON_AddStringToObject(root, "appAccessKeyId", "ashdkjhashdjkhaskdjhjkad");
    cJSON_AddStringToObject(root, "extOrderNo", (char *)"123123123123");
	cJSON_AddStringToObject(root, "mrchNo", (char *)"100251920122121");
	pointer = cJSON_PrintUnformatted(root); 
	//ʹ֮,ͷrootpointer
	//must free root and pointer after use
	cJSON_Delete(root);
	free(pointer);
 * @endcode
 * @brief ַȡjsonṹ,ȡֶ
 * @brief Get json structure from String, get string data
 * @code
	//ȡrecvdata jsonַ
	//get the informaion stored in recvdata json
	cJSON *root,*item;
	root = cJSON_Parse(recvdata);
	item = cJSON_GetObjectItem(root, "mrchNo");
	cJSON_Delete(root);	
 * @endcode 
 * @{
 */

//#include "BwMain_api.h"
#define BWMAIN_API_ERR_UNKNOWVER (0x7F)

/**
 * @brief ȡmainapp汾
 * @param [out]  verBuf
 * @param [in]  verBufSize
 * @retval BWMAIN_API_ERR_UNKNOWVER(0x7F) - ڰ汾ӿڲ
 * @retval  0 - ɹ
 * @retval !0 - ʧ
 */
int MainAppApi_GetVer(char* verBuf, unsigned int verBufSize);

/**
 * @brief ȡsencondapp״̬־
 * @retval  0 - Ҫ
 * @retval  1 - Ҫ
 * @retval BWMAIN_API_ERR_UNKNOWVER(0x7F) - ڰ汾ӿڲ
 * @retval -101 - upd.tmpļ
 * @retval -102 - imgļ
 * @retval <0 - imgļ
 */
int MainAppApi_GetSencondAppUpdateFlag(void);

/**
 * @brief ȡԶ̽
 * @param [in]  mode 0x00 - MODE_RSA1024_SHA1
 *                   0x01 - MODE_RSA1024_SHA256
 * @param [out] pusEnOutLen
 * @param [out] pucEnOut
 * @retval  0 - ɹ
 * @retval BWMAIN_API_ERR_UNKNOWVER(0x7F) - ڰ汾ӿڲ
 * @retval FEBF(-321) - PED_RET_ERROR ͨô
 * @retval FE9C(-356) - PED_RET_ERR_UNLOCK_TIMEOUT Զ̽ʱ
 * @retval FE9B(-357) - PED_RET_ERR_UNLOCK_PARAM Զ̽
 * @retval FE9A(-358) - PED_RET_ERR_UNLOCK_NO Զ̽APδ
 * @retval FE99(-359) - PED_RET_ERR_UNLOCK_CHECK Զ̽У
 * @retval FE98(-360) - PED_RET_ERR_NEED_RESET Ҫ
 * @retval FE97(-361) - PED_RET_ERR_RNG 
 */
int MainAppApi_PedReqRemoteUnlock(unsigned char mode, unsigned short* pusEnOutLen, unsigned char *pucEnOut);

/**
 * @brief ֤Զ̽Ȩ
 * @param [in]  mode 0x00 - MODE_RSA1024_SHA1
 *                   0x01 - MODE_RSA1024_SHA256
 * @param [in] usEnInLen
 * @param [in] pucEnIn
 * @note  ʱʱΪ[ִMainAppApi_PedReqRemoteUnlock5]
 * @retval  0 - ɹ
 * @retval BWMAIN_API_ERR_UNKNOWVER(0x7F) - ڰ汾ӿڲ
 * @retval FEBF(-321) - PED_RET_ERROR ͨô
 * @retval FE9C(-356) - PED_RET_ERR_UNLOCK_TIMEOUT Զ̽ʱ
 * @retval FE9B(-357) - PED_RET_ERR_UNLOCK_PARAM Զ̽
 * @retval FE9A(-358) - PED_RET_ERR_UNLOCK_NO Զ̽APδ
 * @retval FE99(-359) - PED_RET_ERR_UNLOCK_CHECK Զ̽У
 * @retval FE98(-360) - PED_RET_ERR_NEED_RESET Ҫ
 * @retval FE97(-361) - PED_RET_ERR_RNG 
 */
int MainAppApi_PedRemoteUnlock(unsigned char mode, unsigned short usEnInLen, unsigned char *pucEnIn);


/** @} */
#ifdef __cplusplus
}
#endif

#endif

